#include <algorithm>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define INF 0x3f3f3f3f
#define INFLL (int64_t)(1e18)
#define EPS 1e-9

template <class T> istream &operator>>(istream &is, vector<T> &a) {
    for (size_t i = 0; i < a.size(); ++i)
        is >> a[i];
    return is;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    int m;
    cin >> m;
    long long ans = 0;
    vector<long long> v(n, 0);
    for (int i = 1; i <= n; ++i)
        for (int j = i; j <= n; j += i)
            v[i - 1] += a[j - 1];
    for (int i = 0; i < m; ++i) {
        int p, s;
        cin >> p >> s;
        long long cur = -INFLL;
        for (int j = 0; j < n; ++j) {
            long long curr = v[j];
            if (p % (j + 1) == 0)
                curr += s;
            cur = max(cur, curr);
        }
        ans += cur;
    }
    cout << ans;
}
