#include <algorithm>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define INF 0x3f3f3f3f
#define INFLL (int64_t)(1e18)
#define EPS 1e-9

template <class T> istream &operator>>(istream &is, vector<T> &a) {
    for (size_t i = 0; i < a.size(); ++i)
        is >> a[i];
    return is;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> coords(n);
    pair<int, int> ma = {0, 0};
    for (int i = 0; i < n; ++i) {
        cin >> coords[i].first >> coords[i].second;
        ma.first = max(ma.first, coords[i].first);
        ma.second = max(ma.second, coords[i].second);
    }
    int ans = 0;
    for (int i = 1; i <= ma.first; ++i) {
        for (int j = 1; j <= ma.second; ++j) {
            int cur = 0;
            for (int k = 0; k < n; ++k)
                if (coords[k].first >= i - w && coords[k].first <= i &&
                    coords[k].second >= j - h && coords[k].second <= j)
                    ++cur;
            ans = max(ans, cur);
        }
    }
    cout << ans;
}
