#include "biggest.h"
#include<bits/stdc++.h>

using namespace std;

int ispod[100099], par[100099], tin[100099], tout[100099], Time, pos[100099], boja;
bool sig[100099];
bool uresenju[100099];

bool pospos[100099];
vector<int> sigurni;
vector<int> decca[100099];
//int p[10];
int compare(int x, int y) /*{
    if(p[x]>p[y]) return x;
    return y;
}*/;
void dfs(int node) {
    if(pos[node]) return;
    pos[node]=boja;
    tin[node]=++Time;
    for(auto ch:decca[node]) {
        if(sig[ch]) dfs(ch);
    }
    tout[node]=Time;
}
void tfs(int node) {
    if(pospos[node]) return;
    //cout << "CVOR: " << node << "\nIN: " << tin[node] << "\nOUT: " << tout[node] << "\n\n";
    pospos[node]=1;
    for(auto ch:decca[node]) {
        if(sig[ch]) dfs(ch);
    }
}
vector<int> biggest(int n, int k) {
    /// ideja: ubijamo pobednika duela
    /// algoritam nece raditi za k==n-1 i k==n (mala verovatnoca da je k bas 100000)
    int root=compare(1, 2);
    int drugi=3-root;
    par[drugi]=root;
    ispod[drugi]=0;
    ispod[root]=1;
    decca[root].push_back(drugi);
    int broj=0;
    while(true) {
        if(broj>=k) break;
        bool napolje=false;
        for(int i=1; i<=n; ++i) {
            if(broj>=k) {napolje=true; break;}
            if(!sig[par[i]] && par[i]!=0) continue;
            if(sig[i]) continue;
            if(i==root) continue;
            if(compare(i, root)==i) {
                par[root]=i;
                ispod[i]+=ispod[root]+1;
                decca[i].push_back(root);
                root=i;
            }
            else {
                par[i]=root;
                ++ispod[root];
                decca[root].push_back(i);
            }

            if(ispod[root]>=n-k) {
                sig[root]=true;
                sigurni.push_back(root);
                ++broj;
                int kolko=-1, koje=0;
                for(auto ch:decca[root]) {
                    if(ispod[ch]>kolko) {
                        kolko=ispod[ch];
                        koje=ch;
                    }
                }
                root=koje;
            }
        }
        if(napolje) break;
    }
    /// zasad je ostajao po n-k+1 cvor, tako da jedan najbolji ide u resenje
    /// testiram da li to vazi uvek, ili je samo "sreca u nesreci"
    /// ZAKLJUCAK: puka sreca.

    vector<int> memorisi;
    int najm=0;
    /*for(auto y:sigurni) {
        cout << y << ' ';
    }
    cout << "\n";*/
    int boja=1;
    for(int i=0; i<broj; ++i) {
        if(pos[sigurni[i]]) continue;
        Time=-1;
        dfs(sigurni[i]);
        ++boja;
    }
    for(int i=0; i<broj; ++i) {
        if(pospos[sigurni[i]]) continue;
        tfs(sigurni[i]);
    }
    while(k--) {
        int tren=najm;
        while(uresenju[sigurni[tren]]) {
            ++tren;
            najm=tren;
        }
        for(int i=tren+1; i<broj; ++i) {
            if(uresenju[sigurni[i]]) continue;

            if(pos[sigurni[i]]==pos[sigurni[tren]]) {
                if(tin[sigurni[tren]]>tin[sigurni[i]]&&tout[sigurni[tren]]<=tout[sigurni[i]]) {
                    tren=i;
                }
            }
            else if(compare(sigurni[i], sigurni[tren])==sigurni[i]) {
                tren=i;
            }
        }
        memorisi.push_back(sigurni[tren]);
        uresenju[sigurni[tren]]=true;
    }
    /*for(auto y:memorisi) {
        cout << y << ' ';
    }*/
    return memorisi;
}
/*int main() {
    mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
    for(int i=1; i<=5; ++i) p[i]=i;
    shuffle(p+1, p+6 , rng);
    for(int i=1; i<=5; ++i) cout << p[i] << ' ';
    cout << "\n";
    biggest(5, 2);
}*/
