#include <bits/stdc++.h>

using namespace std;

const int N = 1e5;

int n, m, a, b, x, y, aint[800002], lazy[800002];
pair<int, int> v[100002];

void prop (int nod, int st, int dr) {
  aint[nod] += lazy[nod];
  if (st != dr) {
    lazy[2 * nod] += lazy[nod];
    lazy[2 * nod + 1] += lazy[nod];
  }
  lazy[nod] = 0;
}

void update (int nod, int st, int dr, int a, int b, int val) {
  prop(nod, st, dr);
  if (st > dr || b < st || a > dr)
    return;
  if (a <= st && dr <= b) {
    aint[nod] += val;
    if (st != dr) {
      lazy[2 * nod] += val;
      lazy[2 * nod + 1] += val;
    }
    return;
  }
  int mid = (st + dr) / 2;
  update(2 * nod, st, mid, a, b, val);
  update(2 * nod + 1, mid + 1, dr, a, b, val);
  aint[nod] = max(aint[2 * nod], aint[2 * nod + 1]);
}


int main()
{
  cin >> n >> a >> b;
  for (int i = 1; i <= n; i++) {
    cin >> v[i].first >> v[i].second;
  }
  int j = 1;
  int ans = 0;
  for (int i = 1; i <= n; i++) {
    while (j <= n && v[j].first - v[i].first <= a) {
      update(1, 1, N - b, max(1, v[j].second - b), min(N - b, v[j].second), 1);
      j++;
    }
    update(1, 1, N - b, max(1, v[j].second - b), min(N - b, v[j].second), -1);
    prop(1, 1, N - b);
    ans = max(ans, aint[1]);
  }
  cout << ans;
  return 0;
}
