#include <bits/stdc++.h>

using namespace std;

const int N = 1e5;

int n, m, a, b, x, y, aint[800002], lazy[800002], mata[100002], st[100002];
pair<int, int> v[100002];

void prop (int nod, int st, int dr) {
  aint[nod] += lazy[nod];
  if (st != dr) {
    lazy[2 * nod] += lazy[nod];
    lazy[2 * nod + 1] += lazy[nod];
  }
  lazy[nod] = 0;
}

void update (int nod, int st, int dr, int a, int b, int val) {
  prop(nod, st, dr);
  if (st > dr || b < st || a > dr)
    return;
  if (a <= st && dr <= b) {
    aint[nod] += val;
    if (st != dr) {
      lazy[2 * nod] += val;
      lazy[2 * nod + 1] += val;
    }
    return;
  }
  int mid = (st + dr) / 2;
  update(2 * nod, st, mid, a, b, val);
  update(2 * nod + 1, mid + 1, dr, a, b, val);
  aint[nod] = max(aint[2 * nod], aint[2 * nod + 1]);
}

bool cmp (pair<int, int> a, pair<int, int> b) {
  return a.second < b.second;
}


int main()
{
  cin >> n >> a >> b;
  for (int i = 1; i <= n; i++) {
    cin >> v[i].first >> v[i].second;
  }
  sort(v + 1, v + n + 1);
   if (n <= 1000) {
    int ans = 0;
    for (int i = 1; i <= n; i++) {
      vector<pair<int, int> > aux;
      for (int j = i; j <= n; j++) {
        if (v[j].first - v[i].first <= a)
          aux.push_back(v[j]);
        else
          break;
      }
      sort(aux.begin(), aux.end(), cmp);
      int k = 0;
      for (int j = 0; j < aux.size(); j++) {
        while (k < aux.size() && aux[k].second <= aux[j].second + b)
          k++;
        ans = max(k - j, ans);
      }
    }
    for (int i = 1; i <= n; i++) {
      vector<pair<int, int> > aux;
      for (int j = i; j >= 1; j--) {
        if (v[i].first - v[j].first <= a)
          aux.push_back(v[j]);
        else
          break;
      }
      sort(aux.begin(), aux.end(), cmp);
      int k = 0;
      for (int j = 0; j < aux.size(); j++) {
        while (k < aux.size() && aux[k].second <= aux[j].second + b)
          k++;
        ans = max(k - j, ans);
      }
    }
    cout << ans;
    return 0;
  }
  int j = 1, i = 1;
  int ans = 0;
  map<int, int>mp;
  for (int i = 1; i <= n; i++)
    mata[i] = v[i].second;
  sort(mata + 1, mata + n + 1);
  int nr = 0;
  for (int i = 1; i <= n; i++) {
    if (i ==1 || mata[i] != mata[i - 1]) {
      mp[mata[i]] = ++nr;
      st[nr] = lower_bound(mata + 1, mata + i, mata[i] - b) - mata;
    }
  }
  for (int i = 1; i <= n; i++)
    v[i].second = mp[v[i].second];
  for (int i = 1; i <= n; i++) {
    while (j <= n && v[j].first <= v[i].first + a) {
      update(1, 1, nr, st[v[i].second], v[i].second, 1);
      j++;
    }
    update(1, 1, nr, st[v[i].second], v[i].second, -1);
    prop(1, 1, nr);
    ans = max(ans, aint[1]);
  }
  memset(aint, 0, sizeof(aint));
  memset(lazy, 0, sizeof(lazy));
  j = n;
  for (int i = 1; i <= n; i++) {
    while (j >= n && v[j].first >= v[i].first - a) {
      update(1, 1, nr, st[v[i].second], v[i].second, 1);
      j--;
    }
    update(1, 1, nr, st[v[i].second], v[i].second, -1);
    prop(1, 1, nr);
    ans = max(ans, aint[1]);
  }
  cout << ans;
  return 0;
}
