#include <bits/stdc++.h>
#pragma GCC optimize ("O3")
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("O1")

using namespace std;

const int N = 1e5;

int n, m, a, b, x, y, aint[2][800002], lazy[2][800002], mata[100002], st[100002], dr[100002];
pair<int, int> v[100002];

void prop (int nod, int st, int dr, int p) {
  aint[p][nod] += lazy[p][nod];
  if (st != dr) {
    lazy[p][2 * nod] += lazy[p][nod];
    lazy[p][2 * nod + 1] += lazy[p][nod];
  }
  lazy[p][nod] = 0;
}

void update (int nod, int st, int dr, int a, int b, int val, int p) {
  prop(nod, st, dr, p);
  if (st > dr || b < st || a > dr)
    return;
  if (a <= st && dr <= b) {
    aint[p][nod] += val;
    if (st != dr) {
      lazy[p][2 * nod] += val;
      lazy[p][2 * nod + 1] += val;
    }
    return;
  }
  int mid = (st + dr) / 2;
  update(2 * nod, st, mid, a, b, val, p);
  update(2 * nod + 1, mid + 1, dr, a, b, val, p);
  aint[p][nod] = max(aint[p][2 * nod], aint[p][2 * nod + 1]);
}

bool cmp (pair<int, int> a, pair<int, int> b) {
  return a.second < b.second;
}


int main()
{
  ios_base::sync_with_stdio(false);
  cin.tie(0); cout.tie(0);
  cin >> n >> a >> b;
  for (int i = 1; i <= n; i++) {
    cin >> v[i].first >> v[i].second;
  }
  sort(v + 1, v + n + 1);
  int ans = 0;
  for (int i = 1; i <= n; i++)
    mata[i] = v[i].second;
  sort(mata + 1, mata + n + 1);
  int nr = 0;
  for (int i = 1; i <= n; i++)
    if (i == 1 || mata[i] != mata[i - 1])
      mata[++nr] = mata[i];
  int i;
  for (i = 1; i <= nr; i++) {
    st[i] = lower_bound(mata + 1, mata + i, mata[i] - b) - mata;
    dr[i] = upper_bound(mata + i, mata + nr, mata[i] + b) - mata - 1;
  }
  for (int i = 1; i <= n; i++)
    v[i].second = lower_bound(mata + 1, mata + nr + 1, v[i].second) - mata;
  int j = 1;
  for (i = 1; i <= n; i++) {
    while (j <= n && v[j].first <= v[i].first + a) {
      update(1, 1, nr, st[v[j].second], v[j].second, 1, 0);
      update(1, 1, nr, v[j].second, dr[v[j].second], 1, 1);
      j++;
    }
    prop(1, 1, nr, 0);
    prop(1, 1, nr, 1);
    ans = max(ans, max(aint[0][1], aint[1][1]));
    update(1, 1, nr, st[v[i].second], v[i].second, -1, 0);
    update(1, 1, nr, v[i].second, dr[v[i].second], -1, 1);
  }
  memset(aint, 0, sizeof(aint));
  memset(lazy, 0, sizeof(lazy));
  j = n;
  for (i = n; i >= 1; i--) {
    while (j >= 1 && v[j].first >= v[i].first - a) {
      update(1, 1, nr, st[v[j].second], v[j].second, 1, 0);
      update(1, 1, nr, v[j].second, dr[v[j].second], 1, 1);
      j--;
    }
    prop(1, 1, nr, 0);
    prop(1, 1, nr, 1);
    ans = max(ans, max(aint[0][1], aint[1][1]));
    update(1, 1, nr, st[v[i].second], v[i].second, -1, 0);
    update(1, 1, nr, v[i].second, dr[v[i].second], -1, 1);
  }
  cout << ans;
  return 0;
}

