#include "biggest.h"

int pos[100005];
int cop[100005];

void MergeSort (int st, int dr, int N, int K) {
    if (st >= dr) return;

    int mij = (st + dr) / 2;

    MergeSort(st, mij, N, K);
    MergeSort(mij+1, dr, N, K);

    int i = st, j = mij + 1;
    int vf = 0;
    while (i <= mij && j <= dr) {
        int x = compare(pos[i], pos[j]);

        if (pos[i] == x) {
            ++ vf;
            cop[vf] =pos[i];
            ++ i;
        }
        else {
            ++ vf;
            cop[vf] = pos[j];
        }
    }

    while (i <= mij) {
        cop[++vf] = pos[i];
        ++ i;
    }
    while (j <= dr) {
        cop[++vf] = pos[j];
        ++ j;
    }

    for (int i = st; i <= dr; ++ i )
        pos[i] = cop[i];
}

vector <int> biggest(int N, int K) {
    for (int i = 1; i <= N; ++ i )
        pos[i] = i;

    MergeSort(1, N, N, K);
    vector<int>v;
    v.clear();

    for (int i = N; i >= N - K + 1; -- i )
        v.push_back(pos[i]);
    return v;
}
