#include "bits/stdc++.h"

#pragma GCC optimize("O3", "Ofast", "unroll-loops", "fast-math", "unswitch-loops")
#pragma GCC target("sse", "sse2", "sse3", "sse4", "sse4.1", "sse4.2", "avx", "avx2", "mmx")
using namespace std;
#define ios ios_base::sync_with_stdio(0);cout.tie(0);cin.tie(0)
#define sz(a) (int)a.size()
#define ll long long
int n;

int main() {
    ios;
    cin >> n;
    int s[n + 1];
    for (int i = 1; i < n + 1; ++i) {
        cin >> s[i];
    }
    ll ans[n + 1];
    vector<unordered_set<int>> us(n + 1);
    vector<ll> mxd(n + 1);
    for (int i = 1; i <= n; ++i) {
        ans[i] = 0;
        for (int j = i; j <= n; j += i) {
            us[j].insert(i);
            ans[i] += s[j];
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j * j <= i; ++j) {
            if (i % j == 0) {
                mxd[i] = max(mxd[i], ans[j]);
                mxd[i] = max(mxd[i], ans[i/j]);
            }
        }
    }
    int q;
    cin >> q;
    ll answer = 0;
    pair<ll, int> vec[n];
    for (int i = 0; i < n; ++i)
        vec[i] = {ans[i + 1], i + 1};
    sort(vec, vec + n, greater<>());
    vector<ll> meet(n + 1, -1);
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (us[i].find(vec[j].second) == us[i].end()) {
                meet[i] = j;
                break;
            }
        }
    }
    while (q--) {
        int i;
        ll num;
        cin >> i >> num;
        ll mx = mxd[i]+num;
        if (num >= 0)
            answer += max(mx, vec[0].first);
        else {
           if(meet[i]>=0)
               mx=max(mx,vec[meet[i]].first);
            answer += mx;
        }
    }
    cout << answer << "\n";
    return 0;
}