#include<bits/stdc++.h>

using namespace std;

const int MX = 6;

struct Zap {
    int type;
    int l, r;
    int y;
    int ind;

    bool operator<(Zap a) {
        if (a.y != y)
            return y < a.y;
        return type < a.type;
    }
};

vector<int> tree(4 * MX);

void update(int x, int v = 0, int l = 0, int r = MX) {
    if (l > x || r <= x)
        return;
    tree[v]++;
    if (l + 1 == r)
        return;
    int m = (l + r) / 2;
    update(x, v + v + 1, l, m);
    update(x, v + v + 2, m, r);
}

int getsum(int tl, int tr, int v = 0, int l = 0, int r = MX) {
    if (tr <= l || r <= tl)
        return 0;
    if (tl <= l && r <= tr)
        return tree[v];
    int m = (l + r) / 2;
    return getsum(tl, tr, v + v + 1, l, m) + getsum(tl, tr, v + v + 2, m, r);
}

int main() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int> > a(n);
    vector<Zap> zap;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        zap.push_back({0, a[i].second, -1, a[i].first, i});
        zap.push_back({-1, a[i].second - h, a[i].second, a[i].first - w, i});
        zap.push_back({1, a[i].second - h, a[i].second, a[i].first, i});
    }
    sort(zap.begin(), zap.end());
    vector<int> ans(n);
    for (int i = 0; i < (int) zap.size(); ++i) {
        if (zap[i].type == 0) {
            update(zap[i].l);
            continue;
        }
        ans[zap[i].ind] += zap[i].type * getsum(zap[i].l, zap[i].r + 1);
    }
    int mx = 0;
    for (int i = 0; i < n; ++i)
        mx = max(mx, ans[i]);
    cout << mx;
}
