#include<bits/stdc++.h>

using namespace std;

const int MX = 3e5;

vector<int> tree(4 * MX, 0);
vector<int> add(4 * MX, 0);

void push(int v, int l, int r) {
    tree[v] += add[v];
    if (l + 1 == r) {
        add[v] = 0;
        return;
    }
    add[v + v + 1] += add[v];
    add[v + v + 2] += add[v];
    add[v] = 0;
}

void update(int tl, int tr, int x, int v = 0, int l = 0, int r = MX) {
    push(v, l, r);
    if (tr <= l || r <= tl)
        return;
    if (tl <= l && r <= tr) {
        add[v] += x;
        push(v, l, r);
        return;
    }
    if (l + 1 == r)
        return;
    int m = (l + r) / 2;
    update(tl, tr, x, v + v + 1, l, m);
    update(tl, tr, x, v + v + 2, m, r);
    tree[v] = max(tree[v + v + 1], tree[v + v + 2]);
}

bool cmp(pair<int, int> a, pair<int, int> b) {
    if (a.first != b.first)
        return a.first < b.first;
    return a.second > b.second;
}

bool cmpppppp(pair<int, int> a, pair<int, int> b){
    return a.second < b.second;
}
vector<int> help;
int findd(int x){
    int l = -1, r = help.size();
    while(l + 1 < r)
    {
        int m = (l + r) / 2;
        if(help[m] <= x)
            l = m;
        else
            r = m;
    }
    return l;
}
int main() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int> > a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    sort(a.begin(), a.end(), cmpppppp);
    int pr = -1;
    for(int i = 0;i<n;++i){
        if(pr != a[i].second){
            pr = a[i].second;
            help.push_back(a[i].second);
        }
    }
    sort(a.begin(), a.end());
    int mx = 0, p1 = 0;
    for (int i = 0; i < n; ++i) {
        update(findd(a[i].second), findd(a[i].second + h) + 1, 1);
        while (p1 < n && a[p1].first < a[i].first - w) {
            update(findd(a[p1].second), findd(a[p1].second + h) + 1, -1);
            p1++;
        }
        mx = max(mx, tree[0]);
    }
    cout << mx;
}