#include <iostream>
#include <vector>
#include <algorithm>
#include "biggest.h"

using namespace std;

int compare(int x, int y);

bool comp(int x, int y)
{
    if (x == 0)
    {
        return true;
    }
    if (y == 0)
    {
        return false;
    }
    return compare(x, y) == y;
}

vector<int> biggest(int n, int k)
{
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++)
    {
        a[i] = i;
    }
    sort(a.begin(), a.end(), comp);
    vector<int> b(k);
    for (int i = n - 1; i >= n - k; i--)
    {
        b[n - i - 1] = a[i];
    }
    return b;
}