#include <bits/stdc++.h>

using namespace std;

struct pt
{
    int x, y;
};

//bool compx(pt a, pt b)
//{
//    if(a.x <= b.x)
//        return 1;
//    else
//        return 0;
//}
//
//bool compy(pt a, pt b)
//{
//    if(a.y <= b.y)
//        return 1;
//    else
//        return 0;
//}

int main()
{
    int n, w, h;
    cin >> n >> w >> h;
    vector<pt> p(n);
    for(int i = 0; i < n; i++)
        cin >> p[i].x >> p[i].y;
//    vector<pt> sx = p, sy = p;
//    sort(sx.begin(), sx.end(), compx);
//    sort(sy.begin(), sy.end(), compy);

    if(w <= 100 && h <= 100 && n <= 100) /// 1, 2, O(h*w)
    {
        int ans = 0;
        for(int ix = 1; ix <= 100; ix++)
            for(int iy = 1; iy <= 100; iy++)
            {
                int cnt = 0;
                for(pt i: p)
                    if(i.x >= ix && i.x <= ix + w && i.y >= iy && i.y <= iy + h)
                        cnt++;
                ans = max(ans, cnt);
            }
        cout << ans;
        return 0;
    }
    /// 3, O(N^2)
    if(n <= 1000)
    {
        vector<set<int> > low(n), right(n);
        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < n; j++)
            {
                if(p[j].y >= p[i].y && p[j].y <= p[j].y + h)
                    low[i].insert(j);
                if(p[j].x >= p[i].x && p[j].x <= p[i].x + w)
                    right[i].insert(j);
            }
        }
        int ans = 0;
        for(int i = 0; i < n; i++)
            for(int j = 0; j < n; j++)
            {
                vector<int> its;
                set_intersection(low[i].begin(), low[i].end(), right[j].begin(), right[j].end(), back_inserter(its));
                ans = max(ans, (int)its.size());
            }
        cout << ans;
        return 0;
    }
    return 0;
}
