/// 2, 34
#include <bits/stdc++.h>

using namespace std;

struct pt
{
    int x, y;
};

int main()
{
    int n, w, h;
    cin >> n >> w >> h;
    vector<pt> p(n);
    for(int i = 0; i < n; i++)
        cin >> p[i].x >> p[i].y;

    if(w <= 100 && h <= 100 && n <= 100) /// 1, 2, O(h*w)
    {
        int ans = 0;
        for(int ix = 1; ix <= 100; ix++)
            for(int iy = 1; iy <= 100; iy++)
            {
                int cnt = 0;
                for(pt i: p)
                    if(i.x >= ix && i.x <= ix + w && i.y >= iy && i.y <= iy + h)
                        cnt++;
                ans = max(ans, cnt);
            }
        cout << ans;
        return 0;
    }
    /// 3, O(N^2)
    if(n <= 1000)
    {
        int ans = 0;
        for(pt l : p)
        {
            vector<int> v;
            for(pt a: p)
                if(a.x >= l.x && a.x <= l.x + w)
                    v.push_back(a.y);
            sort(v.begin(), v.end());
            for(int i = 0; i < v.size(); i++)
            {
                ans = max(ans, (int)((upper_bound(v.begin(), v.end(), v[i]+h) - v.begin()) - i));
            }
        }
        cout << ans;
        return 0;
    }
    return 0;
}
