/// 2, 34
#include <bits/stdc++.h>

using namespace std;

struct pt
{
    int x, y;
};

int main()
{
    int n, w, h;
    cin >> n >> w >> h;
//    srand(time(0));
//    int n = 100000 - rand()%10000, w = rand()%1000, h = rand()%1000;
    vector<pt> p(n);
    int maxx = 0, maxy = 0;
    for(int i = 0; i < n; i++)
    {
        cin >> p[i].x >> p[i].y;
//        p[i].x = (rand()^1337)%1000;
//        p[i].y = (rand()^765)%1000;
        maxx = max(maxx, p[i].x);
        maxy = max(maxx, p[i].y);
    }

    if(w <= 100 && h <= 100 && n <= 100 && maxx <= 100 && maxy <= 100) /// 1, 2, O(h*w)
    {
        int ans = 0;
        for(int ix = 1; ix <= 100; ix++)
            for(int iy = 1; iy <= 100; iy++)
            {
                int cnt = 0;
                for(pt i: p)
                    if(i.x >= ix && i.x <= ix + w && i.y >= iy && i.y <= iy + h)
                        cnt++;
                ans = max(ans, cnt);
            }
        cout << ans;
        return 0;
    }
    if(w <= 100000000 && h <= 100000000 && n <= 1000 && maxx <= 100000000 && maxy <= 100000000) /// 3, O(N^2)
    {
        int ans = 0;
        for(pt l : p)
        {
            vector<int> v;
            for(pt a: p)
                if(a.x >= l.x && a.x <= l.x + w)
                    v.push_back(a.y);
            sort(v.begin(), v.end());
            for(int i = 0; i < (int)v.size(); i++)
            {
                ans = max(ans, (int)((upper_bound(v.begin(), v.end(), v[i]+h) - v.begin()) - i));
            }
        }
        cout << ans;
        return 0;
    }
    if(w <= 1000 && h <= 1000 && n <= 100000 && maxx <= 1000 && maxy <= 1000) /// 4, O(maxx*maxy)
    {
        unordered_map<int, int> cnt;
        for(pt i: p)
            cnt[i.x*1000 + i.y]++;
        vector<vector<int> > dp(maxx+1, vector<int> (maxy+1));
        for(int j = 1; j <= maxy; j++)
        {
            for(int i = 1; i <= maxx; i++)
            {
                dp[i][j] = dp[i-1][j] + dp[i][j-1] - dp[i-1][j-1] + cnt[i*1000 + j];
            }
        }
        int ans = 0;
        for(pt a: p)
        {
            int x1 = a.x, y1 = min(a.y+h, maxy), x2 = max(0, a.x-w-1), y2 = a.y-1;
            ans = max(ans, dp[x1][y1] - dp[x1][y2] - dp[x2][y1] + dp[x2][y2]);
        }
        cout << ans;
        return 0;
    }
    return 0;
}
