#include <bits/stdc++.h>

#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")

#define int long long
#define ff first
#define ss second
#define pb push_back

using namespace std;

const int N = 5e4 + 5, inf = 1e18 + 100;

int a[N], sum[N], t[2 * N];
vector < int > d[N];

inline void build(int v, int l, int r)
{
    if (l == r)
    {
        t[v] = sum[l];
        return;
    }

    int mid = (l + r) / 2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid + 1, r);

    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

inline void upd(int v, int l, int r, int i, int x)
{
    if (l == r)
    {
        t[v] += x;
        return;
    }

    int mid = (l + r) / 2;
    if (i <= mid) upd(v * 2, l, mid, i, x);
    else upd(v * 2 + 1, mid + 1, r, i, x);

    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> a[i];

    for (int k = 1; k <= n; ++k)
    {
        for (int i = k; i <= n; i += k)
            sum[k] += a[i];

        for (int i = 1; i * i <= k; ++i)
        {
            if (k % i == 0)
            {
                d[k].pb(i);
                if (i * i < k) d[k].pb(k / i);
            }
        }
    }

    build(1, 1, n);

    int j = 0, mx = 0;
    for (int i = 1; i <= n; ++i)
        if (sum[i] > mx) mx = sum[i], j = i;

    int q, ans = 0;
    cin >> q;
    while (q--)
    {
        int pos, x;
        cin >> pos >> x;

        if (x < 0 && pos % j)
        {
            ans += mx;
            continue;
        }

        for (int div : d[pos])
            upd(1, 1, n, div, x);

        ans += t[1];

        for (int div : d[pos])
            upd(1, 1, n, div, -x);
    }

    cout << ans;
    return 0;
}
