#include <iostream>
#include <vector>
#include <utility>
#include <map>

#include "biggest.h"

using namespace std;
/*
int compare(int x, int y) {
	cout << "? " << x << ' ' << y << endl;
	int ans;
	cin >> ans;
	return ans;
}
*/
vector<vector<pair<int, int>>> mp;
int cmpmd(int x, int y) {
	if (y > x) {
		swap(x, y);
	}
	for (int i = 0; i < mp[x].size(); i++) {
		if (mp[x][i].first == y) {
			return mp[x][i].second;
		}
	}
	int ans = compare(x, y);
	mp[x].push_back({ y,ans });
	return ans;
}
vector<int> biggest(int n, int k) {
	mp.resize(n+1);
	vector<int> alive, ans;
	for (int i = 0; i < n; i++) {
		alive.push_back(i + 1);
	}
	if (k < 1001) {
		vector<vector<int>>direct(n + 1);
		int nn = n / 2;
		while (alive.size() > 1) {
			for (int i = alive.size() - 1; i > 0; i -= 2) {
				if (cmpmd(alive[i], alive[i - 1]) == alive[i]) {
					direct[alive[i]].push_back(alive[i - 1]);
					alive[i - 1] = alive[alive.size() - 1];
					alive.pop_back();
				} else {
					direct[alive[i - 1]].push_back(alive[i]);
					alive[i] = alive[alive.size() - 1];
					alive.pop_back();
				}
			}
		}
		ans.push_back(alive[0]);
		vector<int> ex;
		while (ans.size() < k) {
			for (int i = 0; i < ex.size(); i++) {
				if (ex[i] == alive[0]) {
					ex[i] = ex[ex.size() - 1];
					ex.pop_back();
					break;
				}
			}
			for (int i = 0; i < direct[alive[0]].size(); i++) {
				ex.push_back(direct[alive[0]][i]);
			}
			alive = ex;
			while (alive.size() > 1) {
				for (int i = alive.size() - 1; i > 0; i -= 2) {
					if (cmpmd(alive[i], alive[i - 1]) == alive[i]) {
						alive[i - 1] = alive[alive.size() - 1];
						alive.pop_back();
					} else {
						alive[i] = alive[alive.size() - 1];
						alive.pop_back();
					}
				}
			}
			ans.push_back(alive[0]);
		}
	} else {
		vector<vector<int>>merge;
		for (int i = 1; i < n + 1; i++) {
			merge.push_back({ i });
		}
		for (int i = 0; i < merge.size() - 1; i += 2) {
			merge.push_back({});
			int f = 0,s = 0;
			while (f < merge[i].size() && s < merge[i+1].size()) {
				if (cmpmd(merge[i][f], merge[i + 1][s]) == merge[i][f]) {
					merge[merge.size() - 1].push_back(merge[i][f++]);
				} else {
					merge[merge.size() - 1].push_back(merge[i][s++]);
				}
			}
		}
		vector<int> ord = merge[merge.size() - 1];
		while (ord.size() > k) {
			ord.pop_back();
		}
		return ord;
	}
	return ans;
}
/*
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, k;
	cin >> n >> k;
	vector<int> ans = biggest(n, k);
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] << ' ';
	}
	cout << endl;
	return 0;
}
*/