#include <iostream>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

const int N = 1e5 + 7, L = 30;

namespace Aint_dinamic {
    vector < int > fiu_st, fiu_dr, num, lazy;

    void Init() {
        fiu_st.push_back(-1);
        fiu_dr.push_back(-1);
        num.push_back(-1);
        lazy.push_back(-1);
        fiu_st.push_back(0);
        fiu_dr.push_back(0);
        num.push_back(0);
        lazy.push_back(0);
    }

    void init() {
        fiu_st.push_back(0);
        fiu_dr.push_back(0);
        num.push_back(0);
        lazy.push_back(0);
    }

    bool propaga(int nod, int st, int dr) {
        assert(fiu_st[nod] != 0 && fiu_dr[nod] != 0);
        assert(st < dr);
        if (!lazy[nod])
            return 1;
        num[fiu_st[nod]] += lazy[nod];
        num[fiu_dr[nod]] += lazy[nod];
        lazy[fiu_st[nod]] += lazy[nod];
        lazy[fiu_dr[nod]] += lazy[nod];
        lazy[nod] = 0;
    }

    int x, y;
    int val;

    void Adauga(int nod = 1, int st = 1, int dr = L - 1) {
        if (x <= st && dr <= y) {
            num[nod] += val;
            lazy[nod] += val;
            return;
        }
        if (fiu_st[nod] == 0 && fiu_dr[nod] == 0) {
            fiu_st[nod] = fiu_st.size();
            init();//bruh
            fiu_dr[nod] = fiu_st.size();
            init();
            assert(fiu_st[nod] != 0);
        }
        propaga(nod, st, dr);///daca st == dr nu se va ajunge aici
        int mij((st + dr)>>1), ans(0);
        if (x <= mij)
            Adauga(fiu_st[nod], st, mij);
        if (y > mij)
            Adauga(fiu_dr[nod], mij + 1, dr);
        num[nod] = max(num[fiu_st[nod]], num[fiu_dr[nod]]);
    }

    int Query(int nod = 1, int st = 1, int dr = L - 1) {
        if (x <= st && dr <= y)
            return num[nod];///meh
    }
}

struct Event {
    int x;
    int yst, ydr;
    bool yeet;///1 -> +1; 0 -> -1

    bool operator < (const Event _) const {
        if (x == _.x)
            return yeet < _.yeet;
        return x < _.x;
    }
};

multiset < Event > events;

int main()
{
    int n, w, h, x, y;
    cin >> n >> w >> h;
    for (int i = 1; i <= n; ++i) {
        cin >> x >> y;
        events.insert({x, y, y + h, 1});
        events.insert({x + w + 1, y, y + h, 0});
    }
    Aint_dinamic::Init();
    int ans(0);
    for (Event event : events) {
        Aint_dinamic::x = event.yst;
        Aint_dinamic::y = event.ydr;
        Aint_dinamic::val = (event.yeet ? 1 : -1);
        Aint_dinamic::Adauga();
        Aint_dinamic::x = 1;
        Aint_dinamic::y = L - 1;
        ans = max(ans, Aint_dinamic::Query());
    }
    cout << ans;
    return 0;
}
