#include <bits/stdc++.h>

#include "biggest.h"

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); ++i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order;
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 1e5 + 227;

int a[N];
int t[N * 4];
int pos[N];
//int p[N];

gp_hash_table<pii, int> memo;

//int compare(int x, int y) {
//    if(p[x] > p[y]) return x;
//    else return y;
//}

int combine(int x, int y) {
    if(x == -1e9) return y;
    if(y == -1e9) return x;
    if(memo.find(minmax(x, y)) != memo.end()) return memo[minmax(x, y)];
    memo[minmax(x, y)] = compare(x, y);
    return memo[minmax(x, y)];
}

void build(int v, int tl, int tr) {
    if(tl > tr) return;
    if(tl == tr) {
        t[v] = tl;
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v << 1, tl, tm);
    build(v << 1 | 1, tm + 1, tr);
    t[v] = combine(t[v << 1], t[v << 1 | 1]);
}

void upd(int v, int tl, int tr, int pos) {
    if(tl == tr) {
        t[v] = -1e9;
        return;
    }
    int tm = (tl + tr) >> 1;
    if(pos <= tm) {
        upd(v << 1, tl, tm, pos);
    } else {
        upd(v << 1 | 1, tm + 1, tr, pos);
    }
    t[v] = combine(t[v << 1], t[v << 1 | 1]);
}

vector<int> biggest(int N, int K) {
//    fr(i, 1, N) a[i] = compare(i, i), pos[a[i]] = i;

    build(1, 1, N);
    ve<int> ans;
    while(sz(ans) < K) {
        ans.pb(t[1]);
        upd(1, 1, N, t[1]);
    }
    return ans;
}
//
//int main() {
//    int n;
//    cin >> n;
//    int k;
//    cin >> k;
//
//    fr(i, 1, n) p[i] = i;
//    shuffle(p + 1, p + 1 + n, rng);
//
//    fr(i, 1, n) cout << p[i] << " ";
//    cout << "\n";
//
//    ve<int> ans = biggest(n, k);
//
//    fe(x, ans) {
//        cout << x << " ";
//    }
//    cout << "\n";
//}
