#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); ++i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order;
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 5e4 + 227;
const int M = 5e5 + 227;

int n, m;
int a[N];
ll sum[N];
ll ans;
multiset<ll> s;
ve<int> divisors[N];
ll without[N];
ll bst[N];
pair<int, ll> query[M];

int main() {
#ifndef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n;

    fr(i, 1, n) {
        cin >> a[i];
    }

    cin >> m;

    bool subtask = 1;
    fr(i, 0, m - 1) {
        int p;
        ll x;
        cin >> p >> x;
        query[i] = {p, x};
        subtask &= x >= 0;
    }

    fr(i, 1, n) {
        for(int j = i; j <= n; j += i) {
            divisors[j].pb(i);
            sum[i] += a[j];
        }
    }

    fr(i, 1, n) {
        bst[i] = -1e18;
        fe(j, divisors[i]) {
            umx(bst[i], sum[j]);
        }
    }


//    if(subtask) {
//        ll mx_sum = -1e18;
//        fr(i, 1, n) umx(mx_sum, sum[i]);
//
//        ll ans = 0;
//        fr(i, 0, m - 1) {
//            int p = query[i].fi;
//            ll x = query[i].se;
//
//            ans += max(mx_sum, bst[p] + x);
//        }
//
//        cout << ans << "n";
//
//        return 0;
//    }

    fr(i, 1, n) s.insert(sum[i]);

    fr(i, 1, n) {
        fe(j, divisors[i]) {
            s.erase(s.find(sum[j]));
        }
        without[i] = (sz(s) ? *s.rbegin() : -1e18);
        fe(j, divisors[i]) {
            s.insert(sum[j]);
        }
    }

    fr(i, 0, m - 1) {
        int p = query[i].fi;
        ll x = query[i].se;

        ll best = without[p];
        umx(best, bst[p] + x);

        ans += best;
    }

    cout << ans << "\n";

    cerr << "Execution time " << (ld)clock() / CLOCKS_PER_SEC << "sec\n";

    return 0;
}

/*
6
2 -5 3 2 -1 4
2
3 -4
2 3
*/
