#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <iomanip>

using namespace std;

map<pair<int, int>, int> d;

int compare(int x, int y);

vector<int> quick_sort(vector<int> &curr, int k) {
    if (curr.empty()) {
        return {};
    }
    if (curr.size() == 1) {
        return {curr[0]};
    }
    int m = rand() % curr.size();
    vector<int> left, right;
    for(int i = 0; i < curr.size(); ++i) {
        if (i == m) {
            left.push_back(curr[i]);
            continue;
        }
        int l;
        if (d.count({curr[i], curr[m]})) {
            l = d[{curr[i], curr[m]}];
        }
        else {
            l = compare(curr[i], curr[m]);
            d[{curr[i], curr[m]}] = l;
            d[{curr[m], curr[i]}] = l;
        }
        if (curr[m] == l) {
            left.push_back(curr[i]);
        }
        else {
            right.push_back(curr[i]);
        }
    }
    right = quick_sort(right, k);
    vector<int> ans;
    int j = 0;
    for(int i = (int)(right.size()) - 1; i >= 0; --i) {
        if (j >= k) {
            break;
        }
        ans.push_back(right[i]);
        ++j;
    }
    left = quick_sort(left, k - ((int)right.size()));
    for(int i = (int)(left.size()) - 1; i >= 0; --i) {
        if (j >= k) {
            break;
        }
        ans.push_back(left[i]);
        ++j;
    }
    return ans;
}

vector<int> biggest(int n, int k) {
    vector<int> p;
    for(int i = 0; i < n; ++i) {
        p.push_back(i + 1);
    }
    return quick_sort(p, k);
}