#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <iomanip>
#include "biggest.h"

using namespace std;

map<pair<int, int>, int> d;

int compare(int x, int y);

bool cmp(int a, int b) {
    int x;
    if (!d.count({b, a})) {
        x = compare(b, a);
        d[{b, a}] = x;
    }
    else {
        x = d[{b, a}];
    }
    return b == x;
}

vector<int> biggest(int n, int k) {
    vector<int> a(n);
    for(int i = 0; i < n; ++i) {
        a[i] = i + 1;
    }
    nth_element(a.rbegin(), a.rbegin() + (k - 1), a.rend(), cmp);
    sort(a.rbegin(), a.rbegin() + (k - 1), cmp);
    vector<int> ans;
    for(int i = 0; i < k; ++i) {
        ans.push_back(a[i]);
    }
    return ans;
}
