#include<iostream>
#include <stdio.h>
#include <vector>
#include <random>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;
map<pair<int, int>, int> d;

bool compare(int x, int y);

int N;

bool cmp(int a, int b) {
    int x;
    assert(a > 0 && b > 0 && a <= N && b <= N);
    if (!d.count({b, a})) {
        x = compare(b, a);
        d[{b, a}] = x;
        d[{a, b}] = x;
    }
    else {
        x = d[{b, a}];
    }
    return b != x;
}

vector<int> biggest(int n, int k) {
    N = n;
    vector<int> a(n);
    for(int i = 0; i < n; ++i) {
        a[i] = i + 1;
    }
    nth_element(a.begin(), a.begin() + (k - 1), a.end(), cmp);
    sort(a.begin(), a.begin() + (k - 1), cmp);
    vector<int> ans;
    for(int i = 0; i < k; ++i) {
        ans.push_back(a[i]);
    }
    return ans;
}