#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <iomanip>

using namespace std;

map<pair<int, int>, int> d;

int compare(int x, int y);
vector<int> merge_sort(int l, int r, int k) {
    if (l + 1 == r) {
        return {l + 1};
    }
    int m = (l + r) / 2;
    vector<int> left = merge_sort(l, m, k);
    vector<int> right = merge_sort(m, r, k);
    vector<int> ans;
    int ptr = 0, ptr1 = 0;
    for (int i = 0; i < k; ++i) {
        int l;
        if (ptr < left.size() && ptr1 < right.size()) {
            if (!d.count({left[ptr], right[ptr1]})) {
                l = compare(left[ptr], right[ptr1]);
                d[{left[ptr], right[ptr1]}] = l;
                d[{right[ptr1], left[ptr]}] = l;
            }
            else {
                l = d[{left[ptr], right[ptr1]}];
            }
        }
        else if (ptr < left.size()) {
            l = left[ptr];
        }
        else if (ptr1 < right.size()) {
            r = right[ptr1];
        }
        else {
            break;
        }
        if (l == left[ptr]) {
            ans.push_back(left[ptr++]);
        } else {
            ans.push_back(right[ptr1++]);
        }

    }
    return ans;
}

vector<int> biggest(int n, int k) {
    return merge_sort(0, n, k);
}