#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <iomanip>
#include <random>
#include <cassert>

using namespace std;

mt19937 rnd;

int compare(int x, int y);

const int magic = 200;

vector<int> biggest(int n, int k) {
    vector<int> p;
    for (int i = 0; i < n; ++i) {
        p.push_back(i + 1);
    }
    vector<int> curr;
    vector<vector<int>> blocks(1);
    int counter = 0;
    for(int i = 0; i < n; ++i) {
        int l = -1, r = curr.size();
        if (counter) {
            int x = compare(blocks[0][0], i + 1);
            if (x == blocks[0][0]) {
                blocks[0].insert(blocks[0].begin(), i + 1);
            }
            else {
                int l = -1, r = blocks.size() - 1;
                while(l + 1 < r) {
                    int m = (l + r) / 2;
                    if (compare(i + 1, blocks[m].back()) == i + 1) {
                        l = m;
                    }
                    else {
                        r = m;
                    }
                }
                l = 0;
                int num = r;
                r = blocks[r].size();
                while(l + 1 < r) {
                    int m = (l + r) / 2;
                    if (compare(blocks[num][m], i + 1) == i + 1) {
                        l = m;
                    }
                    else {
                        r = m;
                    }
                }
                blocks[num].insert(blocks[num].begin() + l + 1, i + 1);
            }
        }
        else {
            blocks[0].insert(blocks[0].begin(), i + 1);
        }
        ++counter;
        if (counter > k) {
            --counter;
            blocks[0].erase(blocks[0].begin());
        }
        if ((i + 1) % 400 == 0 || blocks[0].size() == 0) {
            int all = 0;
            for(int i = 0; i < blocks.size(); ++i) {
                all += blocks[i].size();
            }
            vector<vector<int>> lol((all + magic - 1) / magic);
            int cnt = 0;
            for(int i = 0; i < blocks.size(); ++i) {
                for(int j : blocks[i]) {
                    lol[cnt / magic].push_back(j);
                    ++cnt;
                }
            }
            blocks = lol;
        }
    }
    for(int i = 0; i < blocks.size(); ++i) {
        for(int j : blocks[i]) {
            curr.push_back(j);
        }
    }
    reverse(curr.begin(), curr.end());
    return curr;
}