#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <iomanip>
#include <random>
#include <cassert>

using namespace std;

int compare(int x, int y);

vector<int> biggest(int n, int k) {
    srand(time(0));
    vector<int> p;
    for (int i = 0; i < n; ++i) {
        p.push_back(i + 1);
    }
    vector<int> curr;
    vector<int> all(n);
    for(int i = 0; i < n; ++i) {
        all[i] = i;
    }
    random_shuffle(all.begin(), all.end());
    for(int i : all) {
        int l = -1, r = curr.size();
        if (curr.size()) {
            int x = compare(curr[0], i + 1);
            if (x == curr[0]) {
                r = 0;
            }
            else {
                l = 0;
            }
        }
        while(l + 1 < r) {
            int m = (l + r) / 2;
            int x = compare(curr[m], i + 1);
            if (x == curr[m]) {
                r = m;
            }
            else {
                l = m;
            }
        }
        curr.insert(curr.begin() + l + 1, i + 1);
        if (curr.size() > k) {
            curr.erase(curr.begin());
        }
    }
    reverse(curr.begin(), curr.end());
    return curr;
}