#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <iomanip>

using namespace std;

#define int long long
int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> s(n);
    vector<int> a(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for(int i = 1; i <= n; ++i) {
        for(int j = i; j <= n; j += i) {
            s[i - 1] += a[j - 1];
        }
    }
    multiset<int> st;
    for(int i : s) {
        st.insert(i);
    }
    int m;
    cin >> m;
    vector<bool> ok(n, false);
    vector<vector<int>> divs(n);
    for(int i = 1; i <= n; ++i) {
        int j = 1;
        while(j * j <= i) {
            if (i % j == 0) {
                divs[i - 1].push_back(j);
                divs[i - 1].push_back(i / j);
            }
            ++j;
        }
        sort(divs[i - 1].begin(), divs[i - 1].end());
        divs[i - 1].resize(unique(divs[i - 1].begin(), divs[i - 1].end()) - divs[i - 1].begin());
    }
    int sum = 0;
    for(int i = 0; i < m; ++i) {
        int p, k;
        cin >> p >> k;
        int j = 1;
        for(int i : divs[p - 1]) {
            if (!ok[i - 1]) {
                st.erase(st.find(s[i - 1]));
                st.insert(s[i - 1] + k);
                ok[i - 1] = true;
            }
        }
        sum += *st.rbegin();
        for(int i : divs[p - 1]) {
            if (ok[i - 1]) {
                st.erase(st.find(s[i - 1] + k));
                st.insert(s[i - 1]);
            }
            ok[i - 1] = false;
        }
    }
    cout << sum << '\n';
    return 0;
}
