#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <iomanip>

using namespace std;

#define int long long

int st[17][(1 << 16)];
int logg[(1 << 16)];

void build(int n, vector<int> &a) {
    for(int i = 0; i < n; ++i) {
        st[0][i] = a[i];
    }
    for(int i = 1; i < 17; ++i) {
        for(int j = 0; j  + (1 << i)  - 1 < n; ++j) {
            st[i][j] = max(st[i - 1][j], st[i - 1][j + (1 << (i - 1))]);
        }
    }
    logg[1] = 0;
    for(int i = 2; i < (1 << 16); ++i) {
        logg[i] = logg[i / 2] + 1;
    }
}

inline int get(int l, int r) {
    int len = r - l + 1;
    return max(st[logg[len]][l], st[logg[len]][r - (1 << logg[len] + 1)]);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> s(n);
    vector<int> a(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for(int i = 1; i <= n; ++i) {
        for(int j = i; j <= n; j += i) {
            s[i - 1] += a[j - 1];
        }
    }
    int m;
    cin >> m;
    vector<bool> ok(n, false);
    vector<vector<int>> divs(n);
    for(int i = 1; i <= n; ++i) {
        int j = 1;
        while(j * j <= i) {
            if (i % j == 0) {
                divs[i - 1].push_back(j);
                divs[i - 1].push_back(i / j);
            }
            ++j;
        }
        sort(divs[i - 1].begin(), divs[i - 1].end());
        divs[i - 1].resize(unique(divs[i - 1].begin(), divs[i - 1].end()) - divs[i - 1].begin());
    }
    int sum = 0;
    build(n, s);
    for(int i = 0; i < m; ++i) {
        int p, k;
        cin >> p >> k;
        int j = 1;
        int maxx_all = -1e18, max_ch = -1e18;
        for(int i : divs[p - 1]) {
                max_ch = max(max_ch, s[i - 1] + k);
        }
        if (divs[p - 1][0] != 1) {
            maxx_all = get(0, divs[p - 1][0] - 2);
        }
        if (divs[p - 1].back() != n) {
            maxx_all = max(maxx_all, get(divs[p - 1].back(), n - 1));
        }
        for(int i = 0; i + 1 < divs[p - 1].size(); ++i) {
            if (divs[p - 1][i] + 1 != divs[p - 1][i + 1]) {
                maxx_all = max(maxx_all, get(divs[p - 1][i], divs[p - 1][i + 1] - 2));
            }
        }
        sum += max(maxx_all, max_ch); //  get_max
    }
    cout << sum << '\n';
    return 0;
}
