#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <stdio.h>
#include <array>
#include <cmath>
#include <iomanip>

using namespace std;

#define int long long

int st[17][(1 << 16)];
int logg[(1 << 16)];

void build(int n, int *a) {
    for (int i = 0; i < n; ++i) {
        st[0][i] = a[i];
    }
    for (int i = 1; i < 17; ++i) {
        for (int j = 0; j + (1 << i) - 1 < n; ++j) {
            st[i][j] = max(st[i - 1][j], st[i - 1][j + (1 << (i - 1))]);
        }
    }
    logg[1] = 0;
    for (int i = 2; i < (1 << 16); ++i) {
        logg[i] = logg[i / 2] + 1;
    }
}

inline int get(int l, int r) {
    int len = r - l + 1;
    return max(st[logg[len]][l], st[logg[len]][r - (1 << logg[len]) + 1]);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //   O(n \sqrt n + m)
    int n;
    cin >> n;
    int s[50000];
    int a[50000];
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = i; j <= n; j += i) {
            s[i - 1] += a[j - 1];
        }
    }
    int m;
    cin >> m;
    vector<bool> ok(n, false);
    vector<int> divs[50000];
    for (int i = 1; i <= n; ++i) {
        int j = 1;
        while (j * j <= i) {
            if (i % j == 0) {
                divs[i - 1].push_back(j);
                divs[i - 1].push_back(i / j);
            }
            ++j;
        }
        sort(divs[i - 1].begin(), divs[i - 1].end()); // maybe this is too slow
        divs[i - 1].resize(unique(divs[i - 1].begin(), divs[i - 1].end()) - divs[i - 1].begin());
    }
    int sum = 0;
    build(n, s);
    pair<int, int> kek[50000];
    for (int i = 0; i < n; ++i) { //  this is ok
        int p = i + 1;
        int j = 1;
        int maxx_all = -1e18, max_ch = -1e18;
        for (int i : divs[p - 1]) {
            max_ch = max(max_ch, s[i - 1]);
        }
        if (divs[p - 1][0] != 1) {
            maxx_all = get(0, divs[p - 1][0] - 2);
        }
        if (divs[p - 1].back() != n) {
            maxx_all = max(maxx_all, get(divs[p - 1].back(), n - 1));
        }
        for (int i = 0; i + 1 < divs[p - 1].size(); ++i) {
            if (divs[p - 1][i] + 1 != divs[p - 1][i + 1]) {
                int l, r;
                l = divs[p - 1][i], r = divs[p - 1][i + 1] - 2;
                int len = r - l + 1;
                maxx_all = max(maxx_all, max(st[logg[len]][l], st[logg[len]][r - (1 << logg[len]) + 1]));
            }
        }
        kek[i] = {maxx_all, max_ch};
    }
    for (int i = 0; i < m; ++i) {
        int p, s;
        cin >> p >> s;
        sum += max(kek[p - 1].first, kek[p - 1].second + s);
    }
    cout << sum;
    return 0;
}