#include "biggest.h"
#include <vector>
#include <map>
using namespace std;

#define ll long long
#define add push_back
#define all(a) a.begin(), a.end()
#define pii pair<int, int>
#define pll pair<long long, long long>
#define fr first
#define sc second

const int N = 100005;

int b[N];

vector<int> biggest(int n, int k){
	vector<int> ret(k, 0);
	int done = 0;
	for(int i = 1; i <= n; i++){
		for(int j = i + 1; j <= n; j++){
			int ans = compare(i, j);
			// q[pii(i, j)] = q[pii(j, i)] = ans;
			b[ans]++;
		}
		if(b[i] >= n - k){
			ret[n - b[i] - 1] = i;
			done++;
		}
		if(done >= k){
			break;
		}
	}
	return ret;
}

// const int N = 1005;

// int b[N], l[N], r[N];
// bool used[N];

// void first_stage(int ind, int n){
// 	if(ind == n){
// 		return;
// 	}
// 	int ans = compare(ind, ind + 1);
// 	if (ans == ind){
// 		first_stage(ind + 1, n);
// 		r[ind] = b[ind + 1] + 1;
// 		b[ind] += b[ind + 1] + 1;
// 	}
// 	else {
// 		b[ind + 1] = b[ind] + 1;
// 		l[ind + 1] = b[ind] + 1;
// 		first_stage(ind + 1, n);
// 	}
// }

// vector<int> biggest(int n, int k){
// 	vector<int> ret;
// 	first_stage(1, n);
// 	int goal = n - 1;
// 	while(true){
// 		int fr_index = 0;
// 		for(int i = 1; i <= n; i++){
// 			if(b[i] >= b[fr_index] && !used[i]){
// 				fr_index = i;
// 			}
// 		}
// 		int index = 0;
// 		for(int i = 1; i < fr_index - l[fr_index]; i++){
// 			if(b[i] >= b[index] && !used[i]){
// 				index = i;
// 			}
// 		}
// 		for(int i = fr_index + r[fr_index] + 1; i <= n; i++){
// 			if(b[i] >= b[index] && !used[i]){
// 				index = i;
// 			}
// 		}
// 		int ans = compare(fr_index, index);
// 		if(ans == fr_index){
// 			if(index > fr_index){
// 				if(fr_index + r[fr_index] == index - l[index]){
// 					b[fr_index] += b[index] - 1;
// 					r[fr_index] = (index + r[index]) - fr_index;
// 				}
// 				else {
// 					b[fr_index] += b[index];
// 					r[fr_index] = (index + r[index]) - fr_index;
// 				}
// 			}
// 			else {
// 				if(fr_index - l[fr_index] == index + l[index]){
// 					b[fr_index] += b[index] - 1;
// 					l[fr_index] = fr_index - (index - l[index]);
// 				}
// 				else {
// 					b[fr_index] += b[index];
// 					l[fr_index] = fr_index - (index - l[index]);
// 				}
// 			}
// 			if(b[fr_index] >= goal){
// 				used[fr_index] = true;
// 				ret.add(fr_index);
// 				goal--;
// 			}
// 		}
// 		else {
// 			if(index < fr_index){
// 				if(index + r[index] == fr_index - l[fr_index]){
// 					b[index] += b[fr_index] - 1;
// 					r[index] = (fr_index + r[fr_index]) - index;
// 				}
// 				else {
// 					b[index] += b[fr_index];
// 					r[index] = (fr_index + r[fr_index]) - index;
// 				}
// 			}
// 			else {
// 				if(index - l[index] == fr_index + l[fr_index]){
// 					b[index] += b[fr_index] - 1;
// 					l[index] = index - (fr_index - l[fr_index]);
// 				}
// 				else {
// 					b[index] += b[fr_index];
// 					l[index] = index - (fr_index - l[fr_index]);
// 				}
// 			}
// 			if(b[index] >= goal){
// 				used[index] = true;
// 				ret.add(index);
// 				goal--;
// 			}
// 		}
// 		if(goal == n - k - 1){
// 			break;
// 		}
// 	}
// 	return ret;
// }