#include <bits/stdc++.h>

#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize ("O3")
#pragma GCC target("avx")

#define pb push_back
#define pii pair <int, int>
#define F first
#define S second
#define int long long
using namespace std;

const int N = 100010 * 5;
int t[N];

void update(int v, int tl, int tr, int l, int r, int s)
{
    if (tl >= l && tr <= r)
    {
        t[v] += s;
        return;
    }

    if (tl > r || tr < l) return;

    int mid = (tl + tr) / 2;
    update(v * 2, tl, mid, l, r, s);
    update(v * 2 + 1, mid + 1, tr, l, r, s);

    t[v] = max(t[v * 2], t[v * 2 + 1]);
    return;
}

int32_t main()
{
    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #endif LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector < int > a(n);

    for (int i = 0; i < n; i++) cin >> a[i];


    int k = 1;
    while (k <= n) k *= 2;
    vector< int > ans(n, 0);

    for (int i = 0; i < n; i++)
    {
        for (int j = i; j < n; j+= i + 1)
            ans[i] += a[j];
    }


    for (int i = k; i < k + n; i++)
        t[i] = ans[i - k];

    for (int i = k + n; i < k * 2; i++) t[i] = t[i - 1];


    for (int i = k - 1; i >= 1; i--)
        t[i] = max(t[i * 2], t[i * 2 + 1]);

    int m;
    cin >> m;


    int sum = 0;


    for (int i = 0; i < m; i++)
    {
        int x, s;
        cin >> x >> s;


        int u = 2;


        vector < int > v;
        v.pb(1);
        if (x != 1) v.pb(x);
        while (u * u <= x)
        {
            if (x % u == 0)
            {
                v.pb(u);
                if (x / u != u) v.pb(x / u);
            }
        }


        for (auto to: v)
        {
            update(1, 1, k, to, to, s);
        }


        sum += t[1];


        for (auto to: v)
        {
            update(1, 1, k, to, to, -1 * s);
        }






    }


    cout << sum;
    return 0;
}
