#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include "unordered_set"
#include "map"
#include "climits"
#define int long long
using namespace std;
vector<vector<int>> g;
vector<vector<int>> gobr;
vector<int> val;
vector<int> startres;
vector<int> notmeval;
int f1(int x){
    int opt = 1;
    for (int i = 2; i * i <= x; ++i) {
        int k = 1;
        while(x % i == 0){
            x /= i;
            k++;
        }
        opt *= k;
    }
    if(x != 1)
        opt *= 2;
    return opt;
}
void dfs(int v){
    if(val[v] != LONG_LONG_MIN)
        return;
    val[v] = startres[v];
    for (auto i : g[v]) {
        dfs(i);
        val[v] = max(val[v], val[i]);
    }
}
vector<int> solve(int x){
    int orgx = x;
    vector<int> ans;
    for (int i = 2; i * i <= x; ++i) {
        int k = 0;
        while(x % i == 0) {
            x /= i;
            k++;
        }
        if(k)
            ans.push_back(orgx / i);
    }
    if(x != 1 and orgx != x)
        ans.push_back(orgx / x);
    return ans;
}
signed main(){
    ios::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n, 0);
    for(auto &i : a)
        cin >> i;
    g.assign(n + 1, {});
    gobr.assign(n + 1, {});
    for (int i = 2; i <= n; ++i) {
        g[i] = solve(i);
        for(auto t : g[i])
            gobr[t].push_back(i);
        //cout << endl;
    }
    int mx = -1e17;
    startres.assign(n + 1, 0);
    for (int i = 1; i <= n; ++i) {
        for (int j = i - 1; j < n; j += i) {
            startres[i] += a[j];
        }
        mx = max(startres[i], mx);
        //cout << startres[i] << ' ';
    }
    //cout << endl;
    notmeval.assign(n + 1, LONG_LONG_MIN);
    val.assign(n + 1, LONG_LONG_MIN);
    for (int k = 2; k <= n; ++k) {
        dfs(k);
        //cout << val[k] << ' ';
    }
    //cout << endl;
    vector<pair<int, int>> nums;
    for (int i = 2; i <= n; ++i) {
        nums.push_back({startres[i], i});
    }
    sort(nums.rbegin(), nums.rend());
    for (int i = 1; i <= n; ++i) {
        for (int j = 0;; ++j) {
            if(j > n) {
                cout << i;
                return 179;
            }
            if(i % nums[j].second != 0) {
                //cout << i << ' ' << nums[j].second << ' ' << nums[j].first << endl;
                notmeval[i] = nums[j].first;
                break;
            }
        }
    }
    int t;
    int ans = 0;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        int p, s;
        cin >> p >> s;
        if(s >= 0)
            ans += max(mx, max(val[p], startres[1]) + s);
        else
            ans += max(notmeval[p], max(val[p], startres[1]) + s);
    }
    cout << ans;
}