#include "biggest.h"
#include <bits/stdc++.h>
using namespace std;

void part_sort(vector<int>& arr, int k){
    if(!k){
        arr.clear();
        return;
    } else if(arr.size() <= 1){
        return;
    } else if(k == 1){
        int max_i = 0;
        for(int i = 1; i < arr.size(); i++){
            if(compare(arr[i], arr[max_i]) == arr[i]){
                max_i = i;
            }
        }
        arr = {arr[max_i]};
        return;
    } else if(k == 2){
        int max_i = 0, prev_max_i = 1;
        if(compare(arr[0], arr[1]) == arr[1]){
            swap(max_i, prev_max_i);
        }
        for(int i = 2; i < arr.size(); i++){
            if(compare(arr[max_i], arr[i]) == arr[i]){
                prev_max_i = max_i;
                max_i = i;
            } else if(compare(arr[prev_max_i], arr[i]) == arr[i]){
                prev_max_i = i;
            }
        }
        arr = {arr[max_i], arr[prev_max_i]};
    } else if(k >= arr.size() / 2 && arr.size() <= 1e3){
        vector<int> sorted = {arr[0]};
        for(int i = 1; i < arr.size(); i++){
            int lb = 0, ub = sorted.size() + 1;
            while(ub - lb > 1){
                int mb = (lb + ub) / 2;
                if(compare(sorted[mb - 1], arr[i]) == arr[i]){
                    lb = mb;
                } else {
                    ub = mb;
                }
            }
            sorted.insert(sorted.begin() + lb, arr[i]);
        }
        reverse(sorted.begin(), sorted.end());
        while(sorted.size() > k){
            sorted.pop_back();
        }
        arr = sorted;
        return;
    }
    int m = arr.size() / 2;
    vector<int> l, r;
    mt19937 rng(time(0));
    int i = (arr.size() + rng() % arr.size()) % arr.size();
    int x = arr[i];
    for(int j = 0; j < arr.size(); j++){
        if(j != i){
            if(compare(x, arr[j]) == x){
                l.push_back(arr[j]);
            } else {
                r.push_back(arr[j]);
            }
        }
    }
    part_sort(r, min(int(r.size()), k));
    part_sort(l, max(0, k - int(r.size()) - 1));
    arr.clear();
    for(auto y : r){
        arr.push_back(y);
    }
    if(r.size() < k){
        arr.push_back(x);
        for(auto y : l){
            arr.push_back(y);
        }
    }
}

std::vector<int> biggest(int n, int k){
    vector<int> arr(n);
    for(int i = 0; i < n; i++){
        arr[i] = i + 1;
    }
    part_sort(arr, k);
    return arr;
}
