#include "biggest.h"
#include <bits/stdc++.h>
using namespace std;

void part_sort(vector<int>& arr, int k){
    int n = arr.size();
    if(!k){
        arr.clear();
        return;
    } else if(n <= 1){
        return;
    } else if(k <= log2(n) / 2){
        vector<int> ans;
        for(int i = 0; i < k; i++){
            ans.push_back(arr[i]);
        }
        part_sort(ans, k);
        for(int i = k; i < n; i++){
            for(int j = 0; j < k; j++){
                if(compare(ans[j], arr[i]) == arr[i]){
                    for(int j_ = k - 1; j_ > j; j_--){
                        ans[j_] = ans[j_ - 1];
                    }
                    ans[j] = arr[i];
                    j = k;
                }
            }
        }
        arr = ans;
        return;
    } else if(k >= n * 2 / 3 && n <= 4e3){
        vector<int> sorted = {arr[0]};
        for(int i = 1; i < n; i++){
            int lb = 0, ub = sorted.size() + 1;
            while(ub - lb > 1){
                int mb = (lb + ub) / 2;
                if(compare(sorted[mb - 1], arr[i]) == arr[i]){
                    lb = mb;
                } else {
                    ub = mb;
                }
            }
            sorted.insert(sorted.begin() + lb, arr[i]);
        }
        reverse(sorted.begin(), sorted.end());
        while(sorted.size() > k){
            sorted.pop_back();
        }
        arr = sorted;
        return;
    }
    vector<int> l, r;
    mt19937 rng(time(0));
    int i = (n + rng() % n) % n;
    int x = arr[i];
    for(int j = 0; j < n; j++){
        if(j != i){
            if(compare(x, arr[j]) == x){
                l.push_back(arr[j]);
            } else {
                r.push_back(arr[j]);
            }
        }
    }
    part_sort(r, min(int(r.size()), k));
    part_sort(l, max(0, k - int(r.size()) - 1));
    arr.clear();
    for(auto y : r){
        arr.push_back(y);
    }
    if(r.size() < k){
        arr.push_back(x);
        for(auto y : l){
            arr.push_back(y);
        }
    }
}

std::vector<int> biggest(int n, int k){
    vector<int> arr(n);
    for(int i = 0; i < n; i++){
        arr[i] = i + 1;
    }
    part_sort(arr, k);
    return arr;
}
