#include <iostream>
#include <algorithm>
#include <set>
using namespace std;
#pragma warning(disable : 4996)

const int N = 5e5, M = 5e5;
const long long inf = 2e13;

int n, m;
long long a[N], b[N], c[N];
long long t[2 * N];
int chr[2 * N], chl[2 * N];
int index = 1;

long long merge(long long a, long long b) {
	return max(a, b);
}

void build(long long arr[], int v = 1, int tl = 1, int tr = n) {
	if (tl == tr) {
		t[v] = arr[tl];
		return;
	}
	int tm = (tl + tr) / 2;
	chl[v] = ++index;
	build(arr, chl[v], tl, tm);
	chr[v] = ++index;
	build(arr, chr[v], tm + 1, tr);
	t[v] = merge(t[chl[v]], t[chr[v]]);
}

void update(int p, long long x, int v = 1, int tl = 1, int tr = n) {
	if (tl == tr) {
		t[v] += x;
		return;
	}
	int tm = (tl + tr) / 2;
	if (p <= tm) {
		update(p, x, chl[v], tl, tm);
	}
	else {
		update(p, x, chr[v], tm + 1, tr);
	}
	t[v] = merge(t[chl[v]], t[chr[v]]);
}

int main() {
	fill(c, c + N, -inf);
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}
	for (int i = 1; i <= n; i++) {
		b[1] += a[i];
		if (i != 1) {
			b[i] += a[i];
		}
		for (int j = 2; j * j <= i; j++) {
			if (i % j == 0) {
				b[j] += a[i];
				if (j != (i / j)) {
					b[i / j] += a[i];
				}
			}
		}
	}
	for (int i = 1; i <= n; i++) {
		c[i] = max(b[i], b[1]);
		for (int j = 2; j * j <= i; j++) {
			if (i % j == 0) {
				c[i] = max(c[i], b[j]);
				c[i] = max(c[i], b[i / j]);
			}
		}
	}
	for (int i = 1; i <= n; i++) {
		cout << c[i] << " ";
	}
	cout << endl;
	build(c);
	long long ans = 0;
	cin >> m;
	for (int i = 0; i < m; i++) {
		int p;
		long long x;
		cin >> p >> x;
		update(p, x);
		ans += t[1];
		//cout << t[1] << endl;
		update(p, -x);
	}
	cout << ans << endl;
}


/*
6
2 -5 3 2 -1 4
2
3 4
2 3
*/