#include <iostream>
#include <algorithm>
using namespace std;
#pragma warning(disable : 4996)

const int N = 5e5, M = 5e5;
const long long inf = 2e13;

int n, m;
long long a[N], b[N], c[N];
long long ans = 0;

long long t[2 * N];
int chr[2 * N], chl[2 * N];
int index = 1;

long long merge(long long a, long long b) {
	return max(a, b);
}

void build(long long arr[], int v = 1, int tl = 1, int tr = n) {
	if (tl == tr) {
		t[v] = arr[tl];
		return;
	}
	int tm = (tl + tr) / 2;
	chl[v] = ++index;
	build(arr, chl[v], tl, tm);
	chr[v] = ++index;
	build(arr, chr[v], tm + 1, tr);
	t[v] = merge(t[chl[v]], t[chr[v]]);
}

long long queue(int p, long long x, int v = 1, int tl = 1, int tr = n) {
	if (tl == tr) {
		if (tl == p) {
			return t[v] + x;
		}
		else {
			return t[v];
		}
	}
	int tm = (tl + tr) / 2;
	if (p <= tm) {
		return merge(queue(p, x, chl[v], tl, tm), t[chr[v]]);
	}
	else {
		return merge(t[chl[v]], queue(p, x, chr[v], tm + 1, tr));
	}
}

int main() {
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}
	cin >> m;
	for (int i = 1; i <= n; i++) {
		b[1] += a[i];
		if (i != 1) {
			b[i] += a[i];
		}
		for (int j = 2; j * j <= i; j++) {
			if (i % j == 0) {
				b[j] += a[i];
				if (j != (i / j)) {
					b[i / j] += a[i];
				}
			}
		}
	}

	if (n <= 5000 && m <= 5000) {
		for (int i = 0; i < m; i++) {
			int p;
			long long x;
			cin >> p >> x;
			long long ansForM = -inf;
			for (int j = 1; j <= n; j++) {
				ansForM = max(ansForM, b[j] + (p % j == 0) * x);
			}
			ans += ansForM;
		}
	}
	else if (n <= 15000 && m <= 3500) {
		for (int i = 0; i < m; i++) {
			int p;
			long long x;
			cin >> p >> x;
			long long ansForM = -inf;
			for (int j = 1; j <= n; j++) {
				ansForM = max(ansForM, b[j] + (p % j == 0) * x);
			}
			ans += ansForM;
		}
	}
	else {
		fill(c, c + N, -inf);
		for (int i = 1; i <= n; i++) {
			c[i] = max(b[i], b[1]);
			for (int j = 2; j * j <= i; j++) {
				if (i % j == 0) {
					c[i] = max(c[i], b[j]);
					c[i] = max(c[i], b[i / j]);
				}
			}
		}
		build(c);
		for (int i = 0; i < m; i++) {
			int p;
			long long x;
			cin >> p >> x;
			ans += queue(p, x);
		}
	}

	cout << ans << endl;
}