#include "biggest.h"
#include <bits/stdc++.h>

using namespace std;

/*int compare(int x, int y) {
    cout << x << ' ' << y << "\n";
    int res;
    cin >> res;
    return res;
}*/

vector <int> seg_sort(int l, int r) {
    if (r == l) {
        return {l + 1};
    }
    vector <int> a = seg_sort(l, (l + r) / 2);
    vector <int> b = seg_sort((l + r) / 2 + 1, r);
    int ind1 = 0, ind2 = 0;
    int l1 = ((l + r) / 2 - l + 1);
    int l2 = (r - l + 1) - l1;
    vector <int> res(r - l + 1);
    for (int i = 0; i < r - l + 1; ++i) {
        if (ind1 == l1) {
            res[i] = b[ind2];
            ind2++;
        } else if (ind2 == l2) {
            res[i] = a[ind1];
            ind1++;
        } else if (compare(a[ind1], b[ind2]) == a[ind1]) {
            res[i] = a[ind1];
            ind1++;
        } else {
            res[i] = b[ind2];
            ind2++;
        }
    }
    return res;
}

vector <int> biggest(int N, int K) {
    int n = N, k = K;
    if (k == 1) {
        int an = 1;
        for (int i = 2; i <= n; ++i) {
            if (compare(an, i) == i) {
                an = i;
            }
        }
        return {an};
    }
    vector <int> an(k);
    vector <int> mid_an(k);
    for (int i = 0; i < n; i += k) {
        vector <int> res = seg_sort(i, min(n, i + k) - 1);
        if (i == 0) {
            for (int j = 0; j < k; ++j) {
                an[j] = res[j];
            }
        } else {
            int l = min(n, i + k) - i;
            int ind1 = 0, ind2 = 0;
            for (int j = 0; j < k; ++j) {
                if (ind1 == k) {
                    mid_an[j] = res[ind2];
                    ind2++;
                } else if (ind2 == l) {
                    mid_an[j] = an[ind1];
                    ind1++;
                } else if (compare(an[ind1], res[ind2]) == an[ind1]) {
                    mid_an[j] = an[ind1];
                    ind1++;
                } else {
                    mid_an[j] = res[ind2];
                    ind2++;
                }
            }
            for (int j = 0; j < k; ++j) {
                an[j] = mid_an[j];
            }
        }
    }
    return an;
}

/*signed main() {
    vector <int> an = biggest(5, 3);
    for (auto el : an) {
        cout << el << ' ';
    }
    return 0;
}*/
