#include <algorithm>
#include <vector>
#include <unordered_set>
#include <iostream>
#include <set>
#include <unordered_map>
using namespace std;
struct pt {
	int x, y;
	pt(int x, int y) {
		this->x = x;
		this->y = y;
	}
	pt(){}
};
vector<int> d;
vector<int> c;
vector<int> dd;
void push(int v) {
	c[2 * v + 1] += c[v];
	c[2 * v + 2] += c[v];
	c[v] = 0;
}
void update(int v,int l,int  r) {
	int m = (l + r) / 2;
	if (d[2 * v + 1] + c[2 * v + 1] > d[2 * v + 2] + (c[2 * v + 2] )) {
		d[v] = d[2 * v + 1] + (c[2 * v + 1]);
	}
	else {
		d[v]=d[2 * v + 2] + (c[2 * v + 2]);
	}
}
void add(int v, int l, int r, int addl, int addr, int val) {
	if (l>addr||r<addl){
		return;
	}
	if (l >= addl && r <= addr) {
		 c[v] += val;
		 return;
	}
	push(v);
	add(2 * v + 1, l, (r + l) / 2, addl, addr, val);
	add(2 * v + 2, (l + r) / 2 + 1, r, addl, addr, val);
	update(v,l,r);
	

}
int ask(int v, int l, int r, int askl, int askr) {
	if (l > askr || r < askl) {
		return 0;;
	}
	if (l >= askl && r <= askr) {
		return d[v]+c[v]*(r-l+1);
	}
	push(v);
	auto aa = ask(2 * v + 1, l, (l + r) / 2, askl, askr);
	auto bb = ask(2 * v + 2, (r + l) / 2 + 1, r, askl, askr);
	update(v,l,r);
	return max(aa, bb);
}

int main() {
	int n;
	cin >> n;
	int w, h;
	cin >> w >> h;
	vector<pt> a(n);
	set<int> shv;
	d.resize(400000);
	dd.resize(400000);
	c.resize(400000);
	unordered_map<int, int> shorten, unshort;
	vector<int> addhlast;
	for (int i = 0; i < n; i++) {
		cin >> a[i].x >> a[i].y;
		shv.insert(a[i].y);
	}
	int iiii = 0;
	for (auto h : shv) {
		shorten[h] = iiii;
		unshort[iiii] = h;
		iiii++;
	}
	int lllid = 0;
	int rrrid = 0;
	addhlast.resize(shv.size());
	for (int i = 0; i < n; i++) {
		a[i].y = shorten[a[i].y];
	}
	sort(a.begin(), a.end(), [&](pt& a, pt& b) {
		return a.x < b.x;
		});

	int ssz = shv.size();

	while (1) {
		addhlast[lllid] = rrrid-1;
		if (lllid == ssz - 1) {
			break;
		}
		if (unshort[rrrid] - unshort[lllid] >h||rrrid==ssz) {
			lllid++;
		}
		else {
			rrrid++;
		}
	}
	



	
	int cmax = 0;
	int rid = 0;
	int lid = 0;
	
	while (1) {
		auto ans = ask(0, 0, 100000, 0, 100000);
		if (ans > cmax) {
			cmax = ans;
		}

		if (rid == n) {
			break;
		}
		if (a[rid].x - a[lid].x > w) {
			add(0, 0, 100000, a[lid].y, addhlast[a[lid].y], -1);
			lid++;
		}
		else {
			
			add(0, 0, 100000, a[rid].y, addhlast[a[rid].y], 1);
			rid++;
		}
	}
	cout << cmax;

	

}