#include<bits/stdc++.h>

using namespace std;

const int N_MAX = 100002;

int compare(int x, int y);

bool cmp (int x, int y)
{
    if(x == 0 || y == 0)
        return y == 0;
    return compare(x, y) == x;
}

int k;

int cnt[N_MAX * 4];

int aux[N_MAX * 4];

void build (int node, int l, int r)
{
    cnt[node] = r - l + 1;
    if(l == r)
        return;
    int mid = ((l + r + 1) >> 1), lSon = (node << 1), rSon = (lSon | 1);
    build(lSon, l, mid - 1);
    build(rSon, mid, r);
}

void upd (int node, int l, int r, int upos)
{
    cnt[node]--;
    aux[node] = 0;
    if(l == r)
        return;
    int mid = ((l + r + 1) >> 1), lSon = (node << 1), rSon = (lSon | 1);
    if(upos <= mid)
        upd(lSon, l, mid - 1, upos);
    else
        upd(rSon, mid, r, upos);
}

int getNext (int node, int l, int r)
{
    if(aux[node] != 0)
        return aux[node];
    if(l == r)
        return aux[node] = l;
    int mid = ((l + r + 1) >> 1), lSon = (node << 1), rSon = (lSon | 1);
    if(cnt[rSon] == 0)
        return aux[node] = getNext(lSon, l, mid - 1);
    if(cnt[lSon] == 0)
        return aux[node] = getNext(rSon, mid, r);
    int a = getNext(lSon, l, mid - 1);
    int b = getNext(rSon, mid, r);
    if(cmp(a, b))
        return aux[node] = a;
    else
        return aux[node] = b;
}

vector <int> biggest (int N, int K)
{
    k = K;
    vector <int> ans;
    build(1, 1, N);
    while(K--)
    {
        int pos = getNext(1, 1, N);
        upd(1, 1, N, pos);
        ans.push_back(pos);
    }
    return ans;
}