#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N_MAX = 50002;

const int BUFFER_SIZE = 10000;

char buffer[BUFFER_SIZE];
int bpos = BUFFER_SIZE - 1;

char read_char ()
{
    bpos++;
    if(bpos == BUFFER_SIZE)
    {
        fread(buffer, sizeof(char), BUFFER_SIZE, stdin);
        bpos = 0;
    }
    return buffer[bpos];
}

ll read_ll ()
{
    ll ans = 0;
    char c;
    while(!isdigit(c = read_char()) && c != '-');
    bool neg = false;
    if(c == '-')
    {
        neg = true;
        c = read_char();
    }
    while(isdigit(c))
    {
        ans = ans * 10 + c - '0';
        c = read_char();
    }
    if(neg == true)
        return -ans;
    return ans;
}

int read_int ()
{
    int ans = 0;
    char c;
    while(!isdigit(c = read_char()) && c != '-');
    bool neg = false;
    if(c == '-')
    {
        neg = true;
        c = read_char();
    }
    while(isdigit(c))
    {
        ans = ans * 10 + c - '0';
        c = read_char();
    }
    if(neg == true)
        return -ans;
    return ans;
}

int n, q;

int a[N_MAX];

ll sum[N_MAX];

multiset <ll> s;

vector <int> d[N_MAX];

vector <ll> queries[N_MAX];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    n = read_int();
    for(int i = 1; i <= n; i++)
        a[i] = read_int();
    for(int i = 1; i <= n; i++)
    {
        for(int j = i; j <= n; j += i)
        {
            d[j].push_back(i);
            sum[i] += a[j];
        }
        s.insert(-sum[i]);
    }
    q = read_int();
    for(int i = 1; i <= q; i++)
    {
        int upos;
        ll uval;
        upos = read_int();
        uval = read_ll();
        queries[upos].push_back(uval);
    }
    ll ans = 0;
    for(int i = 1; i <= n; i++)
        if(!queries[i].empty())
        {
            ll mx = LLONG_MIN;
            for(int p : d[i])
            {
                s.erase(s.find(-sum[p]));
                mx = max(mx, sum[p]);
            }
            ll mx1 = -*s.begin();
            for(ll &val : queries[i])
                ans += max(mx + val, mx1);
            for(int p : d[i])
                s.insert(-sum[p]);
        }
    cout << ans << "\n";
    return 0;
}
