//#include <vector>
//#include <algorithm>
//#include <iostream>
//
//using namespace std;
//int perm_[100001], n_;
//int countq_;
//int compare(int x, int y) {
//	if ((x < 1) || (x > n_) || (y < 1) || (y > n_)) {
//		printf("-2\n");
//		exit(0);
//	}
//	countq_++;
//	if (countq_ > 3e6) {
//		printf("-3\n");
//		exit(0);
//	}
//	if (perm_[x - 1] > perm_[y - 1]) return x;
//	return y;
//}
#include <vector>
#include "biggest.h"
#include <algorithm>
#include <random>
using namespace std;

bool comp(int x, int y)
{
	return compare(x, y) == y;
}
const int cf = 300;

vector <int> srt(int l, int r, int k)
{
	if (l + 1 == r)
	{
		return vector <int>({ l });
	}
	k = min(k, r - l);

	int m = (l + r) >> 1;
	auto le = srt(l, m, k / 2 + cf);
	auto ri = srt(m, r, k / 2 + cf);

	vector <int> ans;
	int i = 0, j = 0;
	while (i < le.size() && j < ri.size())
	{
		if (comp(le[i], ri[j]))
		{
			ans.push_back(ri[j++]);
		}
		else
		{
			ans.push_back(le[i++]);
		}
	}

	while (i < le.size())
		ans.push_back(le[i++]);

	while (j < ri.size())
		ans.push_back(ri[j++]);

	while (ans.size() > k) ans.pop_back();
	return ans;
}

vector <int> biggest(int n, int k)
{
	auto ans = srt(1, n + 1, k + cf);
	while (ans.size() > k) ans.pop_back();

	return ans;
}
//
//int main() {
//	int k, i, type;
//	cin >> n_ >> k >> type;
//
//	if (type == 0)
//	{
//		for (i = 0; i < n_; i++) {
//			cin >> perm_[i];
//		}
//	}
//	else
//	{
//		int seed;
//		cin >> seed;
//
//		//mt19937 rng(seed);
//
//		for (int i = 0; i < n_; i++)perm_[i] = i + 1;
//		//shuffle(perm_, perm_ + n_, rand);
//	}
//	vector <int> ans = biggest(n_, k);
//	for (i = 0; i < ans.size(); i++) {
//		cout << ans[i] << " ";
//	}
//	cout << countq_ << endl;
//	cout << endl;
//	return 0;
//}