#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <assert.h>
#include <map>
#include <deque>

using namespace std;
typedef long long ll;
typedef long double ld;

struct p
{
	int x, y;

	p() {}

	p(int x, int y) : x(x), y(y) {}

	bool operator<(const p& b)
	{
		return make_pair(x, y) < make_pair(b.x, b.y);
	}
};

istream& operator>>(istream& cin, p& a)
{
	return cin >> a.x >> a.y;
}

int n;
vector <p> a;
int h, w;
int ans;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> w >> h;

	a.resize(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];/*
		j_y.push_back(a[i].y);*/
	}

	for (int x = 0; x <= 100; ++x)
	{
		for (int y = 0; y <= 100; ++y)
		{
			int cnt = 0;

			for (auto i : a)
			{
				cnt += i.x <= x && i.y <= y && i.x >= x - w && i.y >= y - h;
			}

			ans = max(ans, cnt);
		}
	}

	cout << ans;
	return 0;
}