#include <iostream>
#include <set>
#include <map>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optmize("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#pragma GCC target ("avx2")
//#pragma GCC optimization ("O3")
//#pragma optimize("O3")

#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
#pragma GCC optimize("-fpeephole2")
#pragma GCC optimize("-fsched-spec")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")

using namespace std;
using namespace __gnu_pbds;
//#define int long long
#define ll long long

typedef tree<
        pair <int, int>,
        null_type,
        less< pair <int, int> >,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set;


const int mod = 1e9 + 7;


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cout.precision(20);
    cout << fixed;

    int n, w, h;
    cin >> n >> w >> h;
    vector < pair <int, int> > a(n);
    map <pair <int, int>, int> f;

    for(int i = 0; i < n; ++i){
        int x, y;
        cin >> x >> y;
        a[i] = {x, y};
        f[a[i]]++;
    }

    sort(a.begin(), a.end());
    /*int otv = 0;
    for(int i = 0; i <= 100; ++i){
        for(int j = 0; j <= 100; ++j){
            int kol = 0;
            for(int k = 0; k < n; ++k){
                if(a[k].first >= i - w && a[k].first <= i && a[k].second >= j - h && a[k].second <= j)
                {
                    kol++;
                }
            }
            otv = max(otv, kol);
        }
    }*/
    int otv = 0;
    vector < vector <int> > pref(1001, vector <int> (1001));
    for(int i = 0; i < 1001; ++i){
        for(int j = 0; j < 1001; ++j){
            //cout << "JJ" << endl;
            if(i == 0 && j == 0){
                pref[i][j] = f[{i, j}];
                continue;
            }
            if(i == 0){
                pref[i][j] = pref[i][j - 1] + f[{i, j}];
                continue;
            }
            if(j == 0){
                pref[i][j] = pref[i - 1][j] + f[{i, j}];
                continue;
            }
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + f[{i, j}];
        }
    }
    for(int i = 0; i < 1001; ++i){
        for(int j = 0; j < 1001; ++j){
            if(i <= w && j <= h){
                otv = max(otv, pref[i][j]);
                continue;
            }
            if(i <= w){
                otv = max(otv, pref[i][j] - pref[i][j - h - 1]);
                continue;
            }
            if(j <= h){
                otv = max(otv, pref[i][j] - pref[i - w - 1][j]);
                continue;
            }
            otv = max(otv, pref[i][j] - pref[i - w - 1][j] + pref[i - w - 1][j - h - 1] - pref[i][j - h - 1]);
        }
    }
    cout << otv;
}
