#include <bits/stdc++.h>
//#define int long long
#define f first
#define s second
#define pb push_back
#define all(a) a.begin(), a.end()
using namespace std;
struct node2{
    int val;
    node2 *l, *r;
    int nl, nr;
    node2(int _nl, int _nr) {
        nl = _nl;
        nr = _nr;
        l = nullptr;
        r = nullptr;
        val = 0;
    }
};
const int R = 1 << 17;
struct node1{
    node1 *l, *r;
    node2 *p;
    int nl, nr;
    node1(int _nl, int _nr) {
        nl = _nl;
        nr = _nr;
        p = nullptr;
        l = nullptr;
        r = nullptr;
    }
};
void add2(int x, node2 *r) {
    if (r->nl <= x && r->nr > x) {
        r->val++;
        if (r->nl+1 < r->nr) {
            int nm = (r->nl+r->nr)/2;
            if (r->l == nullptr)
                r->l = new node2(r->nl, nm);
            if (r->r == nullptr)
                r->r = new node2(nm, r->nr);
            add2(x, r->l);
            add2(x, r->r);
        }
    }
}
void add(int x, int y, node1 *r) {
    if (r->nl <= x && r->nr > x) {
        if (r->p == nullptr) {
            r->p = new node2(0, R);
        }
        add2(y, r->p);
        if (r->nl+1 < r->nr) {
            int nm = (r->nl+r->nr)/2;
            if (r->l == nullptr)
                r->l = new node1(r->nl, nm);
            if (r->r == nullptr)
                r->r = new node1(nm, r->nr);
            add(x, y, r->l);
            add(x, y, r->r);
        }
    }
}
int get2(int xl, int xr, node2 *r) {
    if (xl <= r->nl && r->nr <= xr)
        return r->val;
    if (xr <= r->nl || r->nr <= xl)
        return 0;
    int nm = (r->nl+r->nr)/2;
    if (r->l == nullptr)
        r->l = new node2(r->nl, nm);
    if (r->r == nullptr)
        r->r = new node2(nm, r->nr);
    return get2(xl, xr, r->l)+get2(xl, xr, r->r);
}
int get(int xl, int xr, int yl, int yr, node1 *r) {
    if (xl <= r->nl && r->nr <= xr) {
        if (r->p == nullptr) {
            r->p = new node2(0, R);
        }
        return get2(yl, yr, r->p);
    }
    if (r->nr <= xl || xr <= r->nl)
        return 0;
    int nm = (r->nl+r->nr)/2;
    if (r->l == nullptr)
        r->l = new node1(r->nl, nm);
    if (r->r == nullptr)
        r->r = new node1(nm, r->nr);
    return get(xl, xr, yl, yr, r->l)+get(xl, xr, yl, yr, r->r);
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, w, h;
    cin >> n >> w >> h;
    w++, h++;
    int m = 0;
    node1 *root = new node1(0, R);
    vector<int> x1(n), y1(n);
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        m = max(m, x);
        m = max(m, y);
        x1[i] = x+1, y1[i] = y+1;
        add(x, y, root);
    }
    int ans = 0;
    if (m <= 100) {
        m++;
        for (int x = w; x <= m; ++x) {
            for (int y = h; y <= m; ++y) {
                ans = max(ans, get(x-w, x, y-h, y, root));
            }
        }
        cout << ans;
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        if (x1[i] >= w && y1[i] >= h)
            ans = max(ans, get(x1[i]-w, x1[i], y1[i]-h, y1[i], root));
    }
    cout << ans;
    return 0;
}
