#include <bits/stdc++.h>
//#define int long long
#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(a) a.begin(), a.end()
using namespace std;
const int R = 1 << 18;
int t[R*2], fl[R*2];
void push(int node) {
    if (fl[node] != 0) {
        fl[node*2+1] += fl[node];
        t[node*2+1] += fl[node];
        t[node*2] += fl[node];
        fl[node*2] += fl[node];
    }
    fl[node] = 0;
}
void add(int ql, int qr, int val, int node = 1, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        t[node] += val;
        fl[node] += val;
        return;
    }
    if (qr <= nl || nr <= ql)
        return;
    push(node);
    int nm = (nl+nr)/2;
    add(ql, qr, val, node*2, nl, nm);
    add(ql, qr, val, node*2+1, nm, nr);
    t[node] = max(t[node*2], t[node*2+1]);
}
int get(int ql, int qr, int node = 1, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr)
        return t[node];
    if (qr <= nl || nr <= ql)
        return 0;
    push(node);
    int nm = (nl+nr)/2;
    int v1 = get(ql, qr, node*2, nl, nm);
    int v2 = get(ql, qr, node*2+1, nm, nr);
    t[node] = max(t[node*2], t[node*2+1]);
    return max(v1, v2);
}
bool cmp(pair<int, int> a, pair<int, int> b) {
    if (a.f != b.f)
        return a.f < b.f;
    return a.s > b.s;
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, w, h;
    cin >> n >> w >> h;
    vector<int> x1(n), y1(n);
    for (int i = 0; i < n; ++i)
        cin >> x1[i] >> y1[i];
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i)
        a[i].f = x1[i], a[i].s = y1[i];
    sort(all(a), cmp);
    set<pair<int, int>> now;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        now.insert({a[i].f, i});
        add(a[i].s, a[i].s+h+1, 1);
        while (now.begin()->f < a[i].f-w) {
            add(a[now.begin()->s].s, a[now.begin()->s].s+h+1, -1);
            now.erase(now.begin());
        }
        ans = max(ans, get(a[i].s, a[i].s+h+1));
    }
    cout << ans;
    return 0;
}
