//
//  main.cpp
//  C
//
//  Created by Ivan Podvorniy on 20.11.2020.
//  Copyright © 2020 Ivan Podvorniy. All rights reserved.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
long long t[100000];
long long vals[100000];


void upd(long long p, long long l, long long r, long long ind) {
    if (r - l == 1) {
        t[p] = vals[l];
        return;
    }
    long long m = (l + r) / 2;
    if (ind >= m) {
        upd(2 * p + 2, m, r, ind);
    } else {
        upd(2 * p + 1, l, m, ind);
    }
    t[p] = max(t[2 * p + 1], t[2 * p + 2]);
}

long long get(long long p, long long l, long long r, long long ql, long long qr) {
    if (l >= qr) {
        return -1e18;
    }
    if (r <= ql) {
        return -1e18;
    }
    if (l >= ql && r <= qr) {
        return t[p];
    }
    long long m = (l + r) / 2;
    return max(get(2 * p + 1, l, m, ql, qr), get(2 * p + 2, m, r, ql, qr));
}


signed main() {
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    int v[n];
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    int m;
    cin >> m;
    pair<int, long long> q[m];
    bool fl = false;
    for (int i = 0; i < m; i++)
    {
        cin >> q[i].first >> q[i].second;
        if (q[i].second < 0) {
            fl = true;
        }
    }
    if (fl) {
        for (int i = 1; i <= n; i++) {
            long long summ = 0;
            for (long long j = i; j <= n; j += i) {
                summ += v[j - 1];
            }
            vals[i - 1] = summ;
            upd(0, 0, n, i - 1);
        }

        long long ans = 0;
        vector<int> divs[n];
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j * j <= i; j++) {
                if (i % j == 0) {
                    divs[i - 1].push_back(j);
                    if (i / j != j) {
                        divs[i - 1].push_back(i / j);
                    }
                }
            }
        }
        for (int i = 0; i < m; i++) {
            long long p, s;
            p = q[i].first;
            s = q[i].second;

            for (auto j : divs[p - 1]) {
                vals[j - 1] += s;
                upd(0, 0, n, j - 1);
            }
            long long res = get(0, 0, n, 0, n);
            ans += res;
            for (auto j : divs[p - 1]) {
                vals[j - 1] -= s;
                upd(0, 0, n, j - 1);
            }
        }
        cout << ans << endl;

    }
    else {
        long long vals[n];
        for (int i = 1; i <= n; i++) {
            long long summ = 0;
            for (int j = i; j <= n; j += i) {
                summ += v[j - 1];
            }
            vals[i - 1] = summ;
        }

        long long ans = 0;
        long long maxx = *max_element(vals, vals + n);
        vector<int> divs[n];
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j * j <= i; j++) {
                if (i % j == 0) {
                    divs[i - 1].push_back(j);
                    if (i / j != j) {
                        divs[i - 1].push_back(i / j);
                    }
                }
            }
        }
        for (int i = 0; i < m; i++) {
            int p;
            long long s;
            p = q[i].first;
            s = q[i].second;
            long long now = maxx;
            for (auto j : divs[p - 1]) {
                now = max(now, vals[j - 1] + s);
                if (j != p / j) {
                    now = max(now, vals[p / j - 1] + s);
                }
            }
            ans += now;
            
        }
        cout << ans;
    }
}
