//
//  main.cpp
//  C
//
//  Created by Ivan Podvorniy on 20.11.2020.
//  Copyright © 2020 Ivan Podvorniy. All rights reserved.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
long long t[100000];
long long vals[100000];


void upd(long long p, long long l, long long r, long long ind) {
    if (r - l == 1) {
        t[p] = vals[l];
        return;
    }
    long long m = (l + r) / 2;
    if (ind >= m) {
        upd(2 * p + 2, m, r, ind);
    } else {
        upd(2 * p + 1, l, m, ind);
    }
    t[p] = max(t[2 * p + 1], t[2 * p + 2]);
}

long long get(long long p, long long l, long long r, long long ql, long long qr) {
    if (l >= qr) {
        return -1e18;
    }
    if (r <= ql) {
        return -1e18;
    }
    if (l >= ql && r <= qr) {
        return t[p];
    }
    long long m = (l + r) / 2;
    return max(get(2 * p + 1, l, m, ql, qr), get(2 * p + 2, m, r, ql, qr));
}


signed main() {
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    int v[n];
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    int m;
    cin >> m;
    pair<int, long long> q[m];
    bool fl = false;
    for (int i = 0; i < m; i++)
    {
        cin >> q[i].first >> q[i].second;
        if (q[i].second < 0) {
            fl = true;
        }
    }
    if (fl) {
        for (int i = 1; i <= n; i++) {
            long long summ = 0;
            for (long long j = i; j <= n; j += i) {
                summ += v[j - 1];
            }
            vals[i - 1] = summ;
            upd(0, 0, n, i - 1);
        }
        pair<long long, int> sorted[n];
        for (int i = 0; i < n; i++) {
            sorted[i] = make_pair(vals[i], i);
        }
        sort(sorted, sorted + n);
        long long ans = 0;
        long long divs[n];
        long long divsOther[n];
        for (int i = 1; i <= n; i++) {
            long long maxx = -1e18;
            int other = -1e18;
            for (int j = 1; j <= n; j++) {
                if (i % j == 0) {
                    maxx = max(maxx, vals[j - 1]);
                    maxx = max(maxx, vals[i / j - 1]);
                    int pos = lower_bound(sorted, sorted + n, make_pair(vals[j - 1], j - 1)) - sorted;
                    if (pos != n - 1 && i % (sorted[pos + 1].second + 1) != 0) {
                        other = max(other, pos + 1);
                    }
                }
            }
            divsOther[i - 1] = -1e18;
            if (other != -1e18) {
                while (other != n && i % (sorted[other].second + 1) != 0)
                {
                    divsOther[i - 1] = max(divsOther[i - 1], sorted[other].first);
                    other++;
                }
            }
            divs[i - 1] = maxx;
        }
        for (int i = 0; i < m; i++) {
            long long p, s;
            p = q[i].first;
            s = q[i].second;
            
            ans += max(divs[p - 1] + s, divsOther[p - 1]);
        }
        cout << ans << endl;

    }
    
}
