//
//  main.cpp
//  C
//
//  Created by Ivan Podvorniy on 20.11.2020.
//  Copyright © 2020 Ivan Podvorniy. All rights reserved.
//

#include <iostream>
#include <vector>
#include <algorithm>
#define int long long
using namespace std;
long long vals[100000];



long long sol1(int n, vector<long long> v, int m, vector<pair<int, long long>> q) {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    long long vals[n];
    for (int i = 1; i <= n; i++) {
        long long summ = 0;
        for (long long j = i; j <= n; j += i) {
            summ += v[j - 1];
        }
        vals[i - 1] = summ;
    }
    pair<long long, int> sorted[n];
    for (int i = 0; i < n; i++) {
        sorted[i] = make_pair(vals[i], i);
    }
    sort(sorted, sorted + n);
    long long ans = 0;
    long long divs[n];
    long long divsOther[n];
    for (int i = 1; i <= n; i++) {
        long long maxx = -1e18;
        for (int j = 1; j * j <= i; j++) {
            if (i % j == 0) {
                maxx = max(maxx, vals[j - 1]);
                maxx = max(maxx, vals[i / j - 1]);
                
            }
        }
        
        divs[i - 1] = maxx;
        divsOther[i - 1] = -1e18;
        for (int j = 1; j <= n; j++) {
            if (i % j != 0) {
                divsOther[i - 1] = max(divsOther[i - 1], vals[j - 1]);
            }
        }
        
    }
    for (int i = 0; i < m; i++) {
        long long p, s;
        p = q[i].first;
        s = q[i].second;
        ans += max(divs[p - 1] + s, divsOther[p - 1]);
    }
    return ans;
}


long long sol2(int n, vector<long long> v, int m, vector<pair<int, long long>> q) {
    long long ans = 0;
    for (int i = 0; i < m; i++) {
        vector<int> vals(n);
        v[q[i].first - 1] += q[i].second;
        for (int i = 1; i <= n; i++) {
            int summ = 0;
            for (int j = i; j <= n; j += i) {
                summ += v[j - 1];
            }
            vals[i - 1] = summ;
        }
        ans += *max_element(vals.begin(), vals.end());
        v[q[i].first - 1] -= q[i].second;
    }
    return ans;
}


signed main() {
    int n;
    cin >> n;
    vector<long long> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    int m;
    cin >> m;
    vector<pair<long long, int>> q(m);
    for (int i = 0; i < m; i++)
    {
        cin >> q[i].first >> q[i].second;
    }
    cout << sol1(n, v, m, q);
}
