#include <bits/stdc++.h>
#include <vector>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")

#define ios ios_base::sync_with_stdio(0);cout.tie(0);cin.tie(0);
#define int long long
#define len(a) (int)(a).size()
#define all(a) a.begin(),(a).end()

const int INF = 2e15;
struct segtree{ //for rabbits
  vector<int> tree;
  int n = 1;
  explicit segtree(const vector<int>& a){
      while(n<len(a))n<<=1;
      tree.resize(n*2, -INF);
      for (int i = 0; i < len(a); ++i) {
          tree[n+i] = a[i];
      }
      for (int i = n-1; i > 0; --i) {
          tree[i] = max(tree[i<<1], tree[i<<1|1]);
      }
  }
  void update(int i, int val){
      i+=n;
      tree[i] += val;
      for (i>>=1; i > 0; i>>=1) {
          tree[i] = max(tree[i<<1], tree[i<<1|1]);
      }
  }
};
void solve() {
    int n; cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int m; cin >> m;
    vector<int> rabbits(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; j+=(i+1)) {
            rabbits[i] += a[j];
        }
    }
    segtree r(rabbits);
    int maxs = 0;
    for (int _ = 0; _ < m; ++_) {
        int i, c; cin >> i >> c;
        for (int j = 1; j <= sqrt(i); ++j) {
            if(i%j == 0){
                r.update(j-1, c);
                r.update(i/j-1, c);
            }
        }
        maxs += r.tree[1];
        for (int j = 1; j <= sqrt(i); ++j) {
            if(i%j == 0){
                r.update(j-1, -c);
                r.update(i/j-1, -c);
            }
        }
    }
    cout << maxs << endl;
}

signed main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios;
    solve();
    return 0;
}