#include <bits/stdc++.h>
#include "biggest.h"
std::vector <int> biggest(int N, int K) {
    srand(time(nullptr));
    std::vector <int> ans;
    if (K <= 1000) {
        std::function<void(std::vector<int> &, int)> qsort = [&](std::vector<int> &a, int k) {
            if (a.empty()) return;
            if (a.size() == 1) {
                ans.push_back(a[0]);
                return;
            }
            int med = rand() % a.size();
            std::vector<int> more, less;
            for (int i = 0; i < a.size(); ++i) {
                if (compare(a[i], a[med]) == a[i]) more.push_back(a[i]);
                else less.push_back(a[i]);
            }
            qsort(more, k);
            if (k > more.size()) qsort(less, k - more.size());
        };
        std::vector<int> cur;
        for (int i = 1; i <= N; ++i) cur.push_back(i);
        qsort(cur, K);
    } else {
        std::function <void(std::vector <int>&)> merge_sort = [&](std::vector <int>& a) {
            if (a.size() <= 1) return;
            std::vector <int> f, s;
            for (int i = 0; i < a.size() / 2; ++i) {
                f.push_back(a[i]);
            }
            for (int i = a.size() / 2; i < a.size(); ++i) {
                s.push_back(a[i]);
            }
            merge_sort(f);
            merge_sort(s);
            int ff = 0, ss = 0;
            a.clear();
            while (ff < f.size() || ss < s.size()) {
                if (ff == f.size()) {
                    a.push_back(s[ss]);
                    ++ss;
                } else if (ss == s.size()) {
                    a.push_back(f[ff]);
                    ++ff;
                } else if (compare(f[ff], s[ss]) == s[ss]) {
                    a.push_back(f[ff]);
                    ++ff;
                } else {
                    a.push_back(s[ss]);
                    ++ss;
                }
            }
        };
        std::vector <int> cur;
        for (int i = 1; i <= N; ++i) cur.push_back(i);
        merge_sort(cur);
        for (int i = cur.size() - 1; i >= cur.size() - K; --i) {
            ans.push_back(cur[i]);
        }
    }
    return ans;
}



