#include "biggest.h"
#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>

using namespace std;

/*int compare(int x, int y) {
    cout << x << " " << y << "\n";
    int k;
    cin >> k;
    return k;
}*/

vector<int> biggest(int n, int k) {
    vector<int> ans;
    ans.push_back(0);
    int sz = ans.size();
    for (int i = 1; i < n; ++i) {
        int l = max(-1, sz - k);
        int r = ans.size();
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (compare(ans[m] + 1, i + 1) == i + 1) {
                l = m;
            } else {
                r = m;
            }
            if (sz - r >= k) {
                break;
            }
        }
        if (sz - r < k) {
            ans.insert(r + ans.begin(), i);
            sz += 1;
        }
    }
    vector<int> ans1;
    for (int i = 0; i < k; ++i) {
        ans1.push_back(ans.back() + 1);
        ans.pop_back();
    }
    return ans1;
}

/*int main() {
    auto res = biggest(6, 6);
    for (int i = 0; i < 6; ++i) {
        cout << res[i] << " ";
    }
}*/