#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cmath>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    vector<int> a(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i + 1];
    }
    vector<long long> sum(n + 1, -100000000000000000);
    for (int i = 1; i <= n; ++i) {
        sum[i] = 0;
        for (int j = i; j <= n; j += i) {
            sum[i] += a[j];
        }
    }
    int m;
    cin >> m;
    long long ans = 0;
    for (int i = 0; i < m; ++i) {
        int p, s;
        cin >> p >> s;
        set<int> b;
        for (int j = 1; j <= sqrt(p) + 1; ++j) {
            if (p % j == 0 && b.count(j) == 0) {
                sum[j] += s;
                b.insert(j);
                if (p / j != j) {
                    sum[p / j] += s;
                    b.insert(p / j);
                }
            }
        }
        b.clear();
        ans += *max_element(sum.begin(), sum.end());
        for (int j = 1; j <= sqrt(p) + 1; ++j) {
            if (p % j == 0 && b.count(j) == 0) {
                sum[j] -= s;
                b.insert(j);
                if (p / j != j) {
                    sum[p / j] -= s;
                    b.insert(p / j);
                }
            }
        }
    }
    cout << ans;
}