#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>

using namespace std;

int main() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> points(n);
    set<int> x;
    set<int> y;
    for (int i = 0; i < n; ++i) {
        cin >> points[i].first >> points[i].second;
        x.insert(points[i].first);
        y.insert(points[i].second);
    }
    int ans = 0;
    for (auto i : x) {
        for (auto j : y) {
            int now_ans = 0;
            for (int ind = 0; ind < n; ++ind) {
                if (points[ind].first <= i && points[ind].first >= i - w && points[ind].second <= j && points[ind].second >= j - h){
                    now_ans += 1;
                }
            }
            ans = max(ans, now_ans);
        }
    }
    cout << ans;
}