#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>

using namespace std;

int main() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<vector<int>> dp(1002, vector<int>(1002));
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        dp[x + 1][y + 1] += 1;
    }
    for (int i = 1; i < 1002; ++i) {
        int now = 0;
        for (int j = 1; j < 1002; ++j) {
            now += dp[i][j];
            dp[i][j] = now + dp[i - 1][j];
        }
    }
    int ans = 0;
    for (int i = w + 1; i < 1002; ++i) {
        for (int j = h + 1; j < 1002; ++j) {
            ans = max(ans, dp[i][j] - dp[i - w - 1][j] - dp[i][j - h - 1] + dp[i - w - 1][j - h - 1]);
        }
    }
    cout << ans;
}
