#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <map>

using namespace std;

int main() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<vector<int>> dp(2004, vector<int>(2004));
    set<int> x;
    set<int> y;
    set<int> x3;
    set<int> y3;
    vector<pair<int, int>> a;
    for (int i = 0; i < n; ++i) {
        int x1, y1;
        cin >> x1 >> y1;
        x1 += 1;
        y1 += 1;
        x.insert(x1);
        y.insert(y1);
        x3.insert(x1);
        y3.insert(y1);
        if (x1 - w - 1 >= 0) {
            x.insert(x1 - w - 1);
        }
        if (y1 - h - 1 >= 0) {
            y.insert(y1 - h - 1);
        }
        a.emplace_back(x1, y1);
    }
    x.insert(w + 1);
    y.insert(h + 1);
    map<int, int> x1;
    map<int, int> y1;
    map<int, int> x2;
    map<int, int> y2;
    int ind = 2;
    for (auto u : x) {
        x1[u] = ind;
        x2[ind] = u;
        ++ind;
    }
    ind = 2;
    for (auto u : y) {
        y1[u] = ind;
        y2[ind] = u;
        ++ind;
    }
    for (int i = 0; i < n; ++i) {
        dp[x1[a[i].first]][y1[a[i].second]] += 1;
    }
    for (int i = 1; i < 2004; ++i) {
        int now = 0;
        for (int j = 1; j < 2004; ++j) {
            now += dp[i][j];
            dp[i][j] = now + dp[i - 1][j];
        }
    }
    int ans = 0;
    for (auto i : x3) {
        if (i > w)
            for (auto j : y3) {
                if (j > h) {
                    ans = max(ans, dp[x1[i]][y1[j]] - dp[x1[i - w - 1]][y1[j]] - dp[x1[i]][y1[j - h - 1]] +
                                   dp[x1[i - w - 1]][y1[j - h - 1]]);
                }
            }
    }
    cout << ans;
}
