#include "biggest.h"
#include <iostream>
#include <vector>

using namespace std;

vector<int> merge(vector<int> arr1 , vector<int> arr2){
    int i = 0 , j = 0;
    vector<int> ans(arr1.size() + arr2.size());

    for (int k = 0; k < ans.size(); ++k) {
        if (i < arr1.size() && j < arr2.size()){
            ans[k] = compare(arr1[i]+1 , arr2[j]+1);
            if (ans[k]-1 == arr1[i]){
                i++;
            }
            else{
                j++;
            }
        }
        else if (i < arr1.size()){
            ans[k] = arr1[i]+1;
            i++;
        }
        else{
            ans[k] = arr2[j]+1;
            j++;
        }
    }

    return ans;
}

vector<int> sort(int s , int e){
    vector<int> arr;
    vector<int> arr1;
    vector<int> arr2;
    if (s == e){
        arr.push_back(s);
        return arr;
    }
    else{
        int mid = (s + e) / 2;
        arr1 = sort(s , mid);
        arr2 = sort(mid+1 , e);
        arr = merge(arr1 , arr2);
    }

    return arr;
}

vector<int> biggest(int n , int k){
    vector<int> arr = sort(0 , n-1);
    vector<int> ans;
    for (int i = 0; i < k; ++i) {
        ans.push_back(arr[i]);
    }
    return ans;
}
