#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <bitset>
#include <stack>
#include <unordered_set>
#include <cmath>

using namespace std;

const int N = 50003, M = 500003;

long long a[N], r[N], mx;

void precalc(int n)
{
	long long ans = 0;
	for (int i = 1; i <= n; i++)
	{
		for (int k = i; k <= n; k += i)
		{
			r[i] += a[k];
		}
		ans = max(ans, r[i]);
	}
	mx = ans;
}

int main()
{
	int n;
	cin >> n;
	for (int i = 1; i <= n; i++)
	{
		cin >> a[i];
	}
	precalc(n);
	int m;
	cin >> m;
	long long l = 0;
	while (m--)
	{
		long long p, s;
		cin >> p >> s;
		long long ans = mx;
		for (long long k = 1; k * k <= p; k++)
		{
			if (p % k == 0)
			{
				ans = max(ans, r[k] + s);
				ans = max(ans, r[p / k] + s);
			}
		}
		//cout << ans << endl;
		l += ans;
	}
	cout << l;
	return 0;
}