#include <bits/stdc++.h>

using namespace std;

#define vc vector
typedef int ll;
typedef vc<ll> vll;
typedef pair<ll, ll> pll;
typedef vc<pll> vpll;
typedef vc<vll> vvll;

vll t[800005];
vll a[100005];

const ll n = 1024;

void build(ll l, ll r, ll v) {
    for (ll i = l; i <= r; ++i) {
        for (auto &j : a[i]) {
            t[v].push_back(j);
        }
    }
    sort(t[v].begin(), t[v].end());
    if (l != r) {
        ll mid = (l + r) >> 1;
        build(l, mid, v * 2);
        build(mid + 1, r, v * 2 + 1);
    }
}

ll get(ll l, ll r, ll y1, ll y2) {
    ll mid = (l + r) >> 1;
    l += n;
    r += n;
    ll ret = 0;
    while (l <= r) {
        if (l & 1) {
            ret += upper_bound(t[l].begin(), t[l].end(), y2) - lower_bound(t[l].begin(), t[l].end(), y1);
            l += 1;
        }
        if (!(r & 1)) {
            ret += upper_bound(t[r].begin(), t[r].end(), y2) - lower_bound(t[r].begin(), t[r].end(), y1);
            r -= 1;
        }
        l /= 2;
        r /= 2;
    }
    return ret;
}


int main() {
    ll c = 100000, w = 1, h = 1;
    cin >> c >> w >> h;
    vpll x(c);
    for (ll k = 0; k < c; ++k) {
//        ll x1 = 1, y = 1;
        cin >> x1 >> y;
        a[x1].push_back(y);
        x[k].first = x1;
        x[k].second = y;
//        cout << a[x1].size() << endl;
    }
    build(0, n - 1, 1);
    ll ans = 0;
    for (ll i = 0; i < c; ++i) {
        ans = max(ans, get(x[i].first - w, x[i].first, x[i].second - h, x[i].second));
        ans = max(ans, get(x[i].first - w, x[i].first, x[i].second + h, x[i].second));
        ans = max(ans, get(x[i].first + w, x[i].first, x[i].second - h, x[i].second));
        ans = max(ans, get(x[i].first + w, x[i].first, x[i].second + h, x[i].second));
    }

    cout << ans << endl;
}