#include <bits/stdc++.h>

using namespace std;

#define vc vector
typedef int ll;
typedef vc<ll> vll;
typedef pair<ll, ll> pll;
typedef vc<pll> vpll;
typedef vc<vll> vvll;

vll t[800005];
vll a[100005];

const ll n = 1024;

void build(ll l, ll r, ll v) {
    for (ll i = l; i <= r; ++i) {
        for (auto &j : a[i]) {
            t[v].push_back(j);
        }
    }
    sort(t[v].begin(), t[v].end());
    if (l != r) {
        ll mid = (l + r) >> 1;
        build(l, mid, v * 2);
        build(mid + 1, r, v * 2 + 1);
    }
}

ll get(ll l, ll r, ll y1, ll y2) {
    if (l > r) {
        swap(l, r);
    }
    if (y1 > y2) {
        swap(y1, y2);
    }
//    if (y2 == 11 && r == 9) {
//        cout << "kok";
//    }
    l = max(0, l);
    l += n;
    r = min(r, n - 1);
    r += n;
    ll ret = 0;
    while (l <= r) {
        if (l & 1) {
            ret += upper_bound(t[l].begin(), t[l].end(), y2) - lower_bound(t[l].begin(), t[l].end(), y1);
            l += 1;
        }
        if (!(r & 1)) {
            ret += upper_bound(t[r].begin(), t[r].end(), y2) - lower_bound(t[r].begin(), t[r].end(), y1);
            r -= 1;
        }
        l /= 2;
        r /= 2;
    }
//    if (ret == 9) {
//        cout << "morgenwho";
//    }
    return ret;
}


int main() {
    ll c = 100000, w = 1, h = 1;
    cin >> c >> w >> h;
    vpll x(c);

    for (ll k = 0; k < c; ++k) {
        ll x1 = 1, y = 2;
        cin >> x1 >> y;
        a[x1].push_back(y);
        x[k].first = x1;
        x[k].second = y;
//        cout << a[x1].size() << endl;
    }
    build(0, n - 1, 1);
    ll ans = 0;
    for (ll d = 0; d < c; ++d) {
        for (ll i = -100; i <= 100; ++i) {
            ans = max(ans, get(x[d].first - w + i, x[d].first + i, x[d].second - h, x[d].second));
            ans = max(ans, get(x[d].first - w + i, x[d].first + i, x[d].second + h, x[d].second));
            ans = max(ans, get(x[d].first + w + i, x[d].first + i, x[d].second - h, x[d].second));
            ans = max(ans, get(x[d].first + w + i, x[d].first + i, x[d].second + h, x[d].second));


            ans = max(ans, get(x[d].first - w, x[d].first, x[d].second - h + i, x[d].second + i));
            ans = max(ans, get(x[d].first - w, x[d].first, x[d].second + h + i, x[d].second + i));
            ans = max(ans, get(x[d].first + w, x[d].first, x[d].second - h + i, x[d].second + i));
            ans = max(ans, get(x[d].first + w, x[d].first, x[d].second + h + i, x[d].second + i));
        }
    }

    cout << ans << endl;
}
