#include "biggest.h"
#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;

using ll = long long;
using ld = long double;

std::random_device rd;
std::mt19937 g(rd());

const int N = 1e5;

std::set<pair<int, int>> res[N];
int v[N];

bool ask (int x, int y) {
	if (x == y)
		return false;
	auto it = res[x].lower_bound({y, -1});
	int ans = -1;
	if (it == res[x].end() || it->first != x) {
		ans = compare(x + 1, y + 1);
		res[x].insert({y, ans});
	} else {
		ans = it->second;
	}
	return ans == x + 1;
}

void sort (int start, int end) {
	if (end - start == 1)
		return;
	int m = (start + end) / 2;
	sort(start, m);
	sort(m, end);
	int l = start, r = start + m;
	for (; l < end;++l) {
		for (; r < end && ask(v[r], v[l]); ++r)
			std::swap(v[r], v[l]);
	}
} 

std::vector<int> biggest (int n, int k) {
	//assert(n == N);
	for (int i = 0; i < n; ++i)
		v[i] = i;
	std::vector<int> v1(n);
	for (int i = 0; i < n; ++i)
		v1[i] = v[i];
	//std::shuffle(v.begin(), v.end(), g);
	if (k > 1000)
		std::partial_sort(v, v + k, v + n, ask);
	else {
		std::nth_element(v, v + k - 1, v + n, ask);

		sort(0, k);

		std::partial_sort(v1.begin(), v1.begin() + k, v1.begin() + n, ask);
	}
	std::vector<int> ans(k);
	for (int i = 0; i < k; ++i) {
		ans[i] = v[i] + 1;
		//assert(v[i] == v1[i]);
	}
	return ans;
}
