#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;

using ll = long long;
using ld = long double;

const ll INF = 1e18;

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n;
	cin >> n;

	vector<ll> a(n);
	for (ll &i : a)
		cin >> i;

	vector<ll> sum(n), max(2 * n, -INF);
	for (int i = 0; i < n; ++i)
		for (int j = i; j < n; j += i + 1)
			sum[i] += a[j];

	std::vector<vector<int>> v(n);

	for (int i = 0; i < n; ++i)
		for (int j = i; j < n; j += i + 1) {
			max[j] = std::max(max[j], sum[i]);
			v[j].push_back(i);
		}

	vector<pair<ll, int>> st(n);
	vector<bool> used(n);
	for (int i = 0; i < n; ++i)
		st[i] = {-sum[i], i};
	std::sort(st.begin(), st.end());

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < v[i].size(); ++j)
			used[v[i][j]] = true;
		for (int j = 0; j < n; ++j)
			if (!used[st[j].second]) {
				max[n + i] = -st[j].first;
				break;
			}

		for (int j = 0; j < v[i].size(); ++j)
			used[v[i][j]] = false;
	}

	int m;
	cin >> m;
	ll ans = 0;
	for (int i = 0; i < m; ++i) {
		ll p, s;
		cin >> p >> s;
		--p;
		ans += std::max(max[p] + s, max[n + p]);
	}
	cout << ans;
	return 0;
}