#include <bits/stdc++.h>
using namespace std;

const long long INF = (long long) 1e18;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<long long> a(n + 1), change(n + 1, 0);
  for (int i = 1; i <= n; i++) {
    cin >> a[i];
  }
  vector<long long> sum(n + 1, 0), v;
  long long mx = -INF;
  for (int i = 1; i <= n; i++) {
    for (int j = i; j <= n; j += i) {
      sum[i] += a[j];
    }
    mx = max(mx, sum[i]);
    v.push_back(sum[i]);
  }
  sort(v.rbegin(), v.rend());
  int m;
  cin >> m;
  long long ans = 0;
  while (m--) {
    int p;
    long long s;
    cin >> p >> s;
    vector<int> div;
    long long add = mx;
    for (int i = 1; i * i <= p; i++) {
      if (p % i == 0) div.push_back(i);
      if (p % i == 0 && p != i * i) div.push_back(p / i);
    }
    if (s >= 0) {
      for (auto& x : div) add = max(add, sum[x] + s);
    } else {
      sort(div.begin(), div.end(), [&](int a, int b) {
        return sum[a] > sum[b];
      });
      int ptr = 0;
      for (auto& x : div) if (sum[x] == v[ptr]) ptr++;
      add = max(mx + s, v[ptr]);
    }
    ans += add;
  }
  cout << ans << '\n';
  return 0;
}
