#include <bits/stdc++.h>
using namespace std;

const long long INF = (long long) 1e18;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<long long> a(n + 1);
  for (int i = 1; i <= n; i++) {
    cin >> a[i];
  }
  long long mx = -INF;
  vector<long long> sum(n + 1, 0);
  for (int i = 1; i <= n; i++) {
    for (int j = i; j <= n; j += i) sum[i] += a[j];
    mx = max(mx, sum[i]);
  }
  vector<int> v;
  vector<long long> div_mx(n + 1, -INF);
  for (int i = 1; i <= n; i++) {
    for (int j = i; j <= n; j += i) div_mx[j] = max(div_mx[j], sum[i]);
    v.push_back(i);
  }
  sort(v.begin(), v.end(), [&](int a, int b) {
    return sum[a] > sum[b];
  });
  vector<int> ptr(n + 1, 0);
  for (auto &i : v) {
    for (int j = i; j <= n; j += i) if (sum[v[ptr[j]]] == sum[i]) ptr[j]++;
  }
  int m;
  cin >> m;
  long long ans = 0;
  while (m--) {
    int p;
    long long s;
    cin >> p >> s;
    if (s >= 0) {
      ans += max(mx, div_mx[p] + s);
    } else {
      if (ptr[p] == n) ans += mx + s;
      else ans += max(mx + s, sum[v[ptr[p]]]);
    }
  }
  cout << ans << '\n';
  return 0;
}
