#include<bits/stdc++.h>
#include "biggest.h"
using namespace std;

mt19937 rnd(229);

const int N = 1e6 + 10;
vector<int> t[4 * N];

vector<int> kek(vector<int> &a, vector<int> &b){
    vector<int> ans;
    int l = 0, r = 0;
    while(l < a.size() && r < b.size()){
        if (compare(a[l], b[r]) == b[r]){
            ans.push_back(a[l]);
            l++;
        }
        else{
            ans.push_back(b[r]);
            r++;
        }
    }
    while(l < a.size() || r < b.size()){
        if (l == a.size()) {
            ans.push_back(b[r]);
            r++;
        }
        else{
            ans.push_back(a[l]);
            l++;
        }
    }
    return ans;
}

void build(int v, int l, int r){
    if (l == r){
        t[v].push_back(l);
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m), build(2 * v + 1, m + 1, r);
    t[v] = kek(t[v * 2], t[v * 2 + 1]);
}

vector<int> solve(vector<int> a, int k){
    if (a.size() == 0){
        return vector<int>{};
    }
    if (a.size() == 1){
        return a;
    }
    int rand = rnd() % a.size();
    vector<int> lss, more;
    for (int i = 0; i < a.size(); i++){
        if (i == rand) continue;
        int val = compare(a[i], a[rand]);
        if (val == a[rand]){
            lss.push_back(a[i]);
        }
        else{
            more.push_back(a[i]);
        }
    }
    if (more.size() >= k){
        return solve(more, k);
    }
    else if (more.size() + 1 == k){
        vector<int> u;
        vector<int> www = solve(more, k - 1);
        for (auto to : www){
            u.push_back(to);
        }
        u.push_back(a[rand]);
        return u;
    }
    else{
        vector<int> www;
        vector<int> ww = solve(more, more.size());
        for (auto to : ww){
            www.push_back(to);
        }
        www.push_back(a[rand]);
        ww = solve(lss, k - more.size() - 1);
        for (auto to : ww){
            www.push_back(to);
        }
        return www;
    }
}

vector<int> ans;

void new_solve(int n, int k){
    vector<int> a(k);
    for (int i = 1; i <= n; i++){
        if (a[0] != 0)
            if (compare(a[0], i) == a[0]) continue;
        int l = 0, r = k;
        while(a[l + 1] == 0 && l + 1 < k) l++;
        while(r - l > 1){
            int mid = (r + l) / 2;
            if (a[mid] == 0){
                l = mid;
                continue;
            }
            if (compare(a[mid], i) == i){
                l = mid;
            }
            else{
                r = mid;
            }
        }
        for (int j = 0; j < l; j++){
            a[j] = a[j + 1];
        }
        a[l] = i;
    }
    reverse(a.begin(), a.end());
    ans = a;
}

void stupid_100(int n, int k){
    vector<vector<int>> u;
    for (int i = 1; i <= n; i += 2){
        vector<int> v;
        if (compare(i, i + 1) == i + 1){
            v.push_back(i);
            v.push_back(i + 1);
        }
        else{
            v.push_back(i + 1);
            v.push_back(i);
        }
        u.push_back(v);
    }
    for (int i = 1; i < u.size(); i++){
        int l = -1, r = u[0].size();
        while(r - l > 1){
            int mid = (r + l) / 2;
            if (compare(u[0][mid], u[i][0]) == u[i][0]){
                l = mid;
            }
            else{
                r = mid;
            }
        }
        u[0].insert(u[0].begin() + l + 1, u[i][0]);
        r = u[0].size();
        l++;
        while(r - l > 1){
            int mid = (r + l) / 2;
            if (compare(u[0][mid], u[i][1]) == u[i][1]){
                l = mid;
            }
            else{
                r = mid;
            }
        }
        u[0].insert(u[0].begin() + l + 1, u[i][1]);
    }
    reverse(u[0].begin(), u[0].end());
    for (int i = 0; i < k; i++){
        ans.push_back(u[0][i]);
    }
}

void DO(int n, int k){
    build(1, 1, n);
    for (int i = n - 1; i >= n - k; i--){
        ans.push_back(t[1][i]);
    }
}

vector<int> biggest(int n, int k){
    vector<int> a;
    for (int i = 1; i <= n; i++){
        a.push_back(i);
    }
    if (k <= 100){
        new_solve(n, k);
        return ans;
    }
    if (k <= 150 && n % 2 == 0){
        stupid_100(n, k);
        return ans;
    }
    if (k <= 999){
        new_solve(n, k);
        return ans;
    }
    if (k <= 10000){
        return solve(n, k);
    }
    DO(n, k);
    return ans;
}


