#include<vector>
#include<map>
#include<algorithm>
#include<set>
#include<iostream>
#include<string>
#include<set>
#include<queue>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> lol;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")

#define pb push_back
#define int long long
#define ld long double

mt19937 rnd(51);

const int N = 1e5 + 10;
int t[4 * N], add[4 * N];

void push(int v){
    t[v] += add[v];
    if (v * 2 < 4 * N){
        add[v * 2] += add[v];
        add[v * 2 + 1] += add[v];
    }
    add[v] = 0;
}

void update(int v, int tl, int tr, int l, int r, int val){
    push(v);
    if (l > r) return;
    if (tl == l && tr == r){
        add[v] += val;
        push(v);
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    update(2 * v, tl, tm, l, min(r, tm), val), update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, val);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

int32_t main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, h, w;
    cin >> n >> w >> h;
    vector<vector<int>> low(N), bck(N);
    for (int i = 0; i < n; i++){
        int a, b;
        cin >> a >> b;
        low[b].pb(a);
        bck[a].pb(b);
    }
    int ans = 0;
    for (int i = 0; i < h; i++){
        for (auto to : low[i]){
            update(1, 0, N - 1, max(0ll, to - w) , to, 1);
        }
    }
    for (int i = 0; i + h < N; i++){
        int q = i + h;
        for (auto to : low[q]){
            update(1, 0, N - 1, max(0ll, to - w) , to, 1);
        }
        ans = max(ans, t[1]);
        for (auto to : low[i]){
            update(1, 0, N - 1, max(0ll, to - w) , to, -1);
        }
    }
    for (int i = 0; i < 4 * N; i++){
        add[i] = t[i] = 0;
    }
    for (int i = 0; i < w; i++){
        for (auto to : bck[i]){
            update(1, 0, N - 1, max(0ll, to - h), to, 1);
        }

    }
    for (int i = 0; i + w < N; i++){
        int q = i + w;
        for (auto to : bck[q]){
            update(1, 0, N - 1, max(0ll, to - h), to, 1);
        }
        ans = max(ans, t[1]);
        for (auto to : bck[q]){
            update(1, 0, N - 1, max(0ll, to - h), to, -1);
        }
    }
    cout << ans << endl;
    return 0;
}
