#include<bits/stdc++.h>
using namespace std;


#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")

#define pb push_back
#define ld long double

const int N = 1e5 + 10;
int t[4 * N], add[4 * N];

void push(int v)
{
    t[v] += add[v];
    if (v * 2 < 4 * N)
    {
        add[v * 2] += add[v];
        add[v * 2 + 1] += add[v];
    }
    add[v] = 0;
}

void update(int v, int tl, int tr, int l, int r, int val)
{
    push(v);
    if (l > r)
        return;
    if (tl == l && tr == r)
    {
        add[v] += val;
        push(v);
        return;
    }
    int tm = (tl + tr) / 2;
    update(2 * v, tl, tm, l, min(r, tm), val), update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, val);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

int32_t main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, h, w;
    cin >> n >> w >> h;
    vector<pair<int,int>> v(n);
    vector<int> llow, bback;
    for (int i = 0; i < n; ++i)
    {
        int a, b;
        cin >> a >> b;
        v[i] = {a, b};
        llow.pb(b);
        bback.pb(a);
    }
    sort(llow.begin(), llow.end());
    sort(bback.begin(), bback.end());
    llow.erase(unique(llow.begin(), llow.end()), llow.end());
    bback.erase(unique(bback.begin(), bback.end()), bback.end());
    vector<vector<int>> low(llow.size()), bck(bback.size());
    for (auto to : v){
        int i = lower_bound(llow.begin(), llow.end(), to.second) - llow.begin();
        int j = lower_bound(bback.begin(), bback.end(), to.first) - bback.begin();
        low[i].pb(to.first);
        bck[j].pb(to.second);
    }
    int ans = 0;
    int l = 0, l1 = 0;
    while (l1 < llow.size() && llow[l1] < h)
    {
        int i = lower_bound(llow.begin(), llow.end(), llow[l1]) - llow.begin();
        for (auto to : low[i])
        {
            auto it = lower_bound(bback.begin(), bback.end(), max(0, to - w));
            if (it == bback.end())
                continue;
            else
            {
                int i = it - bback.begin();
                if (bback[i] > to)
                    continue;
                else
                {
                    auto j = upper_bound(bback.begin(), bback.end(), to) - bback.begin() - 1;
                    update(1, 0, N - 1, i, j, 1);
                }
            }
        }
        ans = max(ans, t[1]);
        l1++;
    }
    while(l1 < llow.size())
    {
        int f = llow[l1] - h;
        while(l < llow.size() && llow[l] < f)
        {
            int i = lower_bound(llow.begin(), llow.end(), llow[l]) - llow.begin();
            for (auto to : low[i])
            {
                auto it = lower_bound(bback.begin(), bback.end(), max(0, to - w));
                if (it == bback.end())
                    continue;
                else
                {
                    int i = it - bback.begin();
                    if (bback[i] > to)
                        continue;
                    else
                    {
                        auto j = upper_bound(bback.begin(), bback.end(), to) - bback.begin() - 1;
                        update(1, 0, N - 1, i, j, -1);
                    }
                }
            }
            l++;
        }
        int i = lower_bound(llow.begin(), llow.end(), llow[l1]) - llow.begin();
        for (auto to : low[i])
        {
            auto it = lower_bound(bback.begin(), bback.end(), max(0, to - w));
            if (it == bback.end())
                continue;
            else
            {
                int i = it - bback.begin();
                if (bback[i] > to)
                    continue;
                else
                {
                    auto j = upper_bound(bback.begin(), bback.end(), to) - bback.begin() - 1;
                    update(1, 0, N - 1, i, j, 1);
                }
            }
        }
        ans = max(ans, t[1]);
        l1++;
    }
    for (int i = 0; i < 4 * N; i++)
    {
        add[i] = t[i] = 0;
    }
    l = 0, l1 = 0;
    while(l1 < bback.size() && bback[l1] < w){
        int i = lower_bound(bback.begin(), bback.end(), bback[l1]) - bback.begin();
        for (auto to : bck[i]){
            auto it = lower_bound(llow.begin(), llow.end(), max(0, to - h));
            if (it == llow.end()) continue;
            else{
                int i = it - llow.begin();
                if (llow[i] > to) continue;
                else{
                    auto j = upper_bound(llow.begin(), llow.end(), to) - llow.begin() - 1;
                    update(1, 0, N - 1, i, j, 1);
                }
            }
        }
        ans = max(ans, t[1]);
        l1++;
    }
    while(l1 < bback.size()){
        int f = bback[l1] - w;
        while(l < bback.size() && bback[l] < f){
            int i = lower_bound(bback.begin(), bback.end(), bback[l]) - bback.begin();
            for (auto to : bck[i]){
                auto it = lower_bound(llow.begin(), llow.end(), max(0, to - h));
                if (it == llow.end()) continue;
                else{
                    int i = it - llow.begin();
                    if (llow[i] > to) continue;
                    else{
                        auto j = upper_bound(llow.begin(), llow.end(), to) - llow.begin() - 1;
                        update(1, 0, N - 1, i, j, -1);
                    }
                }
            }
            l++;
        }
        int i = lower_bound(bback.begin(), bback.end(), bback[l1]) - bback.begin();
        for (auto to : bck[i]){
            auto it = lower_bound(llow.begin(), llow.end(), max(0, to - h));
            if (it == llow.end()) continue;
            else{
                int i = it - llow.begin();
                if (llow[i] > to) continue;
                else{
                    auto j = upper_bound(llow.begin(), llow.end(), to) - llow.begin() - 1;
                    update(1, 0, N - 1, i, j, 1);
                }
            }
        }
        ans = max(ans, t[1]);
        l1++;
    }
    cout << ans << endl;
    return 0;
}
