#include "bits/stdc++.h"

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define F first
#define S second
#define ll long long
#define pii pair < int, int >
#define pb push_back

using namespace std;
using namespace __gnu_pbds;

template < typename T >
using ordered_set = tree < T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 1e5;
ll t[N * 4 + 5];
ll get_max (int v, int tl, int tr, int l, int r) {
    if (tl > r || tr < l) return -1e14;
    if (l <= tl && tr <= r) return t[v];
    int mid = (tl + tr) / 2;
    return max (get_max(v * 2, tl, mid, l, r), get_max (v * 2 + 1, mid + 1, tr, l, r));


}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, w, h;
    cin >> n >> w >> h;
    int a[205][205];
    int d[205][205];
    for (int i = 0; i <= 200; i++) {
        for (int j = 0; j <= 200; j++)
            d[i][j] = 0;
    }
    for (int  i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        x++;
        y++;
        a[x][y] ++;
    }
    d[1][1] = a[1][1];

    for (int i = 2; i <= 102; i++) {
        d[1][i] = d[1][i-1] + a[1][i];
        d[i][1] = d[i-1][1] + a[i][1];

    }

    int ans = 0;
    w++;
    h++;

    for (int i = 2; i <= 140; i++) {
        for (int j = 2; j <= 140; j++) {
            d[i][j]+=a[i][j];

            d[i][j] += d[i][j-1] + d[i-1][j] - d[i-1][j-1];

        }
    }

    for (int i = 1; i <= 103; i++) {
        for (int j = 1; j <= 103; j++) {
            int ii = i + h - 1;
            int jj = j + w - 1;
            int cur = d[ii][jj] - d[i-1][jj] - d[ii][j - 1] + d[i-1][j-1];
            ans = max (ans, cur);
            ii = i + w - 1;
            jj = j + h - 1;
            cur = d[ii][jj] - d[i-1][jj] - d[ii][j - 1] + d[i-1][j-1];
            ans = max (ans, cur);
        }
    }
    cout << ans << '\n';

    return 0;
}

