#include "biggest.h"
#include <bits/stdc++.h>
using namespace std;

/*
#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
#pragma GCC optimize("-fpeephole2")
#pragma GCC optimize("-fsched-spec")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
*/

//#define int long long
#define f first
#define s second

vector <pair <int,int> > t;

void build(int v, int l, int r)
{
    if (l==r){
        t[v]={1,l};
        return;
    }
    int m=(l+r)>>1;
    build(v*2,l,m);
    build(v*2+1,m+1,r);
    t[v].f=t[v*2].f+t[v*2+1].f;
    t[v].s=max(t[v*2].s,t[v*2+1].s);
}

void update(int v, int l, int r, int pos, int x)
{
    if (pos<l || r<pos)return;
    if (l==r){
        if (x==1){
            t[v]={1,l};
        }
        else {
            t[v]={0,-1};
        }
        return;
    }
    int m=(l+r)>>1;
    update(v*2,l,m,pos,x);
    update(v*2+1,m+1,r,pos,x);
    t[v].f=t[v*2].f+t[v*2+1].f;
    t[v].s=max(t[v*2].s,t[v*2+1].s);
}

pair <int,int> get(int v, int l, int r, int a, int b)
{
    if (b<l || r<a)return {0,-1};
    if (a<=l && r<=b)return t[v];
    int m=(l+r)>>1;
    auto q1=get(v*2,l,m,a,b);
    auto q2=get(v*2+1,m+1,r,a,b);
    return {q1.f+q2.f,max(q1.s,q2.s)};
}

int f(int x, int y)
{
    if (x==-1)return y;
    if (y==-1)return x;
    if (compare(x,y)==x)return x;
    else return y;
}

int get_maxi(int l, int r, int n)
{
    auto q=get(1,1,n,l,r);
    if (q.f==0){
        return -1;
    }
    if (q.f==1){
        return q.s;
    }
    int m=(l+r)>>1;
    return f(get_maxi(l,m,n),get_maxi(m+1,r,n));
}

vector <int> biggest(int n, int k)
{
    vector <int> ans;
    vector <bool> used(n+1,0);
    t.resize(n*4+5);
    build(1,1,n);
    for (int i=0; i<k; i++){
        int pos=get_maxi(1,n,n);
        used[pos]=1;
        ans.push_back(pos);
    }
}



