#include "biggest.h"
#include <bits/stdc++.h>
using namespace std;

/*
#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
#pragma GCC optimize("-fpeephole2")
#pragma GCC optimize("-fsched-spec")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
*/

#define f first
#define s second

map <pair <int,int>, int> was;

int f(int x, int y)
{
    if (x==-1)return y;
    if (y==-1)return x;
    if (was[{x,y}]!=0){
        return was[{x,y}];
    }
    if (compare(x,y)==x)was[{x,y}]=x;
    else was[{x,y}]=y;
    return was[{x,y}];
}

vector <int> t;
vector <bool> used;

void build(int v, int l, int r)
{
    if (l==r){
        t[v]=l;
        if (used[l]==1)t[v]=-1;
        return;
    }
    int m=(l+r)>>1;
    build(v*2+1,m+1,r);
    build(v*2,l,m);
    t[v]=f(t[v*2],t[v*2+1]);
}

void update(int v, int l, int r, int pos)
{
    if (pos<l || r<pos)return;
    if (l==r){
        t[v]=-1;
        return;
    }
    int m=(l+r)>>1;
    update(v*2+1,m+1,r,pos);
    update(v*2,l,m,pos);
    t[v]=f(t[v*2],t[v*2+1]);
}

vector <int> biggest(int n, int k)
{
    vector <int> ans;
    used.resize(n+1,0);
    t.resize(n*4+5);
    build(1,1,n);
    for (int i=0; i<k; i++){
        int pos=t[1];
        ans.push_back(pos);
        used[pos]=1;
        update(1,1,n,pos);
    }
    return ans;
}



