#include "biggest.h"
#include <bits/stdc++.h>
using namespace std;

#define f first
#define s second

int f(int x, int y)
{
    if (x==-1)return y;
    if (y==-1)return x;
    if (compare(x,y)==x)return x;
    else return y;
}

vector <int> t;
vector <bool> used;

void build(int v, int l, int r)
{
    if (l==r){
        t[v]=l;
        if (used[l]==1)t[v]=-1;
        return;
    }
    int m=(l+r)>>1;
    build(v*2+1,m+1,r);
    build(v*2,l,m);
    t[v]=f(t[v*2],t[v*2+1]);
}

void update(int v, int l, int r, int pos)
{
    if (pos<l || r<pos)return;
    if (l==r){
        t[v]=-1;
        return;
    }
    int m=(l+r)>>1;
    update(v*2+1,m+1,r,pos);
    update(v*2,l,m,pos);
    t[v]=f(t[v*2],t[v*2+1]);
}

vector <int> biggest(int n, int k)
{
    if (k==1){
        int x=1;
        for (int i=2; i<=n; i++){
            x=f(x,i);
        }
        return {x};
    }

    vector <int> ans;
    used.resize(n+1,0);
    t.resize(n*4+5);
    build(1,1,n);
    for (int i=0; i<k; i++){
        int pos=t[1];
        ans.push_back(pos);
        used[pos]=1;
        update(1,1,n,pos);
    }
    return ans;
}


