#include <bits/stdc++.h>
using namespace std;

/*
#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
#pragma GCC optimize("-fpeephole2")
#pragma GCC optimize("-fsched-spec")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
*/


#define int long long
#define f first
#define s second

vector <int> sum;
vector <int> t;

void build(int v, int l, int r)
{
    if (l==r){
        t[v]=sum[l];
        return;
    }
    int m=(l+r)>>1;
    build(v*2,l,m);
    build(v*2+1,m+1,r);
    t[v]=max(t[v*2],t[v*2+1]);
}

void update(int v, int l, int r, int pos, int x)
{
    if (pos<l || r<pos)return;
    if (l==r){
        t[v]=x;
        return;
    }
    int m=(l+r)>>1;
    update(v*2,l,m,pos,x);
    update(v*2+1,m+1,r,pos,x);
    t[v]=max(t[v*2],t[v*2+1]);
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector <int> a(n+1);
    for (int i=1; i<=n; i++){
        cin >> a[i];
    }

    sum.resize(n+1,0);
    t.resize(0);
    t.resize(4*n+10,-1000000000000000);
    for (int i=1; i<=n; i++){
        for (int j=i; j<=n; j+=i){
            sum[i]+=a[j];
        }
    }

    build(1,1,n);
    int ans=0;

    int m;
    cin >> m;
    for (int q=0; q<m; q++){
        int p,s;
        cin >> p >> s;
        vector <int> d;
        for (int i=1; i*i<=p; i++){
            if (p%i!=0)continue;
            d.push_back(i);
            if (p!=i*i)d.push_back(p/i);
        }
        for (int i:d){
            sum[i]+=s;
            update(1,1,n,i,sum[i]);
        }
        ans+=t[1];
        for (int i:d){
            sum[i]-=s;
            update(1,1,n,i,sum[i]);
        }
    }
    cout << ans;
}
/**
6 2
-5 3 2 -1 4 2
3 -4
2 3
*/
