#include <bits/stdc++.h>
using namespace std;

#define int long long
#define f first
#define s second

vector <int> sum;
vector <int> t;

void build(int v, int l, int r)
{
    if (l==r){
        t[v]=sum[l];
        return;
    }
    int m=(l+r)>>1;
    build(v*2,l,m);
    build(v*2+1,m+1,r);
    t[v]=max(t[v*2],t[v*2+1]);
}

void update(int v, int l, int r, int pos, int x)
{
    if (pos<l || r<pos)return;
    if (l==r){
        t[v]=x;
        return;
    }
    int m=(l+r)>>1;
    update(v*2,l,m,pos,x);
    update(v*2+1,m+1,r,pos,x);
    t[v]=max(t[v*2],t[v*2+1]);
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    int summ=0;
    for (int i=1; i<=n; i++){
        summ+=n/i;
    }
    vector <int> a(n+1);
    for (int i=1; i<=n; i++){
        cin >> a[i];
    }

    int m;
    cin >> m;
    vector <pair <int,int> > qu(m);
    bool four=1;
    for (int q=0; q<m; q++){
        cin >> qu[q].f >> qu[q].s;
        if (qu[q].s<0)four=0;
    }

    sum.resize(n+1,0);
    t.resize(0);
    t.resize(4*n+10,-1000000000000000);
    for (int i=1; i<=n; i++){
        for (int j=i; j<=n; j=i+j){
            sum[i]+=a[j];
        }
    }
    int start=-1000000000000000;
    int pos=0;
    for (int i=0; i<n; i++){
        if (start<sum[i]){
            start=sum[i];
            pos=i;
        }
    }
    int ans=0;

    if (four){
        int i;
        int ans=0;
        for (int q=0; q<m; q++){
            int p=qu[q].f;
            int s=qu[q].s;
            if (p%pos==0){
                ans+=start+s;
                continue;
            }
            int now=start;
            for (i=1; i*i<=p; i++){
                if (p%i!=0)continue;
                now=max(now,sum[i]+s);
            }
            ans+=now;
        }
        cout << ans;
        return 0;
    }

    build(1,1,n);

    int i;
    for (int q=0; q<m; q++){
        int p,s;
        p=qu[q].f;
        s=qu[q].s;
        vector <int> d;
        for (i=1; i*i<=p; i++){
            if (p%i!=0)continue;
            d.push_back(i);
            if (p!=i*i)d.push_back(p/i);
        }
        if (s<0){
            for (i=0; i<d.size(); i++){
                sum[d[i]]+=s;
                update(1,1,n,d[i],sum[d[i]]);
            }
            ans+=t[1];
            for (i=0; i<d.size(); i++){
                sum[i]-=s;
                update(1,1,n,d[i],sum[d[i]]);
            }
            continue;
        }
        else {
            int noww=start;
            for (int i=0; i<d.size(); i++){
                noww=max(noww,s+sum[d[i]]);
            }
            ans+=noww;
        }
    }
    cout << ans;
}
/**
6
2 -5 3 2 -1 4
2
3 -4
2 3
*/
