#include <bits/stdc++.h>
using namespace std;

#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
#pragma GCC optimize("-fpeephole2")
#pragma GCC optimize("-fsched-spec")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")


#define int long long
#define f first
#define s second

vector <int> sum;
vector <int> t;

void build(int v, int l, int r)
{
    if (l==r){
        t[v]=sum[l];
        return;
    }
    int m=(l+r)>>1;
    build(v*2,l,m);
    build(v*2+1,m+1,r);
    t[v]=max(t[v*2],t[v*2+1]);
}

void update(int v, int l, int r, int pos, int x)
{
    if (pos<l || r<pos)return;
    if (l==r){
        t[v]=x;
        return;
    }
    int m=(l+r)>>1;
    update(v*2,l,m,pos,x);
    update(v*2+1,m+1,r,pos,x);
    t[v]=max(t[v*2],t[v*2+1]);
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector <int> a(n+1);
    for (int i=1; i<=n; i++){
        cin >> a[i];
    }

    int m;
    cin >> m;
    vector <pair <int,int> > qu(m);
    bool four=1;
    for (int q=0; q<m; q++){
        cin >> qu[q].f >> qu[q].s;
        if (qu[q].s<0)four=0;
    }
    t.resize(4*n+10,-1000000000000000);

    sum.resize(n+1,0);
    for (int i=1; i<=n; i++){
        for (int j=i; j<=n; j=i+j){
            sum[i]+=a[j];
        }
    }
    int start=-1000000000000000;
    int start2=-10000000000000000;
    int pos=0;
    int pos2=0;
    for (int i=0; i<n; i++){
        if (start<sum[i]){
            start2=start;
            pos2=pos;
            start=sum[i];
            pos=i;
            continue;
        }
        if (start2<sum[i]){
            start2=sum[i];
            pos2=i;
        }
    }
    int ans=0;

    if (four){
        int ans=0;
        int i=0;
        for (int q=0; q<m; q++){
            int p=qu[q].f;
            int s=qu[q].s;
            if (p%pos==0){
                ans+=start+s;
                continue;
            }
            if (start2+s<start){
                ans+=start;
                continue;
            }
            int now=start;
            for (i=1; i*i<=p; ++i){
                if (p%i!=0)continue;
                now=max(now,sum[i]+s);
                now=max(now,sum[p/i]+s);
            }
            ans+=now;
        }
        cout << ans;
        return 0;
    }

    build(1,1,n);

    for (int q=0; q<m; q++){
        int p,s;
        p=qu[q].f;
        s=qu[q].s;

        vector <int> d;
        for (int i=1; i*i<=p; i++){
            if (p%i!=0)continue;
            d.push_back(i);
            if (p!=i*i)d.push_back(p/i);
        }
        if (s<0){
            for (int i:d){
                sum[i]+=s;
                update(1,1,n,i,sum[i]);
            }
            ans+=t[1];
            for (int i:d){
                sum[i]-=s;
                update(1,1,n,i,sum[i]);
            }
            continue;
        }
        int noww=start;
        for (int i:d){
            noww=max(noww,s+sum[i]);
        }
        ans+=noww;
    }
    cout << ans;
}
/**
6
2 -5 3 2 -1 4
2
3 -4
2 3
*/
