#include <bits/stdc++.h>
using namespace std;

#define int long long
#define f first
#define s second

vector <int> sum;
vector <int> t;

void build(int v, int l, int r)
{
    if (l==r){
        t[v]=sum[l];
        return;
    }
    int m=(l+r)>>1;
    build(v*2,l,m);
    build(v*2+1,m+1,r);
    t[v]=max(t[v*2],t[v*2+1]);
}

void update(int v, int l, int r, int pos, int x)
{
    if (pos<l || r<pos)return;
    if (l==r){
        t[v]=x;
        return;
    }
    int m=(l+r)>>1;
    update(v*2,l,m,pos,x);
    update(v*2+1,m+1,r,pos,x);
    t[v]=max(t[v*2],t[v*2+1]);
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector <int> a(n+1);
    for (int i=1; i<=n; i++){
        cin >> a[i];
    }

    sum.resize(n+1,0);
    t.resize(0);
    t.resize(4*n+10,-1000000000000000);
    int start=0=-1000000000000000;
    for (int i=1; i<=n; i++){
        for (int j=i; j<=n; j+=i){
            sum[i]+=a[j];
        }
        start=max(start,sum[i]);
    }

    build(1,1,n);
    int ans=0;

    int m;
    cin >> m;

    vector <vector <int> > d(n+1);
    for (int i=1; i<=n; i++){
        for (int j=1; j*j<=i; j++){
            if (i%j!=0)continue;
            d[i].push_back(j);
            if (i!=j*j)d[i].push_back(i/j);
        }
    }

    for (int q=0; q<m; q++){
        int p,s;
        cin >> p >> s;
        if (s>=0){
            int now=start
            for (int i:d[p]){
                now=max(now,sum[i]+s);
            }
            ans+=now;
            continue;
        }
        for (int i:d[p]){
            sum[i]+=s;
            update(1,1,n,i,sum[i]);
        }
        ans+=t[1];
        for (int i:d[p]){
            sum[i]-=s;
            update(1,1,n,i,sum[i]);
        }
    }
    cout << ans;
}
