#include "biggest.h"
#include <bits/stdc++.h>
using namespace std;

int sz;

bool comp(int a, int b) {
    return compare(a, b) == a;
}

vector<int> merge_sort(vector<int> now) 
{
    if(now.size() < 2) return now;
    int mid = now.size() / 2;
    vector<int> left = merge_sort(vector<int>(now.begin(), now.begin() + mid));
    vector<int> right = merge_sort(vector<int>(now.begin() + mid, now.end()));
    vector<int> result;
    int l = 0, r = 0;
    while(l < left.size() && r < right.size()) {
        if(comp(left[l], right[r])) {
            result.push_back(left[l]);
            l++;
        } else {
            result.push_back(right[r]);
            r++;
        }
    }
    while(l < left.size()) {
        result.push_back(left[l]);
        l++;
    }
    while(r < right.size()) {
        result.push_back(right[r]);
        r++;
    }
    return result;
}

vector<int> solve(vector<int> now, int k) {
    vector<int> result;
    int mid = now.size() / 2;
    vector<int> left = merge_sort(vector<int>(now.begin(), now.begin() + mid));
    vector<int> right = merge_sort(vector<int>(now.begin() + mid, now.end()));
    int l = 0, r = 0, count = 0;
    while(count < k && l < left.size() && r < right.size()) {
        if(comp(left[l], right[r])) {
            result.push_back(left[l]);
            l++;
        } else {
            result.push_back(right[r]);
            r++;
        }
        count++;
    }
    while(count < k && l < left.size()) {
        result.push_back(left[l]);
        l++;
        count++;
    }
    while(count < k && r < right.size()) {
        result.push_back(right[r]);
        r++;
        count++;
    }
    return result;
}

vector<int> biggest(int n, int k)
{
    vector<int> now(n);
    sz = n;
    for (int i = 0; i < n; i++)
        now[i] = i + 1;
    now = solve(now, k);
    return vector<int>(now.begin(), now.begin() + k);
}