02:45:26
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef char ch;

ll tr[10000000];
vector<ll>kr;

void build(ll v, ll l, ll r) {
    if (l == r) {
        tr[v] = kr[l];
        return;
    }
    ll mid = (l + r) / 2;
    build(v + v, l, mid);
    build(v + v + 1, mid + 1, r);
    tr[v] = max(tr[v + v], tr[v + v + 1]);
}

void remake_plus(ll v, ll x, ll in, ll l, ll r) {
    if (l == r && l == in) {
        tr[v] += x;
        return;
    }
    ll mid = (l + r) / 2;
    if (in <= mid)
        remake_plus(v + v, x, in, l, mid);
    else
        remake_plus(v + v + 1, x, in, mid + 1, r);
    tr[v] = max(tr[v + v], tr[v + v + 1]);
}

void remake_minus(ll v, ll x, ll in, ll l, ll r) {
    if (l == r && l == in) {
        tr[v] -= x;
        return;
    }
    ll mid = (l + r) / 2;
    if (in <= mid)
        remake_minus(v + v, x, in, l, mid);
    else
        remake_minus(v + v + 1, x, in, mid + 1, r);
    tr[v] = max(tr[v + v], tr[v + v + 1]);
}

ll ans(ll v, ll l, ll r, ll la, ll ra) {
    if (l >= la && r <= ra)
        return tr[v];
    ll mid = (l + r) / 2;
    if (mid >= la && mid + 1 <= ra) {
        ll ax = ans(v + v, l, mid, la, ra);
        ll ay = ans(v + v + 1, mid + 1, r, la, ra);
        return max(ax,ay);
    }
    if (mid >= la)
        return ans(v + v, l, mid, la, ra);
    else
        return ans(v + v + 1, mid + 1, r, la, ra);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, i, j, x;
    cin >> n;
    ll st = 1;
    while (st < n)
        st *= 2;
    vector<ll> a(n + 1);
    for (i = 1; i <= n; i++)
        cin >> a[i];
    kr.resize(n + 1);
    for (i = 1; i <= n; i++)
        for (j = 1; j * j <= i; j++)
            if (i % j == 0) {
                kr[j] += a[i];
                if (i / j != j)
                    kr[i / j] += a[i];
            }
    build(1, 1, st);
    ll m, p, s, sum = 0;
    cin >> m;
    for (i = 0; i < m; i++) {
        cin >> p >> s;
        for (j = 1; j * j <= p; j++) {
            remake_plus(1, s, j, 1, st);
            remake_plus(1, s, p / j, 1, st);
        }
        sum += ans(1, 1, st, 1, n);
        for (j = 1; j * j <= p; j++) {
            remake_minus(1, s, j, 1, st);
            remake_minus(1, s, p / j, 1, st);
        }
    }
    cout << sum;
}