#include <iostream>
#include <vector>
#include <set>
#include <string>
typedef long long ll;
#define pb push_back
using namespace std;
struct Node {
    Node* ru;
    Node* rd;
    Node* lu;
    Node* ld;
    ll value;
};
string to_string(Node& n) {
    string res("{");
    if (n.ru!=nullptr) {
        res+=to_string(*(n.ru));
    }
    res+=",";
    if (n.rd!=nullptr) {
        res+=to_string(*(n.rd));
    }
    res+=",";
    if (n.lu!=nullptr) {
        res+=to_string(*(n.lu));
    }
    res+=",";
    if (n.ld!=nullptr) {
        res+=to_string(*(n.ld));
    }
    res+=",";
    res+=to_string(n.value);
    return res+"}";
}
void add_node(ll x,ll y,ll lx,ll rx,ll dy,ll uy,Node& n) { //I learned! something from yesterday
    n.value++;
    if (rx-lx==1) {
        return;
    }
    ll mx((lx+rx)/2),my((dy+uy)/2);
    if (x>=mx) {
        if (y>=my) {
            if (n.ru==nullptr) {
                Node* m=new Node;
                n.ru=m;
                m->value=0;
                m->ld=nullptr;
                m->lu=nullptr;
                m->rd=nullptr;
                m->ru=nullptr;
                add_node(x,y,mx,rx,my,uy,*(n.ru));
            } else {
                add_node(x,y,mx,rx,my,uy,*(n.ru));
            }
        } else {
            if (n.rd==nullptr) {
                Node* m=new Node;
                n.rd=m;
                m->value=0;
                m->ld=nullptr;
                m->lu=nullptr;
                m->rd=nullptr;
                m->ru=nullptr;
                add_node(x,y,mx,rx,dy,my,*(n.rd));
            } else {
                add_node(x,y,mx,rx,dy,my,*(n.rd));
            }
        }
    } else {
        if (y>=my) {
            if (n.lu==nullptr) {
                Node* m=new Node;
                n.lu=m;
                m->value=0;
                m->ld=nullptr;
                m->lu=nullptr;
                m->rd=nullptr;
                m->ru=nullptr;
                add_node(x,y,lx,mx,my,uy,*(n.lu));
            } else {
                add_node(x,y,lx,mx,my,uy,*(n.lu));
            }
        } else {
            if (n.ld==nullptr) {
                Node* m=new Node;
                n.ld=m;
                m->value=0;
                m->ld=nullptr;
                m->lu=nullptr;
                m->rd=nullptr;
                m->ru=nullptr;
                add_node(x,y,lx,mx,dy,my,*(n.ld));
            } else {
                add_node(x,y,lx,mx,dy,my,*(n.ld));
            }
        }
    }
}
ll sum(ll lx,ll rx,ll dy,ll uy,ll nlx,ll nrx,ll ndy,ll nuy,Node& n) {
    if ((rx<=nlx)|(lx>=nrx)|(dy>=nuy)|(uy<=ndy)) {
        return 0;
    }
    if ((rx>=nrx)&(lx<=nlx)&(dy<=ndy)&(uy>=nuy)) {
        return n.value;
    }
    ll nmx((nlx+nrx)/2),nmy((ndy+nuy)/2),ra(0),rb(0),rc(0),rd(0);
    if (n.ru!=nullptr) {
        ra=sum(lx,rx,dy,uy,nmx,nrx,nmy,nuy,*(n.ru));
    }
    if (n.rd!=nullptr) {
        rb=sum(lx,rx,dy,uy,nmx,nrx,ndy,nmy,*(n.rd));
    }
    if (n.lu!=nullptr) {
        rc=sum(lx,rx,dy,uy,nlx,nmx,nmy,nuy,*(n.lu));
    }
    if (n.ld!=nullptr) {
        rd=sum(lx,rx,dy,uy,nlx,nmx,ndy,nmy,*(n.ld));
    }
    return ra+rb+rc+rd;
}
void auto_add_node(ll x,ll y,ll N,Node& root) { //HERE WAS FIGNYA S AMPERSANDAMI
    add_node(x,y,0,N,0,N,root);
}
ll auto_sum(ll lx,ll rx,ll dy,ll uy,ll N,Node& root) {
    return sum(lx,rx,dy,uy,0,N,0,N,root);
}
ll ubsum(ll lx,ll rx,ll dy,ll uy,ll N,Node& root) {
    return auto_sum(max((ll)0,lx),min(N,rx),max((ll)0,dy),min(N,uy),N,root);
}
ll algo1(vector<pair<ll,ll>> points,ll w,ll h,ll N) { //2,3
    Node root;
    set<ll> xs,ys;
    root.value=0;
    root.ru=nullptr;
    root.rd=nullptr;
    root.lu=nullptr;
    root.ld=nullptr;
    for (ll i=0;i<points.size();i++) {
        auto_add_node(points[i].first,points[i].second,N,root);
        xs.insert(points[i].first);
        ys.insert(points[i].second);
    }
    ll mx(0);
    for (auto i:xs) {
        for (auto j:ys) {
            mx=max(mx,ubsum(i-w,i+1,j-h,j+1,N,root));
        }
    }
    return mx;
}
ll algo2(vector<pair<ll,ll>> points,ll w,ll h,ll N) { //4,5
    Node root;
    root.value=0;
    root.ru=nullptr;
    root.rd=nullptr;
    root.lu=nullptr;
    root.ld=nullptr;
    for (ll i=0;i<points.size();i++) {
        auto_add_node(points[i].first,points[i].second,N,root);
    }
    ll mx(0);
    for (ll i=0;i<points.size();i++) {
        mx=max(mx,ubsum(points[i].first-w,points[i].first+1,points[i].second-h,points[i].second+1,N,root));
    }
    return mx;
}
ll ungeneral_solver(vector<pair<ll,ll>> points,ll w,ll h) {
    ll N2(max(w,h)),N(1);
    for (ll i=0;i<points.size();i++) {
        N2=max(N2,max(points[i].first,points[i].second));
    }
    N2++;
    while (N2>0) {
        N2/=2;
        N*=2;
    }
    if (false) {
        return algo2(points,w,h,N);
    } else {
        return algo1(points,w,h,N);
    }
}
int main(){
    vector<pair<ll,ll>> points;
    ll N,w,h,q,r;
    cin >> N >> w >> h;
    for (ll i=0;i<N;i++) {
        cin >> q >> r;
        points.pb({q,r});
    }
    cout << ungeneral_solver(points,w,h);
}
