#include "biggest.h"
#include <iostream>
#include <vector>
#include <set>
#include <random>

using namespace std;

mt19937 rnd(31);

vector<int> ans;
vector<int> rans;
void solve(const vector<int>& ind, int k, int L, int R) {
        int n = (int) ind.size();
        if (n == k) {
                for (int i : ind) {
                        ans.push_back(i);
                }
                return;
        }
        if (k == 0) return;
        vector<int> big, smol;
        int p = rnd() % n;
        for (int i = 0; i < n; ++i) {
                if (i == p) continue;
                if (compare(ind[p], ind[i]) == ind[i]) {
                        big.push_back(ind[i]);
                } else {
                        smol.push_back(ind[i]);
                }
        }
        if (k <= big.size()) 
                solve(big, k, L, R);
        else {
                for (int i : big) {
                        ans.push_back(i);
                }
                ans.push_back(ind[p]);
                rans[R - big.size()] = p;
                solve(smol, k - 1 - big.size(), L, R - big.size());
        }
}

void qsort(vector<int>& ind) {
        if (ind.size() <= 1) return;
        int p = rnd() % ind.size();
        int k = ind[p];
        vector<int> big, smol;
        for (int i = n - 1; i >= 0; --i) {
                if (i == p) {
                        ind.pop_back();
                        continue;
                }
                if (compare(ind[i], ind[p]) == ind[i]) {
                        big.push_back(ind[i]);
                } else {
                        smol.push_back(ind[i]);
                }
                ind.pop_back();
        }
        qsort(smol); qsort(big);
        for (int i : smol) 
                ind.push_back(i);
        ind.push_back(k);
        for (int i : big) {
                ind.push_back(i);
}

vector<int> biggest (int N, int K) {
        vector<int> ind (N);
        for (int i = 0; i < N; ++i) {
                ind[i] = i + 1;
        }
        qsort(ind);
        vector<int> res;
        for (int i = n - 1; i > n - k - 1; --i)
                res.push_back(ind[i]);
        return res;
}

