#include <bits/stdc++.h>
#pragma GCC optimize ("Ofast")
using namespace std;
#define int int64_t
#define pii pair<int,int>
#define F first
#define S second
int z;

struct mq {
    stack <pii> s1, s2;
    int get () {
        return ((s1.empty()) ? s2.top().S : ((s2.empty()) ? s1.top().S : max(s1.top().S, s2.top().S)));
    }
    void add (int x) {
        s1.push((s1.empty()) ? make_pair(x, x) : make_pair(x, max(x, s1.top().S)));
    }
    void del () {
        if (s2.empty()) {
            while (!s1.empty()) {
                int x = s1.top().F;
                s2.push((s2.empty()) ? make_pair(x, x) : make_pair(x, max(x, s2.top().S)));
                s1.pop();
            }
        }
        s2.pop();
    }
    void clear () {
        while (!s1.empty()) s1.pop();
        while (!s2.empty()) s2.pop();
    }
};

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    int n, w, h;
    cin >> n >> h >> w;
    vector <pii> a(n);
    int b[n+1];
    for (int i=0;i<n;++i) {
        cin >> a[i].F >> a[i].S;
        b[i] = a[i].S;
    }
    sort(b, b+n);
    sort(a.begin(), a.end());
    b[n] = 1000000000000;
    mq q1, q2;
    int l = 0, r = 0, ans = 0;
    int L = 0, R = n;
    while (L < R) {
        int ans1 = 0, ans2 = 0;
        int m = (L+R)/2;
        l = 0;r = 0;
        z = b[m];
        int k = 0;
        for (;r<n;++r) {
            if (a[r].S < z) {
                k++;
                continue;
            }
            q1.add(a[r].S);
            q2.add(-a[r].S);
            while (l < r && (a[r].F - a[l].F > h || q1.get() + q2.get() > w))  {
                if (a[l].S < z) k--;
                l++;
                q1.del();
                q2.del();
            }
            if (a[r].F - a[l].F <= h && q1.get() + q2.get() <= w) {
                ans1 = max(ans1, r-l+1-k);
            }
        }
        q1.clear();q2.clear();
        l = 0;r = 0;k = 0;
        for (;r<n;++r) {
            if (a[r].S <= z) {
                k++;
                continue;
            }
            q1.add(a[r].S);
            q2.add(-a[r].S);
            while (l < r && (a[r].F - a[l].F > h || q1.get() + q2.get() > w)) {
                if (a[l].S < z) k--;
                l++;
                q1.del();
                q2.del();
            }
            if (a[r].F - a[l].F <= h && q1.get() + q2.get() <= w) {
                ans2 = max(ans2, r-l+1-k);
            }
        }
        q1.clear();q2.clear();
        if (ans1 < ans2)
            L = m+1;
        else
            R = m;
        ans = max(ans1, ans2);
    }
    cout << ans;
    return 0;
}
/*
6 2 3
1  1
3 1
2 2
3 3
5 3
3 5
10 8 8
8 9
20 14
3 9
7 8
3 4
7 8
10 19
6 11
5 10
8 2
*/

