#include "biggest.h"
#include <algorithm>
#include <iostream>
#include <vector>
#include <numeric>

#include <map>


std::map<std::pair<int, int>, bool> maap;

bool cmp(int i, int j) {
	//return compare(i, j) == i;
	if (i == j) {
		exit(1);
	}
	if (i > j) {
		return !cmp(j, i);
	}
	if (maap.find(std::pair<int, int>{ i, j }) != maap.end()) {
		return maap[std::pair<int, int>{ i, j }];
	}
	return maap[std::pair<int, int>{ i, j }] = (compare(i, j) == i);
}

std::vector<int> biggest(int n, int k) {
	std::vector<int> vec(n);
	std::iota(vec.begin(), vec.end(), 1);
	std::nth_element(vec.begin(), vec.begin() + k, vec.end(), cmp);
	std::sort(vec.begin(), vec.begin() + k, cmp);
	return std::vector(vec.begin(), vec.begin() + k);
}