#include "biggest.h"
#include <algorithm>
#include <iostream>
#include <vector>
#include <numeric>

#include <unordered_map>

int n, k;
constexpr int GG = 20000;

class Hash {
public:
	uint64_t operator()(const std::pair<int, int> &val)const {
		return std::hash<uint64_t>()((val.first << 32) | val.second);
	}
};
std::unordered_map<std::pair<int, int>, bool, Hash> maap;
bool cmp(int i, int j) {
	if (i == -1) {
		if (j == -1) {
			return false;
		}
		return false;
	}
	if (j == -1) {
		return true;
	}
	if (k > GG) {
		return compare(i, j) == i;
	}
	if (i == j) {
		return false;
		//exit(1);
	}
	if (i > j) {
		return !cmp(j, i);
	}
	if (maap.find(std::pair<int, int>{ i, j }) != maap.end()) {
		return maap[std::pair<int, int>{ i, j }];
	}
	return maap[std::pair<int, int>{ i, j }] = (compare(i, j) == i);
}


int data[1 << 18];
int size;


int get(int i) {
	if (i < size) {
		return 2 * i + (data[2 * i] != data[i]);
	} else {
		exit(1);
	}
}

std::vector<int> biggest(int n, int k) {
	::n = n;
	::k = k;
	if (k > 2) {
		if (k <= GG) {
			maap.rehash(3 * (1 << 20));
		}

		std::vector<int> vec(n);
		std::iota(vec.begin(), vec.end(), 1);
		std::partial_sort(vec.begin(), vec.begin() + k, vec.end(), cmp);
		return std::vector(vec.begin(), vec.begin() + k);
	} else {
		for (size = 1; size < n; size *= 2) {
			;
		}
		std::fill(data, data + size * 2, -1);
		std::iota(data + size, data + size + n, 1);
		for (int i = size - 1; i > 0; i--) {
			data[i] = std::min(data[2 * i], data[2 * i + 1], cmp);
		}
		std::vector<int> ans = { data[1] }, vec;
		for (int i = get(1); ; i = get(i)) {
			vec.push_back(i);
			if (i >= size) {
				break;
			}
		}
		for (int t = 1; t < k; t++) {
			std::pair<int, int> min = { -1, -1 };
			for (int i = 0; i < vec.size(); i++) {
				if (!cmp(min.first, data[vec[i]])) {
					min = { data[vec[i]], i };
				}
			}
			ans.push_back(data[min.first]);
			if (vec[min.second] < size) {
				vec[min.second] = get(vec[min.second]);
			} else {
				vec.erase(vec.begin() + min.second);
			}
		}
		return ans;
	}
}