#include "biggest.h"
#include <algorithm>
#include <iostream>
#include <vector>
#include <numeric>

#include <unordered_map>


constexpr int GG = 20000;


int n, k;
int data[100005];

class Hash {
public:
	uint64_t operator()(const std::pair<int, int> &val)const {
		return std::hash<uint64_t>()((val.first << 32) | val.second);
	}
};
std::unordered_map<std::pair<int, int>, bool, Hash> maap;
bool cmp(int i, int j) {
	if (k > GG) {
		return compare(i, j) == i;
	}
	if (i == j) {
		return false;
		//exit(1);
	}
	if (i > j) {
		return !cmp(j, i);
	}
	if (maap.find(std::pair<int, int>{ i, j }) != maap.end()) {
		return maap[std::pair<int, int>{ i, j }];
	}
	return maap[std::pair<int, int>{ i, j }] = (compare(i, j) == i);
}



std::vector<int> biggest(int n, int k) {
	::n = n;
	::k = k;
	if (k <= GG) {
		maap.rehash(3 * (1 << 20));
	}
	std::iota(data, data + n, 1);

	if (k == 1) {
		return { *std::min_element(data, data + n, cmp) };
	} else if (k > 10000) {
		std::vector<int> vec(n);
		std::iota(vec.begin(), vec.end(), 1);
		std::partial_sort(vec.begin(), vec.begin() + k, vec.end(), cmp);
		return std::vector(vec.begin(), vec.begin() + k);
	}
}