#include <iostream>
#include "biggest.h"
#include <vector>
#include <ctime>
using namespace std;
int n;
static inline void swap(int &a, int &b) {
  int temp;
  temp=a;
  a=b;
  b=temp;
  return;
}
int k;
int v[100001];
static void sort(int left, int right) {
  if(left==right)
    return;
  int first=left,last=right,pivot=(right+left)/2;
  while (first<pivot && compare(v[pivot],v[first])==v[pivot]) {
    first++;
  }
  while (pivot<last &&  compare(v[last],v[pivot])==v[last]) {
    last--;
  }
  while (first<last) {
    swap(v[first],v[last]);
    do {
      first++;
    } while  ( first<=right &&compare(v[pivot],v[first])==v[pivot]);
    do {
      last--;
    } while (left<=last && compare(v[last],v[pivot])==v[last]);
  }
  if(left<=last && right-last<k) {
    sort(left,last);
  }
  else
    sort(last+1,right);
  return;
}
static void altsort(int left, int right) {
  if(left==right)
    return;
  int first=left,last=right,pivot=(right+left)/2;
  while (first<pivot && compare(v[pivot],v[first])==v[pivot]) {
    first++;
  }
  while (pivot<last &&  compare(v[last],v[pivot])==v[last]) {
    last--;
  }
  while (first<last) {
    swap(v[first],v[last]);
    do {
      first++;
    } while  ( first<=right &&compare(v[pivot],v[first])==v[pivot]);
    do {
      last--;
    } while (left<=last && compare(v[last],v[pivot])==v[last]);
  }
  if(left<=last)
    sort(left,last);
  if(last+1<right)
    sort(last+1,right);
  return;
}
vector<int> biggest(int a, int b) {
  n=a;
  k=b;
  for(int i=1; i<=n; i++)
    v[i]=i;
  sort(1,n);
  altsort(n-k+1,n);
  vector<int> results;
  for(int i=0; i<k; i++) {
    results.push_back(v[n-i]);
  }
  return results;
}
