#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define pii pair < int, int >
#include <bits/stdc++.h>
#define ld long double
#define ll long long
#define _ << ' ' <<
#define fi first
#define se second
#define int ll

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update >;

const int N = 3e5 + 100;
const int inf = 1e17;

int32_t main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    vector < int > a(n + 1);
    for(int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    vector < int > sum(n + 1, 0);
    for(int i = 1; i <= n; i++) {
        int d = 1;
        while(d * d <= i) {
            if(i % d == 0) {
                sum[d] += a[i];
                if(d * d != i) sum[i / d] += a[i];
            }
            d++;
        }
    }

    int ans = 0;
    int q;
    cin >> q;
    while(q--) {
        int p, s;
        cin >> p >> s;

        int now = -inf;
        int d = 1;
        while(d * d <= p) {
            if(p % d == 0) {
                sum[d] += s;
                if(d * d != p) sum[p / d] += s;
            }
            d++;
        }

        for(int i = 1; i <= n; i++) {
            now = max(now, sum[i]);
        }

        d = 1;
        while(d * d <= p) {
            if(p % d == 0) {
                sum[d] -= s;
                if(d * d != p) sum[p / d] -= s;
            }
            d++;
        }
        ans += now;
    }

    cout << ans << endl;
    return 0;
}
