#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define pii pair < int, int >
#include <bits/stdc++.h>
#define ld long double
#define ll long long
#define _ << ' ' <<
#define fi first
#define se second
#define int ll

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update >;

const int N = 5e4 + 1;
const int inf = 1e17;

int32_t main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    vector < int > a(n + 1);
    for(int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    vector < int > sum(n + 1, 0);
    for(int i = 1; i <= n; i++) {
        int d = 1;
        while(d * d <= i) {
            if(i % d == 0) {
                sum[d] += a[i];
                if(d * d != i) sum[i / d] += a[i];
            }
            d++;
        }
    }

    int ans = 0;
    int q;
    cin >> q;

    multiset < int > now;
    int mx = -inf, ind;
    for(int i = 1; i <= n; i++) {
        now.insert(sum[i]);
        if(sum[i] > mx) {
            mx = sum[i];
            ind = i;
        }
    }

    vector < int > vec(N), vec2(N);

    for(int i = 1; i <= n; i++) {
        int mxx = -inf, mxx2 = -inf;
        int d = 1;
        vector < int > add;
        while(d * d <= i) {
            if(i % d == 0) {
                mxx = max({ sum[d], mxx, sum[i / d] });
                now.erase(sum[d]);
                now.erase(sum[i / d]);
                add.push_back(sum[d]);
                add.push_back(sum[i / d]);
            }
            d++;
        }
        vec[i] = mxx; vec2[i] = *now.rbegin();
        for(auto el : add) {
            now.insert(el);
        }
    }

    while(q--) {
        int p, s;
        cin >> p >> s;

        if(s >= 0) {
            ans += max(sum[ind], vec[p] + s);
            continue;
        }
        else {
            if(p % ind == 0) {
                ans += max(vec2[p], sum[ind] + s);
            }
            else {
                ans += max(vec2[p], sum[ind]);
            }
        }
    }

    cout << ans << endl;
    return 0;
}
