#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define pii pair < int, int >
#include <bits/stdc++.h>
#define ld long double
#define ll long long
#define _ << ' ' <<
#define fi first
#define se second
#define int ll

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update >;

const int N = 3e5 + 100;
const int inf = 1e17;

int a[2001][2001];

int32_t main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, w, h;
    cin >> n >> w >> h;

    bool F = true;

    vector < pii > v(n + 1);
    for(int i = 1; i <= n; i++) {
        cin >> v[i].fi >> v[i].se;
        a[v[i].fi][v[i].se]++;
        if(n > 100 || v[i].fi > 100 || v[i].se > 100) F = false;
    }

    if(F) {
        int ans = 0;
        for(int i = 1; i <= 100; i++) {
            for(int j = 1; j <= 100; j++) {
                int cnt = 0;
                for(int k = 1; k <= n; k++) {
                    int x = v[k].fi, y = v[k].se;
                    if(x >= i && y >= j && x <= w + i && y <= j + h) {
                        cnt++;
                    }
                }
                ans = max(ans, cnt);
            }
        }
        cout << ans << '\n';
        exit(0);
    }

    for(int i = 1; i <= 1000; i++) {
        for(int j = 1; j <= 1000; j++) {
            a[i][j] += a[i - 1][j] + a[i][j - 1] - a[i - 1][j - 1];
        }
    }

    int ans = 0;

    for(int i = 1; i <= n; i++) {
        int x = v[i].fi, y = v[i].se;
        ans = max(ans, a[x][y] - a[max(0ll, x - w)][y] - a[x][max(0ll, y - h)] + a[max(0ll, x - w)][max(0ll, y - h)]);
    }

    cout << ans << endl;
    return 0;
}
