#include <bits/stdc++.h>

using namespace std;

int n, m, k;
vector <long long> a(5e4 + 100), t(1e5 + 100, -1e18);
vector <vector <int>> del(5e4 + 100);

void build() {
    for (int v = n - 1; v > 0; --v)
        t[v] = max(t[v << 1], t[v << 1 | 1]);
}

void update(int pos, int val) {
    for (t[pos] += val; pos > 0; pos >>= 1)
        t[pos >> 1] = max(t[pos], t[pos ^ 1]);
}

long long query(int l, int r) {
    long long ans = -1e18;
    for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
        if (l & 1) ans = max(ans, t[l++]);
        if (!(r & 1)) ans = max(ans, t[r--]);
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> a[i];
    for (int pos = 1; pos <= n; ++pos) {
        for (int i = 1; i * i <= pos; ++i) {
            if (pos % i) continue;
            del[pos].push_back(i);
            if (i * i != pos)
                del[pos].push_back(pos / i);
        }
    }
    for (int i = 1; i <= n; ++i)
        for (auto j : del[i])
            t[j + n - 1] = (t[j + n - 1] == -1e18 ? a[i] : t[j + n - 1] + a[i]);
    build();
    cin >> m;
    long long ans = 0;
    while (m--) {
        int pos;
        long long val;
        vector <pair <long long, long long>> last;
        cin >> pos >> val;
        for (int i : del[pos]) {
            last.push_back({-val, i + n - 1});
            update(i + n - 1, val);
        }
        ans += t[1];
        for (auto i : last)
            update(i.second, i.first);
    }
    cout << ans;
}
