#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;
const ll MAXN = 1e4 + 10;

void fast_io()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

ll n, a[MAXN], b[MAXN], t[4 * MAXN];

void build_tree(ll root, ll left, ll right)
{
    if (left == right)
    {
        t[root] = b[left];
        return;
    }

    ll mid = (left + right) / 2;
    build_tree(root * 2, left, mid);
    build_tree(root * 2 + 1, mid + 1, right);

    t[root] = max(t[root * 2], t[root * 2 + 1]);
}

void update(ll root, ll left, ll right, ll idx, ll s)
{
    if (left == right)
    {
        t[root] += s;
        return;
    }

    ll mid = (left + right) / 2;
    if (idx <= mid)
        update(root * 2, left, mid, idx, s);
    if (idx > mid)
        update(root * 2 + 1, mid + 1, right, idx, s);

     t[root] = max(t[root * 2], t[root * 2 + 1]);
}
void solve()
{
    cin >> n;
    for (ll i = 1; i <= n; i ++)
    {
        cin >> a[i];
        ll bor = sqrt(i);
        for (ll j = 1; j <= bor; j ++)
        {
            if (i % j == 0)
            {
                b[j] += a[i];
                if (j * j != i)
                    b[i / j] += a[i];
            }
        }
    }

    ll maxx = 0;
    for (ll i = 1; i <= n; i ++)
        if (b[i] > maxx)
            maxx = b[i];

    build_tree(1, 1, n);

    ll ans = 0;
    ll m;
    cin >> m;
    for (ll i = 1; i <= m; i ++)
    {
        ll p, s;
        cin >> p >> s;
        ll bor = sqrt(p), idk = maxx;
        for (ll j = 1; j <= bor; j ++)
        {
            if (p % j == 0)
            {
                update(1, 1, n, j, s);
                if (j * j != p)
                    update(1, 1, n, p / j, s);
            }
        }


        ans += t[1];
        for (ll j = 1; j <= bor; j ++)
        {
            if (p % j == 0)
            {
                update(1, 1, n, j, -s);
                if (j * j != p)
                    update(1, 1, n, p / j, -s);
            }
        }
    }

    cout << ans << endl;
}

int main()
{
    fast_io();
    solve();
    return 0;
}
