#include<bits/stdc++.h>
using namespace std;
#define left dsd
#define right sdfa
const int MAXN=1e5+6;
struct point
{
    int x,y;
    bool operator<(point const& other)const
    {
        return make_pair(x,y)<make_pair(other.x,other.y);
    }
};
vector<point>p;
int n,h,w,maxy;
int tree[4*MAXN];
int lazy[4*MAXN];
map<int,int>newy;
int upy[MAXN];
int downy[MAXN];
int realy[MAXN];
void pushdown(int l,int r,int idx)
{
    tree[idx]+=lazy[idx];
    if(l!=r)
    {
        lazy[idx*2]+=lazy[idx];
        lazy[idx*2+1]+=lazy[idx];
    }
    lazy[idx]=0;
}
void update(int l,int r,int idx,int ql,int qr,int val)
{
    pushdown(l,r,idx);
    if(l>qr)return;
    if(r<ql)return;
    if(l>r)return;
    if(l>=ql&&r<=qr)
    {
        //cout<<"* "<<l<<" "<<r<<" "<<idx<<endl;
        lazy[idx]+=val;
        pushdown(l,r,idx);
        return;
    }
    int mid=(l+r)/2;
    update(l,mid,idx*2,ql,qr,val);
    update(mid+1,r,idx*2+1,ql,qr,val);
    tree[idx]=max(tree[idx*2],tree[idx*2+1]);
}
int query(int l,int r,int idx,int ql,int qr)
{
    pushdown(l,r,idx);
    if(l>r)return 0;
    if(l>qr)return 0;
    if(r<ql)return 0;
    if(l>=ql&&r<=qr)return tree[idx];
    int mid=(l+r)/2;
    return max(query(l,mid,idx*2,ql,qr),query(mid+1,r,idx*2+1,ql,qr));
}
int arr[MAXN];
void update(int l,int r,int val)
{
    for(int i=l;i<=r;i++)
    {
        arr[i]+=val;
    }
}
int query(int l,int r)
{
    int ret=0;
    for(int i=l;i<=r;i++)
    {
        ret=max(ret,arr[i]);
    }
    return ret;
}
map<int,vector<int> >mp;
int main()
{
    cin>>n>>w>>h;
    set<int>s;
    vector<int>xx;
    set<int>ff;
    for(int i=0;i<n;i++)
    {
        int x,y;
        cin>>x>>y;
        s.insert(y);
        p.push_back({x,y});
        mp[x].push_back(y);
        ff.insert(x);
    }
    for(set<int>::iterator it=ff.begin();it!=ff.end();it++)
    {
        xx.push_back((*it));
    }
    sort(p.begin(),p.end());
    for(set<int>::iterator it=s.begin();it!=s.end();it++)
    {
        newy[(*it)]=++maxy;
        realy[maxy]=(*it);
    }
    for(int i=0;i<=maxy;i++)
    {
        int low=0,high=i-1,mid,ans=i;
        while(low<=high)
        {
            mid=(low+high)/2;
            if(realy[i]-realy[mid]<=h)
            {
                ans=mid;
                high=mid-1;
            }
            else low=mid+1;
        }
        downy[i]=ans;
        low=i+1,high=maxy,ans=i;
        while(low<=high)
        {
            mid=(low+high)/2;
            if(realy[mid]-realy[i]<=h)
            {
                ans=mid;
                low=mid+1;
            }
            else high=mid-1;
        }
        upy[i]=ans;
        //cout<<i<<" "<<realy[i]<<" "<<upy[i]<<" "<<downy[i]<<endl;
    }
    sort(xx.begin(),xx.end());
    memset(tree,0,sizeof(tree));
    memset(lazy,0,sizeof(lazy));
    int left=0,right=-1,maxcnt=0;
    for(int i=0;i<xx.size();i++)
    {
        //cout<<xx[i]<<endl;
        while(right+1<xx.size()&&xx[right+1]-xx[i]<=w)
        {
            right++;
            vector<int>vv=mp[xx[right]];
            //cout<<xx[right]<<":\n";
            for(int j=0;j<vv.size();j++)
            {
                int y1=newy[vv[j]];
                //cout<<"+"<<vv[j]<<endl;
                //cout<<y1<<" "<<upy[y1]<<endl;
                //update(y1,upy[y1],+1);
                update(1,MAXN-1,1,y1,upy[y1],+1);
            }
        }
        //cout<<xx[i]<<" "<<xx[right]<<" "<<xx[right+1]<<endl;
        while(left<xx.size()&&xx[left]<xx[i])
        {
            vector<int>vv=mp[xx[left]];
            for(int j=0;j<vv.size();j++)
            {
                int y1=newy[vv[j]];
                //cout<<"-"<<vv[j]<<endl;
                //cout<<y1<<" "<<upy[y1]<<endl;
                //update(y1,upy[y1],-1);
                update(1,MAXN-1,1,y1,upy[y1],-1);
            }
            left++;
        }
        //cout<<"^^"<<query(1,MAXN-1,1,1,MAXN-1)<<endl;
        maxcnt=max(maxcnt,query(1,MAXN-1,1,1,MAXN-1));
        //maxcnt=max(maxcnt,query(1,MAXN-1));
    }
    cout<<maxcnt<<endl;
return 0;
}
