#include<bits/stdc++.h>
#define endl "\n"

using namespace std;

struct stran
{
    int be, en, le, ty;
    stran() {}
    stran(int a, int b, int c, int d)
    {
        be=a;
        en=b;
        le=c;
        ty=d;
    }
};

bool operator<(stran p, stran q)
{
    if(p.le==q.le) return p.ty>q.ty;
    return p.le<q.le;
}

map<int, int> us;

int n;
stran s[200007];

void conv()
{
    int i=0;
    map<int, int>::iterator it;
    for(it=us.begin(); it!=us.end(); it++)
    {
        us[(*it).first]=i;
        i++;
    }
    for(i=0; i<2*n; i++)
    {
        s[i].be=us[s[i].be];
        s[i].en=us[s[i].en];
    }
}

int lazy[900000];
int segm[900000];

void push_lazy(int v, int le, int ri)
{
    segm[v]+=lazy[v];
    if(le!=ri)
    {
        lazy[2*v]+=lazy[v];
        lazy[2*v+1]+=lazy[v];
    }
    lazy[v]=0;
}

void upd(int v, int le, int ri, int be, int en, int nst)
{
    push_lazy(v, le, ri);
    if(be>ri || le>en) return;
    if(be<=le && ri<=en)
    {
        lazy[v]+=nst;
        push_lazy(v, le, ri);
    }
    else
    {
        int mid=(le+ri)/2;
        upd(2*v, le, mid, be, en, nst);
        upd(2*v+1, mid+1, ri, be, en, nst);
        segm[v]=max(segm[2*v], segm[2*v+1]);
    }
}

/**int query(int v, int le, int ri, int be, int en)
{
    push_lazy();
    if(be>ri || le<en) return 0;
    if(be<=le && ri<=en) return segm[v];
    else
    {
        int mid=(le+ri)/2;
        int m1=query(2*v, le, mid, be, en);
        int m2=query(2*v+1, mid+1, ri, be, en);
        return max(m1, m2);
    }
}*/

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int w, h;
    cin>>n>>w>>h;
    for(int i=0; i<n; i++)
    {
        int a, b;
        cin>>a>>b;
        s[2*i]=stran(b, b+h, a, 1);
        s[2*i+1]=stran(b, b+h, a+w, -1);
        us[b]=0;
        us[b+h]=0;
    }
    conv();
    sort(s, s+2*n);
    int maxpr=0;
    for(int i=0; i<900000; i++) segm[i]=0;
    for(int i=0; i<2*n; i++)
    {
        upd(1, 1, n, s[i].be, s[i].en, s[i].ty);
        maxpr=max(maxpr, segm[1]);
    }
    cout<<maxpr<<endl;
    return 0;
}
/**
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5
*/
