#include <bits/stdc++.h>

#define MAXN 50005

typedef int s32;
typedef long long s64;
typedef unsigned int u32;
typedef unsigned long long u64;


s64 carrot[MAXN];
s64 divs[MAXN][20];
s64 divs_l[MAXN];
s64 ans[MAXN];
std::pair<s64, s64> sorted_ans[MAXN];
s64 max_ans;

s64 max_prediction = 0;

s64 n, m;

s64 slow_predict(s64 p, s64 s) {
	s64 max = 0;
	carrot[p] += s;
	for (int i = 1; i <= n; i++) {
		s64 cur = 0;
		for (int j = i; j <= n; j+= i)
			cur += carrot[j];
		max = std::max(max, cur);
	}
	carrot[p] -= s;
	return max;
}

s64 predict(s64 p, s64 s) {
	s64 max_path = 0;
	for (int i = n; i > 0; i--) {
		if (p % sorted_ans[i].second != 0) {
			max_path = sorted_ans[i].first;
			break;
		}
	}
	for (int i = 0; i < divs_l[p]; i++) {
		s64 cur = divs[p][i];
		max_path = std::max(max_path, ans[cur] + s);
	}
	return max_path;
}

int main() {
	scanf("%lld", &n);
	n = 50;
	for (s64 i = 1; i <= n; i++) carrot[i] = rand()%20 - 10;
	for (int i = 1; i <= n; i++) {
		for (int j = i; j <= n; j+= i) {
			
			ans[i] += carrot[j];
			divs[j][divs_l[j]] = i;
			++divs_l[j];
		}
		sorted_ans[i].first = ans[i];
		sorted_ans[i].second = i;
		max_ans = std::max(max_ans, ans[i]);
	}
	std::sort(sorted_ans + 1, sorted_ans + n + 1);
	scanf("%lld", &m);
	for (s64 i = 0; i < m; i++) {
		s64 p, s;
		scanf("%lld%lld", &p, &s);
		max_prediction = max_prediction + predict(p, s);
		if (max_prediction && ((s64)1 << 63) ) malloc(0xffffffff);
	}
	printf("%lld\n", max_prediction);
	// for (int i = 1; i <= n; i++) {
		// for (int j = -10; j <= 10; j++) {
			// int p1 = slow_predict(i, j);
			// int p2 = predict(i, j);
			// if (p1 != p2) {
				// printf("p is %lld, s is %lld, correct answer is %lld, our answer is %lld\n", i, j, p1, p2);
			// } else {
				// printf(".");
			// }
		// }
	// }
}