#include <iostream>
#include <algorithm>
#include <limits.h>
using namespace std;
typedef long long ll;
const ll maxn = 1e5+10;
pair < ll, ll > px[maxn];
pair < ll, ll > py[maxn];
ll n, h[2], ans;
ll binary(ll x) {
    ll l = 0, r = n+1, m;
    while (l < r - 1) {
        m = (l+r)/2;
        if (px[m].first < x) l = m;
        else r = m;
    }
    return r;
}
ll biggerY(ll y) {
    ll l = 0, r = n+1, m;
    while (l < r - 1) {
        m = (l+r)/2;
        if (py[m].first < y) l = m;
        else r = m;
    }
    return r;
}
ll smallerY(ll y) {
    ll l = 0, r = n+1, m;
    while (l < r - 1) {
        m = (l+r)/2;
        if (py[m].first <= y) l = m;
        else r = m;
    }
    return l;
}
ll square(ll x, ll y, ll x1, ll y1) {
    int beg = binary(x), ret = 0;
    //cerr << "square: " << x << ' ' << y << ' ' << x1 << ' ' << y1 << ' ' << beg << '\n';
    for (int i = beg ; i <= n ; ++i) {
        if (px[i].first > x1) break;
        ret += (y <= px[i].second && px[i].second <= y1);
    }
    return ret;
}
int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> h[0] >> h[1];
    for (ll i = 1 ; i <= n ; ++i) {
        cin >> px[i].first >> px[i].second;
        py[i] = {px[i].second, px[i].first};
    }
    sort(px+1, px+n+1);
    sort(py+1, py+n+1);
    //for (ll i = 1 ; i <= n ; ++i)
        //cout << "p[" << i << "]: " << p[i].first << ' ' << p[i].second << '\n';
    for (ll i = 1 ; i <= n ; ++i) {
        for (int j = 0 ; j < 2 ; ++j) {
            int ybeg = biggerY(px[i].second-h[0]), yend = smallerY(px[i].second+h[0]);
            for (int x = ybeg ; x <= yend ; ++x) {
                ans = max(ans, square(min(px[i].first, py[x].second), min(px[i].second, py[x].first), min(px[i].first, py[x].second)+h[1], min(px[i].second, py[x].first)+h[0]));
                ans = max(ans, square(min(px[i].first, py[x].second), max(px[i].second, py[x].first), min(px[i].first, py[x].second)+h[1], max(px[i].second, py[x].first)-h[0]));
            }
            swap(h[0], h[1]);
        }

    }
    cout << ans << '\n';
    return 0;
}
/*


*/
