#include <iostream>
#include <algorithm>
#include <limits.h>
using namespace std;
typedef long long ll;
const ll maxn = 1e5+10;
pair < ll, ll > p[maxn];
ll n, h, w, ans;
ll binary(ll x) {
    ll l = 0, r = n+1, m;
    while (l < r - 1) {
        m = (l+r)/2;
        if (p[m].first < x) l = m;
        else r = m;
    }
    return r;
}
ll square(ll x, ll y, ll x1, ll y1) {
    if (x < 0 || y < 0) return 0;
    int beg = binary(x), ret = 0;
    //cerr << "square: " << x << ' ' << y << ' ' << x1 << ' ' << y1 << ' ' << beg << '\n';
    for (int i = beg ; i <= n ; ++i) {
        if (p[i].first > x1) break;
        ret += (y <= p[i].second && p[i].second <= y1);
    }
    return ret;
}
ll max_x, max_y;
int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> h >> w;
    for (ll i = 1 ; i <= n ; ++i) {
        cin >> p[i].first >> p[i].second;
        max_x = max(max_x, p[i].first);
        max_y = max(max_y, p[i].second);
    }
    sort(p+1, p+n+1);
    for (int x = 0 ; x <= max_x ; ++x) {
        for (int y = 0 ; y <= max_y ; ++y) {
            ans = max(ans, square(x-w, y-h, x, y));
            ans = max(ans, square(x, y-h, x+w, y));
            ans = max(ans, square(x-w, y, x, y+h));
            ans = max(ans, square(x, y, x+w, y+h));
            // rev
            ans = max(ans, square(x-h, y-w, x, y));
            ans = max(ans, square(x, y-w, x+h, y));
            ans = max(ans, square(x-h, y, x, y+w));
            ans = max(ans, square(x, y, x+h, y+w));
        }
    }
    cout << ans << '\n';
    return 0;
}
/*


*/
