#include <iostream>
#include <algorithm>
#include <unordered_map>
using namespace std;
#define endl '\n'
struct Point{
    int x, y;
};
const int MAXN=1e5+10;
const int MAXX=1e8+10;
Point p[MAXN];
int t[101][101], x[MAXN], y[MAXN], maxx;
int tree[4*MAXN];
bool cmp(Point a, Point b) {
    return a.y>b.y;
}
int rect(int x, int y, int w, int h) {
    if (x+w>100 || y+h>100) return 0;
    int s=0;
    for (int i=x;i<=w+x;i++) {
        for (int j=y;j<=h+y;j++) s+=t[i][j];
    }
    return s;
}
void update(int node, int l, int r, int qind, int ch) {
    if (qind>r || qind<l) return;
    if (l==r) {
        tree[node]+=ch;
        return;
    }
    int mid=(l+r)/2;
    update(node*2,l,mid,qind,ch);
    update(node*2+1,mid+1,r,qind,ch);
    tree[node]=tree[node*2]+tree[node*2+1];
}
int query(int node, int l, int r, int ql, int qr) {
    if (ql>r || qr<l) return 0;
    if (l>=ql && r<=qr) return tree[node];
    int mid=(l+r)/2;
    return query(node*2,l,mid,ql,qr)+query(node*2+1,mid+1,r,ql,qr);
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, w, h;
    bool ok=true;
    cin >> n >> w >> h;
    if (w>100 || h>100) ok=false;
    for (int i=0;i<n;i++) {
        cin >> p[i].x >> p[i].y;
        x[i]=p[i].x;
        y[i]=p[i].y;
        maxx=max(maxx,x[i]);
        if (x[i]>100 || y[i]>100) ok=false;
    }
    sort(x,x+n);
    sort(y,y+n);
    if (ok) {
        for (int i=0;i<n;i++) t[p[i].x][p[i].y]++;
        int ans=0;
        for (int i=1;i<=100;i++) {
            for (int j=1;j<=100;j++) {
                ans=max(ans,rect(i,j,w,h));
            }
        }
        cout << ans << endl;
        return 0;
    }
    sort(p,p+n,cmp);
    int br1=0, y1, gr, ans=0;
    for (int i=0;i<n;i++) {
        y1=p[i].y;
        gr=i;
        while (i<n && p[i].y==y1) i++;
        i--;
        ///cout << gr << ' ' << i << endl;
        y1=p[i].y-h;
        while (br1<n && p[br1].y>=y1) {
            ///cout << p[br1].x << ' ' << p[br1].y << endl;
            update(1,0,maxx,p[br1].x,1);
            br1++;
        }
        ///cout << endl;
        for (int j=gr;j<=i;j++) {
            if (p[j].x>=w) ans=max(ans,query(1,0,maxx,p[j].x-w,p[j].x));
        }
        for (int j=gr;j<=i;j++) update(1,0,maxx,p[j].x,-1);
    }
    cout << ans << endl;
    return 0;
}
/**
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5
**/
