#include "biggest.h"
#include <iostream>
#include <vector>
using namespace std;

int compare(int x, int y);

vector<int> biggest(int N, int K)
{
    vector<int> v;
    v.push_back(1);
    int sz = 1;
    for (int i = 2; i <= N; ++ i)
    {
        bool flag = true;
        int l = -1, r = sz, mid;
        while (r - l > 1)
        {
            mid = (l + r) / 2;
            if (compare(i, v[mid]) == i) l = mid;
            else r = mid;
            if (sz - r >= K)
            {
                flag = false;
                break;
            }
        }
        if (flag)
        {
            v.insert(v.begin() + (l + 1), i);
            sz++;
        }
    }

    vector<int> v0;
    for (int i = sz - 1; i >= sz - K; -- i)
    {
        v0.push_back(v[i]);
    }

    return v0;
}
