#include "biggest.h"
#include <iostream>
#include <vector>
using namespace std;

int compare(int x, int y);

vector<int> biggest(int N, int K)
{
    int idx = 1;
    for (int i = 2; i <= N; ++ i)
    {
        if (compare(idx, i) == i) idx = i;
    }

    vector<int> v;
    v.push_back(idx);
    int sz = 1;
    for (int i = 2; i <= N; ++ i)
    {
        if (i == idx) continue;
        if (sz >= K)
        {
            if (compare(v[sz - K], i) != i) continue;
        }
        int l = -1, r = sz, mid;
        while (r - l > 1)
        {
            mid = (l + r) / 2;
            if (compare(i, v[mid]) == i) l = mid;
            else r = mid;
        }
        v.insert(v.begin() + (l + 1), i);
        sz++;
    }

    vector<int> v0;
    for (int i = sz - 1; i >= sz - K; -- i)
    {
        v0.push_back(v[i]);
    }

    return v0;
}
