#include "biggest.h"
#include <iostream>
#include <vector>
using namespace std;

int compare(int x, int y);

vector<int> biggest(int N, int K)
{
    if (K <= 10)
    {
        vector<int> v0(K, 0);
        int last = -1;
        for (int i = 1; i <= N; ++ i)
        {
            for (int j = last; j >= -1; -- j)
            {
                if (j == -1)
                {
                    for (int k = K; k > j + 1; -- k)
                    {
                        v0[k] = v0[k - 1];
                    }
                    if (j + 1 < K) v0[j + 1] = i;
                    last = min(K - 1, last + 1);
                    break;
                }
                if (compare(v0[j], i) != i)
                {
                    for (int k = K; k > j + 1; -- k)
                    {
                        v0[k] = v0[k - 1];
                    }
                    if (j + 1 < K) v0[j + 1] = i;
                    last = min(K - 1, last + 1);
                    break;
                }
            }
        }
        return v0;
    }

    vector<int> v;
    v.push_back(1);
    int sz = 1;
    for (int i = 2; i <= N; ++ i)
    {
        if (sz >= K)
        {
            if (compare(v[sz - K], i) != i) continue;
        }
        int l = (sz >= K ? sz - K : -1), r = sz, mid;
        while (r - l > 1)
        {
            mid = (l + r) / 2;
            if (compare(i, v[mid]) == i) l = mid;
            else r = mid;
        }
        v.insert(v.begin() + (l + 1), i);
        sz++;
    }

    vector<int> v0;
    for (int i = sz - 1; i >= sz - K; -- i)
    {
        v0.push_back(v[i]);
    }

    return v0;
}
