#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

int x[MAXN + 5], y[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, w, h;
    cin >> n >> w >> h;

    vector<int> vx, vy;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> x[i] >> y[i];
        vx.push_back(x[i]);
        vy.push_back(y[i]);
    }

    sort(vx.begin(), vx.end());
    sort(vy.begin(), vy.end());

    if (n <= 1000)
    {
        int ans = 0;
        for (int i = 0; i < vx.size(); ++ i)
        {
            for (int j = 0; j < vy.size(); ++ j)
            {
                int x1 = vx[i], y1 = vy[j];
                int x2 = x1 + w, y2 = y1 + h;
                int cnt = 0;
                for (int k = 1; k <= n; ++ k)
                {
                    if (x1 <= x[k] and x[k] <= x2 and y1 <= y[k] and y[k] <= y2) cnt++;
                }
                ans = max(ans, cnt);
            }
        }

        cout << ans << endl;
    }

    return 0;
}
