#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

int n, w, h;
int x[MAXN + 5], y[MAXN + 5];
int dp[1005][1005];
vector<int> row[MAXN + 5], col[MAXN + 5];

void solve12()
{
    vector<int> vx, vy;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> x[i] >> y[i];
        vx.push_back(x[i]);
        vy.push_back(y[i]);
    }

    sort(vx.begin(), vx.end());
    auto it = unique(vx.begin(), vx.end());
    vx.resize(distance(vx.begin(), it));

    sort(vy.begin(), vy.end());
    it = unique(vy.begin(), vy.end());
    vy.resize(distance(vy.begin(), it));

    int szx = vx.size(), szy = vy.size();
    for (int i = 1; i <= n; ++ i)
    {
        dp[lower_bound(vx.begin(), vx.end(), x[i]) - vx.begin() + 1][lower_bound(vy.begin(), vy.end(), y[i]) - vy.begin() + 1]++;
    }

    int ans = 0;
    for (int i = 1; i <= szx; ++ i)
    {
        for (int j = 1; j <= szy; ++ j)
        {
            dp[i][j] += dp[i - 1][j] + dp[i][j - 1] - dp[i - 1][j - 1];
            int curr = dp[i][j] - dp[lower_bound(vx.begin(), vx.end(), vx[i - 1] - w) - vx.begin()][j]
                                - dp[i][lower_bound(vy.begin(), vy.end(), vy[j - 1] - h) - vy.begin()]
                                + dp[lower_bound(vx.begin(), vx.end(), vx[i - 1] - w) - vx.begin()][lower_bound(vy.begin(), vy.end(), vy[j - 1] - h) - vy.begin()];
            ans = max(ans, curr);
        }
    }

    cout << ans << endl;
}

void solve34()
{
    vector<int> vx, vy;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> x[i] >> y[i];
        vx.push_back(x[i]);
        vy.push_back(y[i]);
    }

    sort(vx.begin(), vx.end());
    auto it = unique(vx.begin(), vx.end());
    vx.resize(distance(vx.begin(), it));

    sort(vy.begin(), vy.end());
    it = unique(vy.begin(), vy.end());
    vy.resize(distance(vy.begin(), it));

    for (int i = 1; i <= n; ++ i)
    {
        row[lower_bound(vy.begin(), vy.end(), y[i]) - vy.begin()].push_back(lower_bound(vx.begin(), vx.end(), x[i]) - vx.begin());
        col[lower_bound(vx.begin(), vx.end(), x[i]) - vx.begin()].push_back(lower_bound(vy.begin(), vy.end(), y[i]) - vy.begin());
    }

    int ans = 0;
    for (int i = 1; i <= n; ++ i)
    {
        int cnt = 0;
        for (int j = (lower_bound(vy.begin(), vy.end(), y[i] - h) - vy.begin()); j <= lower_bound(vy.begin(), vy.end(), y[i]) - vy.begin(); ++ j)
        {
            cnt += (lower_bound(row[j].begin(), row[j].end(), x[i] + 1) - row[j].begin()) - (lower_bound(row[j].begin(), row[j].end(), x[i] - w) - row[j].begin());
        }
        ans = max(ans, cnt);
    }
    cout << ans << endl;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> w >> h;

    if (n <= 1000) solve12();
    else solve34();

    return 0;
}
