#include "biggest.h"
#include <algorithm>
#include <vector>
#include <stack>
#include <cmath>
using namespace std;

int arr[100200];
bool used[100200];
int comp_max[100200];

bool cmp1(int a, int b)
{
    int z = compare(a, b);
    return a == z;
}

vector<int> biggest(int n, int k)
{
    vector<int> ans;
    if(k > 1000){
        for(int i = 1; i <= n; i++){
            arr[i] = i;
        }
        sort(arr+1, arr+n+1, cmp1);
        for(int i = 1; i <= k; i++){
            ans.push_back(arr[i]);
        }
        return ans;
    }
    if(k > 750){
        for(int i = 0; i <= n; i++){
            used[i] = false;
            comp_max[i] = -1;
        }
        int sqn = sqrt(n);
        int mult = 1;
        int currmax = -1;
        for(int i = 1; i <= n; i++){
            if(i > mult*sqn){
                comp_max[mult] = currmax;
                /*if(used[i]){
                    currmax = -1;
                }else{*/
                    currmax = i;
                //}
                mult++;
                continue;
            }
            if(currmax == -1){
                if(!used[i]) currmax = i;
                continue;
            }
            if(/*!used[i] && */compare(currmax, i) == i){
                currmax = i;
            }
        }
        comp_max[sqn+1] = currmax;
        for(int z = 0; z < k; z++){
            currmax = comp_max[1];
            for(int i = 2; i <= sqn+1; i++){
                if(currmax == -1){
                    currmax = comp_max[i];
                    continue;
                }
                if(comp_max[i] != -1 && comp_max[i] == compare(currmax, comp_max[i])){
                    currmax = comp_max[i];
                }
            }
            used[currmax] = true;
            ans.push_back(currmax);
            mult = (currmax-1)/sqn;
            currmax = -1;
            for(int i = mult*sqn+1; i <= min(n, (mult+1)*sqn); i++){
                if(currmax == -1){
                    if(!used[i]) currmax = i;
                    continue;
                }
                if(!used[i] && compare(currmax, i) == i){
                    currmax = i;
                }
            }
            comp_max[mult+1] = currmax;
        }
        return ans;
    }
    if(k > 2){
        for(int i = 0; i <= n; i++){
            used[i] = false;
            comp_max[i] = -1;
        }
        int sqn = n/k;
        int mult = 1;
        int currmax = -1;
        for(int i = 1; i <= n; i++){
            if(i > mult*sqn){
                comp_max[mult] = currmax;
                /*if(used[i]){
                    currmax = -1;
                }else{*/
                    currmax = i;
                //}
                mult++;
                continue;
            }
            if(currmax == -1){
                if(!used[i]) currmax = i;
                continue;
            }
            if(/*!used[i] && */compare(currmax, i) == i){
                currmax = i;
            }
        }
        comp_max[k+1] = currmax;
        for(int z = 0; z < k; z++){
            currmax = comp_max[1];
            for(int i = 2; i <= k+1; i++){
                if(currmax == -1){
                    currmax = comp_max[i];
                    continue;
                }
                if(comp_max[i] != -1 && comp_max[i] == compare(currmax, comp_max[i])){
                    currmax = comp_max[i];
                }
            }
            used[currmax] = true;
            ans.push_back(currmax);
            mult = (currmax-1)/sqn;
            currmax = -1;
            for(int i = mult*sqn+1; i <= min(n, (mult+1)*sqn); i++){
                if(currmax == -1){
                    if(!used[i]) currmax = i;
                    continue;
                }
                if(!used[i] && compare(currmax, i) == i){
                    currmax = i;
                }
            }
            comp_max[mult+1] = currmax;
        }
        return ans;
    }
    if(k > 0){
        for(int i = 0; i <= n; i++){
            used[i] = false;
        }
        stack<int> st;
        int firstNotUsed = 1;
        int lastUsed = -1;
        for(int z = 0; z < k; z++){
            if(st.empty()){
                while(used[firstNotUsed]){
                    firstNotUsed++;
                }
                st.push(firstNotUsed);
            }
            for(int i = max(lastUsed+1, st.top()+1); i <= n; i++){
                if(!used[i] && compare(st.top(), i) == i){
                    st.push(i);
                }
            }
            ans.push_back(st.top());
            lastUsed = st.top();
            used[lastUsed] = true;
            st.pop();
        }
        return ans;
    }
}
