#include <iostream>
#include <algorithm>
using namespace std;

const int MAXN = 100000;

struct bunnie
{
    long long sum;
    int ori;

    bool operator < (bunnie A) const{
        if(sum != A.sum) return sum > A.sum;
        else return ori < A.ori;
    }

};

int n, m;
long long car[MAXN];
bunnie bun[MAXN];

int p;
long long s;
long long currans, ans;

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    for(int i = 1; i <= n; i++){
        cin >> car[i];
    }
    for(int i = 1; i <= n; i++){
        bun[i].ori = i;
        for(int j = 1; j*i <= n; j++){
            bun[i].sum += car[i*j];
        }
    }
    sort(bun+1, bun+n+1);
    /*for(int i = 1; i <= n; i++){
        cout << bun[i].sum << endl;
    }*/
    cin >> m;
    for(int k = 0; k < m; k++){
        cin >> p >> s;
        if(p%bun[1].ori == 0){
            currans = bun[1].sum+s;
        }else{
            currans = bun[1].sum;
        }
        if(s == 0){ans += bun[1].sum; continue;}
        for(int i = 2; i <= n; i++){
            if((s > 0 && s+bun[i].sum <= currans) || (s < 0 && bun[i].sum <= currans)){break;}
            if(p%bun[i].ori == 0){currans = max(currans, bun[i].sum+s);}
            else{currans = max(currans, bun[i].sum);}
        }
        ans += currans;
    }
    cout << ans << endl;

return 0;
}
