#include <iostream>
#include <vector>
#define endl '\n'
#define pb push_back
using namespace std;
int prefix[120][120];
int grid[120][120];
int main() {
    int n, w, h;
    cin >> n >> w >> h;
    for (int i = 0; i < n; ++i) {
            int x, y;
            cin >> x >> y;
            grid[x][y]++;
    }
    prefix[0][0] = grid[0][0];
    for (int i = 0; i < 101; ++i) {
        for (int j = 0; j < 101; ++j) {
            if (i==j && i==0) {
                continue;
            }
            if (i==0) {
                prefix[i][j] = prefix[i][j-1] + grid[i][j];
                continue;
            }
            if (j==0) {
                prefix[i][j] = prefix[i-1][j] + grid[i][j];
                continue;
            }
            prefix[i][j] = prefix[i-1][j] + prefix[i][j-1] - prefix[i-1][j-1] + grid[i][j];
        }
    }
    int maximum = 0;
    for (int i = 0; i < 101; ++i) {
        for (int j = 0; j < 101; ++j) {
            int t = prefix[i+w][j+h];
            if (i>0)
                t-=prefix[i-1][j+h];
            if (j>0)
                t-=prefix[i+w][j-1];
            if (i*j>0) {
                t+= prefix[i-1][j-1];
            }
            maximum = max(maximum, t);
        }
    }
    cout << maximum << endl;
    return 0;
}
