#include "biggest.h"
#include <bits/stdc++.h>
using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
/*
int N, KK;
vector<int> p;

int compare(int x, int y) {
    if (p[x - 1] > p[y - 1])
        return x;
    return y;
}*/

bool cmp(int x, int y) {
    if (x == -1)
        return true;
    if (y == -1)
        return false;
    return compare(x, y) == y;
}

vector<int> get_unordered(int n, int k) {
    if (n == k) {
        vector<int> res;
        for (int i=  1; i <= n; ++i)
            res.push_back(i);
        return res;
    }
    vector<int> res;
    int K = k;
    vector<int> have;
    for (int i = 1; i <= n; ++i)
        have.push_back(i);
    while (have.size() > k && K > 0) {
        int id = have[rnd() % (int)have.size()];
        vector<int> less_id, gr_id;
        for (int i : have) {
            if (i != id) {
                if (cmp(i, id))
                    less_id.push_back(i);
                else
                    gr_id.push_back(i);
            }
        }
        if (K == gr_id.size() + 1) {
            res.push_back(id);
            for (int i : gr_id)
                res.push_back(i);
            break;
        }
        if (K == gr_id.size()) {
            for (int i : gr_id)
                res.push_back(i);
            break;
        }
        if (K > gr_id.size() + 1) {
            K -= (int)gr_id.size() + 1;
            res.push_back(id);
            for (int i : gr_id)
                res.push_back(i);
            have = less_id;
        } else {
            have = gr_id;
        }
    }
    for (int i : have)
        res.push_back(i);
    return res;
}

int find_kth(int k, vector<int> a) {
    int id = a[rnd() % (int)a.size()];
    vector<int> ls, gr;
    for (int i : a) {
        if (i != id) {
            if (cmp(i, id))
                ls.push_back(i);
            else
                gr.push_back(i);
        }
    }
    if (ls.size() + 1 == k)
        return id;
    if (k <= ls.size())
        return find_kth(k, ls);
    return find_kth(k - (int)ls.size() - 1, gr);
}

vector<int> biggest(int n, int k) {
    vector<int> arr(n);
    for (int i = 0; i < n; ++i)
        arr[i] = i + 1;
    int id = find_kth(n - k + 1, arr);
    vector<int> res;
    for (int i = 1; i <= n; ++i) {
        if (i == id || cmp(id, i))
            res.push_back(i);
    }
    sort(res.rbegin(), res.rend(), cmp);
    return res;
}
/*
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        N = rnd() % 30 + 1;
        KK = rnd() % N + 1;
        p = vector<int>(N);
        iota(p.begin(), p.end(), 1);
        shuffle(p.begin(), p.end(), rnd);
        auto arr = biggest(N, KK);
        vector<int> pos(N + 1, -1);
        for (int i = 0; i < N; ++i)
            pos[p[i]] = i + 1;
        vector<int> good;
        for (int i = N; i >= N - KK + 1; --i)
            good.push_back(pos[i]);
        if (arr != good) {
            cout << "TEST FOUND\n";
            cout << "N: " << N << ", K: " << KK << '\n';
            for (int i : p)
                cout << i << " ";
            return 0;
        }
    }
    return 0;
}

*/
