#include <bits/stdc++.h>
using namespace std;

const int N = 50004;
const int M = 500005;
const long long INF = 1e18 + 239;

int n, m;
long long a[N];
long long ans[M];
vector<pair<int, long long>> here[N];
vector<int> d[N];
long long sum[N];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> a[i];
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int p;
        long long s;
        cin >> p >> s;
        ans[i] = -INF;
        here[p].push_back({i, s});
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = i; j <= n; j += i) {
            d[j].push_back(i);
            sum[i] += a[j];
        }
    }
    vector<pair<long long, int>> have;
    for (int i = 1; i <= n; ++i)
        have.push_back({sum[i], i});
    sort(have.rbegin(), have.rend());
    for (int i = 1; i <= n; ++i) {
        long long mx_out = -INF, mx_in = -INF;
        int pos = 0;
        while (pos < n && i % have[pos].second == 0)
            ++pos;
        if (pos != n)
            mx_out = have[pos].first;
        for (int j : d[i])
            mx_in = max(mx_in, sum[j]);
        for (auto pp : here[i]) {
            if (mx_out != -INF)
                ans[pp.first] = max(ans[pp.first], mx_out);
            if (mx_in != -INF)
                ans[pp.first] = max(ans[pp.first], mx_in + pp.second);
        }
    }
    long long sum_ans = 0;
    for (int i = 0; i < m; ++i)
        sum_ans += ans[i];
    cout << sum_ans;
    return 0;
}
