#include <bits/stdc++.h>
using namespace std;

const int N = (1 << 18);

struct T {
    int mx, to_add;

    void upd(int x) {
        mx += x;
        to_add += x;
    }

    T() {}
    T(int mx, int to_add) : mx(mx), to_add(to_add) {}
};

T merge(T a, T b) {
    return {max(a.mx, b.mx), 0};
}

T t[4 * N];

void push(int v) {
    t[2 * v].upd(t[v].to_add);
    t[2 * v + 1].upd(t[v].to_add);
    t[v].to_add = 0;
}

void upd(int v, int tl, int tr, int l, int r, int x) {
    if (tl >= r || tr <= l)
        return;
    if (tl >= l && tr <= r)
        t[v].upd(x);
    else {
        push(v);
        int tm = (tl + tr) / 2;
        upd(2 * v, tl, tm, l, r, x);
        upd(2 * v + 1, tm, tr, l, r, x);
        t[v] = merge(t[2 * v], t[2 * v + 1]);
    }
}

int get_max() {
    return t[1].mx;
}

int n, w, h;
vector<pair<int, int>> point;
vector<int> ys;
int sz;

void add(int i) {
    upd(1, 0, sz, lower_bound(ys.begin(), ys.end(), point[i].second - h) - ys.begin(), lower_bound(ys.begin(), ys.end(), point[i].second) - ys.begin() + 1, 1);
}

void del(int i) {
    upd(1, 0, sz, lower_bound(ys.begin(), ys.end(), point[i].second - h) - ys.begin(), lower_bound(ys.begin(), ys.end(), point[i].second) - ys.begin(), -1);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> w >> h;
    point = vector<pair<int, int>>(n);
    for (int i = 0; i < n; ++i) {
        cin >> point[i].first >> point[i].second;
        ys.push_back(point[i].second);
    }
    sort(ys.begin(), ys.end());
    ys.erase(unique(ys.begin(), ys.end()), ys.end());
    sort(point.begin(), point.end());
    sz = ys.size();
    for (int i = 0; i < 4 * sz; ++i)
        t[i] = {0, 0};
    int L = 0, R = 0;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        while (R < n && point[R].first <= point[i].first + w) {
            add(R);
            ++R;
        }
        while (point[L].first < point[i].first) {
            del(L);
            ++L;
        }
        ans = max(ans, get_max());
    }
    cout << ans;
    return 0;
}
