/**
 *    He hates losing to people
 *    because he's childish. I know
 *    because I hate losing to people..
 *    and I'm childish.   
**/
#include <bits/stdc++.h>

using namespace std;

template<typename A, typename B> string to_string(const pair<A, B>& p);
template<typename A, typename B, typename C> string to_string(const tuple<A, B, C>& t);
template<typename A, typename B, typename C, typename D> string to_string(const tuple<A, B, C, D>& t);
 
string to_string(const string& s) {
    return '"' + s + '"';
}
 
string to_string(const char& c) {
    return "'"s + c + "'";
}
 
string to_string(const char *c) {
    return to_string(string(c));
}
 
string to_string(const bool& b) {
    return (b ? "true" : "false");
}
 
string to_string(const vector<bool>& v) {
    string res = "{";
    for (int i = 0; i < (int) v.size(); ++i) {
      if (i > 0) {
        res += ", ";
    }
    res += to_string(v[i]);
    }
    res += "}";
    return res;
}
 
template<size_t T> string to_string(const bitset<T>& bs) {
    return bs.to_string();
}
 
template<typename T> string to_string(queue<T> q) {
    string res = "{";
    size_t sz = q.size();
    while (sz--) {
        T cur = q.front();
        q.pop();
        q.push(cur);
        if ((int) res.size() > 1) {
            res += ", ";
        }
        res += to_string(cur);
    }
    res += "}";
    return res;
}
 
template<typename T, class C> string to_string(priority_queue<T, vector<T>, C> pq) {
    vector<T> tmp;
    string res = "{";
    while (!pq.empty()) {
        T cur = pq.top();
        pq.pop();
        if ((int) res.size() > 1) {
            res += ", ";
        }
        res += to_string(cur);
        tmp.push_back(cur);
    }
    for (auto el : tmp) {
        pq.push(el);
    }
    res += "}";
    return res;
}
 
template<typename T> string to_string(const T& v) {
    string res = "{";
    for (auto &el : v) {
        if ((int) res.size() > 1) {
            res += ", ";
        }
        res += to_string(el);
    }
    res += "}";
    return res;
}
 
template<typename A, typename B> string to_string(const pair<A, B>& p) {
    return '(' + to_string(p.first) + ", " + to_string(p.second) + ')';
}
template<typename A, typename B, typename C> string to_string(const tuple<A, B, C>& t) {
    return '(' + to_string(get<0>(t)) + ", " + to_string(get<1>(t)) + ", " + to_string(get<2>(t)) + ')';
}
template<typename A, typename B, typename C, typename D> string to_string(const tuple<A, B, C, D>& t) {
    return '(' + to_string(get<0>(t)) + ", " + to_string(get<1>(t)) + ", " + to_string(get<2>(t)) + ", " + to_string(get<3>(t)) + ')';
}
 
void debug_out(int size, bool first, string name) {
    vector<string> tmp = {name};
    vector<int> tmp2 = {size, first};
    cerr << endl;
}
 
constexpr int buffer_size = 255;
 
template<typename Head, typename... Tail> void debug_out(int size, bool first, string name, Head H, Tail... T) {
    string tmp;
    int off = 0;
    while ((!name.empty() && name[0] != ',') || off != 0) {
        tmp += name[0];
        name.erase(name.begin());
        char c = tmp.back();
        if (c == '{' || c == '(') {
            ++off;
        } else if (c == '}' || c == ')'){
            --off;
        }
    }
    if (!name.empty()) {
        name.erase(name.begin());
    }
    if (tmp[0] == ' ') {
        tmp.erase(tmp.begin());
    }
    
    string buff = to_string(H);
    if ((int) buff.size() + size + (int) tmp.size() > buffer_size - 5 && !first) {
        cerr << '\n';
        size = 0;
    }
    cerr << '[' << tmp << ": " << buff << "] ";
    debug_out(((int) buff.size() + size + (int) tmp.size() + 5) % buffer_size, false, name, T...);
}
 
#ifdef DEBUG
#define debug(...) cerr << "-> ", debug_out(3, true, string(#__VA_ARGS__), __VA_ARGS__)
#define here cerr << "-> " << __LINE__ << endl
#else
#define debug(...) void(42)
#define here void(42)
#endif

#define int long long
int32_t main () {
    ios::sync_with_stdio(false);
    cin.tie(0);
 	int n;
	cin >> n;
	vector<int> a(n + 1);
	vector<vector<int>> div(n + 1), mul(n + 1);
	vector<long long> sum(n + 1, 0);
	sum[0] = -LLONG_MAX;
	for (int i = 1; i <= n; ++i) {
		for (int j = i; j <= n; j += i) {
			div[j].push_back(i);
			mul[i].push_back(j);
		}
	}
	//debug(div);
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
	}
	long long mx = -LLONG_MAX, idx = -1;
	for (int i = 1; i <= n; ++i) {
		debug(mul[i]);
		for (int j: mul[i]) {
			sum[i] += a[j] * 1LL;
		}
		if (sum[i] > mx) {
			mx = sum[i];
			idx = i;
		}
	}
	debug(sum);
	int m;
	cin >> m;
	long long ans = 0;
	for (int i = 0; i < m; ++i) {
		int p, s;
		cin >> p >> s;
		if (s > 0) {
			long long foo = -LLONG_MAX;
			for (int j: div[p]) {
				foo = max(foo, sum[j]);
				if (j == idx) {
					ans += sum[j] + s;
					continue;
				}
			}
			if (foo + s > mx) {
				ans += foo + s;
			}
			continue;
		}
		for (int j: div[p]) {
			sum[j] += s;
		}
		ans += *max_element(sum.begin(), sum.end());
		debug(sum);
		for (int j: div[p]) {
			sum[j] -= s;
		}
	}
	cout << ans << '\n';
}

