#include <bits/stdc++.h>
#include "biggest.h"

using namespace std;

typedef pair <int, pair <int, int> > PIII;

PIII H[100005];
int vf = 0;

int FindMaximum (int st, int dr) {
    if (st > dr) return -1;
    int ans = st;

    for (int i = st+1; i <= dr; ++ i ) {
        int x = compare(ans, i);

        if (x == i) ans = i;
    }

    return ans;
}

void HeapUp (int pos) {
    if (pos > 1) {
        int x = compare(H[pos].first, H[pos/2].first);

        if (x == H[pos].first) {
            swap(H[pos], H[pos/2]);
            HeapUp(pos/2);
        }
    }
}

void HeapDown (int pos) {
    int st = 2 * pos;
    int dr = 2 * pos + 1;

    if (st > vf) return;

    if (dr > vf) {
        int x = compare(H[pos].first, H[st].first);

        if (x == H[st].first) {
            swap(H[pos], H[st]);
            HeapDown(st);
        }

        return;
    }

    int Mare;
    int x = compare(H[st].first, H[dr].first);
    if (x == H[st].first) Mare = st;
    else Mare = dr;

    x = compare(H[pos].first, H[Mare].first);

    if (x == H[Mare].first) {
        swap(H[pos], H[Mare]);
        HeapDown(Mare);
    }
}

std :: vector <int> biggest(int N, int K) {
    vector <int> sol;
    vf = 1;
    int p = FindMaximum(1, N);
    H[1] = {p, {1, N}};

    for (int i = 1; i <= K; ++ i ) {
        PIII aux = H[1];
        swap(H[1], H[vf]);
        -- vf;
        HeapDown(1);

        sol.push_back(aux.first);

        int Max_st = FindMaximum(aux.second.first, aux.first-1);
        int Max_dr = FindMaximum(aux.first+1, aux.second.first);

        if (Max_st > -1) {
            ++vf;
            H[vf] = {Max_st, {aux.second.first, aux.first-1}};
            HeapUp(vf);
        }
        if (Max_dr > -1) {
            ++ vf;
            H[vf] = {Max_dr, {aux.first+1, aux.second.second}};
            HeapUp(vf);
        }
    }

    return sol;
}
