#include <bits/stdc++.h>

using namespace std;

constexpr int NMAX = 5e4 + 5;
constexpr long long INF = 1000000000000000000;

int N, M;
long long val[NMAX];
long long pos[NMAX], s[NMAX];
long long sum[NMAX];
long long best[NMAX];
long long normal[NMAX];

long long arb[8*NMAX];

bool fr[NMAX];

long long sol;

void Update (int nod, int a, int b, int poz, long long val) {
    if (a == b) {
        arb[nod] = val;
        return;
    }

    int mij = (a + b) / 2;

    if (poz <= mij) Update(2*nod, a, mij, poz, val);
    else Update(2*nod+1, mij+1, b, poz, val);

    arb[nod] = max(arb[2*nod], arb[2*nod+1]);
}

void Precalculare () {
    for (int i = 1; i <= N; ++ i )
        best[i] = -INF;

    for (int i = 1; i <= N; ++ i ) {
        for (int j = i; j <= N; j += i)
            sum[i] += val[j];

        for (int j = i; j <= N; j += i)
            best[j] = max(best[j], sum[i]);

        Update(1, 1, N, i, sum[i]);
    }

    for (int i = 1; i <= N; ++ i ) {
        if (!fr[i]) continue;
        for (int div = 1; div * div <= i; ++ div ) {
            if (i % div == 0) {
                Update(1, 1, N, div, -INF);
                Update(1, 1, N, i / div, -INF);
            }
        }

        normal[i] = arb[1];
        for (int div = 1; div * div <= i; ++ div ) {
            if (i % div == 0) {
                Update(1, 1, N, div, sum[div]);
                Update(1, 1, N, i / div, sum[i/div]);
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for (int i = 1; i <= N; ++ i )
        cin >> val[i];

    cin >> M;

    for (int i = 1; i <= M; ++ i ) {
        cin >> pos[i] >> s[i];
        fr[pos[i]] = 1;
    }

    Precalculare();

    for (int i = 1; i <= M; ++ i ) {
        long long ans = max(best[pos[i]] + s[i], normal[pos[i]]);

        sol = sol + ans;
    }

    cout << sol << '\n';
    return 0;
}
