#include <bits/stdc++.h>

using namespace std;

constexpr int NMAX = 1e5 + 5;

struct punct {
    int x, y;
};
struct arbore {
    int Max;
    int lazy;
};

punct p[NMAX];

bool cmp (punct a, punct b) {
    return (a.y < b.y || (a.y == b.y && a.x < b.x));
}

int N;
int W, H;

int X[NMAX];
int val[NMAX];
int cnt;
arbore arb[8*NMAX];
int sol;

void Propag (int nod, int st, int dr) {
    if (st == dr) return;
    if (arb[nod].lazy == 0) return;

    arb[2*nod].lazy += arb[nod].lazy;
    arb[2*nod].Max += arb[nod].lazy;
    arb[2*nod+1].lazy += arb[nod].lazy;
    arb[2*nod+1].Max += arb[nod].lazy;

    arb[nod].lazy = 0;
}

void Update (int nod, int st, int dr, int ua, int ub, int val) {
    Propag(nod, st, dr);
    if (ua <= st && dr <= ub) {
        arb[nod].lazy += val;
        arb[nod].Max += val;
        return;
    }

    int mij = (st + dr) / 2;

    if (ua <= mij) Update(2*nod, st, mij, ua, ub, val);
    if (mij < ub) Update(2*nod+1, mij+1, dr, ua, ub, val);

    arb[nod].Max = max(arb[2*nod].Max, arb[2*nod+1].Max);
}

void Normalizare_X () {
    for (int i = 1; i <= N; ++ i )
        X[i] = p[i].x;
    sort(X+1, X+N+1);

    cnt = 0;
    for (int i = 1; i <= N; ++ i ) {
        if (X[i] != X[i-1]) ++ cnt;
        val[i] = cnt;
    }
}

int CautBinar (int nr) {
    int st = 1, dr = N;
    int ans = 0;

    while (st <= dr) {
        int mij = (st + dr) / 2;

        if (X[mij] >= nr) dr = mij - 1;
        else {
            ans = mij;
            st = mij + 1;
        }
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> W >> H;

    for (int i = 1; i <= N; ++ i )
        cin >> p[i].x >> p[i].y;

    sort(p+1, p+N+1, cmp);
    Normalizare_X();

    int st = 1;

    for (int i = 1; i <= N; ++ i ) {
        while (p[st].y < p[i].y - H && st < i) {
            int L = CautBinar(p[st].x);
            int R = CautBinar(p[st].x + W);
            if (L == R) {
                ++ st;
                continue;
            }

            if (X[R+1] == p[st].x + W) ++ R;
            Update(1, 1, cnt, val[L+1], val[R], -1);
            ++ st;
        }

        int L = CautBinar(p[i].x);
        int R = CautBinar(p[i].x + W);
        if (L == R) continue;

        if (X[R+1] == p[st].x + W) ++ R;
        Update(1, 1, cnt, val[L+1], val[R], 1);
        sol = max(sol, arb[1].Max);
    }

    cout << sol << '\n';
    return 0;
}
