#include <iostream>
#include "vector"
#include "unordered_set"
#include "set"

#pragma GCC optimize("O3", "Ofast", "unroll-loops", "fast-math", "unswitch-loops")
#pragma GCC target("sse", "sse2", "sse3", "sse4", "sse4.1", "sse4.2", "avx", "avx2", "mmx")
#define ios ios_base::sync_with_stdio(0);cout.tie(0);cin.tie(0)
#define ll long long int
using namespace std;

int cbrt(int i) {
    int j = 1;
    for (; j * j * j < i; ++j) {
    }
    return j;
}

int main() {
    ios;
    int n;
    cin >> n;
    vector<int> s(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> s[i];
    }
    int q;
    cin >> q;
    vector<ll> ans(n + 1);
    for (int i = 1; i <= n; ++i)
        for (int j = i; j <= n; j += i)
            ans[i] += s[j];
    ll answer = 0;
    set<pair<ll, int>> vec;
    for (int i = 0; i < n; ++i)
        vec.insert({ans[i + 1], i + 1});
    while (q--) {
        int i;
        ll num;
        cin >> i >> num;
        unordered_set<int> st;
        ll mx = -1e18;
        int cnt = 0;
        int u = cbrt(i);
        for (ll j = 1; j * j <= i && cnt < u + 10; ++j) {
            if (i % j == 0) {
                cnt++;
                st.insert(j);
                st.insert(i / j);
                mx = max(mx, ans[j] + num);
                mx = max(mx, ans[i / j] + num);
            }
        }
        if (num >= 0)
            answer += max(mx, vec.rbegin()->first);
        else {
            ll k = mx;
            for (auto j = vec.rbegin(); j !=vec.rend()&& j->first > mx; ++j) {
                if (st.find(j->second) == st.end()) {
                    k = j->first;
                    break;
                }
            }
            answer += k;
        }
    }
    cout << answer << "\n";
    return 0;
}
