#include "biggest.h"
#include <bits/stdc++.h>

using namespace std;

vector<int> makeit(vector<int> &a, int k) {
    if (a.size() <= 1)
        return a;
    vector<int> f, s;
    for (int i = 0; i < (int) a.size() / 2; ++i)
        f.push_back(a[i]);
    for (int i = (int) a.size() / 2; i < (int) a.size(); ++i)
        s.push_back(a[i]);
    f = makeit(f, k);
    s = makeit(s, k);
    vector<int> ans;
    int p1 = f.size() - 1, p2 = s.size() - 1;
    while (p1 >= 0 && p2 >= 0) {
        if (ans.size() == k)
            break;
        if (compare(f[p1], s[p2]) == f[p1])
            ans.push_back(f[p1--]);
        else
            ans.push_back(s[p2--]);
    }
    if (ans.size() < k) {
        while (p1 >= 0 && ans.size() < k)
            ans.push_back(f[p1--]);
        while (p2 >= 0 && ans.size() < k)
            ans.push_back(s[p2--]);
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

vector<int> biggest(int n, int k) {
    if (k < 1000) {
        vector<bool> used(n, false);
        vector<int> ans(1);
        ans[0] = 1;
        for (int i = 1; i < n; ++i) {
            if ((int) ans.size() == k && compare(ans[0], i + 1) == ans[0])
                continue;

            int l = 0, r = (int) ans.size();
            while (l + 1 < r) {
                int m = (l + r) / 2;
                if (compare(i + 1, ans[m]) == i + 1)
                    l = m;
                else
                    r = m;
            }
            if (ans.size() == k && l == -1)
                continue;
            else if (ans.size() == k) {
                for (int j = 1; j <= l; ++j) {
                    ans[j - 1] = ans[j];
                }
                ans[l] = i + 1;
            } else {
                ans.push_back(0);
                for (int j = ans.size() - 2; j >= r; --j)
                    ans[j + 1] = ans[j];
                ans[r] = i + 1;
            }
        }
        reverse(ans.begin(), ans.end());
        return ans;
    }
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        a[i] = i + 1;
    a = makeit(a, k);
    reverse(a.begin(), a.end());
    return a;
}
