/// 2, 34
#include <bits/stdc++.h>
#define le long long

using namespace std;

struct pt
{
    le x, y;
};

int main()
{
    le n, w, h;
    cin >> n >> w >> h;
//    srand(time(0));
//    le n = 100000 - rand()%10000, w = rand()%1000, h = rand()%1000;
    vector<pt> p(n);
    le maxx = 0, maxy = 0;
    for(le i = 0; i < n; i++)
    {
        cin >> p[i].x >> p[i].y;
//        p[i].x = (rand()^1337)%1000;
//        p[i].y = (rand()^765)%1000;
        maxx = max(maxx, p[i].x);
        maxy = max(maxx, p[i].y);
    }

    if(w <= 100 && h <= 100 && n <= 100 && maxx <= 100 && maxy <= 100) /// 1, 2, O(h*w)
    {
        le ans = 0;
        for(le ix = 1; ix <= 100; ix++)
            for(le iy = 1; iy <= 100; iy++)
            {
                le cnt = 0;
                for(pt i: p)
                    if(i.x >= ix && i.x <= ix + w && i.y >= iy && i.y <= iy + h)
                        cnt++;
                ans = max(ans, cnt);
            }
        cout << ans;
        return 0;
    }
    if(w <= 100000000 && h <= 100000000 && n <= 1000 && maxx <= 100000000 && maxy <= 100000000) /// 3, O(N^2)
    {
        le ans = 0;
        for(pt l : p)
        {
            vector<le> v;
            for(pt a: p)
                if(a.x >= l.x && a.x <= l.x + w)
                    v.push_back(a.y);
            sort(v.begin(), v.end());
            for(le i = 0; i < (le)v.size(); i++)
            {
                ans = max(ans, (le)((upper_bound(v.begin(), v.end(), v[i]+h) - v.begin()) - i));
            }
        }
        cout << ans;
        return 0;
    }
    if(w <= 1000 && h <= 1000 && n <= 100000 && maxx <= 1000 && maxy <= 1000) /// 4, O(maxx*maxy)
    {
        unordered_map<le, le> cnt;
        for(pt i: p)
            cnt[i.x*1000 + i.y]++;
        vector<vector<le> > dp(maxx+1, vector<le> (maxy+1));
        for(le j = 1; j <= maxy; j++)
        {
            for(le i = 1; i <= maxx; i++)
            {
                dp[i][j] = dp[i-1][j] + dp[i][j-1] - dp[i-1][j-1] + cnt[i*1000 + j];
            }
        }
        for(le i = 0; i <= maxx; i++, cout << '\n')
            for(le j = 0; j <= maxy; j++)
                cout << dp[i][j] << " ";
        le ans = 0;
        for(pt a: p)
        {
            le x1 = a.x, y1 = min(a.y+h, maxy), x2 = max(0ll, a.x-w-1), y2 = a.y-1;
            //cout << dp[x1][y1] << " " << dp[x1][y2] << " " << dp[x2][y1] << " " << dp[x2][y2] << "\n";
            ans = max(ans, dp[y1][x1] - dp[y1][x2] - dp[y2][x1] + dp[y2][x2]);
        }
        cout << ans;
        return 0;
    }
    return 0;
}
