#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

#define int long long

using namespace std;

vector < int > a, b;
set < int > st;

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    a.resize(n + 1);
    for(int i = 1; i <= n; i++)
        cin >> a[i];
    b.resize(n + 1);
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j * j <= i; j++)
        {
            if(i % j == 0)
            {
                b[j] += a[i];
                b[i / j] += a[i];
            }
            if(j * j == i)
                b[j] -= a[i];
        }
        st.insert(b[i]);
    }
    int q;
    cin >> q;
    int ans = 0;
    while(q--)
    {
        int p, s;
        cin >> p >> s;
        for(int i = 1; i * i <= p; i++)
        {
            if(p % i == 0)
            {
                st.erase(b[i]);
                st.insert(b[i] + s);
                if(i * i != p)
                {
                    st.erase(b[p / i]);
                    st.insert(b[p / i] + s);
                }
            }
        }
        ans += *st.rbegin();
        for(int i = 1; i * i <= p; i++)
        {
            if(p % i == 0)
            {
                st.erase(b[i] + s);
                st.insert(b[i]);
                if(i * i != p)
                {
                    st.erase(b[p / i] + s);
                    st.insert(b[p / i]);
                }
            }
        }
    }
    cout << ans;
    return 0;
}
