#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

#define int long long

using namespace std;

vector < int > a, b;
vector < vector < int > > d;
set < int > st;

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    a.resize(n + 1);
    for(int i = 1; i <= n; i++)
        cin >> a[i];
    b.resize(n + 1);
    d.resize(n + 1);
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j * j <= i; j++)
        {
            if(i % j == 0)
            {
                b[j] += a[i];
                d[i].push_back(j);
                if(j * j != i)
                {
                    b[i / j] += a[i];
                    d[i].push_back(i / j);
                }
            }
        }
    }
    for(int i = 1; i <= n; i++)
        st.insert(b[i]);
    int q;
    cin >> q;
    int ans = 0;
    while(q--)
    {
        int p, s;
        cin >> p >> s;
        for(int i = 0; i < d[p].size(); i++)
        {
            st.erase(b[d[p][i]]);
            st.insert(b[d[p][i]] + s);
        }
        ans += max(0ll,*st.rbegin());
        for(int i = 0; i < d[p].size(); i++)
        {
            st.erase(b[d[p][i]] + s);
            st.insert(b[d[p][i]]);
        }
    }
    cout << ans;
    return 0;
}
