#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
#include <map>
#include <set>

#include "biggest.h"

using namespace std;
typedef long long int63;
typedef pair<int, int> point;
#define FOR(nm,s,e) for(int63 nm = s; nm < e; nm++)
#define fort(s,e) FOR(i,s,e)
#define forto(s,e) FOR(j,s,e)
#define fortoo(s,e) FOR(l,s,e)


/*int compare(int x, int y) {
	cout << "? " << x << ' ' << y << endl;
	int ans;
	cin >> ans;
	return ans;
}*/


vector<vector<pair<int, int>>> mp;
int cmpmd(int x, int y) {
	if (y > x) {
		swap(x, y);
	}
	for (int i = 0; i < mp[x].size(); i++) {
		if (mp[x][i].first == y) {
			return mp[x][i].second;
		}
	}
	int ans = compare(x, y);
	mp[x].push_back({ y,ans });
	return ans;
}
bool f(int x, int y) {
	return cmpmd(x, y) == x;
}
vector<int> biggest(int n, int k) {
	mp.resize(n+1);
	vector<int> alive, ans;
	for (int i = 0; i < n; i++) {
		alive.push_back(i + 1);
	}
	if (k < 10001) {
		vector<vector<int>>direct(n + 1);
		int nn = n / 2;
		while (alive.size() > 1) {
			for (int i = alive.size() - 1; i > 0; i -= 2) {
				if (cmpmd(alive[i], alive[i - 1]) == alive[i]) {
					direct[alive[i]].push_back(alive[i - 1]);
					alive[i - 1] = alive[alive.size() - 1];
					alive.pop_back();
				} else {
					direct[alive[i - 1]].push_back(alive[i]);
					alive[i] = alive[alive.size() - 1];
					alive.pop_back();
				}
			}
		}
		ans.push_back(alive[0]);
		vector<int> ex;
		while (ans.size() < k) {
			for (int i = 0; i < ex.size(); i++) {
				if (ex[i] == alive[0]) {
					ex[i] = ex[ex.size() - 1];
					ex.pop_back();
					break;
				}
			}
			for (int i = 0; i < direct[alive[0]].size(); i++) {
				ex.push_back(direct[alive[0]][i]);
			}
			alive = ex;
			while (alive.size() > 1) {
				for (int i = alive.size() - 1; i > 0; i -= 2) {
					if (cmpmd(alive[i], alive[i - 1]) == alive[i]) {
						alive[i - 1] = alive[alive.size() - 1];
						alive.pop_back();
					} else {
						alive[i] = alive[alive.size() - 1];
						alive.pop_back();
					}
				}
			}
			ans.push_back(alive[0]);
		}
	} else {
		vector<vector<int>>merge;
		for (int i = 1; i < n + 1; i++) {
			merge.push_back({ i });
		}
		for (int i = 0; i < merge.size() - 1; i += 2) {
			merge.push_back({});
			int f = 0,s = 0;
			while (f < merge[i].size() && s < merge[i + 1].size() && f + s < k) {
				if (cmpmd(merge[i][f], merge[i + 1][s]) == merge[i][f]) {
					merge[merge.size() - 1].push_back(merge[i][f++]);
				} else {
					merge[merge.size() - 1].push_back(merge[i+1][s++]);
				}
			}
			while (f < merge[i].size() && f + s < k) {
				merge[merge.size() - 1].push_back(merge[i][f++]);
			}
			while (s < merge[i + 1].size() && f + s < k) {
				merge[merge.size() - 1].push_back(merge[i+1][s++]);
			}
		}
		vector<int> ord = merge[merge.size() - 1];
		while (ord.size() > k) {
			ord.pop_back();
		}
		return ord;
	}
	return ans;
}

vector<int> divlist(int x) {
	vector<int> ans,ans2;
	for (int i = 1; i * i <= x; i++) {
		if (i * i == x) {
			ans.push_back(i);
			continue;
		}
		if ((x / i)*i == x) {
			ans.push_back(i);
			ans2.push_back(x / i);
		}
	}
	for (int i = (int)ans2.size() - 1; i >= 0; i--) {
		ans.push_back(ans2[i]);
	}
	return ans;
}
/*
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	/*int n, k;
	cin >> n >> k;
	vector<int> ans = biggest(n, k);
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] << ' ';
	}
	cout << endl;*//*
	int63 n,w,h;
	cin >> n >> w >> h;
	vector<point> v(n);
	set<int63>x,y;
	fort(0, n) {
		cin >> v[i].first >> v[i].second;
		x.insert(v[i].first);
		y.insert(v[i].second);
	}
	vector<int63>xv, yv;
	for (auto it = x.begin(); it != x.end(); it++) {
		xv.push_back(*it);
	}
	for (auto it = y.begin(); it != y.end(); it++) {
		yv.push_back(*it);
	}
	vector<int63>edx(xv.size()), edy(y.size());
	int63 ed = 0;
	fort(0, edx.size()) {
		while (ed < edx.size() - 1 && xv[ed + 1] - xv[i] <= w) {
			ed++;
		}
		edx[i] = ed;
	}
	ed = 0;
	fort(0, edy.size()) {
		while (ed < edy.size() - 1 && yv[ed + 1] - yv[i] <= h) {
			ed++;
		}
		edy[i] = ed;
	}
	vector<vector<int63>>ps(xv.size() + 1, vector<int63>(yv.size() + 1,0));

	fort(0, n) {
		int63 lo = 0, hi = xv.size() - 1, md;
		while (hi > lo) {
			md = lo + hi;
			md /= 2;
			if (xv[md] >= v[i].first) {
				hi = md;
			} else {
				lo = md + 1;
			}
		}
		v[i].first = lo;
		lo = 0, hi = yv.size() - 1, md;
		while (hi > lo) {
			md = lo + hi;
			md /= 2;
			if (yv[md] >= v[i].second) {
				hi = md;
			} else {
				lo = md + 1;
			}
		}
		v[i].second = lo;
		ps[v[i].first + 1][v[i].second + 1]++;
	}
	fort(1, xv.size() + 1) {
		forto(1, yv.size() + 1) {
			ps[i][j] += ps[i - 1][j] + ps[i][j - 1] - ps[i - 1][j - 1];
		}
	}
	int63 ans = 0;
	fort(0, xv.size()) {
		forto(0, yv.size()) {
			ans = max(ans, ps[edx[i] + 1][edy[j] + 1] - ps[i][edy[j] + 1] - ps[edx[i] + 1][j] + ps[i][j]);
		}
	}
	cout << ans << endl;
	//long long problems - the other way around.
	return 0;
}*/