#include<bits/stdc++.h>
using namespace std;

vector<list<int>> redoers;

list<int> getRedoers(int p) {
	if(!redoers[p].empty()) return redoers[p];
	
	list<int> result;
	
	for(int i = 1; i <= sqrt(p); i++) {
		if(p%i == 0) {
			result.push_back(i);
			if(p/i != i) result.push_back(p/i);
		}
	
	}

	return redoers[p] =result;
}

int main() {
	int n; 
	cin >> n;
	vector<int> a (n);
	for(int i = 0; i < n; i++) {
		cin >> a[i];
	}
	redoers.resize(n+1, {});
	

	int t = -1e8-1;
	vector<int> ti (n, 0);
	for(int i = 1; i <= n; i++) {
		for(int redoer : getRedoers(i)) {
			ti[redoer-1]+=a[i-1];
		}
	}
	
	for(int i = 0; i < n; i++) {
		t = max(t, ti[i]);
	}

	int m;
	cin >> m;
	int p, s, currt;
	int result = 0;
	for(int assumption = 0; assumption < m; assumption++) {
		cin >> p >> s;
		currt = t;
		for(int redoer : getRedoers(p)) {
			currt = max(currt, ti[redoer-1]+s);
		}
		result += currt;
	}

	cout << result << "\n";

}
