#include<bits/stdc++.h>
using namespace std;

struct Point {
	int x;
	int y;

	Point(int a = 0, int b = 0) {
		x = a; y = b;
	}
};

int main() {
	int N, w, h; cin >> N >> w >> h;
	int x, y;
	int maxx = 0; int maxy = 0;
	vector<Point> points (N);

	for(int i = 0; i < N; i++) {
		cin >> x >> y;
		maxx = max(maxx, x); maxy = max(maxy, y);
		points[i] = Point(x, y);
	}
	vector<vector<int>> numPoints (maxx+1+w, vector<int>(maxy+1+h, 0));

	for(Point point : points) {
		numPoints[point.x][point.y]++;
	}

	vector<vector<int>> sums (maxx+1+w, vector<int>(maxy+1+h));

	sums[0][0] = numPoints[0][0];
	for(int i = 1; i < maxx+1+w; i++) {
		sums[i][0] = sums[i-1][0] + numPoints[i][0];
	}
	for(int i = 1; i < maxy+1+h; i++) {
		sums[0][i] = sums[0][i-1] + numPoints[0][i];
	}

	for(int i = 1; i < maxx+1+w; i++) {
		for(int j = 1; j < maxy+1+h; j++) {
			sums[i][j] = sums[i-1][j] + sums[i][j-1] - sums[i-1][j-1] + numPoints[i][j];
		}
	}

	int result = 0;
	for(int i = w+1; i <= maxx+w; i++) {
		for(int j = h+1; j <= maxy+h; j++) {
			result = max(result, (sums[i][j] - sums[i-w-1][j] - sums[i][j-h-1] + sums[i-w-1][j-h-1]));
		}
	}

	cout << result << "\n";
}
