#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <cmath>
#include <climits>
#include <string>
#include <algorithm>
    
using namespace std;
typedef long long ll;


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef HOW_NAME_IFDEF
        freopen("in", "r", stdin);
        freopen("out", "w", stdout);
    #endif
    ll sum=0, s;
    int n, m, p;
    cin >> n;
    vector <int> a(n+2);
    vector <ll> t0(n+2);
    vector <vector<int>> z(n+2);
    for (int i=1; i<=n; i++) {
        cin >> a[i];
    } 
    for (int i=1; i<=n; i++) {
        for (int j=i; j<=n; j+=i) {
            t0[i] += a[j];
            z[j].push_back(i);
        }
    }
    cin >> m;
    for (int i=0; i<m; i++) {
        cin >> p;
        cin >> s;
        vector <ll> t = t0;
        for (auto j : z[p]) {
            t[j] += s; 
        }
        ll max=t[1];
        for (int j=2; j<=n; j++) {
            if (t[j]>max) max = t[j];
        }
        sum += max;
    }
    cout << sum;
    return 0;
}