#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); ++i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order;
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 5e4 + 227;

int n, m;
ll a[N];
ll sum[N];
ll ans;
multiset<ll> s;
ve<int> divisors[N];
ll without[N];
ll maxim[N];

ll slow(int p, ll x) {
    a[p] += x;
    ll best = 0;
    for(int i = 1; i <= n; ++i) {
        ll sum = 0;
        for(int j = i; j <= n; j += i) {
            sum += a[j];
        }
        umx(best, sum);
    }
    a[p] -= x;
    return best;
}

int main() {
#ifndef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n;

//    n = 5 * 1e4;

    fr(i, 1, n) {
        for(int j = i; j <= n; j += i) {
            divisors[j].pb(i);
        }
    }

    fr(i, 1, n) {
        cin >> a[i];

//        a[i] = rng() % int(2e8 + 1) - 1e8;

        fe(j, divisors[i]) {
            sum[j] += a[i];
        }
    }

    fr(i, 1, n) s.insert(sum[i]);

    fr(i, 1, n) {
        fe(j, divisors[i]) {
            s.erase(s.find(sum[j]));
        }
        without[i] = (sz(s) ? *s.rbegin() : -1e18);
        fe(j, divisors[i]) {
            s.insert(sum[j]);
        }
        fe(j, divisors[i]) {
            umx(maxim[i], sum[j]);
        }
    }

//    fr(i, 1, n) {
//        cout << i << " " << without[i] << "\n";
//    }

//    cerr << "Execution time " << (ld)clock() / CLOCKS_PER_SEC << "sec\n";
//
//    return 0;

    cin >> m;
//    m = 2e5;

    fr(i, 0, m - 1) {
        int p;
        ll x;

//        p = rng() % n + 1;
//        x = rng() % ll(2e13) - 1e13;
        cin >> p >> x;

        ll best = without[p];
        umx(best, maxim[p] + x);
//        fe(j, divisors[p]) {
//            umx(best, sum[j] + x);
//        }
//        cout << best << " " << slow(p, x) << "\n";
//        assert(best == slow(p, x));
        ans += slow(p, x);
//        ans += best;
    }

    cout << ans << "\n";

    cerr << "Execution time " << (ld)clock() / CLOCKS_PER_SEC << "sec\n";

    return 0;
}

/*
6
2 -5 3 2 -1 4
2
3 -4
2 3
*/
