#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); ++i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order;
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 1e5 + 227;

int n, w, h;
pii a[N];
int best;
int mx_x, mx_y;

void relax1(int x1, int y1, int x2, int y2) {
    int ans = 0;
    fr(i, 0, n - 1) {
        if(a[i].fi >= x1 && a[i].fi <= x2 && a[i].se >= y1 && a[i].se <= y2) {
            ans++;
        }
    }
    umx(best, ans);
}

int main() {
#ifndef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n >> w >> h;

    fr(i, 0, n - 1) {
        cin >> a[i].fi >> a[i].se;
        umx(mx_x, a[i].fi);
        umx(mx_y, a[i].se);
    }

    fr(x, 1, mx_x) {
        fr(y, 1, mx_y) {
            relax1(x, y, x + w, y + h);
        }
    }

//    fr(i, 0, n - 1) {
//        relax1(a[i].fi, a[i].se, a[i].fi + w, a[i].se + h);
//        relax1(a[i].fi - w, a[i].se, a[i].fi, a[i].se + h);
//        relax1(a[i].fi, a[i].se - h, a[i].fi + w, a[i].se);
//        relax1(a[i].fi - w, a[i].se - h, a[i].fi, a[i].se);
//    }

    cout << best << "\n";

    return 0;
}

/*
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5

10 8 8
8 9
20 14
3 9
7 8
3 4
7 8
10 19
6 11
5 10
8 2

*/
