#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); ++i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order;
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 1e5 + 227;

int n, w, h;
pii a[N];
int best;
int mx_x, mx_y;

ve<int> u_x;

void relax1(int x1, int y1, int x2, int y2) {
    int ans = 0;
    fr(i, 0, n - 1) {
        if(a[i].fi >= x1 && a[i].fi <= x2 && a[i].se >= y1 && a[i].se <= y2) {
            ans++;
        }
    }
    umx(best, ans);
}

int slow_query(int x1, int x2, int y1, int y2) {
    int ans = 0;
    fr(i, 0, n - 1) {
        if(a[i].fi >= x1 && a[i].fi <= x2 && a[i].se >= y1 && a[i].se <= y2) {
            ans++;
        }
    }
    return ans;
}

ve<int> t[4 * N];

void add(int v, int tl, int tr, int pos, int y) {
    if(tl == tr) {
        t[v].pb(y);
        return;
    }
    int tm = (tl + tr) >> 1;
    if(pos <= tm) add(v << 1, tl, tm, pos, y);
    else add(v << 1 | 1, tm + 1, tr, pos, y);
}

void add(int x, int y) {
    x = lower_bound(all(u_x), x) - u_x.begin();
    add(1, 0, sz(u_x) - 1, x, y);
}

void build(int v = 1, int tl = 0, int tr = sz(u_x) - 1) {
    if(tl > tr) return;
    if(tl == tr) {
        sort(all(t[v]));
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v << 1, tl, tm);
    build(v << 1 | 1, tm + 1, tr);
    t[v].resize(sz(t[v << 1]) + sz(t[v << 1 | 1]));
    merge(all(t[v << 1]), all(t[v << 1 | 1]), t[v].begin());

    cout << "vertex: " << tl << " " << tr << ", t[v] = ";
    fe(x, t[v]) cout << x << " ";
    cout << "\n";
}

int query(int v, int tl, int tr, int x1, int x2, int y1, int y2) {
    if(x1 > x2) return 0;
    if(tl == x1 && tr == x2) {
        int l_y = lower_bound(all(t[v]), y1) - t[v].begin();
        int r_y = upper_bound(all(t[v]), y2) - t[v].begin() - 1;
        return max(0, r_y - l_y + 1);
    }
    int tm = (tl + tr) >> 1;
    return query(v << 1, tl, tm, x1, min(x2, tm), y1, y2) + query(v << 1 | 1, tm + 1, tr, max(tm + 1, x1), x2, y1, y2);
}

int query(int x1, int x2, int y1, int y2) {
    int l_x = lower_bound(all(u_x), x1) - u_x.begin();
    int r_x = upper_bound(all(u_x), x2) - u_x.begin() - 1;
    return query(1, 0, sz(u_x) - 1, l_x, r_x, y1, y2);
}

int main() {
#ifndef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n >> w >> h;

    fr(i, 0, n - 1) {
        cin >> a[i].fi >> a[i].se;
        umx(mx_x, a[i].fi);
        umx(mx_y, a[i].se);
        u_x.pb(a[i].fi);
    }


    if(mx_x <= 100 && mx_y <= 100) {
        fr(x, 1, mx_x) {
            fr(y, 1, mx_y) {
                relax1(x, y, x + w, y + h);
            }
        }
        cout << best << "\n";
        return 0;
    }

    sort(all(u_x));
    u_x.erase(unique(all(u_x)), u_x.end());

    fr(i, 0, n - 1) add(a[i].fi, a[i].se);
    build();
    best = 0;
    fr(i, 0, n - 1) {
        umx(best, query(a[i].fi - w, a[i].fi, a[i].se - h, a[i].se));
//        umx(best, slow_query(a[i].fi - w, a[i].fi, a[i].se - h, a[i].se));
//        if(query(a[i].fi - w, a[i].fi, a[i].se - h, a[i].se) != slow_query(a[i].fi - w, a[i].fi, a[i].se - h, a[i].se)) {
//            cout << "WRONG " << a[i].fi << " " << a[i].se << " " << query(a[i].fi - w, a[i].fi, a[i].se - h, a[i].se) << " " << slow_query(a[i].fi - w, a[i].fi, a[i].se - h, a[i].se) << "\n";
//        }

    }

    cout << best << "\n";

    return 0;
}

/*
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5

10 8 8
8 9
20 14
3 9
7 8
3 4
7 8
10 19
6 11
5 10
8 2

*/
