#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <iomanip>

using namespace std;

int compare(int x, int y);
vector<int> merge_sort(int l, int r, vector<int> &idx, int k) {
    if (l + 1 == r) {
        return {idx[l]};
    }
    int m = (l + r) / 2;
    vector<int> left = merge_sort(l, m, idx, k);
    vector<int> right = merge_sort(m, r, idx, k);
    vector<int> ans;
    int ptr = 0, ptr1 = 0;
    for (int i = 0; i < k; ++i) {
        int l = compare(left[ptr] + 1, right[ptr1] + 1) - 1;
        if (l == left[ptr]) {
            ans.push_back(left[ptr++]);
        } else {
            ans.push_back(right[ptr1++]);
        }
    }
    return ans;
}

vector<int> biggest(int n, int k) {
    vector<int> p;
    for (int i = 0; i < n; ++i) {
        p.push_back(i);
    }
    p = merge_sort(0, n, p, k);
    for(int& i : p) {
        ++i;
    }
    return p;
}