#include<iostream>
#include <stdio.h>
#include <vector>
#include <random>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;
map<pair<int, int>, int> d;
vector<int> a, b;

int compare(int x, int y);

int N;

bool cmp(int A, int B) {
    if (A == B) {
        return false;
    }
    int x;
    if (!(A > 0 && B > 0 && A <= N && B <= N)) {
        assert(0);
    }
    if (!d.count({B, A})) {
        x = compare(B, A);
        d[{B, A}] = x;
        d[{A, B}] = x;
    }
    else {
        x = d[{B, A}];
    }
    return B != x;
}

vector<int> biggest(int n, int k) {
    N = n;
    a.resize(n);
    for(int i = 0; i < n; ++i) {
        a[i] = i + 1;
    }
    nth_element(a.begin(), a.begin() + (k - 1), a.end(), cmp);
    sort(a.begin(), a.begin() + (k - 1), cmp);
    vector<int> ans;
    for(int i = 0; i < k; ++i) {
        ans.push_back(a[i]);
    }
    return ans;
}