#include<iostream>
#include <stdio.h>
#include <vector>
#include <random>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;
map<pair<int, int>, int> d;
vector<int> a, b;

int compare(int x, int y);

int N;

bool cmp(int A, int B) {
    if (A == B) {
        return false;
    }
    int x;
    if (!(A > 0 && B > 0 && A <= N && B <= N)) {
        assert(0);
    }
    if (!d.count({B, A})) {
        x = compare(B, A);
        d[{B, A}] = x;
        d[{A, B}] = x;
    } else {
        x = d[{B, A}];
    }
    return B != x;
}

vector<int> merge_sort(int l, int r, int k) {
    if (l + 1 == r) {
        return {l + 1};
    }
    int m = (l + r) / 2;
    vector<int> left = merge_sort(l, m, k);
    vector<int> right = merge_sort(m, r, k);
    vector<int> ans;
    int ptr = 0, ptr1 = 0;
    for (int i = 0; i < k; ++i) {
        int l;
        if (ptr < left.size() && ptr1 < right.size()) {
            l = cmp(left[ptr], right[ptr1]);
        } else if (ptr < left.size()) {
            l = 1;
        } else if (ptr1 < right.size()) {
            r = 0;
        } else {
            break;
        }
        if (l) {
            ans.push_back(left[ptr++]);
        } else {
            ans.push_back(right[ptr1++]);
        }

    }
    return ans;
}

vector<int> biggest(int n, int k) {
    if (k < 50000) {
        N = n;
        a.resize(n);
        for (int i = 0; i < n; ++i) {
            a[i] = i + 1;
        }
        nth_element(a.begin(), a.begin() + (k - 1), a.end(), cmp);
        sort(a.begin(), a.begin() + (k - 1), cmp);
        vector<int> ans;
        for (int i = 0; i < k; ++i) {
            ans.push_back(a[i]);
        }
        return ans;
    } else {
        return merge_sort(0, n, k);
    }

}