#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <iomanip>
#include <random>
#include <cassert>

using namespace std;

mt19937 rnd;

int compare(int x, int y);

vector<int> biggest(int n, int k) {
    vector<int> p;
    for (int i = 0; i < n; ++i) {
        p.push_back(i + 1);
    }
    vector<int> curr;
    for(int i = 0; i < n; ++i) {
        int l = -1, r = curr.size();
        if (curr.size()) {
            int x = compare(curr[0], i + 1);
            if (x == curr[0]) {
                r = 0;
            }
            else {
                l = 0;
            }
        }
        if (curr.size() >= k && l == -1 && r == curr.size()) {
            int b1 = curr.size() / 3;
            if (compare(curr[b1], i + 1) == curr[b1]) {
                r = b1;
            }
            else {
                l = b1;
            }
        }
        while(l + 1 < r) {
            int m = (l + r) / 2;
            int x = compare(curr[m], i + 1);
            if (x == curr[m]) {
                r = m;
            }
            else {
                l = m;
            }
        }
        curr.insert(curr.begin() + l + 1, i + 1);
        if (curr.size() > k) {
            curr.erase(curr.begin());
        }
    }
    reverse(curr.begin(), curr.end());
    return curr;
}