#include <iostream>
#include <vector>
#include <algorithm>
#define endl "\n"

typedef long long ll;

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll n, m;
    cin >> n;
    vector<ll> sweatness(n);
    vector<ll> changedS(n);

    for (int i = 0; i < n; i++)
    {
        cin >> sweatness[i];
    }

    cin >> m;

    ll totalSum = 0;
    while (m--)
    {   
        bool isNegative = false;
        for (int i = 0; i < n; i++)
        {
            changedS[i] = sweatness[i];
            if(isNegative == false) {
                if(changedS[i] < 0) {
                    isNegative = true;
                }
            }
        }

        ll p, s;
        cin >> p >> s;
        changedS[p-1] += s;

        if(isNegative == false) {
            for(int i = 0; i < n; i++) {
                totalSum += changedS[i];
            }
        } else {
            ll tcurrent = 0, tcurrentmax = 0;
            for (int i = 0, k = 1; i < n; i++)
            {
                for (int j = i; j < n; j += k)
                {

                    tcurrent += changedS[j];
                }
                tcurrentmax = max(tcurrent, tcurrentmax);
                tcurrent = 0;
                k++;
            }

            totalSum += tcurrentmax;
        }

        changedS.clear();
    }

    cout << totalSum << endl;

    return 0;
}