#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include "unordered_set"
#include "map"
#include "biggest.h"
using namespace std;
bool inline comp(int x, int y){
    return compare(x, y) == x;
}
inline vector<int> mrg(vector<int> a, vector<int> b){
    vector<int> c;
    int tar = a.size();
    while(c.size() < tar){
        if(b.empty()){
            c.push_back(a.back());
            a.pop_back();
            continue;
        }
        if(!comp(b.back(), a.back())){
            c.push_back(b.back());
            b.pop_back();
        }else{
            c.push_back(a.back());
            a.pop_back();
        }
    }
    reverse(c.begin(), c.end());
    return c;
}
vector<int> biggest(int n, int k){
    int t = (n + k - 1) / k;
    vector<vector<int>> a(t);
    for (int i = 0; i < t; ++i) {
        for (int j = 0; j < k; ++j) {
            if(i * t + j == n)
                break;
            a[i].push_back({i * t + j});
        }
        sort(a[i].begin(), a[i].end(), comp);
    }
    vector<int> ans = a[0];
    for (int i = 1; i < t; ++i) {
        ans = mrg(ans, a[i]);
    }
    reverse(ans.begin(), ans.end());
    return ans;
}