#include "biggest.h"
#include <bits/stdc++.h>
using namespace std;

void part_sort(vector<int>& arr, int k){
    if(!k){
        arr.clear();
        return;
    } else if(arr.size() <= 1){
        return;
    } else if(k <= 10){
        vector<int> ans;
        while(k--){
            int max_i = 0;
            for(int i = 1; i < arr.size(); i++){
                if(compare(arr[i], arr[max_i]) == arr[i]){
                    max_i = i;
                }
            }
            // cout << "this is " << arr[max_i] << "\n";
            ans.push_back(arr[max_i]);
            arr.erase(arr.begin() + max_i);
        }
        arr = ans;
        return;
    }
    int m = arr.size() / 2;
    vector<int> l, r;
    mt19937 rng(time(0));
    int i = (arr.size() + rng() % arr.size()) % arr.size();
    int x = arr[i];
    for(int j = 0; j < arr.size(); j++){
        if(j != i){
            if(compare(x, arr[j]) == x){
                l.push_back(arr[j]);
            } else {
                r.push_back(arr[j]);
            }
        }
    }
    part_sort(r, min(int(r.size()), k));
    part_sort(l, max(0, k - int(r.size()) - 1));
    arr.clear();
    for(auto y : r){
        arr.push_back(y);
    }
    if(r.size() < k){
        arr.push_back(x);
        for(auto y : l){
            arr.push_back(y);
        }
    }
}

std::vector<int> biggest(int n, int k){
    vector<int> arr(n);
    for(int i = 0; i < n; i++){
        arr[i] = i + 1;
    }
    part_sort(arr, k);
    return arr;
}
