#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

ll n, m;
const ll INF = -1e18;

vector<pair<ll, ll>> get_pos(vector<ll>& arr, int i){
    map<ll, ll> mp_;
    for(int j = 1; j * j <= i; j++){
        if(i % j == 0){
            mp_[arr[j - 1]]++;
            if(j * j != i)
                mp_[arr[i / j - 1]]++;
        }
    }
    vector<pair<ll, ll>> ans;
    for(auto p : mp_){
        ans.push_back(p);
    }
    return ans;
}

void get_mod_arr(vector<ll>& arr){
    vector<ll> ans(arr.size());
    for(int i = 1; i <= n; i++){
        ans[i - 1] = 0;
        for(int j = i; j <= n; j += i){
            ans[i - 1] += arr[j - 1];
        }
    }
    arr = ans;
}

void get_ans_plus(vector<ll> arr, vector<ll>& ans){
    // get_mod_arr(arr);
    map<ll, ll> mp;
    for(int i = 0; i < n; i++){
        mp[arr[i]]++;
    }
    vector<pair<ll, ll>> vec;
    for(auto p : mp){
        vec.push_back(p);
    }
    ll max_val = vec.back().first;

    for(int i = 1; i <= n; i++){
        ans[i - 1] = max_val - get_pos(arr, i).back().first;
    }
}

void get_ans_minus(vector<ll> arr, vector<pair<ll, ll>>& ans){
    // get_mod_arr(arr);
    map<ll, ll> mp;
    for(int i = 0; i < n; i++){
        mp[arr[i]]++;
    }
    vector<pair<ll, ll>> vec;
    for(auto p : mp){
        vec.push_back(p);
    }
    ll max_val = vec.back().first;
    for(int i = 1; i <= n; i++){
        vector<pair<ll, ll>> pos = get_pos(arr, i);
        int j = pos.size() - 1;
        for(int k = vec.size() - 1; k >= 0; k--){
            if(vec[k] != pos[j]){
                // cout << i << ": " << vec[k].first << "\n";
                ans[i - 1].first = max_val - vec[k].first;
                ans[i - 1].second = vec[k].first;
                break;
            }
            j--;
        }
    }
}

signed main(){
    cin >> n;
    vector<ll> arr(n);
    for(auto& x : arr){
        cin >> x;
    }
    vector<ll> ans_plus(n);
    vector<pair<ll, ll>> ans_minus(n);
    get_mod_arr(arr);
    get_ans_plus(arr, ans_plus);
    ll max_val = arr[0];
    for(int i = 1; i < n; i++){
        max_val = max(max_val, arr[i]);
    }
    if(n <= 2e4)
        get_ans_minus(arr, ans_minus);
    int m;
    cin >> m;
    ll ans = 0;
    while(m--){
        ll p, s;
        cin >> p >> s;
        p--;
        if(s < 0){
            s = -s;
            if(s <= ans_minus[p].first){
                ans += max_val - s;
                // cout << max_val - s << '\n';
            } else {
                ans += ans_minus[p].second;
                // cout << ans_minus[p].second << '\n';
            }
        } else {
            if(s <= ans_plus[p]){
                ans += max_val;
                // cout << max_val << '\n';
            } else {
                ans += max_val + (s - ans_plus[p]);
                // cout << max_val + (s - ans_plus[p]) << '\n';
            }
        }
    }
    cout << ans << '\n';
}
