#include <iostream>
#include <algorithm>
#include <set>
using namespace std;
#pragma warning(disable : 4996)
#define coor pair<int, int>
#define x first
#define y second

const int N = 1002;

int n, w, h;
multiset<coor> points;

bool checkForRect(coor p) {
	if (
		points.find(coor(p.x + w, p.y)) != points.end() &&
		points.find(coor(p.x, p.y + h)) != points.end() &&
		points.find(coor(p.x + w, p.y + h)) != points.end()
		) {
		return true;
	}
	else {
		return false;
	}
}

bool checkForPo(coor i, coor j) {
	if (
		i.x <= j.x &&
		j.x <= i.x + w &&
		i.y <= j.y &&
		j.y <= i.y + h
		) {
		return true;
	}
	else {
		return false;
	}
}

int main() {
	cin >> n >> w >> h;
	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		points.insert(coor(x, y));
	}
	int ans = -1;
	for (auto i = points.begin(); i != points.end(); i++) {
		for (auto j = i; j != points.end(); j++) {
			int ansForij = 0;
			coor vert = coor( min( (*i).x, (*j).x), min( (*i).y, (*j).y ) );
			for (auto k = points.begin(); k != points.end(); k++) {
				//cerr << checkForPo(vert, *k) << " ";
				ansForij += checkForPo(vert, *k);
			}
			//cerr << vert.x << " " << vert.y << endl;
			ans = max(ans, ansForij);
		}
	}
	cout << ans << endl;
}
