#include <iostream>
#include <algorithm>
#include <set>
using namespace std;
#pragma warning(disable : 4996)
#define coor pair<int, int>
#define x first
#define y second

const int N = 100002;
const int D = 1002;

int n, w, h;
multiset<coor> points;
int g[D][D];

bool checkForPo(coor i, coor j) {
	if (
		i.x <= j.x &&
		j.x <= i.x + w &&
		i.y <= j.y &&
		j.y <= i.y + h
		) {
		return true;
	}
	else {
		return false;
	}
}

int main() {
	cin >> n >> w >> h;
	if (n <= 100) {
		for (int i = 0; i < n; i++) {
			int x, y;
			cin >> x >> y;
			points.insert(coor(x, y));
		}
		int ans = -1;
		for (auto i = points.begin(); i != points.end(); i++) {
			for (auto j = i; j != points.end(); j++) {
				int ansForij = 0;
				coor vert = coor(min((*i).x, (*j).x), min((*i).y, (*j).y));
				for (auto k = points.begin(); k != points.end(); k++) {
					//cerr << checkForPo(vert, *k) << " ";
					ansForij += checkForPo(vert, *k);
				}
				//cerr << vert.x << " " << vert.y << endl;
				ans = max(ans, ansForij);
			}
		}
		cout << ans << endl;
	}
	else {
		int dx = -1, dy = -1;
		for (int i = 0; i < n; i++) {
			int x, y;
			cin >> x >> y;
			dx = max(dx, x);
			dy = max(dy, y);
			points.insert(coor(x, y));
		}
		for (int i = 1; i <= dx; i++) {
			for (int j = 1; j <= dy; j++) {
				g[i][j] = g[i - 1][j] + g[i][j - 1] - g[i - 1][j - 1] + points.count(coor(i, j));
				//cout << i << " " << j << " " << g[i][j] << endl;
			}
		}
		int ans = 0;
		for (auto p = points.begin(); p != points.end(); p++) {
			int ix = (*p).x, iy = (*p).y;
			if (ix > w && iy > h) {
				ans = max(ans,
					g[ix][iy] - g[ix][iy - h - 1] - g[ix - w - 1][iy] + g[ix - w - 1][iy - h - 1]
				);
			}
			else if (ix > w && iy <= h) {
				ans = max(ans, g[ix][iy] - g[ix - w - 1][iy]);
			}
			else if (ix <= w && iy > h) {
				ans = max(ans, g[ix][iy] - g[ix][iy - h - 1]);
			}
			else {
				ans = max(ans, g[ix][iy]);
			}
		}
		cout << ans << endl;
	}
}
