#include <bits/stdc++.h>
#define int long long

using namespace std;

struct node{
    int l, r;
    int x;
};

const int N = 1e6 + 5;

node t[N];
vector <int> no;

void build(int i, int l, int r) {
    t[i].l = l; t[i].r = r;
    t[i].x = -1e18;
    if (r - l == 1) {
        return;
    }
    build(2 * i, l, (l + r) / 2);
    build(2 * i + 1, (l + r) / 2, r);
}

void set_max(int i, int l, int r, int x) {
    if (l <= t[i].l && r >= t[i].r) {
        t[i].x = max(t[i].x, x);
        return;
    }
    if (l >= t[i].r || r <= t[i].l) {
        return;
    }
    set_max(2 * i, l, r, x);
    set_max(2 * i + 1, l, r, x);
}

void fill_no(int i, int ma) {
    if (t[i].l + 1 == t[i].r) {
        no[t[i].l] = max(ma, t[i].x);
        return;
    }
    fill_no(2 * i, max(ma, t[i].x));
    fill_no(2 * i + 1, max(ma, t[i].x));
}

signed main() {
    int n; cin >> n;
    vector <int> a(n);
    vector <int> r(n, 0);
    vector <int> q(n, -1e18);
    no.assign(n, -1e18);
    build(1, 0, n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = i - 1; j < n; j += i) {
            r[i - 1] += a[j];
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (i != 1) {
            set_max(1, 0, i - 1, r[i - 1]);
        }
        for (int j = i - 1; j < n; j += i) {
            q[j] = max(q[j], r[i - 1]);
            if (i != 1) {
                set_max(1, j + 1, min(n, j + i), r[i - 1]);
            }
        }
    }
    fill_no(1, -1e18);
    int an = 0;
    int m; cin >> m;
    for (int i = 0; i < m; ++i) {
        int p, s; cin >> p >> s;
        //cout << q[p - 1] + s << ' ' << no[p - 1] << "\n";
        an += max(q[p - 1] + s, no[p - 1]);
    }
    cout << an << "\n";
}
