#include <iostream>
#include <vector>
#define int long long
#pragma GCC Optimize("Ofast")

using namespace std;

const int N = 2e5 + 5;

int t[N];
vector <int> no;

void build(int i, int l, int r) {
    t[i] = -1e18;
    if (r - l == 1) {
        return;
    }
    build(2 * i, l, (l + r) / 2);
    build(2 * i + 1, (l + r) / 2, r);
}

void set_max(int i, int l, int r, int x, int tl, int tr) {
    if (l <= tl && r >= tr) {
        t[i] = max(t[i], x);
        return;
    }
    if (l >= tr || r <= tl) {
        return;
    }
    set_max(2 * i, l, r, x, tl, (tr + tl) / 2);
    set_max(2 * i + 1, l, r, x, (tl + tr) / 2, tr);
}

void fill_no(int i, int ma, int tl, int tr) {
    if (tl + 1 == tr) {
        no[tl] = max(ma, t[i]);
        return;
    }
    fill_no(2 * i, max(ma, t[i]), tl, (tl + tr) / 2);
    fill_no(2 * i + 1, max(ma, t[i]), (tl + tr) / 2, tr);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n; cin >> n;
    vector <int> a(n);
    vector <int> r(n, 0);
    vector <int> q(n, -1e18);
    no.assign(n, -1e18);
    build(1, 0, n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = i - 1; j < n; j += i) {
            r[i - 1] += a[j];
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (i != 1) {
            set_max(1, 0, i - 1, r[i - 1], 0, n);
        }
        for (int j = i - 1; j < n; j += i) {
            q[j] = max(q[j], r[i - 1]);
            if (i != 1) {
                set_max(1, j + 1, min(n, j + i), r[i - 1], 0, n);
            }
        }
    }
    fill_no(1, -1e18, 0, n);
    int an = 0;
    int m; cin >> m;
    for (int i = 0; i < m; ++i) {
        int p, s; cin >> p >> s;
        an += max(q[p - 1] + s, no[p - 1]);
    }
    cout << an << "\n";
    return 0;
}
