#include <iostream>
#include <vector>
#include "biggest.h"
#include <time.h>
using namespace std;
/*int compare(int x, int y) {
	cout << x << ' ' << y<<endl;
	int a;
	cin >> a;
	return a;
}*/
vector<int> a;
struct node {
	int y;
	int val;
	node* l=NULL, * r=NULL;
	int size = 1;
	node(int val) {
		this->val = val;
		y = rand();
	}
};
int gs(node* root) {
	if (!root)
		return 0;
	return root->size;
}
void update(node* root) {
	if (root) {
		root->size = 1 + gs(root->l) + gs(root->r);
	}
}
pair<node*, node*> split(node* root, int val) {
	if (root == NULL) {
		return { NULL,NULL };
	}
	if (val >= gs(root->l) + 1) {
		auto t = split(root->r, val - gs(root->l) - 1);
		root->r = t.first;
		update(root);
		return { root,t.second };
	}
	else {
		auto t = split(root->l, val);
		root->l = t.second;
		update(root);
		return { t.first,root };
	}
}
node* merge(node* l, node* r) {
	if (!l) {
		return r;
	}
	if (!r) {
		return l;
	}
	if (l->y > r->y) {
		auto t = merge(l->r, r);
		l->r = t;
		update(l);
		return l;
	}
	else {
		auto t = merge(l, r->l);
		r->l = t;
		update(r);
		return r;

	}
}
vector<int> ans;
void dfs(node* v) {
	if (!v) {
		return;
	}
	dfs(v->l);
	ans.push_back(v->val+1);
	dfs(v->r);
}
void mergesort(int l, int r, int k) {
	if (l >= r) {
		return;
	}
	int m = (l + r) / 2;
	mergesort(l, m, k);
	mergesort(m + 1, r, k);
	int cur = 0;
	int lpos = l;
	int rpos = m + 1;
	vector<int> aa(r - l + 1);
	while (lpos != m + 1 || rpos != r + 1) {
		if (cur < k) {
			if (lpos == m + 1) {
				aa[cur] = a[rpos];
				rpos++;
				cur++;
			}
			else if (rpos == r + 1) {
				aa[cur] = a[lpos];
				lpos++;
				cur++;
			}
			else if (compare(a[lpos] + 1, a[rpos] + 1) == a[lpos] + 1) {
				aa[cur] = a[lpos];
				cur++;
				lpos++;
			}
			else {
				aa[cur] = a[rpos];
				cur++;
				rpos++;
			}
		}
		else {
			if (lpos == m + 1) {
				aa[cur] = a[rpos];
				cur++;
				rpos++;
			}
			else {
				aa[cur] = a[lpos];
				cur++;
				lpos++;
			}
		}
	}

	for (int i = 0; i < r - l + 1; i++) {
		a[l + i] = aa[i];
	}
}
int vall(node* root, int id) {
	if (id == gs(root->l)) {
		return root->val;
	}
	if (id < gs(root->l)) {
		return vall(root->l, id);
	}
	return vall(root->r, id - gs(root->l) - 1);
}
vector<int> biggest(int n, int k) {
	srand(time(NULL));
	a.resize(n);
	for (int i = 0; i < n; i++) {
		a[i] = i;

	}
	mergesort(0, k - 1, k);
	
	node* root = NULL;
	for (int i = 0; i < k; i++) {
		root = merge(root, new node(a[i]));

	}

	for (int i = k; i < n; i++) {
		int L = -1;

		int R = k;
		while (R - L > 1) {
			int mid = (L + R) / 2;
			int val = vall(root, mid);
			if (compare(val + 1, a[i] + 1) == val + 1) {
				L = mid;

			}
			else {
				R = mid;
			}
		}
		auto t = split(root, R);
		root = merge(merge(t.first, new node(a[i])), t.second);
	
		root = split(root, k).first;

	}
	dfs(root);
	return ans;

}
/*int main() {
	auto hh = biggest(6, 3);
	for (auto h : hh) {
		cout << h << ' ';
	}
}*/