#include <iostream>
#include <vector>
#include <unordered_set>
using namespace std;
vector<long long> a;
vector<long long> d;
void build(int v, int l, int r) {
	if (l == r) {

		d[v] = a[l];
		return;
	}
	if (l > r) {
		return;
	}
	build(2 * v + 1, l, (l + r) / 2);
	build(2 * v + 2, (l + r) / 2 + 1, r);
	d[v] = max(d[2 * v + 1], d[2 * v + 2]);
}
void add(int v, int l, int r,int pos,long long val) {
	if (l > pos || r < pos) {
		return;
	}
	if (l == r && l == pos) {
		d[v] += val;
		return;
	}
	add(2 * v + 1, l, (l + r) / 2, pos, val);
	add(2 * v + 2, (l + r) / 2 + 1, r, pos, val);
	d[v] = max(d[2 * v + 1], d[2 * v + 2]);
}

long long ask(){
	return d[0];
}

vector<int> fpr
; unordered_set<int> listt[40005];
vector<int> ers(40005,1);
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	fpr.resize(40005);
	int n;
	cin >> n;
	a.resize(n);
	vector<int> aa(n);
	for (int i = 0; i < n; i++) {
		cin >> aa[i];
	}
	int m;
	cin >> m;

	d.resize(4 * n);

	for (int i = 2; i < 40005; i++) {
		if (ers[i]) {
			for (int j = i * 2; j < 40005; j+=i) {
				ers[j] = 0;
			}
		}
	}
	vector<int> prl;
	
	for (int i = 2; i < 40005; i++) {
		if (ers[i]) {
			prl.push_back(i);
		}
	}
	for (int i = 2; i <= 40000; i++) {
		if (ers[i]) {
			fpr[i] = i;
		}
		else {
			for (int j = 2; j < i; j++) {
				if (i % j == 0) {
					fpr[i] = j;
					break;
				}
			}
		}
	}
	listt[1].insert(1);
	for (int i = 2; i <= 40000; i++) {
		listt[i] = listt[i / fpr[i]];
		for (auto h : listt[i / fpr[i]]) {
			listt[i].insert(fpr[i] * h);
		}
	}
	for (int i = 0; i < n; i++) {
		for (auto h : listt[i + 1]) {
			a[h-1] += aa[i];
		}
	}
	long long sum = 0;
	build(0, 0, n-1);
	for (int i = 0; i < m; i++) {
		long long p, s;
		cin >> p >> s;
		for (auto h : listt[p]) {
			add(0, 0, n-1, h-1, s);
		}
		sum += ask();
		for (auto h : listt[p]) {
			add(0, 0, n-1, h-1, -s);
		}
		
	}
	cout << sum;

}