// biggest.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include "biggest.h" 

using namespace std;


vector<int> biggest(int N, int K)
{
	vector<int> n = mergeSort(0, N - 1);
	/*for (int i = 0; i < n; i++)
	{
		n.push_back(i)
	}*/
	vector<int> ans;
	for (int i = N - 1; i > K; i--)
	{
		ans.push_back(n[i]);
	}
	return ans;
}

vector<int> mergeSort(int f, int l)
{
	vector<int> temp;
	if (f == l)
	{
		temp.push_back(f);
		return temp;
	}
	else {
		int mid = (l + f) / 2;
		vector<int> temp1 = mergeSort(f, mid);
		vector<int> temp2 = mergeSort(mid + 1, l);
		int i = 0;
		int j = 0;
		while (i < temp1.size() && j < temp2.size())
		{
			int t = compare(temp1[i], temp2[j]);
			if (t == temp1[i])
			{
				temp.push_back(temp2[j]);
				j++;
			}
			else
			{
				temp.push_back(temp1[i]);
				i++;
			}
		}
		while (i < temp1.size())
		{
			temp.push_back(temp1[i]);
			i++;
		}
		while (j < temp2.size())
		{
			temp.push_back(temp2[j]);
			j++;
		}
		return temp;
	}
}