#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N_MAX = 50002;

int gcd (int a, int b)
{
    if(b == 0)
        return a;
    return gcd(b, a % b);
}

int n, q;

ll a[N_MAX];

ll sum[N_MAX];

multiset <ll> s;

vector <int> d[N_MAX];

vector <ll> queries[N_MAX];


ll f (int upos, ll uval)
{
    for(int i : d[upos])
    {
        s.erase(s.find(-sum[i]));
        sum[i] += uval;
        s.insert(-sum[i]);
    }
    ll ans = -*s.begin();
    for(int i : d[upos])
    {
        s.erase(s.find(-sum[i]));
        sum[i] -= uval;
        s.insert(-sum[i]);
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for(int i = 1; i <= n; i++)
        cin >> a[i];
    for(int i = 1; i <= n; i++)
        for(int j = i; j <= n; j += i)
            d[j].push_back(i);
    int mxi = 0;
    for(int i = 1; i <= n; i++)
    {
        for(int j = i; j <= n; j += i)
            sum[i] += a[j];
        s.insert(-sum[i]);
        if(mxi == 0 || sum[i] >= sum[mxi])
            mxi = i;
    }
    cin >> q;
    for(int i = 1; i <= q; i++)
    {
        int upos;
        ll uval;
        cin >> upos >> uval;
        queries[upos].push_back(uval);
    }
    ll ans = 0;
    for(int i = 1; i <= n; i++)
        if(!queries[i].empty())
        {
            if(i * mxi / gcd(i, mxi) > n)
            {
                ans += (int)queries[i].size() * sum[mxi];
                continue;
            }
            sort(queries[i].begin(), queries[i].end());
            ll val = f(i, queries[i].back());
            int l = 0, r = (int)queries[i].size() - 1;
            while(l < r)
            {
                int mid = ((l + r) >> 1);
                ll val1 = f(i, queries[i][mid]);
                if(val1 == val + queries[i][mid] - queries[i].back())
                    r = mid;
                else
                    l = mid + 1;
            }
            ans += l * f(i, queries[i][0]);
            for(int j = l; j < (int)queries[i].size(); j++)
                ans += val + queries[i][j] - queries[i].back();
        }
    cout << ans << "\n";
    return 0;
}
