#include <bits/stdc++.h>

using namespace std;

const int N_MAX = 100002;

int n;

int lx, ly;

struct Point
{
    int x, y;
    int nx;
};

bool operator < (const Point &a, const Point &b)
{
    return a.y < b.y;
}

Point v[N_MAX];

int vx[N_MAX];

map <int, int> mpx;

int invx[N_MAX];

int Lx[N_MAX];

queue <int> q;

struct SGTNode
{
    int maxVal;
    int lazy;
};

SGTNode SGT[N_MAX * 4];

void split (int node)
{
    int lSon = (node << 1), rSon = (lSon | 1);
    SGT[lSon].maxVal += SGT[node].lazy;
    SGT[rSon].maxVal += SGT[node].lazy;
    SGT[lSon].lazy += SGT[node].lazy;
    SGT[rSon].lazy += SGT[node].lazy;
    SGT[node].lazy = 0;
}

void update (int node, int l, int r, int ul, int ur, int uval)
{
    if(ul <= l && r <= ur)
    {
        SGT[node].maxVal += uval;
        SGT[node].lazy += uval;
        return;
    }
    split(node);
    int mid = ((l + r) >> 1), lSon = (node << 1), rSon = (lSon | 1);
    if(ul <= mid)
        update(lSon, l, mid, ul, ur, uval);
    if(mid + 1 <= ur)
        update(rSon, mid + 1, r, ul, ur, uval);
    SGT[node].maxVal = max(SGT[lSon].maxVal, SGT[rSon].maxVal);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> ly >> lx;
    for(int i = 1; i <= n; i++)
        cin >> v[i].x >> v[i].y;
    for(int i = 1; i <= n; i++)
        vx[i] = v[i].x;
    sort(vx + 1, vx + n + 1);
    int currx = 0;
    for(int i = 1; i <= n; i++)
        if(i == 1 || vx[i] > vx[i - 1])
        {
            mpx[vx[i]] = ++currx;
            invx[currx] = vx[i];
        }
    for(int i = 1; i <= n; i++)
        v[i].nx = mpx[v[i].x];
    Lx[0] = 1;
    for(int x = 1; x <= currx; x++)
    {
        Lx[x] = Lx[x - 1];
        while(Lx[x] < x && invx[x] - invx[Lx[x]] > lx)
            Lx[x]++;
    }
    sort(v + 1, v + n + 1);
    int ans = 0;
    for(int i = 1; i <= n; i++)
    {
        while(!q.empty() && v[i].y - v[q.front()].y > ly)
        {
            int j = q.front();
            update(1, 1, n, Lx[v[j].nx], v[j].nx, -1);
            q.pop();
        }
        q.push(i);
        update(1, 1, n, Lx[v[i].nx], v[i].nx, +1);
        ans = max(ans, SGT[1].maxVal);
    }
    cout << ans << "\n";
    return 0;
}
