#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <assert.h>
#include <map>
#include <deque>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;
int n, m;
int a[50010];
ll b[50010];

vector <ll> qu[50010];
vector <int> divs[50010];
multiset <ll> all;
ll ans;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];

		int d = 1; 
		while (d * d < i)
		{
			if (i % d == 0)
			{
				divs[i].push_back(d);
				divs[i].push_back(i / d);
			}
			++d;
		}

		if (d * d == i)
		{
			divs[i].push_back(d);
		}
	}
	cin >> m;

	for (int i = 1; i <= m; ++i)
	{
		int x;
		ll v;
		cin >> x >> v;
		qu[x].push_back(v);
	}

	for (int i = 1; i <= n; ++i)
	{
		for (auto j : divs[i])
		{
			b[j] += a[i];
		}
	}

	for (int i = 1; i <= n; ++i)
	{
		all.insert(b[i]);
	}

	for (int i = 1; i <= n; ++i)
	{
		ll maxi = -4e18;
		for (auto j : divs[i])
		{
			maxi = max(maxi, b[j]);
			all.erase(all.find(b[j]));
		}

		assert(divs[i].size());
		for (auto j : qu[i])
		{
			ans += max(maxi + j, *all.rbegin());
		}

		for (auto j : divs[i])
		{
			all.insert(b[j]);
		}
	}

	cout << ans;
	return 0;
}