#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <assert.h>
#include <map>
#include <deque>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;
int n, m;
int a[50010];
ll b[50010];

vector <ll> qu[50010];
vector <int> divs[50010];
multiset <ll> all;
ll ans;

vector <int> p;
int d[50010];
int po[50010];
int full[50010];
vector <int> primes[50010];
int fgr[50010];

void cnt(int i)
{
	int di = 1;
	const int pre = i / full[i];
	divs[i].reserve(divs[pre].size() * (po[i] + 1));
	for (int power = 0; power <= po[i]; ++power)
	{
		for (auto j : divs[pre])
		{
			divs[i].push_back(j * di);
		}
		di *= d[i];
	}
}

void cntpr(int i)
{
	const int pre = i / full[i];
	primes[i] = primes[pre];
	primes[i].push_back(d[i]);
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];
	}
	cin >> m;

	bool gr = true;
	for (int i = 1; i <= m; ++i)
	{
		int x;
		ll v;
		cin >> x >> v;
		qu[x].push_back(v);
		if (v < 0) gr = false;
	}

	if (gr)
	{
		divs[1].push_back(1);

		for (int i = 2; i <= n; ++i)
		{
			if (d[i] == 0)
			{
				d[i] = i;
				po[i] = 1;
				full[i] = d[i];
				p.push_back(i);
			}

			for (auto pr : p) if (pr < d[i])
			{
				if ((ll)i * pr <= n)
				{
					d[i * pr] = pr;
					po[i * pr] = 1;
					full[i * pr] = pr;
				}
			}

			if ((ll)i * d[i] <= n)
			{
				d[i * d[i]] = d[i];
				po[i * d[i]] = po[i] + 1;
				full[i * d[i]] = full[i] * d[i];
			}
		}

		for (int i = 2; i <= n; ++i)
		{
			cnt(i);
			cntpr(i);
		}

		for (int i = 1; i <= n; ++i)
		{
			for (auto j : divs[i])
			{
				b[j] += a[i];
			}
		}

		ll all_mx = -4e18;
		for (int i = 1; i <= n; ++i) all_mx = max(all_mx, b[i]);

		for (int i = 1; i <= n; ++i)
		{
			fgr[i] = b[i];

			for (int prm : primes[i])
			{
				fgr[i] = max(fgr[i / prm], fgr[i]);
			}

			for (auto j : qu[i])
			{
				ans += max(fgr[i] + j, all_mx);
			}
		}
		cout << ans;
		return 0;
	}

	divs[1].push_back(1);

	for (int i = 2; i <= n; ++i)
	{
		if (d[i] == 0)
		{
			d[i] = i;
			po[i] = 1;
			full[i] = d[i];
			p.push_back(i);
		}

		for (auto pr : p) if (pr < d[i])
		{
			if ((ll)i * pr <= n)
			{
				d[i * pr] = pr;
				po[i * pr] = 1;
				full[i * pr] = pr;
			}
		}

		if ((ll)i * d[i] <= n)
		{
			d[i * d[i]] = d[i];
			po[i * d[i]] = po[i] + 1;
			full[i * d[i]] = full[i] * d[i];
		}
	}

	for (int i = 2; i <= n; ++i)
	{
		cnt(i);
	}

	for (int i = 1; i <= n; ++i)
	{
		for (auto j : divs[i])
		{
			b[j] += a[i];
		}
	}

	for (int i = 1; i <= n; ++i)
	{
		all.insert(b[i]);
	}

	for (int i = 1; i <= n; ++i)
	{
		ll maxi = -4e18;
		for (auto j : divs[i])
		{
			maxi = max(maxi, b[j]);
			all.erase(all.find(b[j]));
		}

		assert(divs[i].size());
		for (auto j : qu[i])
		{
			ans += max(maxi + j, *all.rbegin());
		}

		for (auto j : divs[i])
		{
			all.insert(b[j]);
		}
	}

	cout << ans;
	return 0;
}