#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <assert.h>
#include <map>
#include <deque>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;
int n, m;
int a[50010];
ll b[50010];

vector <ll> qu[50010];
vector <int> divs[50010];
ll ans;

vector <int> p;
int d[50010];
int po[50010];
int full[50010];
vector <int> primes[50010];
ll fgr[50010];

inline void cnt(int i)
{
	int di = 1;
	const int pre = i / full[i];
	divs[i].reserve(divs[pre].size() * (po[i] + 1));
	for (int power = 0; power <= po[i]; ++power)
	{
		for (auto j : divs[pre])
		{
			divs[i].push_back(j * di);
		}
		di *= d[i];
	}
}

inline void cntpr(int i)
{
	const int pre = i / full[i];
	primes[i] = primes[pre];
	primes[i].push_back(d[i]);
}

ll other[50010];

ll t[4 * 50010];
int idx[50010];

void build(int i, int l, int r)
{
	if (l + 1 == r)
	{
		t[i] = b[l];
		idx[l] = i;
		return;
	}

	int m = (l + r) >> 1;
	build(2 * i + 1, l, m);
	build(2 * i + 2, m, r);
	t[i] = max(t[2 * i + 1], t[2 * i + 2]);
}

int q;
ll v;
void change()
{
	int i = idx[q];
	t[i] = v;
	while (i)
	{
		i = (i - 1) >> 1;
		t[i] = max(t[2 * i + 1], t[2 * i + 2]);
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;

	for (int16_t i = 1; i <= n; ++i)
	{
		cin >> a[i];
	}
	cin >> m;

	bool gr = true;
	for (int i = 1; i <= m; ++i)
	{
		int x;
		ll v;
		cin >> x >> v;
		qu[x].push_back(v);
		if (v < 0) gr = false;
	}

	divs[1].push_back(1);

	for (int16_t i = 2; i <= n; ++i)
	{
		if (d[i] == 0)
		{
			d[i] = i;
			po[i] = 1;
			full[i] = d[i];
			p.push_back(i);
		}

		for (auto pr : p) if (pr < d[i])
		{
			if ((unsigned int)i * pr <= n)
			{
				d[i * pr] = pr;
				po[i * pr] = 1;
				full[i * pr] = pr;
			}
		}

		if ((unsigned int)i * d[i] <= n)
		{
			d[i * d[i]] = d[i];
			po[i * d[i]] = po[i] + 1;
			full[i * d[i]] = full[i] * d[i];
		}
	}

	for (int i = 2; i <= n; ++i)
	{
		cntpr(i);
		cnt(i);
	}

	for (int i = 1; i <= n; ++i)
	{
		for (auto j : divs[i])
		{
			b[j] += a[i];
		}
	}
	build(0, 1, n + 1);
	for (int i = 1; i <= n; ++i)
	{
		for (auto j : divs[i])
		{
			q = j;
			v = -4e18;
			change();
		}
		other[i] = t[0];
		for (auto j : divs[i])
		{
			q = j;
			v = b[j];
			change();
		}
	}

	for (int i = 1; i <= n; ++i)
	{
		if (i) fgr[i] = b[i];
		else fgr[i] = -4e18;

		for (int prm : primes[i])
		{
			fgr[i] = max(fgr[i / prm], fgr[i]);
		}

		for (auto j : qu[i])
		{
			ans += max(fgr[i] + j, other[i]);
		}
	}

	cout << ans;
	return 0;
}