//
//  main.cpp
//  C
//
//  Created by Ivan Podvorniy on 20.11.2020.
//  Copyright © 2020 Ivan Podvorniy. All rights reserved.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
vector<int> t;
vector<int> vals;

void upd(int p, int l, int r, int ind) {
    if (r - l == 1) {
        t[p] = vals[l];
        return;
    }
    int m = (l + r) / 2;
    if (ind >= m) {
        upd(2 * p + 2, m, r, ind);
    } else {
        upd(2 * p + 1, l, m, ind);
    }
    t[p] = max(t[2 * p + 1], t[2 * p + 2]);
}

int get(int p, int l, int r, int ql, int qr) {
    if (l >= qr) {
        return -1e9;
    }
    if (r <= ql) {
        return -1e9;
    }
    if (l >= ql && r <= qr) {
        return t[p];
    }
    int m = (l + r) / 2;
    return max(get(2 * p + 1, l, m, ql, qr), get(2 * p + 2, m, r, ql, qr));
}


int main() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    t.resize(4 * n);
    vals.resize(4 * n);
    for (int i = 1; i <= n; i++) {
        int summ = 0;
        for (int j = i; j <= n; j += i) {
            summ += v[j - 1];
        }
        vals[i -1 ] = summ;
        upd(0, 0, n, i - 1);
    }
    int m;
    cin >> m;
    int ans = 0;
    for (int i = 0; i < m; i++) {
        int p, s;
        cin >> p >> s;
        for (int j = 1; j * j <= p; j++) {
            if (p % j == 0) {
                vals[j - 1] += s;
                upd(0, 0, n, j - 1);
                vals[p / j - 1] += s;
                upd(0, 0, n, p / j - 1);
            }
        }
        ans += get(0, 0, n, 0, n);
        for (int j = 1; j * j <= p; j++) {
            if (p % j == 0) {
                vals[j - 1] -= s;
                upd(0, 0, n, j - 1);
                vals[p / j - 1] -= s;
                upd(0, 0, n, p / j - 1);
            }
        }
    }
    cout << ans;
}