//
//  main.cpp
//  D
//
//  Created by Ivan Podvorniy on 20.11.2020.
//  Copyright © 2020 Ivan Podvorniy. All rights reserved.
//

#include <iostream>
#include <random>
#include <algorithm>
#include <vector>


using namespace std;

vector<int> t;
vector<int> mod;

void push(int p) {
    mod[2 * p + 1] += mod[p];
    mod[2 * p + 2] += mod[p];
    t[p] += mod[p];
    mod[p] = 0;
}

void upd(int p, int l, int r, int ql, int qr, int plus) {
    push(p);
    if (l >= qr) {
        return;
    }
    if (r <= ql) {
        return;
    }
    if (l >= ql && r <= qr) {
        mod[p] += plus;
        push(p);
        return;
    }
    int m = (l + r) / 2;
    upd(2 * p + 1, l, m, ql, qr, plus);
    upd(2 * p + 2, m, r, ql, qr, plus);
    t[p] = max(t[2 * p + 1], t[2 * p + 2]);
}

int get(int p, int l, int r, int ql, int qr) {
    push(p);
    if (l >= qr) {
        return -1e9;
    }
    if (r <= ql) {
        return -1e9;
    }
    if (l >= ql && r <= qr) {
        return t[p];
    }
    int m = (l + r) / 2;
    return max(get(2 * p + 1, l, m, ql, qr), get(2 * p + 2, m, r, ql, qr));
}
void print_array() {
    for (int i = 0; i < 7; i++) {
        cout << get(0, 0, 1e5, i, i + 1) << ' ';
    }
    cout << endl;
}
signed main() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<vector<int>> columns(1e5 + 1);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        columns[x].push_back(y);
    }
    t.resize(4000 * 100);
    mod.resize(8000 * 100);
    int maxx = 0;
    for (int i = 0; i < w + 1; i++) {
        for (auto y : columns[i]) {
            upd(0, 0, 1e5, max(0, y - h), y + 1, 1);
        }
    }
    maxx = max(maxx, get(0, 0, 1e5, 0, 1e5));
    
    for (int i = w + 1; i <= 7; i++) {
        for (auto y: columns[i]) {
            upd(0, 0, 1e5, max(0, y - h), y + 1, 1);
            
        }
        for (auto y: columns[i - w - 1]) {
            upd(0, 0, 1e5, max(0, y - h), y + 1, -1);
        }
         maxx = max(maxx, get(0, 0, 1e5, 0, 1e5));
    }
    cout << maxx;
    
}

