//
//  main.cpp
//  D
//
//  Created by Ivan Podvorniy on 20.11.2020.
//  Copyright © 2020 Ivan Podvorniy. All rights reserved.
//

#include <iostream>
#include <random>
#include <map>
#include <algorithm>
#include <vector>


using namespace std;

struct node {
    int val, mod;
    node *l;
    node *r;
    
    node(int val, int mod) {
        this->val = val;
        this->mod = mod;
        this->l = 0;
        this->r = 0;
    }
    void push() {
        if (!l) {
            l = new node(0, 0);
        }
        if (!r) {
            r = new node(0, 0);

        }
        l->mod += mod;
        r->mod += mod;
        val += mod;
        mod = 0;
    }
};
void upd(node *p, int l, int r, int ql, int qr, int plus) {
    p->push();
    if (l >= qr) {
        return;
    }
    if (r <= ql) {
        return;
    }
    if (l >= ql && r <= qr) {
        p->mod += plus;
        p->push();
        return;
    }
    int m = (l + r) / 2;
    if (!p->l) {
        p->l = new node(0, 0);

    }
    if (!p->r) {
        p->r = new node(0, 0);

    }
    upd(p->l, l, m, ql, qr, plus);
    upd(p->r, m, r, ql, qr, plus);
    p->val = max(p->l->val, p->r->val);
}

int get(node *p, int l, int r, int ql, int qr) {
    p->push();
    if (l >= qr) {
        return -1e9;
    }
    if (r <= ql) {
        return -1e9;
    }
    if (l >= ql && r <= qr) {
        return p->val;
    }
    int m = (l + r) / 2;
    if (!p->l) {
        p->l = new node(0, 0);
    }
    if (!p->r) {
        p->r = new node(0, 0);

    }
    return max(get(p->l, l, m, ql, qr), get(p->r, m, r, ql, qr));
}
node *p = new node(0, 0);

void print_array() {
    for (int i = 0; i < 7; i++) {
        cout << get(p, 0, 1e9, i, i + 1) << ' ';
    }
    cout << endl;
}
int sol1(int n, int w, int h, vector<pair<int, int>> v) {
    /*
     int m;
     cin >> m;
     t.resize(2e5);
     mod.resize(4e5);
     for (int i = 0; i < m; i++) {
     int t;
     cin >> t;
     if (t == 0) {
     int l, r;
     cin >> l >> r;
     cout << get(0, 0, 1e5, l, r) << endl;
     }
     else {
     int l, r, p;
     cin >> l >> r >> p;
     upd(0, 0, 1e5, l, r, p);
     }
     }*/
    map<int, vector<int>> columns;
    for (int i = 0; i < n; i++) {
        int x, y;
        x = v[i].first;
        y = v[i].second;
        columns[x].push_back(y);
    }
    int maxx = 0;
    auto it = columns.begin();
    for (auto [i, v] : columns) {
        for (auto y: columns[i]) {
            upd(p, 0, 1e9, max(0, y - h), y + 1, 1);
        }
        while (it->first <= i - w - 1) {
            for (auto y: it->second) {
                upd(p, 0, 1e9, max(0, y - h), y + 1, -1);
            }
            it++;
        }
        
        maxx = max(maxx, get(p, 0, 1e9, 0, 1e9));
        
        
    }
    return maxx;
}

int main() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].first >> v[i].second;
        
    }
    cout << sol1(n, w, h, v);
}

/*
 10 8 8
 8 9
 20 14
 3 9
 7 8
 3 4
 7 8
 10 19
 6 11
 5 10
 8 2
 */
