#include "biggest.h"
#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

vector<int> biggest(int n, int k) {
    vector<int> ans;
    ans.push_back(0);
    for (int i = 1; i < n; ++i) {
        if (compare(ans[ans.size() - 1] + 1, i + 1) == i + 1) {
            ans.push_back(i);
        }
    }
    for (int i = 1; i < n; ++i) {
        if (count(ans.begin(), ans.end(), i) == 0) {
            int l = -1;
            int r = ans.size();
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (compare(ans[m] + 1, i + 1) == i + 1) {
                    l = m;
                } else {
                    r = m;
                }
                if (r <= ans.size() - k) {
                    break;
                }
            }
            if (r > ans.size() - k) {
                vector<int> new_ans;
                for (int j = 0; j < ans.size(); ++j) {
                    if (j == r) {
                        new_ans.push_back(i);
                    }
                    new_ans.push_back(ans[j]);
                }
                ans = new_ans;
                if (r == ans.size()){
                    ans.push_back(i);
                }
            }
        }
    }
    vector<int> ans1;
    for (int i = 0; i < k; ++i) {
        ans1.push_back(ans.back() + 1);
        ans.pop_back();
    }
    return ans1;
}
