#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cmath>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    vector<int> a(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i + 1];
    }
    vector<long long> sum(n + 1, -2000000000000000000);
    for (int i = 1; i <= n; ++i) {
        sum[i] = 0;
        for (int j = i; j <= n; j += i) {
            sum[i] += a[j];
        }
    }
    int m;
    cin >> m;
    long long ans = 0;
    long long ans1 = *max_element(sum.begin(), sum.end());
    for (int i = 0; i < m; ++i) {
        long long p, s;
        cin >> p >> s;
        long long mx = -1000000000000000000;
        for (int j = 1; j <= sqrt(p); ++j) {
            if (p % j == 0) {
                sum[j] += s;
                mx = max(mx, sum[j]);
                if (p / j != j) {
                    sum[p / j] += s;
                    mx = max(mx, sum[p / j]);
                }
            }
        }
        if (s >= 0) {
            ans += max(ans1, mx);
        }
        else {
            ans += *max_element(sum.begin(), sum.end());
        }
        for (int j = 1; j <= sqrt(p); ++j) {
            if (p % j == 0) {
                sum[j] -= s;
                if (p / j != j) {
                    sum[p / j] -= s;
                }
            }
        }
    }
    cout << ans;
}