#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    vector<int> a(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i + 1];
    }
    vector<long long> sum(n + 1, -2000000000000000000);
    vector<vector<long long>> indexes(n + 1);
    for (int i = 1; i <= n; ++i) {
        sum[i] = 0;
        for (int j = i; j <= n; j += i) {
            sum[i] += a[j];
            indexes[j].push_back(i);
        }
    }
    int m;
    cin >> m;
    long long ans = 0;
    set<pair<long long, long long>> c;
    for (long long i = 1; i <= n; ++i) {
        c.insert({sum[i], i});
    }
    for (int i = 0; i < m; ++i) {
        long long p, s;
        cin >> p >> s;
        long long ans1 = -1000000000000000000;
        for (auto j : indexes[p]) {
            c.erase({sum[j], j});
            ans1 = max(ans1, sum[j] + s);
        }
        if (c.size() > 0) {
            ans += max(c.rbegin()->first, ans1);
        } else {
            ans += ans1;
        }
        for (auto j : indexes[p]) {
            c.insert({sum[j], j});
        }
    }
    cout << ans;
}