#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    vector<int> a(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i + 1];
    }
    vector<long long> sum(n + 1, -2000000000000000000);
    vector<vector<long long>> indexes(n + 1);
    for (int i = 1; i <= n; ++i) {
        sum[i] = 0;
        for (int j = i; j <= n; j += i) {
            sum[i] += a[j];
            indexes[j].push_back(i);
        }
    }
    int m;
    cin >> m;
    long long ans = 0;
    vector<pair<long long, long long>> c;
    for (int i = 0; i < n + 1; ++i) {
        c.push_back({sum[i], i});
    }
    sort(c.rbegin(), c.rend());
    for (int i = 0; i < m; ++i) {
        long long p, s;
        cin >> p >> s;
        long long ans1 = -1000000000000000000;
        set<long long> ind;
        for (auto j : indexes[p]) {
            ans1 = max(ans1, sum[j] + s);
            ind.insert(j);
        }
        for (int j = 0; j < n + 1; ++j) {
            if (ind.count(c[j].second) == 0) {
                ans1 = max(ans1, c[j].first);
                break;
            }
            if (ans >= c[j].first - s) {
                break;
            }
        }
        ans += ans1;
    }
    cout << ans;
}