#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <bitset>
#include <stack>
#include <unordered_set>
#include <cmath>

using namespace std;



int main()
{
	int n, w, h;
	cin >> n >> w >> h;
	set<int> Xs, Ys;
	set<pair<int, int>> pts;
	for (int i = 0; i < n; i++)
	{
		int x, y;
		cin >> x >> y;
		Xs.insert(x);
		Ys.insert(y);
		pts.insert({ x, y });
	}
	vector<int> vx(1, 0), vy(1, 0);
	for (int x : Xs)
		vx.push_back(x);
	for (int y : Ys)
		vy.push_back(y);
	vector<vector<int>> t(vx.size(), vector<int>(vy.size()));
	int ans = 0;
	for (int i = 0; i < vx.size(); i++)
	{
		for (int j = 0; j < vy.size(); j++)
		{
			if (i > 0)
				t[i][j] += t[i - 1][j];
			if (j > 0)
				t[i][j] += t[i][j - 1];
			if (i > 0 && j > 0)
				t[i][j] -= t[i - 1][j - 1];
			t[i][j] += pts.find({ i, j }) != pts.end();
			if (vx[i] >= w && vy[j] >= h)
			{
				int di = lower_bound(vx.begin(), vx.end(), vx[i] - w) - vx.begin();
				int dj = lower_bound(vy.begin(), vy.end(), vy[i] - h) - vy.begin();
				ans = max(ans, t[i][j] - (dj > 0 ? t[i][dj - 1] : 0) - (di > 0 ? t[di - 1][j] : 0) + (di > 0 && dj > 0 ? t[di - 1][dj - 1] : 0));
				//cout << "e";
			}
		}
	}
	cout << ans;
	return 0;
}