#include "biggest.h"
#include <vector>
using namespace std;

#define add push_back

int t[400010];

void make(int v, int tl, int tr) {
	if (tl == tr) {
		t[v] = tl;
	}
	else {
		int tm = (tl + tr) / 2;
		make(v * 2, tl, tm);
		make(v * 2 + 1, tm + 1, tr);
		if (compare(t[v * 2], t[v * 2 + 1]) == t[v * 2]) {
			t[v] = t[v * 2];
		}
		else {
			t[v] = t[v * 2 + 1];
		}
	}
}

void update(int v, int tl, int tr, int p) {
	if (tl == tr) {
		t[v] = 0;
	}
	else {
		int tm = (tl + tr) / 2;
		if (p <= tm) update(v * 2, tl, tm, p);
		else update(v * 2 + 1, tm + 1, tr, p);
		if (t[v * 2] == 0) {
			t[v] = t[v * 2 + 1];
		}
		else if (t[v * 2 + 1] == 0) {
			t[v] = t[v * 2];
		}
		else if (compare(t[v * 2], t[v * 2 + 1]) == t[v * 2]) {
			t[v] = t[v * 2];
		}
		else {
			t[v] = t[v * 2 + 1];
		}
	}
}

vector<int> biggest(int n, int k) {
	make(1, 1, n);
	vector<int> v;
	v.add(t[1]);
	k--;
	while (k--) {
		update(1, 1, n, t[1]);
		v.add(t[1]);
	}
	return v;
}