#include <bits/stdc++.h>

using namespace std;

#define vc vector
typedef int ll;
typedef vc<ll> vll;
typedef pair<ll, ll> pll;
typedef vc<pll> vpll;
typedef vc<vll> vvll;

vll t[800005];
vll a[100005];

const ll n = 1024;

void build(ll l, ll r, ll v) {
    for (ll i = l; i <= r; ++i) {
        for (auto &j : a[i]) {
            t[v].push_back(j);
        }
    }
    sort(t[v].begin(), t[v].end());
    if (l != r) {
        ll mid = (l + r) >> 1;
        build(l, mid, v * 2);
        build(mid + 1, r, v * 2 + 1);
    }
}

ll get(ll l, ll r, ll y1, ll y2) {
    if (l > r) {
        swap(l, r);
    }
    if (y1 > y2) {
        swap(y1, y2);
    }
//    if (y2 == 11 && r == 9) {
//        cout << "kok";
//    }
    l = max(0, l);
    l += n;
    r = min(r, n - 1);
    r += n;
    ll ret = 0;
    while (l <= r) {
        if (l & 1) {
            ret += upper_bound(t[l].begin(), t[l].end(), y2) - lower_bound(t[l].begin(), t[l].end(), y1);
            l += 1;
        }
        if (!(r & 1)) {
            ret += upper_bound(t[r].begin(), t[r].end(), y2) - lower_bound(t[r].begin(), t[r].end(), y1);
            r -= 1;
        }
        l /= 2;
        r /= 2;
    }
//    if (ret == 9) {
//        cout << "morgenwho";
//    }
    return ret;
}

#define lb(x) lower_bound(rt.begin(), rt.end(), x) - rt.begin()
#define ub(x) upper_bound(rt.begin(), rt.end(), x) - rt.begin()

int main() {
    ll c = 100000, w = 1, h = 1;
    cin >> c >> w >> h;
    vpll x(c);

    vll rt;
    for (ll k = 0; k < c; ++k) {
        ll x1 = 1, y = 2;
        cin >> x1 >> y;
        x[k].first = x1;
        x[k].second = y;
        rt.push_back(x1);
        rt.push_back(y);
//        cout << a[x1].size() << endl;
    }
    sort(rt.begin(), rt.end());
    rt.resize(unique(rt.begin(), rt.end()) - rt.begin());
    for (auto &i : x) {
        i.first = lower_bound(rt.begin(), rt.end(), i.first) - rt.begin();
        i.second = lower_bound(rt.begin(), rt.end(), i.second) - rt.begin();
        a[i.first].push_back(i.second);
    }
    build(0, n - 1, 1);
    ll ans = 0;
    for (ll d = 0; d < c; ++d) {
        for (ll i = -10; i <= 10; ++i) {
            ll l1 = x[d].first - w + i;
            ll l2 = x[d].first + w + i;
            ll r = x[d].first + i;
            ll x11 = x[d].second - h;
            ll x12 = x[d].second + h;
            ll x2 = x[d].second;
            l1 = lb(l1);
            l2 = lb(l2);
            r = ub(r) - 1;
            x11 = lb(x11);
            x12 = lb(x12);
            x2 = ub(x2) - 1;

            ans = max(ans, get(l1, r, x11, x2));
            ans = max(ans, get(l1, r, x12, x2));
            ans = max(ans, get(l2, r, x11, x2));
            ans = max(ans, get(l2, r, x12, x2));


//            ans = max(ans, get(lower_bound(rt.begin(), rt.end(), x[d].first - w), lower_bound(x[d].first, lower_bound(x[d].second - h +i) - rt.begin(), lower_bound(x[d].second +i) - rt.begin());
//            ans = max(ans, get(lower_bound(rt.begin(), rt.end(), x[d].first - w), lower_bound(x[d].first, lower_bound(x[d].second + h +i) - rt.begin(), lower_bound(x[d].second +i) - rt.begin());
//            ans = max(ans, get(lower_bound(rt.begin(), rt.end(), x[d].first + w), lower_bound(x[d].first, lower_bound(x[d].second - h +i) - rt.begin(), lower_bound(x[d].second +i) - rt.begin());
//            ans = max(ans, get(lower_bound(rt.begin(), rt.end(), x[d].first + w), lower_bound(x[d].first, lower_bound(x[d].second + h +i) - rt.begin(), lower_bound(x[d].second +i) - rt.begin());
        }
    }

    cout << ans << endl;
}