#include <bits/stdc++.h>

using namespace std;

#define vc vector
typedef int ll;
typedef vc<ll> vll;
typedef pair<ll, ll> pll;
typedef vc<pll> vpll;
typedef vc<vll> vvll;

vll t[800005];
vll a[400005];

const ll n = 131072;

void build(ll l, ll r, ll v) {
    for (ll i = l; i <= r; ++i) {
        for (auto &j : a[i]) {
            t[v].push_back(j);
        }
    }
    sort(t[v].begin(), t[v].end());
    if (l != r) {
        ll mid = (l + r) >> 1;
        build(l, mid, v * 2);
        build(mid + 1, r, v * 2 + 1);
    }
}

ll get(ll _l, ll _r, ll x1, ll x2, ll l, ll r, ll v) {
    if (_l <= l && r <= _r) {
        return upper_bound(t[v].begin(), t[v].end(), x2) - lower_bound(t[v].begin(), t[v].end(), x1);
    }
    if (r < _l || _r < l) {
        return 0;
    }
    ll mid = (l + r) >> 1;
    return get(_l, _r, x1, x2, l, mid, v * 2) + get(_l, _r, x1, x2, mid + 1, r, v * 2 + 1);
}

inline ll get(ll l, ll r, ll x1, ll x2) {
    if (l > r) {
        swap(l,r);
    }
    if (x1 > x2) {
        swap(x1, x2);
    }
    return get(l, r, x1, x2, 0, n - 1, 1);
}


int main() {
    ll c = 100000, w = 1, h = 1;
    cin >> c >> w >> h;

    vpll x(c);
    if (c <= 200 && w <= 200 && c <= 200) {
        for (ll k = 0; k < c; ++k) {
            ll x1 = 1, y = 2;
            cin >> x1 >> y;
            a[x1].push_back(y);
            x[k].first = x1;
            x[k].second = y;
//        cout << a[x1].size() << endl;
        }
        build(0, n - 1, 1);
        ll ans = 0;
        for (ll d = 0; d < c; ++d) {
            for (ll i = -100; i <= 100; ++i) {
                ans = max(ans, get(x[d].first - w + i, x[d].first + i, x[d].second - h, x[d].second));
                ans = max(ans, get(x[d].first - w + i, x[d].first + i, x[d].second + h, x[d].second));
                ans = max(ans, get(x[d].first + w + i, x[d].first + i, x[d].second - h, x[d].second));
                ans = max(ans, get(x[d].first + w + i, x[d].first + i, x[d].second + h, x[d].second));


                ans = max(ans, get(x[d].first - w, x[d].first, x[d].second - h + i, x[d].second + i));
                ans = max(ans, get(x[d].first - w, x[d].first, x[d].second + h + i, x[d].second + i));
                ans = max(ans, get(x[d].first + w, x[d].first, x[d].second - h + i, x[d].second + i));
                ans = max(ans, get(x[d].first + w, x[d].first, x[d].second + h + i, x[d].second + i));
            }
        }
    } else {
        for (ll k = 0; k < c; ++k) {
            ll x1 = 1, y = 1;
            cin >> x1 >> y;
            a[x1].push_back(y);
            x[k].first = x1;
            x[k].second = y;
        }
        build(0, n - 1, 1);
        ll ans = 0;
        for (ll i = 0; i < c; ++i) {
            ans = max(ans, get(x[i].first - w, x[i].first, x[i].second - h, x[i].second, 0, n - 1, 1));
        }

        cout << ans << endl;
    }
}