#include <bits/stdc++.h>
#define debug(x) cerr << #x << " " << x << '\n'
//#pragma GCC optimize "O3"
//#pragma GCC optimize ("Ofast")

using namespace std;

const int N = 5e4;
const int M = 5e5;

void SetIO() {
#ifdef BLAT
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif // BLAT
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

long long dp[5 + N], dpi[5 + N];
long long v[5 + N];

void Add(int i) {
    int d = 1;
    for(d = 1; d * d < i; d++) {
        if(i % d == 0) {
            dp[d] += v[i];
            dp[i / d] += v[i];
        }
    }
    if(d * d == i) dp[d] += v[i];
}

struct ura {
    long long val, pos;

    bool operator < (const ura &aux) const {
        return val > aux.val;
    }
};

set <ura> ms;
stack <pair <long long, long long>> st;

/*void Revert(int val) {
    while(st.size()) {
        ura top = st.top();
        ms.erase(top);
        top.val -= val;
        top.luat = false;
        ms.insert(top);
        st.pop();
    }
}*/

int main() {
    SetIO();
    int n, m;
    long long sum(0);
    cin >> n;

    for(int i = 1; i <= n; i++) {
        cin >> v[i];
        Add(i);
    }

    for(int i = 1; i <= n; i++) {
        //debug(dp[i]);
        dpi[i] = dp[i];
        ms.insert({dp[i], i});
    }

    cin >> m;
    for(int i = 1; i <= m; i++) {
        long long idx, val, d;
        bool ok(true);
        cin >> idx >> val;

        for(d = 1; d * d < idx; d++) {
            if(idx % d == 0) {
                ms.erase({dp[d], d});
                dp[d] += val;
                ms.insert({dp[d], d});

                ms.erase({dp[idx / d], idx / d});
                dp[idx / d] += val;
                ms.insert({dp[idx / d], idx / d});

                //st.push(make_pair(d, val));
                //st.push(make_pair(idx / d, val));
            }
        }

        if(d * d == idx) {
            ms.erase({dp[d], d});
            dp[d] += val;
            ms.insert({dp[d], d});
            //st.push(make_pair(d, val));
        }

        ura x = *ms.begin();
        sum += 1LL * x.val;
        //cout << x.val << '\n';

        ms.clear();
        for(int i = 1; i <= n; i++) {
            dp[i] = dpi[i];
            ms.insert({dp[i], i});
        }
        /*while(st.size()) {
            pair <long long, long long> top = st.top();
            ms.erase({dp[top.first], top.first});
            dp[top.first] -= val;
            ms.insert({dp[top.first], top.first});

            st.pop();
        }*/

        /* ura top = *ms.rbegin();
         if(idx % top.pos != 0) {
             ok = false;
             cout << top.val << '\n';
             Revert(val);
         } else {
             if(top.luat == true) {
                 ok = false;
                 cout << top.val << '\n';
                 Revert(val);
             } else {
                 ms.erase(top);
                 top.val = top.val + val;
                 top.luat = true;
                 st.push(top);
                 ms.insert(top);
             }
        }*/
    }

    cout << sum << '\n';
    return 0;
}
