#include <bits/stdc++.h>
#define endl "\n"
using namespace std;
typedef long long ll;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 1e5 + 200;
pair<int, int> point[N + 1];
vector<int> coord[N + 1];

struct node{
  node *l = 0, *r = 0;
  int val = 0;
  bool changed = false;
};

void build(node *v, int tl, int tr){
  if(tl == tr)
    return;
  int tm = (tl + tr) / 2;
  v->l = new node();
  v->r = new node();
  build(v->l, tl, tm);
  build(v->r, tm + 1, tr);
}

void nw(node *v, node *pr, int tl, int tr, int x){
  while(!coord[x].empty() && coord[x].back() > tr)
    coord[x].pop_back();
  if(tl == tr){
    v->val = pr->val;
    for(int i = (int)coord[x].size() - 1; i >= 0; i --){
      if(coord[x][i] < tl)
        break;
      v->val ++;
    }
    return;
  }
  int tm = (tl + tr) / 2;
  for(int i = (int)coord[x].size() - 1; i >= 0; i --){
    if(coord[x][i] < tl)
      break;
    if(coord[x][i] <= tm && v->l == 0)
      v->l = new node();
    else if(coord[x][i] > tm && v->r == 0)
      v->r = new node();
  }
  if(v->r == 0)
    v->r = pr->r;
  else
    nw(v->r, pr->r, tm+1, tr, x);
  if(v->l == 0)
    v->l = pr->l;
  else
    nw(v->l, pr->l, tl, tm, x);
  v->val = v->l->val + v->r->val;
}


int sum(node *v, int tl, int tr, int l, int r){
  if(l > r)
    return 0;
  if(tl == l && tr == r)
    return v->val;
  int tm = (tl + tr) / 2;
  return sum(v->l, tl, tm, l, min(r, tm)) + sum(v->r, tm + 1, tr, max(l, tm + 1), r);
}

int n, w, h;
//void brute(){
//  for(int i = 0; i < n; i ++){
//    auto [x, y] = point[i];
//    for(int a = max(1, x - h)
//  }
//}

int main () {
  ios_base::sync_with_stdio(0);
  cin.tie(0); cout.tie(0);
  cin >> n >> w >> h;
  for(int i = 0; i < n; i ++){
    int x, y;
    cin >> x >> y;
    point[i] = {x, y};
    coord[x].push_back(y);
  }
//  if(n <= 1000){
//    brute();
//    return 0;
//  }
  for(int i = 0; i <= N; i ++)
    sort(coord[i].begin(), coord[i].end());
  vector<node*> kek(N + 1);
  kek[0] = new node();
  build(kek[0], 0, N);
  for(int i = 1; i <= N; i ++)
    kek[i] = new node(),
    nw(kek[i], kek[i - 1], 0, N, i);
  int ans = 0;
  for(int i = 0; i < n; i ++){
    auto [x, y] = point[i];
    int xl = max(0, x - w - 1);
    int yd = max(0, y - h);
    ans = max(ans, sum(kek[x], 0, N, yd, y) - sum(kek[xl], 0, N, yd, y));
  }
  cout << ans;

}
