#include "biggest.h"
#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;

using ll = long long;
using ld = long double;

std::random_device rd;
std::mt19937 g(rd());

const int N = 5e4;

std::set<pair<int, int>> res[N];

bool ask (int x, int y) {
	auto it = res[x].lower_bound({y, -1});
	int ans = -1;
	if (it == res[x].end() || it->first != y) {
		ans = compare(x + 1, y + 1);
		res[x].insert({y, ans});
	} else {
		ans = it->second;	
	}
	return ans == x + 1;
}

std::vector<int> biggest (int n, int k) {
	vector<int> v(n);
	for (int i = 0; i < n; ++i)
		v[i] = i;
	//std::shuffle(v.begin(), v.end(), g);
	if (k < 1000)
		std::partial_sort(v.begin(), v.begin() + k, v.end(), ask);
	else {
		std::nth_element(v.begin(), v.begin() + k - 1, v.end(), ask);

		// cerr << "v:";
		// for (int i = 0; i < n; ++i)
		//  cerr << v[i] << ' ';
		// cerr << '\n';
		std::sort(v.begin(), v.begin() + k, ask);
	}
	std::vector<int> ans(k);
	for (int i = 0; i < k; ++i) {
		ans[i] = v[i] + 1;
		//assert(v[i] == v1[i]);
	}
	return ans;
}
