#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;

using ll = long long;
using ld = long double;

const int INF = 1e9;

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n;
	cin >> n;

	vector<ll> a(n);
	for (ll &i : a)
		cin >> i;

	vector<ll> sum(n), max(2 * n, -INF);
	for (int i = 0; i < n; ++i)
		for (int j = i; j < n; j += i + 1)
			sum[i] += a[j];

	std::vector<vector<int>> v(n);

	for (int i = 0; i < n; ++i)
		for (int j = i; j < n; j += i + 1) {
			max[j] = std::max(max[j], sum[i]);
			v[j].push_back(i);
		}

	std::set<pair<ll, int>> s;
	for (int i = 0; i < n; ++i)
		s.insert({-sum[i], i});
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < v[i].size(); ++j)
			s.erase({-sum[v[i][j]], v[i][j]});

		max[n + i] = -s.begin()->first;

		for (int j = 0; j < v[i].size(); ++j)
			s.insert({-sum[v[i][j]], v[i][j]});
	}	

	int m;
	cin >> m;
	ll ans = 0;
	for (int i = 0; i < m; ++i) {
		ll p, s;
		cin >> p >> s;
		--p;
		ans += std::max(max[p] + s, max[n + p]);
	}
	cout << ans;
	return 0;
}