#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#define int long long
#define ll int
#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")

using namespace std;

int func(vector <pair<int,int>> *tree, const int y1, const int y2, int l, int r, int L, int R, int now = 0){
    if (l > r){
        return 0;
    }
    if (l == L && r == R){
        int left = -1, right = tree[now].size();
        while (left != right - 1){
            int middle = (left + right) / 2;
            if (tree[now][middle].second < y1){
                left = middle;
            }else{
                right = middle;
            }
        }
        int LEFT = -1, RIGHT = tree[now].size();
        while (LEFT != RIGHT - 1){
            int MIDDLE = (LEFT + RIGHT) / 2;
            if (tree[now][MIDDLE].second > y2){
                RIGHT = MIDDLE;
            }else{
                LEFT = MIDDLE;
            }
        }
        return RIGHT - left - 1;
    }
    int m = (L + R) / 2;
    return func(tree, y1, y2, l, min(r, m), L , m, now * 2 + 1) + func(tree, y1, y2, max(l, m + 1), r, m + 1, R, now * 2 + 2);
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int a, w, h;
    cin >> a >> w >> h;
    pair <int, int> mas[a];
    for (int u = 0;u < a;u++){
        int c, d;
        cin >> c >> d;
        d = INT_MAX - d;
        mas[u] = make_pair(c, d);
    }
    sort(mas, mas + a);
    const int size = ((ll)1 << (ll)ceil(log2(a) + 1)) - 1;
    int ind = size / 2;
    vector <pair <int, int>> help[size];
    for (int u = 0;u < a;u++){
        help[ind + u].emplace_back(mas[u].second, mas[u].first);
    }
    for (int u = ind - 1;u > -1;u--){
        help[u] = help[u * 2 + 1];
        for (const auto &i : help[u * 2 + 2]){
            help[u].push_back(i);
        }
    }
    for (int u = 0;u < size;u++){
        sort(help[u].begin(), help[u].end());
    }
    for (int u = 0;u < size;u++) {
        for (auto &i : help[u]) {
            swap(i.first, i.second);
        }
    }
    int answer = 0;
    for (int u = 0;u < a;u++){
        int x2 = mas[u].first;
        for (int y = u;y < a;y++){
            int y1 = mas[y].second;
            int y2 = y1 + w;
            if (mas[y].first - x2 > h){
                break;
            }
            if (y1 > mas[u].second){
                continue;
            }
            int l = 0, r = x2;
            while (l != r - 1){
                int m = (l + r) / 2;
                if (mas[m].first < x2 - h){
                    l = m;
                }else{
                    r = m;
                }
            }
            answer = max(answer, func(help, y1, y2, r, y, 0, ind));
        }
    }
    cout << answer;

}
