#include <bits/stdc++.h>
using namespace std;

const long long INF = (long long) 1e18;

int divisors[(int) 5e4], used[(int) 5e4];

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<long long> a(n + 1), change(n + 1, 0);
  for (int i = 1; i <= n; i++) {
    cin >> a[i];
  }
  vector<long long> sum(n + 1, 0), v;
  long long mx = -INF;
  for (int i = 1; i <= n; i++) {
    for (int j = i; j <= n; j += i) {
      sum[i] += a[j];
    }
    mx = max(mx, sum[i]);
    v.push_back(i);
  }
  sort(v.begin(), v.end(), [&](int a, int b) {
    return sum[a] > sum[b];
  });
  int m;
  cin >> m;
  long long ans = 0;
  memset(used, 0, sizeof used);
  while (m--) {
    int p;
    long long s;
    cin >> p >> s;
    long long add = mx;
    int ptr = 0;
    for (int i = 1; i * i <= p; i++) {
      if (p % i == 0) {
        divisors[ptr++] = i;
        if (i * i != p) {
          divisors[ptr++] = p / i;
        }
      }
    }
    if (s >= 0) {
      for (int i = 0; i < ptr; i++) {
        add = max(add, sum[divisors[i]] + s);
      }
    } else {
      int i;
      for (i = 0; i < ptr; i++) used[divisors[i]] = 1;
      for (i = 0; used[v[i]]; i++);
      add = max(mx + s, sum[v[i]]);
      for (i = 0; i < ptr; i++) used[divisors[i]] = 0;
    }
    ans += add;
  }
  cout << ans << '\n';
  return 0;
}
