#include <bits/stdc++.h>

#define pb push_back
#define ll long long
#define pii pair<int, int>
#define xx first
#define yy second
#define MAXN 100010

using namespace std;

int n, w, h, x[MAXN], y[MAXN], biti[MAXN], bitj[MAXN], mat[1010][1010], pref[1010][1010], ress;
pair<int, int> tck[MAXN];

void updi(int x)
{
    while (x<MAXN)
    {
        biti[x]++;
        x+=x&(-x);
    }
}
void updj(int x)
{
    while (x<MAXN)
    {
        bitj[x]++;
        x+=x&(-x);
    }
}

int sumi(int x)
{
    int ret=0;
    while (x)
    {
        ret+=biti[x];
        x-=x&(-x);
    }
    return ret;
}
int sumj(int x)
{
    int ret=0;
    while (x)
    {
        ret+=bitj[x];
        x-=x&(-x);
    }
    return ret;
}

int main(){
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin>>n>>w>>h;

    int maxxglupo=-1, maxyglupo=-1;
    for (int i=0; i<n; i++)
    {
        cin>>x[i]>>y[i];
        tck[i]={x[i], y[i]};
        maxxglupo=max(maxxglupo, x[i]);
        maxyglupo=max(maxyglupo, y[i]);
    }

    if (n<=100010 && maxxglupo<=1010 && maxyglupo<=1010 && h<=1010 && w<=1010)
    {
        for (int i=0; i<n; i++) mat[x[i]][y[i]]++;

        for (int i=1; i<=1006; i++)
        {
            for (int j=1; j<=1006; j++)
            {
                //cout<<mat[i][j]<<" "<<i<<" "<<j<<endl;
                //cout<<pref[i-1][j]<<" "<<pref[i][j-1]<<" r "<<pref[i-1][j-1]<<endl;
                pref[i][j]=pref[i-1][j]+pref[i][j-1]-pref[i-1][j-1]+mat[i][j];
                //cout<<pref[i][j]<<endl;
            }
        }

        for (int xg=w+1; xg<=1006; xg++)
        {
            for (int yg=h+1; yg<=1006; yg++)
            {
                int xp=xg-w; int yp=yg-h;
                int trRes=pref[xg][yg];
                trRes-=pref[xg][yp-1];
                trRes-=pref[xp-1][yg];
                trRes+=pref[xp-1][yp-1];
                //cout<<xx<<" xxyy "<<yy<<" "<<trRes<<endl;
                ress=max(trRes, ress);
            }
        }
        cout<<ress;
    }
    else if (n<=1010)
    {
        sort(tck, tck+n);

        //for (int i=0; i<n; i++) cout<<tck[i].xx<<" "<<tck[i].yy<<endl;

        for (int i=0; i<n; i++)
        {
            vector<int> koji;
            for (int j=i; j<n && tck[j].xx<=tck[i].xx+w; j++)
            {
                koji.pb(tck[j].yy);
            }
            //cout<<i<<" "<<koji.size()<<endl;
            sort(koji.begin(), koji.end());

            int dp=0;
            for (int lp=0; lp<koji.size(); lp++)
            {
                while (dp<koji.size() && koji[dp]<=koji[lp]+h) dp++;
                ress=max(ress, dp-lp);
            }
        }
        cout<<ress;
    }
    else if (n<=100010 && maxxglupo<=100010 && maxyglupo<=100010 && h<=100010 && w<=100010)
    {
        sort(tck, tck+n, greater<pii>());

        //for (int i=0; i<n; i++) cout<<tck[i].xx<<" "<<tck[i].yy<<endl;

        int j=0;
        //cout<<"EE"<<endl;
        for (int i=0; i<n; i++)
        {
            //cout<<i<<endl;
            while (j<n && tck[j].xx>=tck[i].xx-w) { /*cout<<j<<" j "<<tck[j].yy<<endl;*/  cout<<tck[j].yy<<endl; updj(tck[j].yy); j++; }

            //cout<<i<<" ij "<<j<<endl;
            //cout<<i<<endl;

            int uOpseguDoj;
            if (tck[i].yy>h) uOpseguDoj=sumj(tck[i].yy)-sumj(tck[i].yy-h-1);
            else uOpseguDoj=sumj(tck[i].yy);

            int uOpseguDoi;
            if (tck[i].yy>h) sumi(tck[i].yy)-sumi(tck[i].yy-h-1);
            else uOpseguDoi=sumi(tck[i].yy);

            //cout<<uOpseguDoj<<" opsezi "<<uOpseguDoi<<endl;

            int trRess=uOpseguDoj-uOpseguDoi;
            updi(tck[i].yy);

            //cout<<i<<": "<<trRess<<endl;
            ress=max(ress, trRess);
        }
        cout<<ress<<endl;
    }

}
