#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

int main()
{
    int n;
    cin>>n;
    vector<int64_t> a(n+1);
    vector<pair<int64_t,int> > pref(n+1, {0,0});
    vector<pair<int,int64_t> > sum(n+1, {0,0});
    for(int i=1; i<=n; ++i)
    {
        cin>>a[i];
    }
    for(int i=1; i<=n; ++i)
    {
        for(int j=i; j<=n; j+=i)
        {
            pref[i].first+=a[j];
            sum[i].second+=a[j];
        }
        sum[i].first=i;
        pref[i].second=i;
    }
    sort(pref.begin(),pref.end());
    int64_t ans=0;
    int m;
    cin>>m;
    while(m--)
    {
        int64_t p,s;
        cin>>p>>s;
        int64_t curmax=pref[n].first;
        if(pref[n].second==p)
        {
            curmax+=s;
            if(s<0)
            {
                 int i=n-1;
                 while(i>=1 && p%pref[i].second==0)
                 {
                     i--;
                 }
                 curmax=max(curmax,pref[i].first);
            }
        }
        curmax=max(sum[p].second + s,curmax);
        for(int i=1; i<=(int64_t) sqrt(p); ++i)
        {
            if(p%i==0)
            {
                curmax=max(sum[i].second + s,curmax);
            }
        }
        ans+=curmax;
    }
    cout<<ans<<endl;
    return 0;
}
