#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

#define int long long
#define f first
#define s second

vector <int> t;
vector <int> maxi;

void build(int v, int l, int r)
{
    if (l==r){
        t[v]=maxi[l];
        return;
    }
    int m=(l+r)>>1;
    build(v*2,l,m);
    build(v*2+1,m+1,r);
    t[v]=max(t[v*2],t[v*2+1]);
}

void update(int v, int l, int r, int pos, int x)
{
    if (pos<l || r<pos)return;
    if (l==r){
        t[v]=x;
        return;
    }
    int m=(l+r)>>1;
    update(v*2,l,m,pos,x);
    update(v*2+1,m+1,r,pos,x);
    t[v]=max(t[v*2],t[v*2+1]);
}


signed main()
{
    //freopen("output.txt","w",stdout);
    //ios::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);
    int n;
    cin >> n;
    vector <int> a(n+1);
    for (int i=1; i<=n; i++){
        cin >> a[i];
    }

    vector <int> summ(n+1,0);
    for (int i=1; i<=n; i++){
        for (int j=i; j<=n; j=i+j){
            summ[i]+=a[j];
        }
    }

    vector <vector <int> > sum(n+1);
    int start=-1000000000000000;
    for (int i:summ)start=max(start,i);

    for (int i=1; i<=n; i++){
        for (int j=1; j*j<=i; j++){
            if (i%j!=0)continue;
            sum[i].push_back(summ[j]);
            sum[i].push_back(summ[i/j]);
        }
    }

    maxi.resize(n+1,-1000000000000000);
    for (int i=1; i<=n; i++){
        for (int j:sum[i]){
            maxi[i]=max(maxi[i],j);
        }
    }

    t.resize(n+1,0);
    build(1,1,n);
    cout << "+";

    int ans=0;
    int m;
    cin >> m;
    for (int q=0; q<m; q++){
        int p,s;
        cin >> p >> s;
        update(1,1,n,p,maxi[p]+s);
        ans+=t[1];
        update(1,1,n,p,maxi[p]);
    }
    cout << ans;
    return 0;
}
/**
6
2 -5 3 2 -1 4
2
3 -4
2 3
*/
