#include <bits/stdc++.h>
using namespace std;

/*
#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
#pragma GCC optimize("-fpeephole2")
#pragma GCC optimize("-fsched-spec")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
*/

//#define int long long
#define f first
#define s second

struct event
{
    int x,y,t;
    event(){}
    event(int x, int y, int t):x(x),y(y),t(t){}
};

bool comp(event a, event b)
{
    if (a.x!=b.x)return a.x<b.x;
    return a.t<b.t;
}

vector < int> t;
vector < int> add;

int w,h;

void push(int v, int l, int r)
{
    if (l==r){
        t[v]+=add[v];
        add[v]=0;
        return;
    }
    t[v]+=add[v];
    add[2*v]+=add[v];
    add[2*v+1]+=add[v];
    add[v]=0;
}


void update(int v, int l, int r, int A, int B, int x)
{
    push(v,l,r);
    if (B<l || r<A)return;
    if (A<=l && r<=B){
        add[v]+=x;
        push(v,l,r);
        return;
    }

    int m=(l+r)>>1;
    update(v*2,l,m,A,B,x);
    update(v*2+1,m+1,r,A,B,x);
    t[v]=max(t[v*2],t[v*2+1]);
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n >> w >> h;
    t.resize(10000000,0);
    add.resize(10000000,0);

    vector <pair <int,int> > pts(n);
    for (int i=0; i<n; i++){
        cin >> pts[i].f >> pts[i].s;
    }

    map <int,int> z,re_z;
    int now=1;
    vector <int> aa(n);
    for (int i=0; i<n; i++){
        aa[i]=pts[i].s;
    }
    sort(aa.begin(),aa.end());
    for (int i=0; i<n; i++){
        if (z[aa[i]]==0){
            z[aa[i]]=now;
            re_z[now]=aa[i];
            now++;
        }
    }
    map <int,int> need_h;
    int pos=0;
    for (int i=1; i<now; i++){
        if (need_h[i]==0){
            int x=re_z[i];
            while (pos+1<n && aa[pos+1]-x<=h)pos++;
            if (pos==n)pos--;
            need_h[i]=z[aa[pos]];
        }
    }

    vector <event> q;
    for (int i=0; i<n; i++){
        q.push_back({pts[i].f,z[pts[i].s],1});
        q.push_back({pts[i].f+w+1,z[pts[i].s],-1});
    }
    sort(q.begin(),q.end(),comp);

    int ans=0;
    for (int ii=0; ii<q.size(); ii++){
        int type=q[ii].t;
        int x=q[ii].x;
        int y=q[ii].y;
        if (type==-1){
            update(1,0,1000000,y,need_h[y],-1);
            continue;
        }
        update(1,0,1000000,y,need_h[y],1);
        ans=max(ans,(int)t[1]);
    }
    cout << ans;

}
/**
6 2 3
100000001 100000001
100000003 100000001
100000002 100000002
100000003 100000003
100000005 100000003
100000003 100000005
*/

