#include <random>
#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <algorithm>
#include <cmath>
#include <map>
#include <iomanip>
#include <string>
#include <unordered_map>
#include <chrono>
#include "biggest.h"

using namespace std;

#define ll long long

#define VI vector<int>
#define VB vector<bool>
#define VS vector<string>
#define VC vector<char>
#define PAR pair<int, int>
#define VP vector<PAR>
#define VVI vector<VI>
#define VVC vector<VC>
#define VVB vector<VB>
#define VVP vector<VP>
#define endl '\n'

std::vector<int> biggest(int n, int k) {
	vector<int> curr(n);
	for (int i = 0; i < n; ++i) {
		curr[i] = i + 1;
	}
	VI res;
	int rem = k;
	while (rem > 0) {
		int ind = rand() % curr.size();
		vector<int> left, right;
		for (auto it = curr.begin(); it != curr.end(); ++it) {
			if (compare(*it, ind) == *it) {
				right.push_back(*it);
			}
			else {
				left.push_back(*it);
			}
		}
		if (right.size() <= rem) {
			for (int val : right) {
				res.push_back(val);
			}
			rem -= right.size();
			curr = left;
		}
		else {
			curr = right;
		}
	}
	return res;
}