#include "biggest.h"
#include <bits/stdc++.h>
using namespace std;

bool comp(int a, int b)
{
    return compare(a, b) == a;
}

vector<int> merge_sort(vector<int> now, int k)
{
    if (now.size() < 2)
        return now;
    int mid = now.size() / 2;
    sort(now.begin(), now.begin() + mid, comp);
    sort(now.begin() + mid, now.end(), comp);
    vector<int> left = vector<int> (now.begin(), now.begin() + mid);
    vector<int> right = vector<int>(now.begin() + mid, now.end());
    vector<int> result;
    int l = 0, r = 0, count = 0;
    while (count < k && l < left.size() && r < right.size())
    {
        if (comp(left[l], right[r]))
        {
            result.push_back(left[l]);
            l++;
        }
        else
        {
            result.push_back(right[r]);
            r++;
        }
        count++;
    }
    while (count < k && l < left.size())
    {
        result.push_back(left[l]);
        l++;
        count++;
    }
    while (count < k && r < right.size())
    {
        result.push_back(right[r]);
        r++;
        count++;
    }
    return result;
}

vector<int> biggest(int n, int k)
{
    vector<int> now(n);
    for (int i = 0; i < n; i++)
    {
        now[i] = i + 1;
    }
    now = merge_sort(now, k);
    return vector<int>(now.begin(), now.begin() + k);
}