#include <bits/stdc++.h>

using namespace std;

const int NMAX = 1e4;
int mat[NMAX + 5][NMAX + 6];

int solve( int si, int sj, int dist1, int dist2 ){
  if( si == 0 && sj == 0 )
    return mat[dist1 + si][dist2 + sj];
  if( si == 0 )
    return mat[dist1 + si][dist2 + sj] - mat[si + dist1][sj - 1];
  if( sj == 0 )
     return mat[dist1 + si][dist2 + sj] - mat[si - 1][sj + dist2];
  return mat[dist1 + si][dist2 + sj] + mat[si - 1][sj - 1] - mat[si - 1][sj + dist2] - mat[si + dist1][sj - 1];
}

int main() {
  //freopen( ".in", "r", stdin );
  //freopen( ".out", "w", stdout );
  int n, w, h, maxlin, maxcol, maxx, i, x, y, j;
  cin >> n >> w >> h;
  maxlin = maxcol = 0;
  for( i = 1; i <= n; ++i ){
    cin >> x >> y;
    ++mat[x][y];
    maxlin = max(maxlin, x);
    maxcol = max(maxcol, y);
  }

  if( n <= 1000 ){
    for( i = 1; i <= max(maxlin, w + 1); ++i )
      for( j = 1; j <= max(maxcol, h + 1); ++j )
        mat[i][j] += mat[i - 1][j] + mat[i][j - 1] - mat[i - 1][j - 1];
    maxx = 0;
    for( i = 0; i <= max(maxlin, w + 1); ++i )
      for( j = 0; j <= max(maxcol, h + 1); ++j )
        maxx = max(maxx, solve(i, j, w, h));
    cout << maxx;
  }
  return 0;
}
