#include "biggest.h"
#include <iostream>
#include <vector>
#include <set>
#include <random>

using namespace std;

mt19937 rnd(31);

vector<int> ans;
void solve(const vector<int>& ind, int k) {
        int n = (int) ind.size();
        if (n == k) {
                for (int i : ind) {
                        ans.push_back(i);
                }
                return;
        }
        if (k == 0) return;
        vector<int> big, smol;
        int p = rnd() % n;
        for (int i = 0; i < n; ++i) {
                if (i == p) continue;
                if (compare(ind[p], ind[i]) == ind[i]) {
                        big.push_back(ind[i]);
                } else {
                        smol.push_back(ind[i]);
                }
        }
        if (k <= big.size()) 
                solve(big, k);
        else {
                for (int i : big) {
                        ans.push_back(i);
                }
                ans.push_back(ind[p]);
                solve(smol, k - 1 - big.size());
        }
}

vector<int> biggest (int N, int K) {
        vector<int> ind (N);
        for (int i = 0; i < N; ++i) {
                ind[i] = i + 1;
        }
        solve(ind, K);
        return ans;
}

