#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

#define int ll

const ll inf = 4e18 + 1329;

signed main() {
    int n; cin >> n;
    vector<int> a (n + 1, 0);
    for (int i = 1; i <= n; ++i) cin >> a[i];
    vector<ll> t (n + 1, 0);
    for (int d = 1; d <= n; ++d) {
        for (int i = d; i <= n; i += d) {
            t[d] += a[i];
        }
    }
    vector<ll> in (n + 1, -inf);
    for (int i = 1; i <= n; ++i) {
        for (int k = 1; k * k <= i; ++k) {
            if (i % k != 0) continue;
            in[i] = max(in[i], t[k]);
            in[i] = max(in[i], t[i / k]);
        }
    }
    vector<ll> out (n + 1, -inf);
    for (int i = 1; i <= n; ++i) {
        for (int d = 1; d <= n; ++d) {
            if (i % d == 0) continue;
            out[i] = max(out[i], t[d]);
        }
    }
    ll ans = 0;
    int m; cin >> m;
    while (m--) {
        int s, p; cin >> s >> p;
        //cout << in[s] << ' ' << out[s] << '\n';
        ans += max(in[s] + p, out[s]);
    }
    cout << ans << '\n';
}
