#include <bits/stdc++.h>
#pragma GCC optimize ("Ofast")
using namespace std;
#define int int64_t
#define pii pair<int,int>
#define F first
#define S second

struct mq {
    stack <pii> s1, s2;
    int get () {
        return ((s1.empty()) ? s2.top().S : ((s2.empty()) ? s1.top().S : max(s1.top().S, s2.top().S)));
    }
    void add (int x) {
        s1.push((s1.empty()) ? make_pair(x, x) : make_pair(x, max(x, s1.top().S)));
    }
    void del () {
        if (s2.empty()) {
            while (!s1.empty()) {
                int x = s1.top().F;
                s2.push((s2.empty()) ? make_pair(x, x) : make_pair(x, max(x, s2.top().S)));
                s1.pop();
            }
        }
        s2.pop();
    }
};

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    int n, w, h;
    cin >> n >> w >> h;
    pii a[n];
    for (int i=0;i<n;++i) {
        cin >> a[i].F >> a[i].S;
    }
    sort(a, a+n);
    mq q1, q2;
    int l = 0, r = 0, ans = 0;
    for (;r<n;++r) {
        q1.add(a[r].S);
        q2.add(-a[r].S);
        while (l < r && (a[r].F - a[l].F > h || q1.get() + q2.get() > w)) {
            l++;
            q1.del();
            q2.del();
        }
        if (a[r].F - a[l].F <= h && q1.get() + q2.get() <= w)
            ans = max(ans, r-l+1);
    }
    cout << ans;
    return 0;
}
