#include "biggest.h"
#include <algorithm>
#include <iostream>
#include <vector>
#include <numeric>


bool cmp(int i, int j) {
	return compare(i, j) == i;
}

std::vector<int> biggest(int n, int k) {
	std::vector<int> vec(n);
	std::iota(vec.begin(), vec.end(), 1);
	std::nth_element(vec.begin(), vec.begin() + k, vec.end(), cmp);
	std::sort(vec.begin(), vec.begin() + k, cmp);
	return std::vector(vec.begin(), vec.begin() + k);
}