#include "biggest.h"
#include <algorithm>
#include <iostream>
#include <vector>
#include <numeric>

#include <unordered_map>


class Hash {
public:
	uint64_t operator()(const std::pair<int, int> &val)const {
		return std::hash<uint64_t>()((val.first << 32) | val.second);
	}
};
std::unordered_map<std::pair<int, int>, bool, Hash> maap;

bool cmp(int i, int j) {
	//return compare(i, j) == i;
	if (i == j) {
		exit(1);
	}
	if (i > j) {
		return !cmp(j, i);
	}
	if (maap.find(std::pair<int, int>{ i, j }) != maap.end()) {
		return maap[std::pair<int, int>{ i, j }];
	}
	return maap[std::pair<int, int>{ i, j }] = (compare(i, j) == i);
}

std::vector<int> biggest(int n, int k) {
	std::vector<int> vec(n);
	std::iota(vec.begin(), vec.end(), 1);
	std::partial_sort(vec.begin(), vec.begin() + k, vec.end(), cmp);
	return std::vector(vec.begin(), vec.begin() + k);
}