#include "biggest.h"
#include <algorithm>
#include <iostream>
#include <vector>
#include <numeric>

#include <unordered_map>
#include <map>
#include <bitset>
#include <random>


constexpr int KK = 5005;
constexpr int GG = 10000;

int n, k;
int data[100005];
char help[KK][KK];
int ind[100005];
std::mt19937 rnd(29865);

bool cmp0(int i, int j) {
	if (i == j) {
		return false;
	}
	return compare(i, j) == i;
}

class Hash {
public:
	uint64_t operator()(const std::pair<int, int> &val)const {
		return std::hash<uint64_t>()((val.first << 32) | val.second);
	}
};
std::unordered_map<std::pair<int, int>, bool, Hash> map;
bool cmp(int i, int j) {
	if (k > GG) {
		return compare(i, j) == i;
	}
	if (i > j) {
		return !cmp(j, i);
	}
	if (map.find(std::pair<int, int>{ i, j }) != map.end()) {
		return map[std::pair<int, int>{ i, j }];
	}
	return map[std::pair<int, int>{ i, j }] = (compare(i, j) == i);
}




bool cmp2(int i, int j) {
	if (i > j) {
		return !cmp2(j, i);
	}
	if (help[ind[i]][ind[j]] == -1) {
		help[ind[i]][ind[j]] = cmp0(i, j);
	}
	return help[ind[i]][ind[j]];
}

std::vector<int> biggest(int n, int k) {
	::n = n;
	::k = k;
	std::iota(data, data + n, 1);

	if (k == 1) {
		return { *std::min_element(data, data + n, cmp0) };
	} else if ((k >= 10000) || (k <= 1000)) {
		std::vector<int> vec(n);
		std::iota(vec.begin(), vec.end(), 1);
		if (k <= 1000) {
			std::partial_sort(vec.begin(), vec.begin() + k, vec.end(), cmp);
		} else {
			std::partial_sort(vec.begin(), vec.begin() + k, vec.end(), cmp0);
		}
		return std::vector(vec.begin(), vec.begin() + k);
	} else {
		while (true) {
			constexpr int CNT = 100;
			std::vector<int> vec;
			for (int i = 0; i < CNT; i++) {
				while (true) {
					int p = data[rnd() % n];
					if (std::find(vec.begin(), vec.end(), p) == vec.end()) {
						vec.push_back(p);
						break;
					}
				}
			}
			std::vector<int> srt = { vec.front() };
			for (int i = 1; i < CNT; i++) {
				auto ps = std::upper_bound(srt.begin(), srt.end(), vec[i], cmp0);
				srt.insert(ps, vec[i]);
			}

			int val = srt[int(k * 1.0 / n * CNT * 3)];

			int x = std::remove_if(data, data + n, [&](int i) {return !cmp0(i, val); }) - data;
			if (x >= k) {
				n = x;
				break;
			}
		}

		std::cerr << "n is: " << n << std::endl;

		std::partial_sort(data, data + k, data + n, cmp0);

		return std::vector(data, data + k);

		//std::nth_element(data, data + k - 1, data + n, cmp0);
		//if (k > KK) {
		//	std::sort(data, data + k - 1, cmp0);
		//} else {
		//	std::fill(ind, ind + n + 1, -1);
		//	for (int i = 0; i < (k - 1); i++) {
		//		ind[data[i]] = i;
		//	}
		//	for (int i = 0; i < k - 1; i++) {
		//		for (int j = 0; j < k - 1; j++) {
		//			help[i][j] = -1;
		//		}
		//	}
		//	std::sort(data, data + k - 1, cmp2);
		//}
		//return std::vector(data, data + k);
	}
	exit(1);
}