#include <bits/stdc++.h>
#define X first
#define Y second
#define F first
#define S second
#define pb push_back
#define ull size_t
#define ll long long
#define inf INT_MAX

using namespace std;


int power(int a, int b);
void update_max_tree(int pos, vector < vector < int > > &tree);
void update_min_tree(int pos, vector < vector < int > > &tree);


int main(){
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

    int n, w, h, buf;
    n = 100;
    w = 42;
    h = 31;
    srand(time(0));
    vector < pair < int, int > > points(n);
    for(auto &i: points){
        i.X = abs(rand() % 100);
        i.Y = abs(rand() % 100);
    }
    int real_n = power(2, ceil(log2(n)));
    vector < vector < int > > max_x_tree(real_n * 2, vector < int > (6, 0));
    for(int i = real_n; i < real_n * 2; i++){
        if(i - real_n < n){
            buf = points[i - real_n].X;
        }else{
            buf = 0;
        }
        max_x_tree[i] = {buf, i, i, -1, -1, i};
    }
    for(int i = real_n * 2 - 1; i > 1; i -= 2){
        if(max_x_tree[i][0] > max_x_tree[i - 1][0]){
            max_x_tree[i / 2] = {max_x_tree[i][0],
                                max_x_tree[i - 1][1], max_x_tree[i][2], i - 1, i, max_x_tree[i][5]};
        }else{
            max_x_tree[i / 2] = {max_x_tree[i - 1][0],
                                max_x_tree[i - 1][1], max_x_tree[i][2], i - 1, i, max_x_tree[i - 1][5]};
        }
    }
    vector < vector < int > > max_y_tree(real_n * 2, vector < int > (6, 0));
    for(int i = real_n; i < real_n * 2; i++){
        if(i - real_n < n){
            buf = points[i - real_n].Y;
        }else{
            buf = 0;
        }
        max_y_tree[i] = {buf, i, i, -1, -1, i};
    }
    for(int i = real_n * 2 - 1; i > 1; i -= 2){
        if(max_y_tree[i][0] > max_y_tree[i - 1][0]){
            max_y_tree[i / 2] = {max_y_tree[i][0],
                                max_y_tree[i - 1][1], max_y_tree[i][2], i - 1, i, max_y_tree[i][5]};
        }else{
            max_y_tree[i / 2] = {max_y_tree[i - 1][0],
                                max_y_tree[i - 1][1], max_y_tree[i][2], i - 1, i, max_y_tree[i - 1][5]};
        }
    }
    vector < vector < int > > min_x_tree(real_n * 2, vector < int > (6, 0));
    for(int i = real_n; i < real_n * 2; i++){
        if(i - real_n < n){
            buf = points[i - real_n].X;
        }else{
            buf = inf;
        }
        min_x_tree[i] = {buf, i, i, -1, -1, i};
    }
    for(int i = real_n * 2 - 1; i > 1; i -= 2){
        if(min_x_tree[i][0] < min_x_tree[i - 1][0]){
            min_x_tree[i / 2] = {min_x_tree[i][0],
                                min_x_tree[i - 1][1], min_x_tree[i][2], i - 1, i, min_x_tree[i][5]};
        }else{
            min_x_tree[i / 2] = {min_x_tree[i - 1][0],
                                min_x_tree[i - 1][1], min_x_tree[i][2], i - 1, i, min_x_tree[i - 1][5]};
        }
    }
    vector < vector < int > > min_y_tree(real_n * 2, vector < int > (6, 0));
    for(int i = real_n; i < real_n * 2; i++){
        if(i - real_n < n){
            buf = points[i - real_n].Y;
        }else{
            buf = inf;
        }
        min_y_tree[i] = {buf, i, i, -1, -1, i};
    }
    for(int i = real_n * 2 - 1; i > 1; i -= 2){
        if(min_y_tree[i][0] < min_y_tree[i - 1][0]){
            min_y_tree[i / 2] = {min_y_tree[i][0],
                                min_y_tree[i - 1][1], min_y_tree[i][2], i - 1, i, min_y_tree[i][5]};
        }else{
            min_y_tree[i / 2] = {min_y_tree[i - 1][0],
                                min_y_tree[i - 1][1], min_y_tree[i][2], i - 1, i, min_y_tree[i - 1][5]};
        }
    }
    int curr, smax_y_size = n, smax_x_size = n, smin_y_size = n, smin_x_size = n;
    int smax_y_cnt = 0, smax_x_cnt = 0, smin_y_cnt = 0, smin_x_cnt = 0;
    vector < vector < int > > smax_x_tree = max_x_tree;
    curr = smax_x_tree[1][0];
    while(smax_x_tree[1][0] == curr){
        smax_x_tree[smax_x_tree[1][5]][0] = 0;
        update_max_tree(smax_x_tree[1][5] / 2, smax_x_tree);
        smax_x_size--;
        smax_x_cnt++;
    }
    vector < vector < int > > smax_y_tree = max_y_tree;
    curr = smax_y_tree[1][0];
    while(smax_y_tree[1][0] == curr){
        smax_y_tree[smax_y_tree[1][5]][0] = 0;
        update_max_tree(smax_y_tree[1][5] / 2, smax_y_tree);
        smax_y_size--;
        smax_y_cnt++;
    }
    vector < vector < int > > smin_x_tree = min_x_tree;
    curr = smin_x_tree[1][0];
    while(smin_x_tree[1][0] == curr){
        smin_x_tree[smin_x_tree[1][5]][0] = inf;
        update_min_tree(smin_x_tree[1][5] / 2, smin_x_tree);
        smin_x_size--;
        smin_x_cnt++;
    }
    vector < vector < int > > smin_y_tree = min_y_tree;
    curr = smin_y_tree[1][0];
    while(smin_y_tree[1][0] == curr){
        smin_y_tree[smin_y_tree[1][5]][0] = inf;
        update_min_tree(smin_y_tree[1][5] / 2, smin_y_tree);
        smin_y_size--;
        smin_y_cnt++;
    }
//==============================================================================
//                                 init  end
//==============================================================================


    int updated, id = 0;
    long double cnt = n;
    while((max_x_tree[1][0] - min_x_tree[1][0] > w or max_y_tree[1][0] - min_y_tree[1][0] > h) and (smax_x_cnt > 0 or smax_y_cnt > 0) and cnt > 1){
        if(max_x_tree[1][0] - min_x_tree[1][0] > w and smax_x_cnt > 0){
            if(double(max_x_tree[1][0] - smax_x_tree[1][0]) / smax_x_cnt >
               double(smin_x_tree[1][0] - min_x_tree[1][0]) / smin_x_cnt){
                curr = max_x_tree[1][0];
                while(max_x_tree[1][0] == curr){
                    max_x_tree[max_x_tree[1][5]][0] = 0;
                    max_y_tree[max_x_tree[1][5]][0] = 0;
                    min_x_tree[max_x_tree[1][5]][0] = inf;
                    min_y_tree[max_x_tree[1][5]][0] = inf;
                    updated = max_x_tree[1][5];
                    update_max_tree(updated / 2, max_x_tree);
                    update_max_tree(updated / 2, max_y_tree);
                    update_min_tree(updated / 2, min_x_tree);
                    update_min_tree(updated / 2, min_y_tree);
                    cnt--;
                }
                curr = smax_x_tree[1][0];
                while(smax_x_tree[1][0] == curr){
                    smax_x_tree[smax_x_tree[1][5]][0] = 0;
                    update_max_tree(smax_x_tree[1][5] / 2, smax_x_tree);
                    smax_x_size--;
                    smax_x_cnt++;
                }
            }else{
                curr = min_x_tree[1][0];
                while(min_x_tree[1][0] == curr){
                    max_x_tree[min_x_tree[1][5]][0] = 0;
                    max_y_tree[min_x_tree[1][5]][0] = 0;
                    min_x_tree[min_x_tree[1][5]][0] = inf;
                    min_y_tree[min_x_tree[1][5]][0] = inf;
                    updated = min_x_tree[1][5];
                    update_max_tree(updated / 2, max_x_tree);
                    update_max_tree(updated / 2, max_y_tree);
                    update_min_tree(updated / 2, min_x_tree);
                    update_min_tree(updated / 2, min_y_tree);
                    cnt--;
                }
                curr = smin_x_tree[1][0];
                while(smin_x_tree[1][0] == curr){
                    smin_x_tree[smin_x_tree[1][5]][0] = 0;
                    update_min_tree(smin_x_tree[1][5] / 2, smin_x_tree);
                    smin_x_size--;
                    smin_x_cnt++;
                }
            }
        }
        if(max_y_tree[1][0] - min_y_tree[1][0] > h and smax_y_cnt > 0){
            if(double(max_y_tree[1][0] - smax_y_tree[1][0]) / smax_y_cnt >
               double(smin_y_tree[1][0] - min_y_tree[1][0]) / smin_y_cnt){
                curr = max_y_tree[1][0];
                while(max_y_tree[1][0] == curr){
                    max_x_tree[max_y_tree[1][5]][0] = 0;
                    max_y_tree[max_y_tree[1][5]][0] = 0;
                    min_x_tree[max_y_tree[1][5]][0] = inf;
                    min_y_tree[max_y_tree[1][5]][0] = inf;
                    updated = max_y_tree[1][5];
                    update_max_tree(updated / 2, max_x_tree);
                    update_max_tree(updated / 2, max_y_tree);
                    update_min_tree(updated / 2, min_x_tree);
                    update_min_tree(updated / 2, min_y_tree);
                    cnt--;
                }
                curr = smax_y_tree[1][0];
                while(smax_y_tree[1][0] == curr){
                    smax_y_tree[smax_y_tree[1][5]][0] = 0;
                    update_max_tree(smax_y_tree[1][5] / 2, smax_y_tree);
                    smax_y_size--;
                    smax_y_cnt++;
                }
            }else{
                curr = min_y_tree[1][0];
                while(min_y_tree[1][0] == curr){
                    max_x_tree[min_y_tree[1][5]][0] = 0;
                    max_y_tree[min_y_tree[1][5]][0] = 0;
                    min_x_tree[min_y_tree[1][5]][0] = inf;
                    min_y_tree[min_y_tree[1][5]][0] = inf;
                    updated = min_y_tree[1][5];
                    update_max_tree(updated / 2, max_x_tree);
                    update_max_tree(updated / 2, max_y_tree);
                    update_min_tree(updated / 2, min_x_tree);
                    update_min_tree(updated / 2, min_y_tree);
                    cnt--;
                }
                curr = smin_y_tree[1][0];
                while(smin_y_tree[1][0] == curr){
                    smin_y_tree[smin_y_tree[1][5]][0] = 0;
                    update_min_tree(smin_y_tree[1][5] / 2, smin_y_tree);
                    smin_y_size--;
                    smin_y_cnt++;
                }
            }

        }
    }
    cout << cnt;

return 0;
}


void update_max_tree(int pos, vector < vector < int > > &tree){
    if (tree[tree[pos][3]][0] > tree[tree[pos][4]][0]){
        tree[pos][0] = tree[tree[pos][3]][0];
        tree[pos][5] = tree[tree[pos][3]][5];
    }else{
        tree[pos][0] = tree[tree[pos][4]][0];
        tree[pos][5] = tree[tree[pos][4]][5];
    }
    if(pos != 1){
        update_max_tree(pos / 2, tree);
    }
}


void update_min_tree(int pos, vector < vector < int > > &tree){
    if (tree[tree[pos][3]][0] < tree[tree[pos][4]][0]){
        tree[pos][0] = tree[tree[pos][3]][0];
        tree[pos][5] = tree[tree[pos][3]][5];
    }else{
        tree[pos][0] = tree[tree[pos][4]][0];
        tree[pos][5] = tree[tree[pos][4]][5];
    }
    if(pos != 1){
        update_min_tree(pos / 2, tree);
    }
}


int power(int a, int b){
    int ans = 1;
    for(int i = 0; i < b; i++){
        ans *= a;
    }
    return ans;
}
