#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <set>
#include <map>
#include <math.h>
#include <queue>

using namespace std;

typedef long long ll;
const int INF = INT_MAX;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif

    int n;
    cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }

    vector<int> k(n);
    for (int i = 1; i <= n; i++)
    {
        for (int j = (i - 1); j < n; j += i)
        {
            k[i - 1] += a[j];
        }
    }

    int ans = 0;

    int m;
    cin >> m;
    while (m--)
    {
        int p, s;
        cin >> p >> s;

        int maxim = -1;

        for (int i = 0; i < n; i++)
        {
            if ((i + 1) % p == 0)
            {
                k[i] += s;
            }
            maxim = max(maxim, k[i]);
            if ((i + 1) % p == 0)
            {
                k[i] -= s;
            }
        }
        ans += maxim;
    }

    cout << ans << '\n';
}