#include <bits/stdc++.h>

//#include <ext/pb_ds/detail/standard_policies.hpp>

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

#define whole(hyperX) (hyperX).begin (), (hyperX).end ()

#define sqr(hyperX) (hyperX) * (hyperX)
#define pw(hyperX) (1LL << (hyperX))

using namespace std;

//using namespace __gnu_pbds;

const int MaXn = 1 * 1e5 + 115;

//template <typename key> using Ordered_Set = tree <key, null_type, less <key> rb_tree_tag, tree_order_statistics_node_update>;

long long answer[MaXn], t[10 * MaXn];

void build (int Vertex, int tLeft, int tRight) {

    if (!(tLeft - tRight))
        t[Vertex] = answer[tLeft] + 0;

    else {

        int tC = (tLeft + tRight) / 2;

        build (Vertex * 2, tLeft, tC);
        build (Vertex * 2 + 1, tC + 1, tRight);

        t[Vertex] = max (t[Vertex * 2], t[Vertex * 2 + 1]);
    }
}

void update (int Vertex, int tLeft, int tRight, int p, long long Value) {

    if (!(tLeft - p) && !(tRight - p))
        t[Vertex] = Value + 0;

    else {

        int tC = (tLeft + tRight) / 2;

        if (p > tC)
            update (Vertex * 2 + 1, tC + 1, tRight, p, Value);

        else
            update (Vertex * 2, tLeft, tC, p, Value);

        t[Vertex] = max (t[Vertex * 2], t[Vertex * 2 + 1]);
    }
}

long long get (int Vertex, int tLeft, int tRight, int p) {

    if (!(tLeft - p) && !(tRight - p))
        return t[Vertex];

    else {

        int tC = (tLeft + tRight) / 2;

        if (p > tC)
            get (Vertex * 2 + 1, tC + 1, tRight, p);

        else
            get (Vertex * 2, tLeft, tC, p);
    }
}

int main () {

    ios_base :: sync_with_stdio (0);
    cin.tie (0); cout.tie (0);

#ifdef Local

    freopen ("MaxS.in", "r", stdin);
    freopen ("MaxS.out", "w", stdout);

#endif // Local

    int n;
    cin >> n;

    vector <long long> have(n + 1);

    for (int now = 1; now < n + 1; now++)
        cin >> have[now];

    for (int now = 1; now < n + 1; now++)
        for (int then = now + 0; then < n + 1; then = then + now)
            answer[now] = answer[now] + have[then];

    build (1, 1, n);

    int Q;
    cin >> Q;

    long long w = 0;
    while (Q--) {

        int p;
        cin >> p;

        long long delta;
        cin >> delta;

        for (int d = 1; d * d < p + 1; d++) {

            long long x = get (1, 1, n, d);
            update (1, 1, n, d, x + delta);

            int S = p / d;
            if (!(S - d))
                continue;

            long long y = get (1, 1, n, S);
            update (1, 1, n, S, y + delta);
        }

        w = w + t[1];

         for (int d = 1; d * d < p + 1; d++) {

            long long x = get (1, 1, n, d);
            update (1, 1, n, d, x - delta);

            int S = p / d;
            if (!(S - d))
                continue;

            long long y = get (1, 1, n, S);
            update (1, 1, n, S, y - delta);
        }

        return 0;
    }

    cout << w << "\n";
    return 0;
}
