#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct P {
    ll x, y;

    P(ll x, ll y) : x(x), y(y) {}

    P() : P(0, 0) {}
};

ll p_add(vector<ll> &w, vector<ll> &w1, ll i) {
    ll r = !w[i] && w1[i];
    w[i] = 1;
    return r;
}

ll p_del(vector<ll> &w, vector<ll> &w1, ll i) {
    ll r = w[i] && w1[i];
    w[i] = 0;
    return r;
}

int main() {
    ll n, w, h;
    cin >> n >> w >> h;
    vector<P> p(n, P());
    for (auto&[x, y] : p) cin >> x >> y;
    vector<ll> sx(n, 0), sy(n, 0);
    for (ll i = 0; i < n; i++) sx[i] = sy[i] = i;
    sort(sx.begin(), sx.end(), [&p](ll a, ll b) -> bool { return p[a].x < p[b].x; });
    sort(sy.begin(), sy.end(), [&p](ll a, ll b) -> bool { return p[a].y < p[b].y; });
    ll l = 0, r = 0, t = 0, b = 0;
    ll ans = 0, cnt = 0;
    vector<ll> wx(n, 0), wy(n, 0);
    while (b < n) {
        while (t < n && p[sy[t]].y - p[sy[b]].y <= h) cnt += p_add(wy, wx, sy[t++]);
        while (l < n) {
            while (r < n && p[sx[r]].x - p[sx[l]].x <= w) cnt += p_add(wx, wy, sx[r++]);
            ans = max(ans, cnt);
            cnt -= p_del(wx, wy, sx[l++]);
        }
        cnt -= p_del(wy, wx, sy[b++]);
    }
    cout << ans;
}
