#include "biggest.h"
#include <bits/stdc++.h>
using namespace std;

map < pair < int, int >, int > mp;

vector < int > biggest(int N, int K)
{
    vector < int > v;
    v.push_back(1);
    for(int i = 2; i <= N; i ++)
    {
        int l = 0, r = v.size() - 1;

        int res = mp[make_pair(v[r], i)];
        if (res == 0)
        {
            res = compare(v[r], i);
            if (res == v[r])
                res = 1;
            else
                res = -1;
            mp[make_pair(v[r], i)] = res;
            mp[make_pair(i, v[r])] = -res;
        }
        if (res == 1)
        {
            if (v.size() < K)
                v.push_back(i);
            continue;
        }

        r --;

        while(l <= r)
        {
            int m = (l + r) / 2;
            if (m == v.size() - 1)
            {
                r = m - 1;
                continue;
            }

            int res = mp[make_pair(v[m], i)];
            if (res == 0)
            {
                res = compare(v[m], i);
                if (res == v[m])
                    res = 1;
                else
                    res = -1;
                mp[make_pair(v[m], i)] = res;
                mp[make_pair(i, v[m])] = -res;
            }

            if (res == 1)
                l = m + 1;
            else
                r = m - 1;
        }

        v.insert(v.begin() + l, i);
        if (v.size() > K)
            v.pop_back();
        //cout << v[1] << endl;
    }

    return v;
}
