#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;
const ll MAXN = 5e4 + 10, MAXM = 5e5 + 10;

void fast_io()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

ll n, a[MAXN], b[MAXN], t[4 * MAXN], all[MAXM];

struct query
{
    ll p, s;
} q[MAXN];

vector < pair < ll, ll > > v[MAXN];

void build_tree(ll root, ll left, ll right)
{
    if (left == right)
    {
        t[root] = b[left];
        return;
    }

    ll mid = (left + right) / 2;
    build_tree(root * 2, left, mid);
    build_tree(root * 2 + 1, mid + 1, right);

    t[root] = max(t[root * 2], t[root * 2 + 1]);
}

void update(ll root, ll left, ll right, ll idx, ll s)
{
    if (left == right)
    {
        t[root] += s;
        return;
    }

    ll mid = (left + right) / 2;
    if (idx <= mid)
        update(root * 2, left, mid, idx, s);
    if (idx > mid)
        update(root * 2 + 1, mid + 1, right, idx, s);

    t[root] = max(t[root * 2], t[root * 2 + 1]);
}
void solve()
{
    cin >> n;
    for (ll i = 1; i <= n; i ++)
    {
        cin >> a[i];
        ll bor = sqrt(i);
        for (ll j = 1; j <= bor; j ++)
        {
            if (i % j == 0)
            {
                b[j] += a[i];
                if (j * j != i)
                    b[i / j] += a[i];
            }
        }
    }

    ll m;
    cin >> m;

    /**if (m <= 5e3)
    {
        ll maxx = 0;
        for (ll i = 1; i <= n; i ++)
            if (b[i] > maxx)
                maxx = b[i];

        build_tree(1, 1, n);

        ll ans = 0;
        for (ll i = 1; i <= m; i ++)
        {
            ll p, s;
            cin >> p >> s;
            ll bor = sqrt(p), idk = maxx;
            for (ll j = 1; j <= bor; j ++)
            {
                if (p % j == 0)
                {
                    update(1, 1, n, j, s);
                    if (j * j != p)
                        update(1, 1, n, p / j, s);
                }
            }


            ans += t[1];

            for (ll j = 1; j <= bor; j ++)
            {
                if (p % j == 0)
                {
                    update(1, 1, n, j, -s);
                    if (j * j != p)
                        update(1, 1, n, p / j, -s);
                }
            }
        }

        cout << ans << endl;
    }
    else*/
    {
        ll maxx = 0;
        for (ll i = 1; i <= n; i ++)
            if (b[i] > maxx)
                maxx = b[i];

        for (ll i = 1; i <= m; i ++)
            cin >> q[i].p >> q[i].s, v[q[i].p].push_back(make_pair(q[i].s, i));

        for (ll i = 1; i <= n; i ++)
        {
            if (v[i].size() == 0)
                continue;
            ll idk = maxx, bor = sqrt(i), sz = v[i].size();
            for (ll j = 1; j <= bor; j ++)
            {
                if (i % j == 0)
                {
                    for (ll f = 0; f < sz; f ++)
                    {
                        if (b[j] + v[i][f].first > all[v[i][f].second])
                            all[v[i][f].second] = b[j] + v[i][f].first;
                        if (b[i / j] + v[i][f].first > all[v[i][f].second])
                            all[v[i][f].second] = b[i / j] + v[i][f].first;
                    }
                }
            }
        }

        ll ans = 0;
        for (ll i = 1; i <= m; i ++)
            ans = ans + max(all[i], maxx);

        cout << ans << endl;
    }
}

int main()
{
    fast_io();
    solve();
    return 0;
}
/**
5
-7 1 -3 9 0
2
1 2
1 8
*/
