#include<iostream>
#include<vector>
#include<set>

#include "biggest.h"

using namespace std;

vector<int> biggest(int n, int k){
    set<pair<int, int>> already_find;
    vector<vector<int>> intervals;

    vector<int> initial_interval;
    for(int i=1;i<=n;++i){
        initial_interval.push_back(i);
    }
    intervals.push_back(initial_interval);

    vector<int> res;
    for(int target=n;target>=n-k+1;--target){
        vector<vector<int>> new_intervals;
        int target_pos=1,interval_ind=0;

        for(auto it=already_find.begin();it!=already_find.end();++it){
            if(compare(target, (*it).second)==target){
                target_pos=(*it).first+1;
                break;
            }

            new_intervals.push_back(intervals[interval_ind++]);
        }

        vector<int> left_half,right_half;
        for(int curr : intervals[interval_ind]){
            if(curr==target){
                continue;
            }
            if(compare(target, curr)==target){
                ++target_pos;
                left_half.push_back(curr);
            }else{
                right_half.push_back(curr);
            }
        }

        cout<<target_pos<<endl;
        already_find.insert({target_pos, target});
        res.push_back(target_pos);

        new_intervals.push_back(left_half);
        new_intervals.push_back(right_half);
        for(int i=interval_ind+1;i<(int)intervals.size();++i){
            new_intervals.push_back(intervals[i]);
        }

        intervals=new_intervals;
    }

    return res;
}
