#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <limits.h>
using namespace std;
typedef long long ll;
const ll maxn = 5e4+10, maxm = 5e5+10;
vector < ll > d[maxn];
set < pair < ll, ll > > s;
map < ll, ll > mapp;
ll a[maxn];
ll sums[maxn];
pair < ll, ll > sorted_sums[maxn];
ll resums[maxn];
void find_div(ll x) {
    ll sq = sqrt(x);
    if (sq*sq < x) ++sq;
    for (ll i = 1 ; i <= sq && i <= x/i ; ++i) {
        if (x % i == 0) {
            ////cerr << x << ": " << a[x] << ' ' << i << ' ' << x/i << ' ' << sq << '\n';
            d[x].push_back(i);
            sums[i] += a[x];
            if (i != x/i) {
                d[x].push_back(x/i);
                sums[x/i] += a[x];
            }
            ////cerr << "sums[" << i << "]: " << sums[i] << '\n';
            ////cerr << "sums[" << x/i << "]: " << sums[x/i] << '\n';
        }
    }
}
ll mem[maxn];
bool bl[maxn];
ll n, m, p,change, ans, len = 1, begmax, currmax;
/*void prll() {
    cout << "sums:\n";
    for (ll i = 1 ; i <= n ; ++i)m
        cout << i << " -> " << sums[i] << '\n';
    cout << '\n';
}*/
int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    for (ll i = 1 ; i <= n ; ++i)
        cin >> a[i];
    for (ll i = 1 ; i <= n ; ++i)
        find_div(i);
    for (ll i = 1 ; i <= n ; ++i)
        sorted_sums[i] = {sums[i], i};
    sort(sorted_sums+1, sorted_sums+n+1, greater < pair < ll, ll > > ());
    mapp[sorted_sums[1].second] = sorted_sums[1].first;
    for (ll i = 2 ; i <= n ; ++i) {
        ll a = sorted_sums[i].second, b = sorted_sums[1].second, nok = a*b/__gcd(a, b);
        //cerr << "sorted_sums[" << i << "]: " << sorted_sums[i].first << ' ' << sorted_sums[i].second << ' ' << nok << '\n';
        if (nok > (n/b)*b) nok = (n/b)*b+1;
        mapp[nok] = max(mapp[nok], sorted_sums[i].first);
    }
    for (auto i : mapp)
        s.insert({-i.second, i.first});
    /*for (auto i : s) {
        //cerr << "nok, sum: " << i.first << " -> " << i.second << '\n';
    }*/
    while (len < n) len *= 2;
    begmax = sorted_sums[1].first;
    cin >> m;
    for (ll i = 1 ; i <= m ; ++i) {
        cin >> p >> change;
        if (change < 0) {
            if (bl[p]) {
                ans += max(mem[p], -s.begin()->first+change);
                continue;
            }
            bl[p] = 1;
            ll currans = -s.begin()->first+change;
            for (auto j : s) {
                if (p % j.second > 0) {
                    currans = mem[p] = max(currans, -j.first);
                    break;
                }
                //cerr << "currans: " << currans << ' ' << -j.first << ' ' << j.second << '\n';
            }
            //cerr << i << ": " << currans << '\n';
            ans += currans;
        } else {
            currmax = begmax;
            for (ll x : d[p]) {
                currmax = max(currmax, sums[x] + change);
            }
            ans += currmax;
        }
    }
    cout << ans << '\n';
    return 0;
}

