#include <iostream>
#include <algorithm>
#include <limits.h>
using namespace std;
typedef long long ll;
const ll maxn = 1e5+10;
pair < ll, ll > p[maxn];
ll n, w, h, ans;
ll binary(ll x) {
    ll l = 0, r = n+1, m;
    while (l < r - 1) {
        m = (l+r)/2;
        if (p[m].first < x) l = m;
        else r = m;
    }
    return r;
}
ll square(ll x, ll y, ll x1, ll y1) {
    //cerr << ""
    ll ret = 0, beg = binary(x);
    for (ll i = beg ; i <= n ; ++i) {
        if (p[i].first > x1) break;
        ret += (p[i].second >= y && p[i].second <= y1);
    }
    //cerr << "square: " << x << "(" << binary(x) << ") " << y << ' ' << x1 << ' ' << y1 << ": " << ret << '\n';
    return ret;
}
int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> w >> h;
    for (ll i = 1 ; i <= n ; ++i) {
        cin >> p[i].first >> p[i].second;
    }
    sort(p+1, p+n+1);
    //for (ll i = 1 ; i <= n ; ++i)
        //cout << "p[" << i << "]: " << p[i].first << ' ' << p[i].second << '\n';
    p[n+1] = {INT_MAX/2, INT_MAX/2};
    for (ll i = 1 ; i <= n ; ++i) {
        ll x = p[i].first, y = p[i].second;
        //cerr << "x, y: " << x << ' ' << y << ' ' << binary(x) << '\n';
        ans = max(ans, square(x-w, y-h, x, y));
        ans = max(ans, square(x, y-h, x+w, y));
        ans = max(ans, square(x-w, y, x, y+h));
        ans = max(ans, square(x, y, x+w, y+h));
        // rev
        ans = max(ans, square(x-h, y-w, x, y));
        ans = max(ans, square(x, y-w, x+h, y));
        ans = max(ans, square(x-h, y, x, y+w));
        ans = max(ans, square(x, y, x+h, y+w));

    }
    cout << ans << '\n';
    return 0;
}
/*


*/
