#include <iostream>
#include <algorithm>
#include <unordered_map>
using namespace std;
#define endl '\n'
struct Point{
    int x, y;
};
const int MAXN=1e5+10;
const int MAXX=1e8+10;
Point p[MAXN];
int t[101][101], x[MAXN], y[MAXN];
int maxx, minx, maxy, miny;
bool cmp(Point a, Point b) {
    return a.y<b.y;
}
int rect(int x, int y, int w, int h) {
    if (x+w>100 || y+h>100) return 0;
    int s=0;
    for (int i=x;i<=w+x;i++) {
        for (int j=y;j<=h+y;j++) s+=t[i][j];
    }
    return s;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, w, h;
    bool ok=true;
    cin >> n >> w >> h;
    if (w>100 || h>100) ok=false;
    for (int i=0;i<n;i++) {
        cin >> p[i].x >> p[i].y;
        x[i]=p[i].x;
        y[i]=p[i].y;
        if (x[i]>100 || y[i]>100) ok=false;
    }
    sort(x,x+n);
    sort(y,y+n);
    if (ok) {
        minx=miny=n+2;
        for (int i=0;i<n;i++) {
            maxx=max(maxx,p[i].x);
            if (p[i].x>w) minx=min(minx,p[i].x-w);
            maxy=max(maxy,p[i].y);
            if (p[i].y>h) miny=min(miny,p[i].y-h);
            t[p[i].x][p[i].y]++;
        }
        int ans=0;
        for (int i=minx;i<=maxx;i++) {
            for (int j=miny;j<=maxy;j++) {
                ans=max(ans,rect(i,j,w,h));
            }
        }
        cout << ans << endl;
    }
    /**
    int brx, bry;
    brx=bry=1;
    for (int i=0;i<n;i++) {
        if (i>0) {
            if (x[i]!=x[i-1]) brx++;
            if (y[i]!=y[i-1]) bry++;
        }
        mx[x[i]]=brx;
        my[y[i]]=bry;
    }
    sort(p,p+n,cmp);

    int cur;
    for (int i=0;i<n;i++) {
        cur=ma[x[i]];

    }
    **/
    return 0;
}
