#include<iostream>
#include<stack>
#include<cmath>
#include<algorithm>
#define INF 100000000000000000
#define N 500000
//#define endl '\n'
using namespace std;
typedef long long ll;
ll i,j,p,q,n,m,k,a[N+6],b[N+6],del[N+6],fen[N+6],ans;
struct  durvo
{
    ll l,r,st;
}d[N*10];
stack <durvo> st;
void build(ll v,ll l,ll r)
{
    d[v].l=l;d[v].r=r;
    if(l==r)
    {
        d[v].st=b[l];
        return ;
    }
    build(v*2,l,(l+r)/2);
    build(v*2+1,(l+r)/2+1,r);
    d[v].st=max(d[v*2].st,d[v*2+1].st);
}
void update(ll v,ll pz,ll st)
{
    if(d[v].l==pz && d[v].r==pz)
    {
        d[v].st=st;
        return ;
    }
    if(pz<=d[v*2].r)update(v*2,pz,st);
    else update(v*2+1,pz,st);
    d[v].st=max(d[v*2].st,d[v*2+1].st);
}
void eratosten()
{
    for(i=2;i<=n/2;i++)
    {
        for(j=i;j<i*i;j+=i)
        {
            b[i]+=a[j];
        }
        for(j=i*i;j<=n;j+=i)
        {
            b[i]+=a[j];
            if(del[i]==0)
            {
                del[j]=i;
            }
        }
        if(del[i]==0)del[i]=i;
    }
}

void Find(ll n)
{
    ll pr=n;
    //cout<<pr<<" "<<q+b[pr]<<endl;
    update(1,pr,q+b[pr]);
    st.push({1,pr,b[pr]});
    for(j=1;j<=sqrt(n);j++)
    {
        if(n%j==0)
        {
            update(1,j,b[j]+q);
            st.push({1,j,b[j]});
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    for(i=1;i<=n;i++)
    {
        cin>>a[i];
        b[1]+=a[i];
        if(i>n/2)b[i]=a[i],del[i]=i;
    }
    eratosten();
    build(1,1,n);
    //cout<<d[1].st<<endl;
    cin>>m;
    for(i=1;i<=m;i++)
    {
        cin>>p>>q;
        Find(p);
        ///cout<<d[1].st<<endl;
        ans+=d[1].st;
        while(!st.empty())
        {
            durvo t=st.top();st.pop();
            update(t.l,t.r,t.st);
        }
    }
    cout<<ans<<endl;
    return 0;
}
/**
6
2 -5 3 2 -1 4
2
3 -4
3 5
*/
