#include <iostream>
#include <set>
#include <unordered_map>
#include <algorithm>
#include <vector>
using namespace std;
#define endl '\n'
#define int long long
#define MAXN 50005
const int one = 1;
const int INF = (one << 62);
int br;
int arr[MAXN], rabbit[MAXN];
int maxi[MAXN];
int q;
unordered_map<int, int> u;
set<int> s;
vector<int> v;
int cmp(int a, int b)
{
    return rabbit[a] > rabbit[b];
}
signed main()
{
    cin.tie(0); ios::sync_with_stdio(false);
    for(int i = 0; i < MAXN; ++i){
        maxi[i] = -INF;
    }
    cin >> br;
    for(int i = 1; i <= br; ++i){
        cin >> arr[i];
    }
    int global = 0;
    for(int i = 1; i <= br; ++i){
        int sum = 0;
        for(int z = i; z <= br; z += i){
            sum += arr[z];
        }
        rabbit[i] = sum;
        global = max(global, rabbit[i]);
        v.push_back(i);
    }
    sort(v.begin(), v.end(), cmp);
    for(int i = 1; i <= br; ++i){
        for(int z = i; z <= br; z += i){
            maxi[z] = max(maxi[z], rabbit[i]);
        }
    }
    int res = 0;
    cin >> q;
    for(int i = 0; i < q; ++i){
        int pos, val; cin >> pos >> val;
        if(val >= 0){
            res += max(maxi[pos] + val, global);
        }
        else{
            if(maxi[pos] != global){
                res += global; continue;
            }
            int maximum = 0;
            for(int i : v){
                if(pos % i != 0){
                    maximum = rabbit[i]; break;
                }
            }
            res += max(maximum, maxi[pos] + val);
        }
    }
    cout << res << endl;
    return 0;
}
