#include "biggest.h"
#include <iostream>
#include <vector>
using namespace std;

int compare(int x, int y);

vector<int> biggest(int N, int K)
{
    vector<int> v;
    v.push_back(1);
    int sz = 1;
    for (int i = 2; i <= N; ++ i)
    {
        if (sz >= K)
        {
            if (compare(v[sz - K], i) != i) continue;
        }
        if (compare(v[sz - 1], i) == i)
        {
            v.insert(v.begin() + sz, i);
            sz++;
            continue;
        }
        int l = max(sz - K, -1), r = sz, mid;
        while (r - l > 1)
        {
            mid = (l + r) / 2;
            if (compare(i, v[mid]) == i) l = mid;
            else r = mid;
        }
        v.insert(v.begin() + (l + 1), i);
        sz++;
    }

    vector<int> v0;
    for (int i = sz - 1; i >= sz - K; -- i)
    {
        v0.push_back(v[i]);
    }

    return v0;
}
