#include "biggest.h"
#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 100000;

int c[MAXN + 5], cnt[MAXN + 5];

int compare(int x, int y);

vector<int> biggest(int N, int K)
{
    c[1] = 1;
    c[N + 1] = 1;
    for (int i = 2; i <= N; ++ i)
    {
        if (compare(i - 1, i) == i) c[i] = 1;
        else c[i] = 0;
    }

    for (int i = 1; i <= N; ++ i)
    {
        if (c[i] == 1 and c[i + 1] == 0)
        {
            int j = i;
            int cnt0 = 0;
            while (c[j] == 1)
            {
                j--;
                cnt0++;
                cnt[j] += cnt0;
            }

            j = i;
            cnt0 = 0;
            while (c[j] == 0)
            {
                j++;
                cnt0++;
                cnt[j] += cnt0;
            }
        }
    }

    vector<int> v;
    int sz = 0;
    for (int i = 1; i <= N; ++ i)
    {
        if (cnt[i] >= K) continue;
        if (sz >= K)
        {
            if (compare(v[sz - K], i) != i) continue;
        }
        int l = max(sz - K, -1), r = sz, mid;
        while (r - l > 1)
        {
            mid = (l + r) / 2;
            if (compare(i, v[mid]) == i) l = mid;
            else r = mid;
        }
        v.insert(v.begin() + (l + 1), i);
        sz++;
    }

    vector<int> v0;
    for (int i = sz - 1; i >= sz - K; -- i)
    {
        v0.push_back(v[i]);
    }

    return v0;
}
