#include <algorithm>
#include "biggest.h"
#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 100000;

int l[MAXN + 5], r[MAXN + 5], cnt[MAXN + 5];

int compare(int x, int y);

void rec(int u, int x)
{
    cnt[u]++;
    if (compare(u, x) == u)
    {
        if (l[u] == -1)
        {
            l[u] = x;
            l[x] = r[x] = -1;
            cnt[x] = 1;
        }
        else rec(l[u], x);
    }
    else
    {
        if (r[u] == -1)
        {
            r[u] = x;
            l[x] = r[x] = -1;
            cnt[x] = 1;
        }
        else rec(r[u], x);
    }
}

int find_num(int u, int k)
{
    if (k <= (l[u] != -1 ? cnt[l[u]] : 0)) return find_num(l[u], k);
    if (k == (l[u] != -1 ? cnt[l[u]] : 0) + 1) return u;
    return find_num(r[u], k - ((l[u] != -1 ? cnt[l[u]] : 0) + 1));
}

vector<int> biggest(int N, int K)
{
    l[1] = r[1] = -1;
    cnt[1] = 1;
    for (int i = 2; i <= N; ++ i)
    {
        if (cnt[1] > K and compare(i, find_num(1, cnt[1] - K + 1)) != i) continue;
        rec(1, i);
    }

    vector<int> v0;
    for (int i = cnt[1]; i > cnt[1] - K; -- i)
    {
        v0.push_back(find_num(1, i));
    }

    return v0;
}
