#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 50000;

int a[MAXN + 5];
int divs[MAXN + 5];
long long sum[MAXN + 5];
long long mx1[MAXN + 5], mx2[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        mx1[i] = mx2[i] = (long long)(-1e18);
    }

    vector< pair<long long, int> > v;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = i; j <= n; j += i)
        {
            sum[i] += a[j];
        }
        v.push_back(make_pair(sum[i], i));
    }

    sort(v.begin(), v.end());
    reverse(v.begin(), v.end());

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j * j <= i; ++ j)
        {
            if (i % j == 0)
            {
                mx1[i] = max(mx1[i], sum[j]);
                divs[j] = i;
                mx1[i] = max(mx1[i], sum[i / j]);
                divs[i / j] = i;
            }
        }

        for (int j = 0; j < v.size(); ++ j)
        {
            if (divs[v[j].second] != i)
            {
                mx2[i] = v[j].first;
                break;
            }
        }
    }

    int m;
    cin >> m;

    long long ans = 0;
    for (int i = 1; i <= m; ++ i)
    {
        int p;
        long long s;
        cin >> p >> s;
        ans += max(mx1[p] + s, mx2[p]);
    }

    cout << ans << endl;

    return 0;
}
