#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <set>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

int x[MAXN + 5], y[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, w, h;
    cin >> n >> w >> h;

    set<int> sx, sy;
    vector< pair<int, int> > v;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> x[i] >> y[i];
        sx.insert(x[i]);
        sy.insert(y[i]);
        v.push_back(make_pair(x[i], y[i]));
    }

    if (n <= 1000)
    {
        int ans = 0;
        for (auto it1 = sx.begin(); it1 != sx.end(); ++ it1)
        {
            for (auto it2 = sy.begin(); it2 != sy.end(); ++ it2)
            {
                int x1 = (*it1), y1 = (*it2);
                int x2 = x1 + w, y2 = y1 + h;
                int cnt = 0;
                for (int i = 1; i <= n; ++ i)
                {
                    if (x1 <= x[i] and x[i] <= x2 and y1 <= y[i] and y[i] <= y2) cnt++;
                }
                ans = max(ans, cnt);
            }
        }

        cout << ans << endl;
    }

    return 0;
}
