#include "biggest.h"
#include <algorithm>
#include <vector>
#include <stack>
using namespace std;

int arr[100200];
bool used[100200];

bool cmp1(int a, int b)
{
    int z = compare(a, b);
    return a == z;
}

vector<int> biggest(int n, int k)
{
    vector<int> ans;
    if(k > 10000){
        for(int i = 1; i <= n; i++){
            arr[i] = i;
        }
        sort(arr+1, arr+n+1, cmp1);
        for(int i = 1; i <= k; i++){
            ans.push_back(arr[i]);
        }
        return ans;
    }
    if(k > 0){
        stack<int> st;
        int firstNotUsed = 1;
        int lastUsed = -1;
        for(int z = 0; z < k; z++){
            if(st.empty()){
                while(used[firstNotUsed]){
                    firstNotUsed++;
                }
                st.push(firstNotUsed);
            }
            for(int i = max(lastUsed+1, st.top()+1); i <= n; i++){
                if(compare(st.top(), i) == i){
                    st.push(i);
                }
            }
            ans.push_back(st.top());
            lastUsed = st.top();
            used[lastUsed] = true;
            st.pop();
        }
    }
}
