#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
using namespace std;

const int MAXN = 100000;

struct bunnie
{
    long long sum;
    int ori;

    bool operator < (bunnie A) const{
        /*if(sum != A.sum)*/ return sum > A.sum;
        //else return ori < A.ori;
    }

};

int primeCount[1048576];
vector<int> primes;
vector<int> divs;

bool isPrime(int p)
{
    for(int i = 2; i <= sqrt(p); i++){
        if(p%i == 0){
            return false;
        }
    }
    return true;
}

void alldiv(int a, int curr, int pr)
{

    if(pr == primes.size()){
        divs.push_back(curr);
        return;
    }
    int mult = 1;
    for(int i = 0; i <= primeCount[primes[pr]]; i++){
        alldiv(a, curr*mult, pr+1);
        mult *= primes[pr];
    }
}

void raz(int a)
{
    primes.clear();
    divs.clear();
    for(int i = 2; !isPrime(a) && i < a; i++){
        primeCount[i] = 0;
        while(a % i == 0){
            a /= i;
            primeCount[i]++;
        }
        if(primeCount[i] > 0){
            primes.push_back(i);
        }
    }
    if(a != 1){
        primes.push_back(a);
        primeCount[a] = 1;
    }
}

int n, m;
long long car[MAXN];
bunnie bun[MAXN];

int p, p1[1048576];
long long s, s1[1048576];
long long currans, ans;

long long chungus;

long long mins;

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    for(int i = 1; i <= n; i++){
        cin >> car[i];
    }
    for(int i = 1; i <= n; i++){
        bun[i].ori = i;
        for(int j = 1; j*i <= n; j++){
            bun[i].sum += car[i*j];
        }
    }
    sort(bun+1, bun+n+1);
    /*for(int i = 1; i <= n; i++){
        cout << bun[i].sum << endl;
    }*/
    cin >> m;
    for(int k = 0; k < m; k++){
        cin >> p1[k] >> s1[k];
        mins = min(mins, s1[k]);
    }
    if(mins < 0){
        for(int k = 0; k < m; k++){
            p = p1[k]; s = s1[k];
            if(p%bun[1].ori == 0){
                currans = bun[1].sum+s;
            }else{
                currans = bun[1].sum;
            }
            if(s == 0){ans += bun[1].sum; continue;}
            for(int i = 2; i <= n; i++){
                if((s > 0 && s+bun[i].sum <= currans) || (s < 0 && bun[i].sum <= currans)){break;}
                if(p%bun[i].ori == 0){currans = max(currans, bun[i].sum+s);}
                else{currans = max(currans, bun[i].sum);}
            }
            ans += currans;
        }
    }else{
        for(int k = 0; k < m; k++){
            p = p1[k]; s = s1[k];
            chungus = bun[1].sum;
            raz(p);
            alldiv(p, 1, 0);
            for(int i = 0; i < divs.size(); i++){
                int cd = divs[i];
                chungus = max(chungus, bun[cd].sum+s);
            }
            ans += chungus;
        }
    }
    cout << ans << endl;

return 0;
}
