// an attemp for subtasks 4, 5
#include <iostream>
#include <algorithm>
using namespace std;

struct point {
	int x, y;
};

point points[100000];
int n, w, h;

bool cmp(point x, point y)
{
	if (x.x > y.x) return true;
	if (x.x == y.x and x.y > y.y) return true;
	return false;
}

void init()
{
	cin >> n >> w >> h;
	for (int i = 0; i < n; i++) {
		cin >> points[i].x >> points[i].y;
	}

	sort(points, points + n, cmp);
}

int countPoints(int x)
{
	int out = 0;

	for (int i = x; i < n; i++) {
		if (points[i].x < points[x].x - w) break;
		if (points[i].x >= points[x].x - w and points[i].y >= points[x].y - h) {
			out++;
		}
	}

	return out;
}

int main()
{
	int maxPoints = 0, temp;

	init();

	for (int i = 0; i < n; i++) {
		temp = countPoints(i);

		if (temp > maxPoints) maxPoints = temp;
	}

	cout << maxPoints << endl;

	return 0;
}
/*
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5
*/