#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct P {
	int x;
	int y;
};

int find(vector<P> points, int N, int h, int w, int hmm)
{
	int br = 0, max = 0;
	for (int i = 0; i < N; i++)
	{
		for (int k = points[i].y - h + hmm; k <= points[i].y + hmm; k++)
		{
			for (int j = points[i].x - w + hmm; j <= points[i].x + hmm; j++)
			{
				for (int p = 0; p < points.size(); p++)
					if (k == points[p].y and j == points[p].x)
						br++;
			}
		}
		if (br > max)
			max = br;
		br = 0;
	}
	return max;
}

int repeat(int times, vector<P> points, int N, int h, int w)
{
	int max=0;
	for (int i = 0; i < times; i++)
	{
		int temp = find(points, N, h, w, i);
		if (temp > max)
			max = temp;
	}
	return max;
}



int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int h, w, N,max=0,br=0,br2=0;
	cin >> N >> w >> h;
	vector<P> points;
	P point;
	for (int i = 0; i < N; i++)
	{
		
		cin >> point.x;
		cin >> point.y;
		points.push_back(point);
	}
	
	cout << repeat(10,points,N,h,w);
}